SystemOrganization addCategory: #'Widgets-Text'!
SystemOrganization addCategory: #'Widgets-Core'!
SystemOrganization addCategory: #'Widgets-Support'!
SystemOrganization addCategory: #'Widgets-Views'!
SystemOrganization addCategory: #'Widgets-Views-Support'!
SystemOrganization addCategory: #'Widgets-Views-Examples'!
SystemOrganization addCategory: #'Widgets-Events'!
SystemOrganization addCategory: #'Widgets-Sandbox'!
SystemOrganization addCategory: #'Widgets-Sandbox-Tests'!
SystemOrganization addCategory: #'Widgets-Documentation'!
SystemOrganization addCategory: #'Widgets-Painter'!
SystemOrganization addCategory: #'Widgets-Layouts'!
SystemOrganization addCategory: #'Widgets-Layouts2'!

Trait named: #TUiItemModel
	uses: {}
	category: 'Widgets-Views'!

!TUiItemModel methodsFor: 'item model - hierarchy' stamp: 'mt 4/22/2012 15:48:17.262'!
childAt: index inGroup: groupName
	"Return the child at the given index in the given group. Override this if you need index-based child access."
	
	^ (self perform: groupName) at: index! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 5/2/2012 10:37:00.346'!
childChanged: index

	self childrenChangedFrom: index to: index inGroup: self groups first.! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 4/22/2012 16:05:08.614'!
childChanged: index inGroup: groupName

	self childrenChangedFrom: index to: index inGroup: groupName.! !

!TUiItemModel methodsFor: 'item model - hierarchy' stamp: 'mt 4/26/2012 13:37:40.081'!
childCount

	^ self groups
		inject: 0
		into: [:sum :group | sum + (self childCountInGroup: group)]! !

!TUiItemModel methodsFor: 'item model - hierarchy' stamp: 'mt 4/22/2012 15:50:03.599'!
childCountInGroup: groupName
	"Override this if you can return the group size in a faster way ;-)"

	^ (self perform: groupName) size! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 5/2/2012 10:37:10.347'!
childInserted: index

	self childrenInsertedFrom: index to: index inGroup: self groups first.! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 4/22/2012 16:05:19.22'!
childInserted: index inGroup: groupName

	self childrenInsertedFrom: index to: index inGroup: groupName.! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 5/2/2012 10:37:32.383'!
childRemoved: index

	self childrenRemovedFrom: index to: index inGroup: self groups first.! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 5/2/2012 10:37:38.338'!
childRemoved: index inGroup: groupName

	self childrenRemovedFrom: index to: index inGroup: groupName.! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 4/22/2012 16:04:57.207'!
childrenChangedFrom: startIndex to: endIndex inGroup: groupName

	self emit.! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 4/22/2012 16:04:50.038'!
childrenInsertedFrom: startIndex to: endIndex inGroup: groupName

	self emit.! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 4/22/2012 16:04:38.76'!
childrenRemovedFrom: startIndex to: endIndex inGroup: groupName

	self emit.! !

!TUiItemModel methodsFor: 'item model - hierarchy' stamp: 'mt 4/22/2012 15:46:27.653'!
groups
	"Return a list of all child groups. Each group can be implemented as #groupName returning a list of all child nodes OR handled in #childAt:inGroup:."
	
	^ #()! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 4/27/2012 11:01:43.402'!
modelReset
	"The internal state has been invalidated. A view needs to refetch all indices."
	
	self emit.! !

!TUiItemModel methodsFor: 'item model - properties' stamp: 'mt 2/12/2012 15:27:56.656'!
properties
	"Return an ordered list of all known properties. This list can then be used to configure column specifications of item views more conveniently."
	
	^ #()! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 2/3/2012 14:20:14.294'!
propertiesChanged
	"Emit this whenever you want all your properties to be refetched. If you are the invisible root of a model, all visible nodes will be updated."

	self emit.! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 4/26/2012 13:42:30.714'!
propertiesChanged: someProperties

	self emit.! !

!TUiItemModel methodsFor: 'item model - signals' stamp: 'mt 2/3/2012 14:21:00.332'!
propertyChanged: aSymbol
	"A property that may be used in an item view via a colum spec has changed and needs to be updated. If you are the invisible root, all corresponding colums (resp. visible nodes) will be updated and not just single nodes."

	self propertiesChanged: {aSymbol}.! !

!String methodsFor: '*widgets-text' stamp: 'mt 11/30/2010 16:33:22.136'!
asHtmlText

	^ UiHtmlTextFormatter toText: self! !

!String methodsFor: '*widgets-text' stamp: 'mt 5/2/2011 16:04:38.121'!
escapeHtmlText
	"Replaces all tokens that could be problematic when converting this string into a text using #asHtmlText."
	
	^ (self copyReplaceAll: '<' with: '\<')
		copyReplaceAll: '>' with: '\>'! !

!String methodsFor: '*widgets-support' stamp: 'mt 4/28/2009 16:39'!
withoutLineEndings

	^ self withSqueakLineEndings
		copyReplaceAll: String cr
		with: ' '
		asTokens: false! !

!String methodsFor: '*widgets-support' stamp: 'mt 4/28/2009 16:40'!
withoutLineEndingsTruncatedTo: aNumber

	^ self withoutLineEndings truncateWithElipsisTo: aNumber! !

!Object methodsFor: '*widgets-events' stamp: 'mt 2/26/2011 13:45:37.745'!
isEventHandler

	^ false! !

Object subclass: #UiDirectoryEntry
	uses: TUiItemModel
	instanceVariableNames: 'entry files folders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Examples'!

!UiDirectoryEntry commentStamp: 'mt 1/23/2012 10:23:17.687' prior: 0!
This is an adaptor for displaying the directory structure in an item view.!

UiDirectoryEntry class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!UiDirectoryEntry class methodsFor: 'examples' stamp: 'mt 1/23/2012 14:01:58.821'!
ex01

	UiTreeView new
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #entryName. #icon -> #entry})
			headerText: 'Name';
			iconConverter: [:entry | entry isDirectory ifTrue: [UiSilkIcons folderIcon] ifFalse: []]);
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #entrySize})
			headerText: 'Size');
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #entryTimestamp})
			headerText: 'Modification Date and Time';
			textConverter: [:timestamp |
				(timestamp date printFormat: #(1 2 3 $- 1 1 2)), ' ',
				(String streamContents: [:stream | timestamp time
					print24: true
					showSeconds: false
					on: stream])]);
		model: (UiDirectoryEntry fromPath: 'C:');
		openInWorld.! !

!UiDirectoryEntry class methodsFor: 'examples' stamp: 'mt 1/23/2012 14:02:10.186'!
ex02

	UiTreeView new
		addTextColumn: 'Name' selector: #entryName;
		addTextColumn: 'Size' selector: #entrySize;
		addTextColumn: 'Timestamp' selector: #entryTimestamp;
		model: (UiDirectoryEntry fromPath: 'C:');
		openInWorld.! !

!UiDirectoryEntry class methodsFor: 'examples' stamp: 'mt 1/23/2012 14:02:22.929'!
ex03

	UiTreeView new
		addTextColumn: 'Name' selector: #entryName;
		addTextColumn: 'Size' selector: #entrySize;
		addTextColumn: 'Timestamp' selector: #entryTimestamp;
		model: UiDirectoryEntry root;
		openInWorld.! !

!UiDirectoryEntry class methodsFor: 'instance creation' stamp: 'mt 1/23/2012 10:29:35.429'!
fromPath: aPathString

	^ self new
		entry: (FileDirectory on: aPathString) directoryEntry! !

!UiDirectoryEntry class methodsFor: 'instance creation' stamp: 'mt 1/23/2012 10:28:21.154'!
root

	^ UiDirectoryRoot new
		entry: FileDirectory root! !

!UiDirectoryEntry methodsFor: 'item model - hierarchy' stamp: 'mt 4/23/2012 11:03:04.711'!
childAt: index inGroup: groupName
	
	^ UiDirectoryEntry new
		entry: ((self perform: groupName) at: index)! !

!UiDirectoryEntry methodsFor: 'accessing' stamp: 'mt 1/23/2012 10:13:31.454'!
entry
	^ entry! !

!UiDirectoryEntry methodsFor: 'accessing' stamp: 'mt 4/23/2012 10:59:49.083'!
entry: anObject

	entry := anObject.
	
	"Update children cache."
	(entry notNil and: [entry isDirectory]) ifTrue: [
		self folders: (entry asFileDirectory entries select: [:e | e isDirectory]).
		self files: (entry asFileDirectory entries select: [:e | e isDirectory not])].! !

!UiDirectoryEntry methodsFor: 'data' stamp: 'mt 1/23/2012 10:12:19.915'!
entryName


	^ self entry name! !

!UiDirectoryEntry methodsFor: 'data' stamp: 'mt 1/23/2012 10:12:25.512'!
entrySize

	^ self entry size! !

!UiDirectoryEntry methodsFor: 'data' stamp: 'mt 1/23/2012 10:38:51.517'!
entryTimestamp

	^ self entry creationDateAndTime asTimeStamp! !

!UiDirectoryEntry methodsFor: 'accessing' stamp: 'mt 4/23/2012 12:03:34.781'!
files

	^ files ifNil: [#()]! !

!UiDirectoryEntry methodsFor: 'accessing' stamp: 'mt 4/23/2012 10:54:33.491'!
files: anObject

	files := anObject.! !

!UiDirectoryEntry methodsFor: 'accessing' stamp: 'mt 4/23/2012 12:03:40.408'!
folders

	^ folders ifNil: [#()]! !

!UiDirectoryEntry methodsFor: 'accessing' stamp: 'mt 4/23/2012 10:54:41.336'!
folders: anObject

	folders := anObject.! !

!UiDirectoryEntry methodsFor: 'item model - hierarchy' stamp: 'mt 4/23/2012 10:49:17.897'!
groups
	
	^ #(folders files)! !

!UiDirectoryEntry methodsFor: 'item model - properties' stamp: 'mt 4/26/2012 13:36:34.021'!
properties

	^ #(entryName entrySize entryTimestamp)! !

UiDirectoryEntry subclass: #UiDirectoryRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Examples'!

!UiDirectoryRoot commentStamp: 'mt 1/23/2012 10:26:35.612' prior: 0!
This is the root of all directories where #entry is of type FileDirectory and no DirectoryEntry.!

!UiDirectoryRoot methodsFor: 'accessing' stamp: 'mt 4/23/2012 11:09:49.386'!
entry: anObject

	entry := anObject.
	
	"Update children cache."
	entry ifNotNil: [
		self folders: (entry entries select: [:e | e isDirectory]).
		self files: (entry entries select: [:e | e isDirectory not])].! !

Object subclass: #UiDocNode
	instanceVariableNames: 'nodes parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Documentation'!

UiDocNode subclass: #UiDocImageNode
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Documentation'!

!UiDocImageNode class methodsFor: 'instance creation' stamp: 'mt 11/29/2011 14:51:53.104'!
fromBase64: aString

	^ self fromForm: (Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: aString readStream))! !

!UiDocImageNode class methodsFor: 'instance creation' stamp: 'mt 11/29/2011 14:50:45.437'!
fromForm: aForm

	^ self new
		form: aForm! !

!UiDocImageNode class methodsFor: 'instance creation' stamp: 'mt 11/29/2011 14:51:59.864'!
fromMorph: aMorph

	^ self fromForm: aMorph imageForm! !

!UiDocImageNode class methodsFor: 'instance creation' stamp: 'mt 11/29/2011 14:52:10.709'!
fromMorphClass: aMorphClass

	^ self fromMorph: aMorphClass new! !

!UiDocImageNode methodsFor: 'visitng' stamp: 'mt 12/1/2011 09:21:51.189'!
accept: aDocVisitor

	aDocVisitor visitImageNode: self.! !

!UiDocImageNode methodsFor: 'actions' stamp: 'mt 11/29/2011 14:49:08.614'!
exportAsPngTo: aFileName

	PNGReadWriter
		putForm: self form
		onFileNamed: aFileName.! !

!UiDocImageNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:48:51.368'!
form

	^ form! !

!UiDocImageNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:48:57.477'!
form: aForm

	form := aForm.! !

!UiDocImageNode methodsFor: 'testing' stamp: 'mt 11/29/2011 15:02:07.292'!
isImageNode

	^ true! !

!UiDocNode methodsFor: 'visitng' stamp: 'mt 12/1/2011 09:21:41.068'!
accept: aDocVisitor

	self subclassResponsibility.! !

!UiDocNode methodsFor: 'accessing' stamp: 'mt 12/1/2011 10:25:23.856'!
add: aNode

	self nodes add: aNode.
	aNode parent: self.! !

!UiDocNode methodsFor: 'testing' stamp: 'mt 11/29/2011 15:01:32.153'!
isImageNode

	^ false! !

!UiDocNode methodsFor: 'testing' stamp: 'mt 11/29/2011 15:01:46.546'!
isPropertyNode

	^ false! !

!UiDocNode methodsFor: 'testing' stamp: 'mt 11/29/2011 15:01:52.652'!
isSignalNode

	^ false! !

!UiDocNode methodsFor: 'testing' stamp: 'mt 11/29/2011 15:01:58.645'!
isWidgetNode

	^ false! !

!UiDocNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:32:18.755'!
nodes

	^ nodes ifNil: [nodes := OrderedCollection new]! !

!UiDocNode methodsFor: 'accessing' stamp: 'mt 12/1/2011 10:24:59.476'!
parent

	^ parent! !

!UiDocNode methodsFor: 'accessing' stamp: 'mt 12/1/2011 10:25:04.312'!
parent: aNode

	parent := aNode.! !

UiDocNode subclass: #UiDocPropertyNode
	instanceVariableNames: 'symbol comment type defaultValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Documentation'!

UiDocPropertyNode subclass: #UiDocInheritedPropertyNode
	instanceVariableNames: 'widgetName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Documentation'!

!UiDocInheritedPropertyNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 15:01:05.292'!
widgetName
	^ widgetName! !

!UiDocInheritedPropertyNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 15:01:05.391'!
widgetName: anObject
	widgetName := anObject! !

!UiDocPropertyNode methodsFor: 'visitng' stamp: 'mt 12/1/2011 09:21:55.896'!
accept: aDocVisitor

	aDocVisitor visitPropertyNode: self.! !

!UiDocPropertyNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:35:46.73'!
comment
	^ comment! !

!UiDocPropertyNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:35:46.776'!
comment: anObject
	comment := anObject! !

!UiDocPropertyNode methodsFor: 'accessing' stamp: 'mt 12/1/2011 10:16:49.625'!
defaultValue
	^ defaultValue! !

!UiDocPropertyNode methodsFor: 'accessing' stamp: 'mt 12/1/2011 10:16:49.688'!
defaultValue: anObject
	defaultValue := anObject! !

!UiDocPropertyNode methodsFor: 'convenience' stamp: 'mt 12/1/2011 11:00:22.788'!
defaultValueString

	^ (self defaultValue isString or: [self defaultValue isText])
		ifTrue: ['''{1}''' format: {self defaultValue asString}]
		ifFalse: [self defaultValue asString]! !

!UiDocPropertyNode methodsFor: 'testing' stamp: 'mt 11/29/2011 15:02:18.075'!
isPropertyNode

	^ true! !

!UiDocPropertyNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:53:58.534'!
symbol
	^ symbol! !

!UiDocPropertyNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:53:58.612'!
symbol: anObject
	symbol := anObject! !

!UiDocPropertyNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:35:46.814'!
type
	^ type! !

!UiDocPropertyNode methodsFor: 'accessing' stamp: 'mt 12/1/2011 10:09:57.665'!
type: anObject
	
	type := anObject.! !

!UiDocPropertyNode methodsFor: 'convenience' stamp: 'mt 12/1/2011 10:12:39.821'!
typeString

	^ self type isArray
		ifTrue: ['Symbol']
		ifFalse: [self type asString]! !

UiDocNode subclass: #UiDocSignalNode
	instanceVariableNames: 'symbol comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Documentation'!

!UiDocSignalNode methodsFor: 'visitng' stamp: 'mt 12/1/2011 09:22:02.058'!
accept: aDocVisitor

	aDocVisitor visitSignalNode: self.! !

!UiDocSignalNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:54:30.493'!
comment
	^ comment! !

!UiDocSignalNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:54:30.541'!
comment: anObject
	comment := anObject! !

!UiDocSignalNode methodsFor: 'testing' stamp: 'mt 11/29/2011 15:02:30.832'!
isSignalNode

	^ true! !

!UiDocSignalNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:54:30.352'!
symbol
	^ symbol! !

!UiDocSignalNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:54:30.424'!
symbol: anObject
	symbol := anObject! !

UiDocNode subclass: #UiDocWidgetNode
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Documentation'!

!UiDocWidgetNode methodsFor: 'visitng' stamp: 'mt 12/1/2011 09:22:10.917'!
accept: aDocVisitor

	aDocVisitor visitWidgetNode: self.! !

!UiDocWidgetNode methodsFor: 'convenience' stamp: 'mt 12/1/2011 09:40:20.56'!
briefComment

	^ (self comment first: (self comment findString: '.'))
		ifEmpty: [self comment]! !

!UiDocWidgetNode methodsFor: 'convenience' stamp: 'mt 12/1/2011 09:35:45.216'!
comment

	^ self theClass instanceSide organization classComment asString withBlanksTrimmed! !

!UiDocWidgetNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 15:03:09.212'!
imageNodes

	^ self nodes select: [:node | node isImageNode]! !

!UiDocWidgetNode methodsFor: 'testing' stamp: 'mt 11/29/2011 15:02:40.19'!
isWidgetNode

	^ true! !

!UiDocWidgetNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 15:03:16.8'!
propertyNodes

	^ self nodes select: [:node | node isPropertyNode]! !

!UiDocWidgetNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 15:03:24.199'!
signalNodes

	^ self nodes select: [:node | node isSignalNode]! !

!UiDocWidgetNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:48:03.303'!
theClass

	^ class! !

!UiDocWidgetNode methodsFor: 'accessing' stamp: 'mt 11/29/2011 14:48:10.888'!
theClass: aClass

	class := aClass.! !

Object subclass: #UiDocVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Documentation'!

UiDocVisitor subclass: #UiDocTracWikiExporter
	instanceVariableNames: 'out mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Documentation'!

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 11:15:46.034'!
classLabel: aClass
	
	^ (self isWidgetClass: aClass)
			ifTrue: ['[../{1} {2}]' format: {aClass name asLowercase. aClass name}]
			ifFalse: ['!!', aClass name].! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 11/29/2011 15:41:34.89'!
contents

	^ out contents! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 10:49:17.613'!
initialize

	super initialize.
	out := WriteStream with: ''.! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 11:20:53.149'!
isWidgetClass: aClass

	^ (PackageOrganizer default packageOfClass: aClass ifNone: [ nil ])
		= (PackageInfo named: #Widgets) or: [aClass == Morph]! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 10:04:54.047'!
mode

	^ mode ifNil: [mode := #toc]! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 10:05:08.469'!
mode: aSymbol
	"#toc, #content"

	mode := aSymbol.! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 11:16:03.559'!
nextPutClassLabel: aClass
	"Make a link for widget classes and none for others."
	
	out nextPutAll: (self classLabel: aClass).! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 15:36:54.801'!
nextPutWidgetDetails: aWidgetNode

	self mode: #details.
	
	out
		cr;
		nextPutAll: '== Detailed Description == #details';
		cr;
		nextPutAll: aWidgetNode comment.
	
	out
		cr;
		nextPutAll: '== Property Documentation =='.
		
	aWidgetNode propertyNodes do: [:node | self visitNode: node].

	out
		cr;
		nextPutAll: '== Method Documentation =='.
	
	aWidgetNode signalNodes do: [:node | self visitNode: node].! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 15:16:42.936'!
nextPutWidgetSummary: aWidgetNode

	out
		cr;
		nextPutAll: '''''''System Category:'''''' '.
	(aWidgetNode theClass category findTokens: '-')
		do: [:token | out nextPutAll: '!!', token]
		separatedBy: [out nextPutAll: ' - '].

	out
		cr;
		nextPutAll: ('= {1} (!!{2}) =' format: {aWidgetNode theClass widgetClassName. aWidgetNode theClass});
		cr;
		nextPutAll: aWidgetNode briefComment.
		
	aWidgetNode briefComment size < aWidgetNode comment size
		ifTrue: [out nextPutAll: ' [#details More...]'].
		
	out
		cr; cr;
		nextPutAll: '''''''Inherits:'''''' '.

	aWidgetNode theClass allSuperclasses
		do: [:cls | self nextPutClassLabel: cls]
		separatedBy: [out nextPutAll: ' -> '].

	out
		cr; cr;
		nextPutAll: '''''''Inherited by:'''''' '.
		
	aWidgetNode theClass subclasses
		do: [:cls | self nextPutClassLabel: cls]
		separatedBy: [out nextPutAll: ', '].! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 11:33:37.666'!
nextPutWidgetTOC: aWidgetNode

	self mode: #toc.
	
	out
		cr;
		nextPutAll: '== Properties =='.
		
	aWidgetNode propertyNodes do: [:node | self visitNode: node].
	
	aWidgetNode theClass allSuperclasses do: [:cls |
		(cls class selectors includes: #widgetProperties) ifTrue: [ | p1 p2 |
			p1 := cls widgetProperties gather: [:category | category value].
			p2 := (cls superclass class canUnderstand: #widgetProperties)
				ifTrue: [cls superclass widgetProperties gather: [:category | category value]]
				ifFalse: [#()].
			out
				cr;
				nextPutAll: (' * {1} properties inherited from {2}' format: {
					p1 count: [:prop | (p2 includes: prop) not].
					self classLabel: cls})]].

	out
		cr;
		nextPutAll: '== Signals =='.
	
	aWidgetNode signalNodes do: [:node | self visitNode: node].
	
	aWidgetNode theClass allSuperclasses do: [:cls | | signals |
		signals := cls signals.
		signals ifNotEmpty: [
			out
				cr;
				nextPutAll: (' * {1} signals inherited from {2}' format: {
					signals size.
					self classLabel: cls})]].! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 11:00:27.873'!
visitPropertyNode: aPropertyNode

	self mode == #toc ifTrue: [
		out
			cr;
			nextPutAll: (' * [#property{1} {2}] : {3}' format: {
				aPropertyNode symbol asLowercase.
				aPropertyNode symbol.
				aPropertyNode typeString})].

	self mode == #details ifTrue: [
		out
			cr;
			nextPutAll: ('=== {1} : {2} === #property{3}' format: {
				aPropertyNode symbol.
				aPropertyNode typeString.
				aPropertyNode symbol asLowercase});
			cr;
			nextPutAll: aPropertyNode comment;
			cr; cr;
			nextPutAll: ('By default, this property is ''''''{1}''''''.' format: {
				aPropertyNode defaultValueString}).
			"cr; cr;
			nextPutAll: '''''''Accessors:''''''';
			cr"
			
	].! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 10:40:17.354'!
visitSignalNode: aSignalNode

	self mode == #toc ifTrue: [
		out
			cr;
			nextPutAll: (' * [#signal{1} {2}]' format: {
				aSignalNode symbol asLowercase.
				aSignalNode symbol})].

	self mode == #details ifTrue: [
		out
			cr;
			nextPutAll: ('=== {1} (Signal) === #signal{2}' format: {
				aSignalNode symbol.
				aSignalNode symbol asLowercase});
			cr;
			nextPutAll: aSignalNode comment].! !

!UiDocTracWikiExporter methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 10:39:31.244'!
visitWidgetNode: aWidgetNode

	out nextPutAll: '[[PageOutline(1-2)]]'.

	self
		nextPutWidgetSummary: aWidgetNode;
		nextPutWidgetTOC: aWidgetNode;
		nextPutWidgetDetails: aWidgetNode.
! !

!UiDocVisitor methodsFor: 'visiting' stamp: 'mt 11/29/2011 15:31:42.479'!
visitImageNode: anImageNode! !

!UiDocVisitor methodsFor: 'visiting' stamp: 'mt 12/1/2011 09:22:58.445'!
visitNode: aDocNode

	aDocNode accept: self.! !

!UiDocVisitor methodsFor: 'visiting' stamp: 'mt 11/29/2011 15:31:57.077'!
visitPropertyNode: aPropertyNode! !

!UiDocVisitor methodsFor: 'visiting' stamp: 'mt 11/29/2011 15:32:03.266'!
visitSignalNode: aSignalNode! !

!UiDocVisitor methodsFor: 'visiting' stamp: 'mt 11/29/2011 15:32:09.749'!
visitWidgetNode: aWidgetNode! !

Object subclass: #UiDocumentationGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Documentation'!

!UiDocumentationGenerator methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 10:53:59.557'!
commentForMethod: aCompiledMethod

	| parser |
	parser := RBParser parseMethod: aCompiledMethod getSource asString.
	
	^ parser comments
		ifEmpty: ['']
		ifNotEmpty: [parser source
			"Adjust index to skip comment delimiters."
			copyFrom: parser comments first first + 1
			to: parser comments first last - 1]! !

!UiDocumentationGenerator methodsFor: 'as yet unclassified' stamp: 'mt 12/1/2011 15:30:36.677'!
generate

	| root exporter |
	root := UiDocNode new.
	"(PackageInfo named: #Widgets) classes"
	{Morph} do: [:cls | "((cls inheritsFrom: Morph) and: [cls isWidgetClass] and: [cls isExperimentalWidgetClass not])" true ifTrue: [
		| classNode |
		classNode := UiDocWidgetNode new theClass: cls.
		root add: classNode.
		
		((cls superclass canUnderstand: #widgetProperties)
			ifTrue: [cls widgetProperties copyWithoutAll: cls superclass widgetProperties]
			ifFalse: [cls widgetProperties]) do: [:category |
			category value do: [:property | | method |
				method := cls lookupSelector: property key.
				classNode add: (UiDocPropertyNode new
					symbol: property key;
					type: property value;
					comment: (self commentForMethod: method);
					defaultValue: (cls new perform: property key))]].
			
		cls signals do: [:selector | | method |
			method := cls lookupSelector: selector.
			classNode add: (UiDocSignalNode new
				symbol: selector;
				comment: (self commentForMethod: method))]
		]].

	exporter := UiDocTracWikiExporter new.
	"exporter visitNode: root." "root accept: exporter ???"
	root nodes first accept: exporter.
	^ exporter contents! !

Object subclass: #UiEventHandler
	instanceVariableNames: 'properties signalConnections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Events'!

!UiEventHandler commentStamp: 'mt 3/28/2011 10:20:21.148' prior: 0!
An event handler that maps morphic events to signals.

Adds support for #handlesMouseUp: which is not present in Morphic.

An event handler has its own signal connections stored locally to improve lookup performance. As signal processing happens only in the "UI Process" a null mutex is used to secure the connections. Do not try to connect or emit those signals from within another process.!

!UiEventHandler methodsFor: 'private' stamp: 'mt 3/19/2011 09:30:45.989'!
asMouseWheelEvent: aKeyboardEvent
	"Converts the given keyboard event into a mouse wheel event. CHECK WITH #isMouseWheelEvent: FIRST BEFORE CALLING THIS FUNCTION!!"
	
	^ UiMouseWheelEvent new
		setType: #mouseWheel
		position: aKeyboardEvent position
		direction: (aKeyboardEvent keyCharacter = Character arrowUp
			ifTrue: [#up]
			ifFalse: [#down])
		buttons: aKeyboardEvent buttons
		hand: aKeyboardEvent hand
		stamp: aKeyboardEvent timeStamp! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:37:37.495'!
click: aMouseEvent fromMorph: aMorph

	self mouseClicked: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'signals - processing' stamp: 'mt 3/28/2011 10:29:15.009'!
disconnectAllSignals

	signalConnections := nil.! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:37:50.079'!
doubleClick: aMouseEvent fromMorph: aMorph

	self mouseDoubleClicked: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'mouse - accessing' stamp: 'mt 3/22/2011 21:46:58.592'!
doubleClickTimeout: anEvent fromMorph: aMorph

	^ (self valueOfProperty: #doubleClickTimeout) value! !

!UiEventHandler methodsFor: 'mouse - accessing' stamp: 'mt 2/26/2011 13:36:13.637'!
dragThreshold

	^ (self valueOfProperty: #dragThreshold) value! !

!UiEventHandler methodsFor: 'mouse - accessing' stamp: 'mt 2/26/2011 14:35:29.928'!
dragThreshold: anInteger

	self setProperty: #dragThreshold toValue: [anInteger].! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 2/26/2011 14:00:32.752'!
focusLost

	self emit.! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 5/6/2011 08:59:32.254'!
focusLostInSubmorph: aMorph
	"Emitted whenever a submorph (any depth) received keyboard focus."
	
	self emit.! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 5/6/2011 09:46:43.349'!
focusReceived

	self emit.! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 5/6/2011 08:59:42.347'!
focusReceivedInSubmorph: aMorph
	"Emitted whenever a submorph (any depth) received keyboard focus."
	
	self emit.! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 14:46:03.624'!
grabKeyboardOnMouseEnter

	^ self valueOfProperty: #grabKeyboardOnMouseEnter! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 14:44:44.938'!
grabKeyboardOnMouseEnter: aBoolean

	self setProperty: #grabKeyboardOnMouseEnter toValue: aBoolean.! !

!UiEventHandler methodsFor: 'keyboard - shortcuts' stamp: 'mt 8/13/2012 10:31:45.871'!
handleShortcut: aKeyboardEvent

	| map pattern |
	self shortcuts ifEmpty: [^ self].
	
	map := {
		aKeyboardEvent commandKeyPressed -> #cmd.
		aKeyboardEvent controlKeyPressed -> #ctrl.
		aKeyboardEvent shiftPressed -> #shift.
	}.
	pattern := OrderedCollection new.
	
	map do: [:assoc | assoc key ifTrue: [pattern add: assoc value]].
	
	pattern := pattern sorted asArray -> aKeyboardEvent keyCharacter asLowercase.
	
	(self shortcuts at: pattern ifAbsent: []) ifNotNil: [:target |
		target first first
			ifNotNil: [:receiver | receiver perform: target second]
			ifNil: [self shortcuts removeKey: pattern] "kind of garbage collection here"].! !

!UiEventHandler methodsFor: 'keyboard - testing' stamp: 'mt 3/19/2011 09:32:21.583'!
handlesKeyboard: aKeyboardEvent

	(self isMouseWheelEvent: aKeyboardEvent)
		ifTrue: [^ self handlesMouseWheel: (self asMouseWheelEvent: aKeyboardEvent)].
		
	^ (self valueOfProperty: #handlesKeyboard) cull: aKeyboardEvent! !

!UiEventHandler methodsFor: 'mouse - testing' stamp: 'mt 3/2/2011 10:58:01.646'!
handlesMouseDown: event

	^ (self valueOfProperty: #handlesMouseDown) cull: event! !

!UiEventHandler methodsFor: 'mouse - testing' stamp: 'mt 2/26/2011 12:22:20.428'!
handlesMouseOver: event

	^ (self valueOfProperty: #handlesMouseOver) cull: event! !

!UiEventHandler methodsFor: 'mouse - testing' stamp: 'mt 2/26/2011 12:22:15.214'!
handlesMouseOverDragging: event

	^ (self valueOfProperty: #handlesMouseOverDragging) cull: event! !

!UiEventHandler methodsFor: 'mouse - testing' stamp: 'mt 2/26/2011 12:22:10.553'!
handlesMouseStillDown: event

	^ (self valueOfProperty: #handlesMouseStillDown) cull: event! !

!UiEventHandler methodsFor: 'mouse - testing' stamp: 'mt 3/2/2011 11:02:56.866'!
handlesMouseUp: event

	^ (self valueOfProperty: #handlesMouseUp) cull: event! !

!UiEventHandler methodsFor: 'mouse - testing' stamp: 'mt 3/11/2011 16:42:36.799'!
handlesMouseWheel: event

	^ (self valueOfProperty: #handlesMouseWheel) cull: event! !

!UiEventHandler methodsFor: 'signals - processing' stamp: 'mt 3/28/2011 10:17:26.776'!
hasSignalConnections

	^ true! !

!UiEventHandler methodsFor: 'initialization' stamp: 'mt 4/14/2011 17:16:22.119'!
initialize

	super initialize.
	
	self
		mouseDownPriority: 0;  
		setProperty: #handlesKeyboard toValue: [true];
		setProperty: #handlesMouseDown toValue: [true];
		setProperty: #handlesMouseUp toValue: [true];
		setProperty: #handlesMouseOver toValue: [true];
		setProperty: #handlesMouseOverDragging toValue: [true];
		setProperty: #handlesMouseStillDown toValue: [false];
		setProperty: #handlesMouseWheel toValue: [false];
		setProperty: #doubleClickTimeout toValue: [20 "ms"];
		dragThreshold: 0 "pixel";
		grabKeyboardOnMouseEnter: false;
		releaseKeyboardOnMouseLeave: false;
		tabAmongFields: false. "not implemented yet"! !

!UiEventHandler methodsFor: 'testing' stamp: 'mt 2/26/2011 13:45:11.154'!
isEventHandler

	^ true! !

!UiEventHandler methodsFor: 'private' stamp: 'mt 3/19/2011 09:28:51.321'!
isMouseWheelEvent: aKeyboardEvent
	"Check whether the given keyboard event encoded a mouse wheel event."
	
	^ aKeyboardEvent isKeystroke
		and: [aKeyboardEvent controlKeyPressed]
		and: [aKeyboardEvent keyCharacter = Character arrowUp
			or: [aKeyboardEvent keyCharacter = Character arrowDown]]! !

!UiEventHandler methodsFor: 'keyboard - handling' stamp: 'mt 3/2/2011 11:34:46.902'!
keyDown: aKeyboardEvent fromMorph: aMorph

	self keyPressed: aKeyboardEvent.
	
	(#(3 13 10) includes: aKeyboardEvent keyValue)
		ifTrue: [self returnPressed].! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 2/26/2011 12:28:56.969'!
keyPressed: aKeyboardEvent

	self emit.! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 2/26/2011 12:29:04.453'!
keyReleased: aKeyboardEvent

	self emit.! !

!UiEventHandler methodsFor: 'keyboard - handling' stamp: 'mt 3/19/2011 09:33:33.637'!
keyStroke: aKeyboardEvent fromMorph: aMorph

	"Handle VM-specific mapping from mouse wheel interaction to key stroke event: [Ctrl]+Up/Down"
	(self isMouseWheelEvent: aKeyboardEvent)
		ifTrue: [^ self mouseWheel: (self asMouseWheelEvent: aKeyboardEvent) fromMorph: aMorph].

	(self tabAmongFields and: [aKeyboardEvent keyCharacter = Character tab])
		ifTrue: [self shouldBeImplemented].
		
	self
		handleShortcut: aKeyboardEvent;
		keyStroked: aKeyboardEvent.
		
	(#(3 13 10) includes: aKeyboardEvent keyValue)
		ifTrue: [self returnStroked].! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 2/26/2011 12:44:29.785'!
keyStroked: aKeyboardEvent

	self emit.! !

!UiEventHandler methodsFor: 'keyboard - handling' stamp: 'mt 2/26/2011 13:49:48.08'!
keyUp: aKeyboardEvent fromMorph: aMorph

	self keyReleased: aKeyboardEvent.! !

!UiEventHandler methodsFor: 'keyboard - handling' stamp: 'mt 5/6/2011 09:09:36.587'!
keyboardFocusChange: aBoolean fromMorph: aMorph

	"Give the morph a chance to update its appearance."
	aMorph redrawLater.

	aBoolean
		ifTrue: [self focusReceived]
		ifFalse: [self focusLost].
		
	aMorph owner ifNotNil: [:owner |
		owner keyboardFocusChange: aBoolean inSubmorph: aMorph].! !

!UiEventHandler methodsFor: 'keyboard - handling' stamp: 'mt 5/6/2011 10:21:15.427'!
keyboardFocusChange: aBoolean inSubmorph: aSubmorph fromMorph: aMorph

	aBoolean
		ifTrue: [self focusReceivedInSubmorph: aSubmorph]
		ifFalse: [self focusLostInSubmorph: aSubmorph].
		
	aMorph owner ifNotNil: [:owner |
		owner keyboardFocusChange: aBoolean inSubmorph: aSubmorph].! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:24:29.576'!
mouseClicked: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:24:34.692'!
mouseDoubleClicked: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:37:10.381'!
mouseDown: aMouseEvent fromMorph: aMorph

	aMouseEvent hand
		waitForClicksOrDrag: aMorph
		event: aMouseEvent
		selectors: #(click: doubleClick: doubleClickTimeout: startDrag:)
		threshold: self dragThreshold.
		
	self mousePressed: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'mouse - accessing' stamp: 'mt 2/26/2011 14:28:19.68'!
mouseDownPriority

	^ (self valueOfProperty: #mouseDownPriority) value! !

!UiEventHandler methodsFor: 'mouse - accessing' stamp: 'mt 2/26/2011 14:47:19.021'!
mouseDownPriority: anInteger

	self setProperty: #mouseDownPriority toValue: anInteger.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:41:28.994'!
mouseDragStarted: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 14:50:57.641'!
mouseEnter: aMouseEvent fromMorph: aMorph

	self mouseEntered: aMouseEvent.
	
	self grabKeyboardOnMouseEnter
		ifTrue: [aMorph grabKeyboard].! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 4/25/2011 09:56:31.185'!
mouseEnterDragging: aMouseEvent fromMorph: aMorph

	self mouseEnteredDragging: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:54:22.461'!
mouseEntered: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 4/25/2011 09:55:56.594'!
mouseEnteredDragging: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 4/7/2011 14:25:49.3'!
mouseLeave: aMouseEvent fromMorph: aMorph

	self mouseLeft: aMouseEvent.

	self releaseKeyboardOnMouseLeave
		ifTrue: [aMorph releaseKeyboard].! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 4/25/2011 09:56:41.098'!
mouseLeaveDragging: aMouseEvent fromMorph: aMorph

	self mouseLeftDragging: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 4/7/2011 14:25:48.943'!
mouseLeft: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 4/25/2011 09:56:02.024'!
mouseLeftDragging: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:56:17.454'!
mouseMove: aMouseEvent fromMorph: aMorph

	self mouseMoved: aMouseEvent.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:56:01.172'!
mouseMoved: aMouseMoveEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:24:21.32'!
mousePressed: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:24:26.458'!
mouseReleased: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:53:35.477'!
mouseStillDown: aMouseEvent fromMorph: aMorph

	self mousePressed: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 3/22/2011 22:34:35.025'!
mouseUp: aMouseEvent fromMorph: aMorph

	(self handlesMouseUp: aMouseEvent)
		ifTrue: [self mouseReleased: aMouseEvent].! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 3/11/2011 16:48:14.378'!
mouseWheel: aMouseEvent fromMorph: aMorph

	(self handlesMouseWheel: aMouseEvent)
		ifTrue: [
			aMouseEvent direction = #up
				ifTrue: [self mouseWheelUp: aMouseEvent].
			aMouseEvent direction = #down
				ifTrue: [self mouseWheelDown: aMouseEvent]].! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 3/11/2011 16:40:59.573'!
mouseWheelDown: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 3/11/2011 16:40:55.772'!
mouseWheelUp: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'keyboard - shortcuts' stamp: 'mt 8/13/2012 10:33:39.384'!
on: keyPattern send: aSelector to: aReceiver
	"Add a keyboard shortcut that is handled inside this event handler. The case (lower/upper) of the character does not matter. Example:
	self eventHandler on: #ctrl -> $c send: #copy to: self.
	self eventHandler on: #(ctrl shift) -> Character arrowUp send: #pageUp to: self.
	self eventHandler on: Character enter send: #save to: self.
	
	Modifiers: #cmd, #ctrl, #shift"

	| normalizedPattern |
	normalizedPattern := keyPattern isVariableBinding "= association"
		ifTrue: [keyPattern key isSymbol
			ifTrue: [{keyPattern key} -> keyPattern value asLowercase]
			ifFalse: [keyPattern key sorted -> keyPattern value asLowercase]]
		ifFalse: [#() -> keyPattern asLowercase "character given only"].

	self shortcuts at: normalizedPattern put: {WeakArray with: aReceiver. aSelector}! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 11:53:31.141'!
properties

	^ properties ifNil: [properties := Dictionary new]! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 14:46:17.804'!
releaseKeyboardOnMouseLeave

	^ self valueOfProperty: #releaseKeyboardOnMouseLeave! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 14:45:45.391'!
releaseKeyboardOnMouseLeave: aBoolean

	self setProperty: #releaseKeyboardOnMouseLeave toValue: aBoolean.! !

!UiEventHandler methodsFor: 'keyboard - shortcuts' stamp: 'mt 2/26/2011 13:02:56.278'!
removeAllShortcuts

	^ self removeProperty: #shortcuts! !

!UiEventHandler methodsFor: 'properties' stamp: 'mt 2/26/2011 11:55:36.248'!
removeProperty: aSymbol

	self properties removeKey: aSymbol ifAbsent: [].! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 3/2/2011 11:33:52.002'!
returnPressed
	
	self emit.! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 3/2/2011 11:32:38.703'!
returnStroked
	"Emitted whenefer Character enter, cr, or lf is stroked."
	
	self emit.! !

!UiEventHandler methodsFor: 'properties' stamp: 'mt 2/26/2011 11:54:47.669'!
setProperty: aSymbol toValue: anObject

	anObject ifNil: [^ self removeProperty: aSymbol].
	self properties at: aSymbol put: anObject.! !

!UiEventHandler methodsFor: 'keyboard - shortcuts' stamp: 'mt 2/26/2011 13:02:33.829'!
shortcuts

	^ self properties at: #shortcuts ifAbsentPut: [Dictionary new]! !

!UiEventHandler methodsFor: 'signals - processing' stamp: 'mt 3/28/2011 10:17:00.743'!
signalConnections

	^ signalConnections ifNil: [signalConnections := Dictionary new]! !

!UiEventHandler methodsFor: 'signals - processing' stamp: 'mt 3/28/2011 10:17:47.015'!
signalMutex

	^ UiNullMutex! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:41:18.965'!
startDrag: aMouseEvent fromMorph: aMorph

	self mouseDragStarted: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 16:30:19.736'!
tabAmongFields
	"Pass keyboard focus to next morph?"
	
	^ self valueOfProperty: #tabAmongFields! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 16:29:49.718'!
tabAmongFields: aBoolean

	self setProperty: #tabAmongFields toValue: aBoolean.! !

!UiEventHandler methodsFor: 'properties' stamp: 'mt 2/26/2011 13:18:22.966'!
valueOfProperty: aSymbol

	^ self valueOfProperty: aSymbol ifAbsent: []! !

!UiEventHandler methodsFor: 'properties' stamp: 'mt 2/26/2011 11:56:30.935'!
valueOfProperty: aSymbol ifAbsent: aBlock

	^ self properties at: aSymbol ifAbsent: aBlock! !

Object subclass: #UiHtmlTextFormatter
	instanceVariableNames: 'offset runStack runArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Text'!

!UiHtmlTextFormatter commentStamp: 'mt 7/18/2012 15:38' prior: 0!
I create a text instance from a given string that contains html tags for emphasis. Examples:

'Hello, <b>World!!</b>' asHtmlText
'<i>Hello</i>, World!!' asHtmlText
'<font color="#00cc00">Hello!!</font>, World!!' asHtmlText
'<font color="#FF00FF">Ahahaha!! <b>Hello</b>, <i>World</i></font>!!' asHtmlText asMorph openInHand
'<font color="#0000ff">Ahahaha!! <b><font size="7">Hello</font></b></font>, <i><b>World</b></i>!!' asHtmlText
'<font color="#444444"><b>Hello</b> <i>World!!</i></font>' asHtmlText asMorph openInHand

Supports line breaks: 'Hello<br>World!!' asHtmlText asMorph openInHand.

Escape control characters with $\. Double-escape them if you use #format:.
('<b>Hello \\>\\> {1}!!</b>' format: {'World'}) asHtmlText!

!UiHtmlTextFormatter class methodsFor: 'formatting' stamp: 'mt 6/22/2010 22:28:43.544'!
toText: aString

	^ self new toText: aString! !

!UiHtmlTextFormatter methodsFor: 'initialization' stamp: 'mt 3/23/2012 14:53:57.086'!
initialize

	super initialize.
	offset := 0. "To ignore characters in the input string that are used by tags."
	runStack := Stack new.
	runArray := RunArray new.
	
	"{text attributes. start index. end index. number of open tags}"
	runStack push: {OrderedCollection new. 1. nil. 0}.! !

!UiHtmlTextFormatter methodsFor: 'mapping' stamp: 'mt 6/24/2012 13:23:31.447'!
mapTagToAttribute: aTag

	| rx strm result fontFamily fontSize |
	aTag = '<b>' ifTrue: [^ {TextEmphasis bold}].
	aTag = '<i>' ifTrue: [^ {TextEmphasis italic}].
	aTag = '<u>' ifTrue: [^ {TextEmphasis underlined}].
	aTag = '<code>' ifTrue: [^ {TextFontReference toFont: Preferences standardCodeFont}].
	
	result := OrderedCollection new.
	
	"<font color=""#00FFCC"">"
	rx := 'color\s*=\s*"(#\w\w\w\w\w\w)' asRegex.
	strm := aTag readStream.
	[rx searchStream: strm]
		whileTrue: [ result add: (TextColor color: (Color fromString: (rx subexpression: 2)))].
	
	"<font family=""Bitmap SegoeUI Light"">"
	rx := 'family\s*=\s*"([^"]+)"' asRegex.
	strm := aTag readStream.
	[rx searchStream: strm]
		whileTrue: [fontFamily := rx subexpression: 2].

	"<font size=""7"">"
	rx := 'size\s*=\s*"(\d+)' asRegex.
	strm := aTag readStream.
	[rx searchStream: strm]
		whileTrue: [fontSize := rx subexpression: 2].

	fontSize ifNil: [fontSize := 9].
	result add: (TextFontReference toFont: (fontFamily
		ifNil: [TextStyle default fontOfPointSize: fontSize]
		ifNotNil: [:ff | StrikeFont familyName: ff pointSize: fontSize])).

	^ result! !

!UiHtmlTextFormatter methodsFor: 'parsing' stamp: 'mt 3/23/2012 14:36:55.179'!
parseString: anHtmlString

	| tag lookForNewTag result start end attrs escapeNextCharacter |
	lookForNewTag := true.
	tag := OrderedCollection new.
	result := OrderedCollection new.
	escapeNextCharacter := false.
	
	anHtmlString withIndexDo: [:character :index |
		escapeNextCharacter
			ifTrue: [result add: character. escapeNextCharacter := false]
			ifFalse: [
				character = $\
					ifTrue: [offset := offset + 1. escapeNextCharacter := true]
					ifFalse: [
						character = $< ifTrue: [lookForNewTag := false].
						character = $> ifTrue: [lookForNewTag := true].
		
						(lookForNewTag and: [character ~= $>])
							ifTrue: [result add: character]
							ifFalse: [tag add: character. offset := offset + 1]..
			
						(tag notEmpty and: [tag last = $>]) ifTrue: [
							"Full tag like <b> or </b> found."
							|tmp|
							tmp := String withAll: tag.
							tmp second ~= $/
								ifTrue: [self processStartTag: tmp pos: index]
								ifFalse: [self processEndTag: tmp pos: index].			
							tag := OrderedCollection new.
							lookForNewTag := true]]]].
	
	"Add last run."
	
	"Set end index."
	runStack top at: 3 put: anHtmlString size - offset.
	
	"Write to run array."
	start := runStack top second.
	end := runStack top third.
	attrs := runStack top first.
	runArray addLast: attrs times: end - start + 1.
	
	^ String withAll: result! !

!UiHtmlTextFormatter methodsFor: 'parsing' stamp: 'mt 6/22/2010 22:27:58.149'!
processEndTag: aTag pos: index

	|start end attrs|
	"De-Accumulate adjacent tags."
	runStack top at: 4 put: runStack top fourth - 1.
	runStack top fourth > 0
		ifTrue: [^ self "not yet"].
		
	"Set end index."
	runStack top at: 3 put: index - offset.
	
	"Write to run array."
	start := runStack top second.
	end := runStack top third.
	attrs := runStack top first.
	runArray addLast: attrs times: end - start + 1.

	runStack pop.
	runStack top at: 2 put: index - offset + 1.! !

!UiHtmlTextFormatter methodsFor: 'parsing' stamp: 'mt 3/27/2012 10:16:27.463'!
processStartTag: aTag pos: index

	|start end attrs|
	"Accumulate adjacent tags."
	(runStack size > 1 and: [runStack top second = (index - offset + 1) "= adjacent start tags"])
		ifTrue: [
			runStack top at: 1 put: (runStack top first copy addAll: (self mapTagToAttribute: aTag); yourself).
			runStack top at: 4 put: (runStack top fourth + 1). "increase number of open tags"
			^self].
			
	"Set end index."
	runStack top at: 3 put: index - offset.
	"Write to run array."
	start := runStack top second.
	end := runStack top third.
	attrs := runStack top first.
	runArray addLast: attrs times: end - start + 1.
	"Remove start/end info to reuse attributes later."
	runStack top at: 2 put: nil.
	runStack top at: 3 put: nil.
	"Copy attr list and add new attr."
	runStack push: ({runStack top first copy addAll: (self mapTagToAttribute: aTag); yourself. index - offset + 1. nil. 1}).! !

!UiHtmlTextFormatter methodsFor: 'formatting' stamp: 'mt 6/24/2012 13:07:29.022'!
toText: aString
	"Parse all known HTML attributes in the given string to text attributes."
	
	^ [Text string: (self parseString: (aString copyReplaceAll: '<br>' with: String cr)) runs: runArray] 
		on: Error
		do: [:e | aString asText]! !

Object subclass: #UiItemModelNullNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiItemModelNullNode commentStamp: 'mt 4/12/2011 11:21:15.846' prior: 0!
A model index that stores dummy data to, e.g., compute the default item extent.!

!UiItemModelNullNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 09:45:51.656'!
icon

	^ Form extent: 16@16 depth: 32! !

!UiItemModelNullNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 09:45:57.42'!
text

	^ 'This <b>is</b> a <i>dummy item</i>!!' asHtmlText! !

Object subclass: #UiItemOrder
	instanceVariableNames: 'map sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiItemOrder commentStamp: 'mt 10/16/2010 14:45:30.134' prior: 0!
A cached order of some items. Needs to be updated frequently.!

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 19:08:23.107'!
items: someItems at: anIndex
	
	self map ifNil: [^ someItems at: anIndex].
	^ someItems at: (self map at: anIndex)! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 15:03:57.143'!
items: someItems collect: aBlock

	self map ifNil: [^ someItems collect: aBlock].
	^ map collect: [:index | aBlock value: (someItems at: index)]! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 15:03:42.612'!
items: someItems do: aBlock

	self map ifNil: [^ someItems do: aBlock].
	map do: [:index | aBlock value: (someItems at: index)]! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 19:12:41.82'!
items: someItems withIndexDo: aBlock

	self map ifNil: [^ someItems withIndexDo: aBlock].
	map do: [:index | aBlock value: (someItems at: index) value: index]! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:57:00.465'!
map

	^ map! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:57:44.975'!
map: anArray
	"Example: #(5 4 3 2 1) will revert a list with 5 items."

	map := anArray.! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 7/6/2012 10:38:13.264'!
mapAt: anIndex
	
	^ self map
		ifNil: [anIndex]
		ifNotNil: [:m | m at: anIndex]! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 7/6/2012 10:38:32.475'!
mapIndexOf: aMappedIndex
	
	^ self map
		ifNil: [aMappedIndex]
		ifNotNil: [:m | m indexOf: aMappedIndex]! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:04:46.949'!
sortBlock

	^ sortBlock! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:44:45.717'!
sortBlock: aBlock

	sortBlock := aBlock.! !

!UiItemOrder methodsFor: 'manual mapping' stamp: 'mt 10/16/2010 20:12:05.571'!
unmapIndex: anIndex

	self map ifNil: [^ anIndex].
	^ self map indexOf: anIndex! !

!UiItemOrder methodsFor: 'updating' stamp: 'mt 5/18/2012 12:04:06.902'!
updateSortedResult: sortedItems
	"An optional post-processing step. Restore groups."

	| groupIndex groupEmpty result |
	groupIndex := 1.
	groupEmpty := false. "The first group must never be empty."
	result := OrderedCollection new.
	
	[groupEmpty] whileFalse: [
		groupEmpty := true.
		sortedItems do: [:each |
			(each valueOfProperty: #modelIndex) groupIndex = groupIndex
				ifTrue: [result add: each. groupEmpty := false]].
		groupIndex := groupIndex + 1].
	
	^ result! !

!UiItemOrder methodsFor: 'updating' stamp: 'mt 7/12/2012 17:54:07.175'!
updateWith: someItems

	| sortedCopy separators separatorPositions |
	self sortBlock ifNil: [^ self map: nil].	
	someItems ifEmpty: [^ self map: nil].
	
	"link separators with groups"
	separators := someItems select: [:item | item hasProperty: #isGroupSeparator].
	
	"sort without separators"
	sortedCopy := (someItems reject: [:item | item hasProperty: #isGroupSeparator])
		"unbox morphs into nodes"
		sortBy: [:item1 :item2 | self sortBlock
			value: (item1 valueOfProperty: #modelIndex) node
			value: (item2 valueOfProperty: #modelIndex) node].
	sortedCopy := self updateSortedResult: sortedCopy.
	
	"insert separators again"
	separatorPositions := Array new: separators size.
	separatorPositions at: 1 put: 1.
	separators allButFirst withIndexDo: [:separator :sepId |
		(sortedCopy detect: [:item |
			((separator valueOfProperty: #parentModelIndex) = (item valueOfProperty: #modelIndex) parent
				and: [(separator valueOfProperty: #groupIndex) = (item valueOfProperty: #modelIndex) groupIndex])]
			ifNone: []) ifNotNil: [:item | separatorPositions at: sepId + 1 put: (sortedCopy indexOf: item)]].
	separators withIndexDo: [:separator :sepId |
		sortedCopy add: separator beforeIndex: (separatorPositions at: sepId) + sepId - 1].
			
	
	"update index map"
	map := Array new: someItems size.
	sortedCopy withIndexDo: [:item :index |
		map at: index put: (someItems indexOf: item)].! !

UiItemOrder subclass: #UiTreeItemOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiTreeItemOrder commentStamp: 'mt 11/2/2010 13:09:33.58' prior: 0!
An item order that considers the model index hierarchy (i.e., parent indices) while sorting.!

!UiTreeItemOrder methodsFor: 'updating' stamp: 'mt 4/29/2012 12:41:11.301'!
parent: currentParent list: aList result: result

	| groupIndex groupEmpty |
	groupIndex := 1.
	groupEmpty := false. "The first group must never be empty."
	
	[groupEmpty] whileFalse: [
		groupEmpty := true.
		aList do: [:each |
			| index |
			index := each valueOfProperty: #modelIndex.
			(index parent = currentParent and: [index groupIndex = groupIndex]) ifTrue: [
				result add: each.
				groupEmpty := false.
				self parent: index list: (aList copyWithout: each) result: result]].
		groupIndex := groupIndex + 1].! !

!UiTreeItemOrder methodsFor: 'updating' stamp: 'mt 4/28/2012 18:26:59.953'!
updateSortedResult: sortedItems
	"rebuild tree-structure"

	| result |
	result := OrderedCollection new.
	self parent: nil list: sortedItems result: result.
	^ result! !

Object subclass: #UiItemViewColumnSpec
	instanceVariableNames: 'textSelector iconSelector balloonTextSelector checkedSelector menuSelector headerText headerIcon headerBalloonText itemOrientation balloonTextConverter textConverter iconConverter overrideStandardListFont selectableSelector checkableSelector editableSelector editorCreator editorFinisher editorAcceptSignal editorRevertSignal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiItemViewColumnSpec commentStamp: 'mt 7/6/2012 10:30:16.426' prior: 0!
This specification is used by the view to access model data and create (morphic) items for the viewport PER COLUMN.

UiItemViewColumnSpec newFrom: {
	#text -> #authorName.
	#icon -> #statusForm "selector in model or key in UiPropertyItemNode".
	#balloonText -> 3. "3rd property in #properties of model"}.!

!UiItemViewColumnSpec class methodsFor: 'defaults' stamp: 'mt 1/23/2012 09:45:24.433'!
defaultItemExtent

	^ ((self newFrom: {#text -> #text. #icon -> #icon})
		itemFor: UiItemModelNullNode new) extent! !

!UiItemViewColumnSpec class methodsFor: 'instance creation' stamp: 'mt 7/6/2012 11:46:48.284'!
newFrom: selectorMap
	"Targets can be symbols OR integers. The latter one needs #properties to be implemented in all nodes. See TUiItemModel trait."

	selectorMap isArray
		"{#text -> #name. #icon -> #stateForm}"
		ifTrue: [^ self newFrom: (Dictionary newFrom: selectorMap)].
		
	^ self new
		"item data"
		textSelector: (selectorMap at: #text ifAbsent: []);
		iconSelector: (selectorMap at: #icon ifAbsent: []);
		balloonTextSelector: (selectorMap at: #balloonText ifAbsent: []);
		menuSelector: (selectorMap at: #menu ifAbsent: []);
		checkedSelector: (selectorMap at: #checked ifAbsent: []);
		"header data"
		headerText: (selectorMap at: #headerText ifAbsent: []);
		headerIcon: (selectorMap at: #headerIcon ifAbsent: []);
		"flags"
		selectableSelector: (selectorMap at: #selectable ifAbsent: []);
		checkableSelector: (selectorMap at: #checkable ifAbsent: []);
		editableSelector: (selectorMap at: #editable ifAbsent: [])
		
! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 1/22/2012 17:08:34.301'!
balloonTextConverter

	^ balloonTextConverter! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 1/22/2012 17:07:22.391'!
balloonTextConverter: aBlock

	balloonTextConverter := aBlock.! !

!UiItemViewColumnSpec methodsFor: 'accessing - nodes' stamp: 'mt 2/12/2012 15:57:36.897'!
balloonTextFor: aNode

	^ self data: balloonTextSelector for: aNode

	! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 1/22/2012 16:35:00.343'!
balloonTextSelector
	^ balloonTextSelector! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 1/22/2012 16:35:00.373'!
balloonTextSelector: anObject
	balloonTextSelector := anObject! !

!UiItemViewColumnSpec methodsFor: 'accessing - nodes' stamp: 'mt 7/5/2012 15:49:06.61'!
checkableFor: aNode

	^ ((self data: checkableSelector for: aNode) ifNil: [false])
		and: [self checkedSelector notNil]
	! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 7/5/2012 15:39:11.629'!
checkableSelector
	^ checkableSelector! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 7/5/2012 15:39:19.169'!
checkableSelector: anObject
	checkableSelector := anObject! !

!UiItemViewColumnSpec methodsFor: 'accessing - nodes' stamp: 'mt 2/12/2012 15:58:00.989'!
checkedFor: aNode

	^ (self data: checkedSelector for: aNode) ifNil: [false]
	! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 1/22/2012 16:35:00.403'!
checkedSelector
	^ checkedSelector! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 1/22/2012 16:35:00.433'!
checkedSelector: anObject
	checkedSelector := anObject! !

!UiItemViewColumnSpec methodsFor: 'accessing - nodes' stamp: 'mt 7/6/2012 10:33:41.754'!
data: aSymbolOrIntegerOrBoolean for: aNode
	"Private. Access property directly or use a indirection via #properties in node. This makes tree nodes having different kinds of properties more flexible."
	
	| property |
	aSymbolOrIntegerOrBoolean ifNil: [^ nil].
	
	"Support hardcoded boolean defaults."
	aSymbolOrIntegerOrBoolean == true ifTrue: [^ true].
	aSymbolOrIntegerOrBoolean == false ifTrue: [^ false].
	
	"Support ordered properties referenced by an integer. Consider #properties in node."
	property := aSymbolOrIntegerOrBoolean isInteger
		ifTrue: [aNode properties at: aSymbolOrIntegerOrBoolean ifAbsent: []]
		ifFalse: [aSymbolOrIntegerOrBoolean].
	
	"Lookup property as accessor or key in dictionary."
	^ property ifNotNil: [:p | (p ~~ #yourself and: [aNode isDictionary])
		ifTrue: [aNode at: p ifAbsent: []]
		ifFalse: [aNode perform: p]]! !

!UiItemViewColumnSpec methodsFor: 'building' stamp: 'mt 1/22/2012 16:58:20.965'!
defaultItemExtent

	^ (self itemFor: UiItemModelNullNode new) extent! !

!UiItemViewColumnSpec methodsFor: 'building' stamp: 'mt 1/22/2012 16:56:31.564'!
doLayoutFor: aMorph

	| offset |
	self itemOrientation = #horizontal ifTrue: [
		aMorph submorphs last isTextMorph
			ifTrue: [ | fontHeight |
				fontHeight := aMorph submorphs last textStyle defaultFont height.
				(fontHeight * 2) < aMorph submorphs last height
					"More than one line?"
					ifTrue: [aMorph height: aMorph submorphs last height]
					ifFalse: [aMorph height: fontHeight]]
			ifFalse: [
				aMorph height: aMorph submorphs last height].
				
		"Manual layouting."
		offset := (aMorph left + 3) @ 1.
		aMorph submorphs do: [:m |
			m left: offset x.
			offset := offset + ((m width + 2) @ 0).
			m top: aMorph top - (m height - aMorph height // 2) + offset y].
	
		"Expand item horizontally to its contents."
		aMorph
			width: aMorph submorphBounds width + 5; "font rendering bugfix"
			height: aMorph height + 1. "font rendering bugfix"
		
		^ self].
	
	self itemOrientation = #vertical ifTrue: [
		aMorph width: aMorph submorphs last width + 10.
			
		"Manual layouting."
		offset := aMorph top + 3.
		aMorph submorphs do: [:m |
			m top: offset.
			offset := offset + m height + 2.
			m left: (aMorph left - (m width - aMorph width // 2))].
	
		aMorph height: aMorph submorphBounds height + 2].! !

!UiItemViewColumnSpec methodsFor: 'accessing - nodes' stamp: 'mt 7/6/2012 09:41:58.34'!
editableFor: aNode

	^ (self data: editableSelector for: aNode) ifNil: [false]
	! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 7/6/2012 09:36:44.919'!
editableSelector
	^ editableSelector! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 7/6/2012 09:36:38.296'!
editableSelector: anObject
	editableSelector := anObject! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 7/8/2012 14:48:27.207'!
editorAcceptSignal
	"Signal that should be listened for to finish the editing."
	
	^ editorAcceptSignal ifNil: [#returnPressed:]! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 7/8/2012 14:49:09.212'!
editorAcceptSignal: aSymbol
	editorAcceptSignal := aSymbol.! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 7/8/2012 14:59:09.417'!
editorCreator
	"A block that creates an editor given the node that needs to be edited."
	
	^ editorCreator ifNil: [editorCreator := [:spec :node |
			UiLineEdit new
				hideCursor: false;
				outerBorderWidth: 0;
				font: Preferences standardListFont;
				theText: (spec textFor: node); selectAll]].! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 7/6/2012 11:42:07.863'!
editorCreator: aBlock	
	editorCreator := aBlock.! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 7/12/2012 10:29:57.951'!
editorFinisher
	"A block that should take editor data and write it back to the model."
	
	^ editorFinisher ifNil: [editorFinisher := [:editor :node |
			node perform: (self textSelector, #:) asSymbol withArguments: {editor theText}]].! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 7/6/2012 11:46:04.146'!
editorFinisher: aBlock
	editorFinisher := aBlock.! !

!UiItemViewColumnSpec methodsFor: 'building' stamp: 'mt 7/6/2012 11:43:21.232'!
editorFor: aNode

	| editor |
	editor := (self editorCreator value: self value: aNode)
		hResizing: #spaceFill;
		setProperty: #selectable toValue: true;
		yourself.
	^ editor! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 7/8/2012 14:49:32.343'!
editorRevertSignal
	
	^ editorRevertSignal ifNil: [#escapePressed:]! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 7/8/2012 14:49:43.667'!
editorRevertSignal: aSymbol
	
	editorRevertSignal := aSymbol.! !

!UiItemViewColumnSpec methodsFor: 'header' stamp: 'mt 1/22/2012 16:39:08.048'!
headerBalloonText

	^ headerBalloonText! !

!UiItemViewColumnSpec methodsFor: 'header' stamp: 'mt 1/22/2012 16:39:23.239'!
headerBalloonText: stringOrText

	headerBalloonText := stringOrText.! !

!UiItemViewColumnSpec methodsFor: 'header' stamp: 'mt 1/22/2012 16:38:42.192'!
headerIcon

	^ headerIcon! !

!UiItemViewColumnSpec methodsFor: 'header' stamp: 'mt 1/22/2012 16:38:31.156'!
headerIcon: aForm

	headerIcon := aForm.! !

!UiItemViewColumnSpec methodsFor: 'building' stamp: 'mt 7/11/2012 09:39:01.9'!
headerItem

	| icon text balloonText item |	
	icon := self headerIcon.
	text := self headerText.
	balloonText := self headerBalloonText.
	
	(text isNil and: [icon isNil]) ifTrue: [text := ' ' asText].
	
	item := Morph new color: Color transparent.
		
	icon ifNotNil: [item addMorphBack: icon asMorph].
	text ifNotNil: [
		text isString ifTrue: [text := text asText].
		text isString | text isText ifFalse: [text := text asString asText].
		self overrideStandardListFont ifFalse: [text addAttribute: (TextFontReference toFont: Preferences standardListFont)].
		item addMorphBack: text asMorph lock].
	balloonText ifNotNil: [
		item balloonText: balloonText].
	
	self doLayoutFor: item.	

	^ item! !

!UiItemViewColumnSpec methodsFor: 'header' stamp: 'mt 1/22/2012 16:37:57.892'!
headerText

	^ headerText! !

!UiItemViewColumnSpec methodsFor: 'header' stamp: 'mt 1/22/2012 16:38:13.581'!
headerText: stringOrText

	headerText := stringOrText.! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 1/22/2012 17:08:20.423'!
iconConverter

	^ iconConverter! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 1/22/2012 17:07:45.402'!
iconConverter: aBlock

	iconConverter := aBlock.! !

!UiItemViewColumnSpec methodsFor: 'accessing - nodes' stamp: 'mt 2/12/2012 15:58:15.074'!
iconFor: aNode

	^ self data: iconSelector for: aNode

	! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 1/22/2012 16:35:00.281'!
iconSelector
	^ iconSelector! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 1/22/2012 16:35:00.312'!
iconSelector: anObject
	iconSelector := anObject! !

!UiItemViewColumnSpec methodsFor: 'testing' stamp: 'mt 1/23/2012 11:01:23.807'!
includesAnyProperty: someProperties
	
	^ someProperties anySatisfy: [:property | self includesProperty: property]! !

!UiItemViewColumnSpec methodsFor: 'testing' stamp: 'mt 2/12/2012 16:25:45.346'!
includesAnyProperty: someProperties inNode: aNode
	
	^ someProperties anySatisfy: [:property | self includesProperty: property inNode: aNode]! !

!UiItemViewColumnSpec methodsFor: 'testing' stamp: 'mt 7/6/2012 09:37:56.118'!
includesProperty: aProperty
	
	^ {textSelector. iconSelector. balloonTextSelector. checkedSelector. selectableSelector. checkableSelector. editableSelector}
		anySatisfy: [:selector | selector == aProperty]! !

!UiItemViewColumnSpec methodsFor: 'testing' stamp: 'mt 7/9/2012 17:15:29.478'!
includesProperty: aProperty inNode: aNode

	| checkBlock |
	checkBlock := [:symbolOrInteger | (symbolOrInteger isInteger
		ifTrue: [aNode properties at: symbolOrInteger ifAbsent: []]
		ifFalse: [symbolOrInteger]) = aProperty].
	
	^ {textSelector. iconSelector. balloonTextSelector. checkedSelector. selectableSelector. checkableSelector. editableSelector}
		anySatisfy: [:selector | checkBlock value: selector]! !

!UiItemViewColumnSpec methodsFor: 'building' stamp: 'mt 7/12/2012 10:24:22.094'!
itemFor: aNode

	| icon text balloonText item checkbox |	
	icon := self iconFor: aNode "ifNil: [Morph new extent: 16@16; color: Color transparent]".
	text := self textFor: aNode.
	balloonText := self balloonTextFor: aNode.
	
	"Configurable data conversion step."
	self iconConverter ifNotNil: [:c | icon := c value: icon].
	self textConverter ifNotNil: [:c | text := c value: text].
	self balloonTextConverter ifNotNil: [:c | balloonText := c value: balloonText].
	
	"Workaround for item layouting if item is empty."
	(text isNil and: [icon isNil]) ifTrue: [text := ' ' asText].
	
	item := Morph new color: Color transparent.
	
	"A checkbox is created if this column was configured to have checkable nodes."
	(self checkableFor: aNode) ifTrue: [
		checkbox := UiCheckBox basicNew initializeNoText.
		checkbox checked: (self checkedFor: aNode).
		self connect: checkbox signal: #toggled: to: aNode selector: (self checkedSelector, #:) asSymbol.
		self connect: checkbox signal: #toggled: to: checkbox selector: #visible:.
		item addMorphBack: checkbox].
	
	icon ifNotNil: [item addMorphBack: icon asMorph].
	text ifNotNil: [
		text isString ifTrue: [text := text asText].
		text isString | text isText ifFalse: [text := text asString asText].
		self overrideStandardListFont ifFalse: [text addAttribute: (TextFontReference toFont: Preferences standardListFont)].
		item addMorphBack: text asMorph lock].
	balloonText ifNotNil: [
		item balloonText: balloonText].
	
	"Store morphs in properties for later access."
	item
		setProperty: #text toValue: text;
		setProperty: #icon toValue: icon;
		setProperty: #balloonText toValue: balloonText;
		setProperty: #checkBox toValue: checkbox;
		setProperty: #selectable toValue: (self selectableFor: aNode).

	self doLayoutFor: item.	
	checkbox ifNotNil: [checkbox hide].
	
	^ item! !

!UiItemViewColumnSpec methodsFor: 'building' stamp: 'mt 1/22/2012 16:55:48.639'!
itemOrientation

	^ itemOrientation ifNil: [itemOrientation := #horizontal]! !

!UiItemViewColumnSpec methodsFor: 'building' stamp: 'mt 1/22/2012 16:56:11.312'!
itemOrientation: aSymbol
	"#vertical, #horizontal"

	 itemOrientation := aSymbol.! !

!UiItemViewColumnSpec methodsFor: 'accessing - nodes' stamp: 'mt 2/14/2012 17:17:42.851'!
menuFor: aNode

	^ [self data: menuSelector for: aNode]
		on: MessageNotUnderstood
		do: ["Allow only some nodes to implement a menuSelector. This DNU is not expensive."]

	! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 1/22/2012 16:35:00.465'!
menuSelector
	^ menuSelector! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 1/22/2012 16:35:00.495'!
menuSelector: anObject
	menuSelector := anObject! !

!UiItemViewColumnSpec methodsFor: 'accessing' stamp: 'mt 6/26/2012 08:56:51.738'!
overrideStandardListFont
	"Check whether Preferences>>#standardListFont should NOT be used for all items, but custom text fonts are supported."
	
	^ overrideStandardListFont ifNil: [false]! !

!UiItemViewColumnSpec methodsFor: 'accessing' stamp: 'mt 6/26/2012 08:57:10.244'!
overrideStandardListFont: aBoolean

	overrideStandardListFont := aBoolean.! !

!UiItemViewColumnSpec methodsFor: 'accessing - nodes' stamp: 'mt 6/26/2012 13:11:09.727'!
selectableFor: aNode

	^ (self data: selectableSelector for: aNode) ifNil: [true]
	! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 6/26/2012 13:09:29.552'!
selectableSelector
	^ selectableSelector! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 6/26/2012 13:09:29.597'!
selectableSelector: anObject
	selectableSelector := anObject! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 1/22/2012 17:08:42.26'!
textConverter

	^ textConverter! !

!UiItemViewColumnSpec methodsFor: 'accessing - converting' stamp: 'mt 1/22/2012 17:07:33.389'!
textConverter: aBlock

	textConverter := aBlock.! !

!UiItemViewColumnSpec methodsFor: 'accessing - nodes' stamp: 'mt 2/12/2012 15:58:35.349'!
textFor: aNode

	^ self data: textSelector for: aNode

	! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 1/22/2012 16:35:00.219'!
textSelector
	^ textSelector! !

!UiItemViewColumnSpec methodsFor: 'accessing - selectors' stamp: 'mt 1/22/2012 16:35:00.25'!
textSelector: anObject
	textSelector := anObject! !

UiItemViewColumnSpec subclass: #UiItemViewSimpleColumnSpec
	instanceVariableNames: 'labelColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiItemViewSimpleColumnSpec commentStamp: 'mt 8/16/2012 09:26:04.678' prior: 0!
Performance-optimized version of the default column specification.!

!UiItemViewSimpleColumnSpec methodsFor: 'building' stamp: 'mt 8/16/2012 09:23:15.989'!
doLayoutFor: aMorph

	| offset |
	self itemOrientation = #horizontal ifTrue: [
		| formHeight |
		formHeight := aMorph form ifNil: [0] ifNotNil: [:f | f height].
		aMorph height: (aMorph font height max: formHeight).
				
		"Manual layouting."
		offset := 3 @ 1.
		aMorph form ifNotNil: [
			aMorph formPosition: (offset + (0@(aMorph height - aMorph form height // 2))).
			offset := offset + ((aMorph form width + 2) @ 0)].
		
		aMorph label ifNotNil: [
			aMorph labelPosition: (offset + (0@(aMorph font height - aMorph height // 2))).
			offset := offset + (((aMorph font widthOfString: aMorph label) + 2) @ 0)].
		
		"Expand item horizontally to its contents."
		aMorph
			width: offset x; "font rendering bugfix"
			height: aMorph height + 1. "font rendering bugfix"
		
		^ self].
	
	self itemOrientation = #vertical ifTrue: [
		| formWidth labelWidth |
		formWidth := aMorph form ifNil: [0] ifNotNil: [:f | f width].
		labelWidth := aMorph label ifNil: [0] ifNotNil: [:l | aMorph font widthOfString: l].
		
		aMorph width: (formWidth max: labelWidth) + 10.
			
		"Manual layouting."
		offset := 3.
		aMorph form ifNotNil: [
			aMorph formPosition: (aMorph width - formWidth // 2)@offset.
			offset := offset + aMorph form height + 2].
		
		aMorph label ifNotNil: [
			aMorph labelPosition: (aMorph width - labelWidth // 2)@offset.
			offset := offset + aMorph font height + 2].		
		
		aMorph height: offset].! !

!UiItemViewSimpleColumnSpec methodsFor: 'building' stamp: 'mt 6/29/2012 18:07:07.365'!
headerItem

	| item |	
	item := UiItemViewMorph new
		form: self headerIcon;
		label: self headerText asString;
		font: Preferences standardListFont;
		labelColor: Color black;
		balloonText: self headerBalloonText;	
		yourself.

	self doLayoutFor: item.	
	
	^ item! !

!UiItemViewSimpleColumnSpec methodsFor: 'building' stamp: 'mt 8/16/2012 09:25:38.497'!
itemFor: aNode

	| item emph text |	
	text := self textFor: aNode.
	emph := text isText
		ifFalse: [0]
		ifTrue: [((text attributesAt: 1) detect: [:att | att emphasisCode ~= 0] ifNone: [])
			ifNil: [0]
			ifNotNil: [:att | att emphasisCode]].
		
	item := UiItemViewMorph new
		form: (self iconFor: aNode);
		label: text asString;
		font: (Preferences standardListFont emphasized: emph);
		labelColor: self labelColor;
		balloonText: (self balloonTextFor: aNode);	
		setProperty: #selectable toValue: (self selectableFor: aNode);
		yourself.

	self doLayoutFor: item.	
	
	^ item! !

!UiItemViewSimpleColumnSpec methodsFor: 'accessing' stamp: 'mt 8/16/2012 09:12:06.096'!
labelColor

	^ labelColor ifNil: [labelColor := Color black]! !

!UiItemViewSimpleColumnSpec methodsFor: 'accessing' stamp: 'mt 8/16/2012 09:12:14.932'!
labelColor: aColor

	labelColor := aColor.! !

Object subclass: #UiItemViewDragDropSpec
	instanceVariableNames: 'dragEnabled dropEnabled source dragTransferType textSelector iconSelector dropMode acceptBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/19/2012 11:07:48.681'!
acceptBlock
	"See TransferMorph for accessible fields. This block is called to check whether the object should be dropped in the view that uses this spec."

	^ acceptBlock ifNil: [acceptBlock := [:transferMorph | true]]! !

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/19/2012 09:23:40.744'!
acceptBlock: aBlock

	acceptBlock := aBlock.! !

!UiItemViewDragDropSpec methodsFor: 'accessing - nodes' stamp: 'mt 7/18/2012 10:28:38.24'!
data: aSymbolOrIntegerOrBoolean for: aNode
	"Private. Access property directly or use a indirection via #properties in node. This makes tree nodes having different kinds of properties more flexible."
	
	| property |
	aSymbolOrIntegerOrBoolean ifNil: [^ nil].
	
	"Support hardcoded boolean defaults."
	aSymbolOrIntegerOrBoolean == true ifTrue: [^ true].
	aSymbolOrIntegerOrBoolean == false ifTrue: [^ false].
	
	"Support ordered properties referenced by an integer. Consider #properties in node."
	property := aSymbolOrIntegerOrBoolean isInteger
		ifTrue: [aNode properties at: aSymbolOrIntegerOrBoolean ifAbsent: []]
		ifFalse: [aSymbolOrIntegerOrBoolean].
	
	"Lookup property as accessor or key in dictionary."
	^ property ifNotNil: [:p | (p ~~ #yourself and: [aNode isDictionary])
		ifTrue: [aNode at: p ifAbsent: []]
		ifFalse: [aNode perform: p]]! !

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/18/2012 10:04:23.878'!
dragEnabled
	^ dragEnabled ifNil: [true]! !

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/18/2012 10:04:08.007'!
dragEnabled: anObject
	dragEnabled := anObject! !

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/19/2012 11:06:30.291'!
dragTransferType
	"Can be used to lookup the kind of data that was picked up in the view that uses this spec."

	^ dragTransferType! !

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/18/2012 10:21:32.514'!
dragTransferType: anObject
	dragTransferType := anObject! !

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/18/2012 10:04:35.402'!
dropEnabled
	^ dropEnabled ifNil: [true]! !

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/18/2012 10:04:08.045'!
dropEnabled: anObject
	dropEnabled := anObject! !

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/18/2012 10:57:29.844'!
dropMode
	"#over, #between"
	
	^ dropMode ifNil: [dropMode := #between]! !

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/18/2012 10:57:04.5'!
dropMode: anObject
	dropMode := anObject! !

!UiItemViewDragDropSpec methodsFor: 'accessing - nodes' stamp: 'mt 7/18/2012 10:28:59.403'!
iconFor: aNode

	^ self data: iconSelector for: aNode! !

!UiItemViewDragDropSpec methodsFor: 'accessing - selectors' stamp: 'mt 7/18/2012 10:27:22.919'!
iconSelector
	^ iconSelector! !

!UiItemViewDragDropSpec methodsFor: 'accessing - selectors' stamp: 'mt 7/18/2012 10:27:22.966'!
iconSelector: anObject
	iconSelector := anObject! !

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/18/2012 10:17:00.455'!
source
	^ source! !

!UiItemViewDragDropSpec methodsFor: 'accessing' stamp: 'mt 7/18/2012 10:17:00.503'!
source: anObject
	source := anObject! !

!UiItemViewDragDropSpec methodsFor: 'accessing - nodes' stamp: 'mt 7/25/2012 14:59:53.568'!
textFor: aNode

	^ (self data: textSelector for: aNode) ifNil: [aNode asString]! !

!UiItemViewDragDropSpec methodsFor: 'accessing - selectors' stamp: 'mt 7/18/2012 10:27:10.578'!
textSelector
	^ textSelector! !

!UiItemViewDragDropSpec methodsFor: 'accessing - selectors' stamp: 'mt 7/18/2012 10:27:10.622'!
textSelector: anObject
	textSelector := anObject! !

!UiItemViewDragDropSpec methodsFor: 'building' stamp: 'mt 8/9/2012 10:39:54.511'!
transferItemFor: someNodes

	| item draggedMorph |
	item := TransferMorph withPassenger: someNodes from: self source.
	item dragTransferType: self dragTransferType.
	
	draggedMorph := Morph new
		color: Color transparent;
		changeTableLayout;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
		
	someNodes size > 3
		ifTrue: [
			draggedMorph listDirection: #leftToRight.	
			draggedMorph
				addMorphBack: (UiFugueIcons documentsStackIcon asMorph);
				addMorphBack: ((self textFor: someNodes first) asString, '(', (someNodes size - 1) asString, ' more)') asMorph]
		ifFalse: [
			draggedMorph listDirection: #topToBottom.
			someNodes do: [:node |
				| row |
				row := Morph new
					color: Color transparent;
					changeTableLayout;
					listDirection: #leftToRight;
					hResizing: #shrinkWrap;
					vResizing: #shrinkWrap.

				(self iconFor: node) ifNotNil: [:form |
					row addMorphBack: form asMorph].
				row addMorphBack: (self textFor: node) asMorph.
				draggedMorph addMorphBack: row]].
	
	item draggedMorph: draggedMorph.
	item addMorphBack: draggedMorph.
	item fullBounds.

	^ item! !

Object subclass: #UiItemViewGroupSpec
	instanceVariableNames: 'hideIfFirst'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiItemViewGroupSpec methodsFor: 'building' stamp: 'mt 6/26/2012 11:14:22.127'!
doLayoutFor: aMorph

	| offset |
	aMorph submorphs last isTextMorph
		ifTrue: [ | fontHeight |
			fontHeight := aMorph submorphs last textStyle defaultFont height.
			(fontHeight * 2) < aMorph submorphs last height
				"More than one line?"
				ifTrue: [aMorph height: aMorph submorphs last height]
				ifFalse: [aMorph height: fontHeight]]
		ifFalse: [
			aMorph height: aMorph submorphs last height].
			
	"Manual layouting."
	offset := (aMorph left + 3) @ 1.
	aMorph submorphs do: [:m |
		m left: offset x.
		offset := offset + ((m width + 2) @ 0).
		m top: aMorph top - (m height - aMorph height // 2) + offset y].

	"Expand item horizontally to its contents."
	aMorph
		width: aMorph submorphBounds width + 5; "font rendering bugfix"
		height: aMorph height + 1. "font rendering bugfix"! !

!UiItemViewGroupSpec methodsFor: 'accessing' stamp: 'mt 6/28/2012 17:16:58.572'!
hideIfFirst
	"Configure visiblity of first group separator for top-level items."

	^ hideIfFirst ifNil: [true]! !

!UiItemViewGroupSpec methodsFor: 'accessing' stamp: 'mt 6/28/2012 17:16:23.937'!
hideIfFirst: aBoolean

	hideIfFirst := aBoolean.! !

!UiItemViewGroupSpec methodsFor: 'building' stamp: 'mt 6/28/2012 17:16:41.351'!
itemFor: aNode groupIndex: aGroupIndex isTopLevel: aBoolean
	"Create a morph that separates groups in item views."
	
	| icon text balloonText item |	
	aBoolean ifFalse: [
		item := Morph new
			color: Color transparent;
			extent: 6@6;
			yourself.
		item
			setProperty: #selectable toValue: false;
			setProperty: #drawLine toValue: false;
			setProperty: #hideIfFirst toValue: true;
			setProperty: #hideIfEmpty toValue: true.
		^ item].
	
	icon := nil.
	text := ('<font family="Bitmap Segoe UI" size="12" color="#0B61A4">', (aNode groups at: aGroupIndex), '</font>') asHtmlText.
	balloonText := nil.
		
	item := Morph new color: Color transparent.
		
	icon ifNotNil: [item addMorphBack: icon asMorph].
	text ifNotNil: [item addMorphBack: text asMorph lock].
	balloonText ifNotNil: [item balloonText: balloonText].
	
	self doLayoutFor: item.	
	
	item
		setProperty: #selectable toValue: true;
		setProperty: #drawLine toValue: true;
		setProperty: #hideIfFirst toValue: self hideIfFirst;
		setProperty: #hideIfEmpty toValue: false.
	
	^ item! !

!UiItemViewGroupSpec methodsFor: 'accessing' stamp: 'mt 6/26/2012 11:37:05.416'!
lineColor

	^ Color r: 11/255 g: 97/255 b: 164/255! !

UiItemViewGroupSpec subclass: #UiListViewGroupSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiListViewGroupSpec methodsFor: 'building' stamp: 'mt 6/28/2012 16:59:38.358'!
itemFor: aNode groupIndex: aGroupIndex isTopLevel: aBoolean
	"Create a morph that separates groups in item views."
	
	| item |	
	item := Morph new
		color: Color transparent;
		extent:1@6;
		yourself.
	item
		setProperty: #selectable toValue: false;
		setProperty: #drawLine toValue: true;
		setProperty: #hideIfFirst toValue: true;
		setProperty: #hideIfEmpty toValue: false.

	^ item! !

!UiListViewGroupSpec methodsFor: 'as yet unclassified' stamp: 'mt 6/28/2012 16:48:10.65'!
lineColor

	^ Color gray: 0.9! !

UiItemViewGroupSpec subclass: #UiTableViewGroupSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiTableViewGroupSpec methodsFor: 'building' stamp: 'mt 8/8/2012 13:06:25.896'!
itemFor: aNode groupIndex: aGroupIndex isTopLevel: aBoolean
	"Create a morph that separates groups in item views."
	
	| item |	
	item := Morph new
		color: Color transparent;
		extent: 6@1;
		yourself.
	item
		setProperty: #hideAlways toValue: true;
		setProperty: #selectable toValue: false.

	^ item! !

Object subclass: #UiIterator
	instanceVariableNames: 'root iteratorState iteratorPosition iteratorShadow process sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiIterator commentStamp: 'mt 8/8/2012 11:34:05.156' prior: 0!
An iterator for collections. Optionally concurrent.

f := UiIterator new.
f root: Smalltalk classNames.
self connect: f signal: #found: to: Transcript selector: #show:.
self connect: f signal: #found: to: Transcript selector: #show: pattern: {#=. String cr}.
self connect: f signal: #finished to: Transcript selector: #show: pattern: {#=. 'Done.'}.
f nextSatisfying: [:name | name includesSubstring: 'tool' caseSensitive: false] forkAt: 35.!

UiIterator subclass: #UiItemModelFinder
	instanceVariableNames: 'traversalMode rootIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiItemModelFinder commentStamp: 'mt 6/23/2011 17:18:46.568' prior: 0!
A helper class that allows to find model indices in an item model.

A column filter can be used to reduce the search operation to specific columns in a specific order. The amount of columns being searched has an impact on the performance.

The item model can be traversed #breadthFirst or #depthFirst (default).

A subset of the collection API is present (e.g., #do:, #detect:).

====
Example
====

| view model finder |
view := UiTreeView new.
model := UiSmalltalkModel new.
finder := UiItemModelFinder on: model.

finder
   columnFilter: #(1); "nur Spalte 1"
   traversalMode: #depthFirst. "standard; #breadthFirst mglich"

"Knoten finden und selektieren/ausklappen."
view currentIndex: (finder detect: [:modelIndex |
   modelIndex text asString startsWith: "Morph"]).

"Iterative Suche. Fr weiteren Index Code wiederholt ausfhren:"
view currentIndex: (finder nextSatisfying: [:modelIndex |
   modelIndex text asString startsWith: "Morph"]).
!

!UiItemModelFinder class methodsFor: 'instance creation' stamp: 'mt 2/2/2012 15:21:05.931'!
on: aNode

	^ self new
		root: aNode! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:31.949'!
allSatisfy: aBlock

	^ self allSatisfy: aBlock startingAt: self root! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:32.065'!
allSatisfy: aBlock startingAt: aNode

	self
		do: [:index | (aBlock value: index) ifFalse: [^ false]]
		startingAt: aNode.
		
	^ true! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:32.15'!
anySatisfy: aBlock

	^ self anySatisfy: aBlock startingAt: self root! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:32.237'!
anySatisfy: aBlock startingAt: aNode

	self
		do: [:index | (aBlock value: index) ifTrue: [^ true]]
		startingAt: aNode.
		
	^ false! !

!UiItemModelFinder methodsFor: 'collection api - private' stamp: 'mt 8/8/2012 11:02:35.254'!
childNodesFor: aParentNode

	^ aParentNode groups gather: [:group |
		(1 to: (aParentNode childCountInGroup: group)) collect: [:i | aParentNode childAt: i inGroup: group]]! !

!UiItemModelFinder methodsFor: 'iterator api - private' stamp: 'mt 8/8/2012 11:15:09.209'!
childrenFor: aParentModelIndex

	| node |
	node := aParentModelIndex
		ifNil: [self root]
		ifNotNil: [:index | index node].
	
	self flag: #performance. "mt: signal connections not necessary. see UiModelIndex>>connectIndex."
	^ (node groups gather: [:group | 
		| indices |
		indices := (1 to: (node childCountInGroup: group)) collect: [:i | 
			UiModelIndex
				row: i column: 1 group: group
				groupIndex: nil "not used"
				parent: aParentModelIndex
				node: (node childAt: i inGroup: group)
				spec: nil "not used"].
		self sortBlock ifNotNil: [:sb |
			"node unboxing"
			indices := indices sortBy: [:i1 :i2 | sb value: i1 node value: i2 node]].
		indices]) asOrderedCollection! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:32.323'!
count: aBlock

	^ self count: aBlock startingAt: self root! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:32.408'!
count: aBlock startingAt: aNode

	| sum |
	sum := 0.
	self
		do: [:each | (aBlock value: each) ifTrue: [sum := sum + 1]]
		startingAt: aNode.
	^ sum! !

!UiItemModelFinder methodsFor: 'iterator api' stamp: 'mt 8/8/2012 11:06:35.642'!
current

	(iteratorPosition isNil or: [iteratorPosition = 0])
		ifTrue: [^ self root].

	^ self currentIndex ifNotNil: [:index | index node]! !

!UiItemModelFinder methodsFor: 'iterator api - private' stamp: 'mt 8/8/2012 11:08:21.665'!
currentIndex

	(iteratorPosition isNil or: [iteratorPosition = 0])
		ifTrue: [^ self rootIndex].
		
	iteratorPosition > iteratorState size
		ifTrue: [^ nil "at end"].
	
	^ iteratorState at: iteratorPosition! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:32.494'!
detect: aBlock

	^ self
		detect: aBlock
		ifNone: [Error signal: 'Object is not in the collection.']! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:32.579'!
detect: aBlock ifNone: exceptionBlock

	^ self
		detect: aBlock
		ifNone: exceptionBlock
		startingAt: self root
		! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:32.665'!
detect: aBlock ifNone: exceptionBlock startingAt: aNode

	self
		do: [:index | (aBlock value: index) ifTrue: [^ index]]
		startingAt: aNode.
		
	^ exceptionBlock value! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:32.75'!
detect: aBlock startingAt: aNode

	^ self
		detect: aBlock
		ifNone: [Error signal: 'Object is not in the collection.']
		startingAt: aNode! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:32.837'!
do: aBlock
	
	self do: aBlock startingAt: self root.! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:32.923'!
do: aBlock startingAt: aNode
	"Startng index WILL NOT be evaluated."
	
	self traversalMode == #depthFirst
		ifTrue: [self doDepthFirst: aBlock startingAt: aNode].
	self traversalMode == #breadthFirst
		ifTrue: [self doBreadthFirst: aBlock startingAt: aNode].! !

!UiItemModelFinder methodsFor: 'collection api - private' stamp: 'mt 8/8/2012 10:58:06.684'!
doBreadthFirst: aBlock startingAt: aNode
	"Breadth-first search."
	
	| nextChildren |
	nextChildren := (self childNodesFor: aNode) asOrderedCollection.
		
	[nextChildren notEmpty] whileTrue: [
		| nextChild |
		nextChild := nextChildren removeFirst.
		nextChildren addAll: (self childNodesFor: nextChild).
		aBlock value: nextChild].! !

!UiItemModelFinder methodsFor: 'collection api - private' stamp: 'mt 8/8/2012 10:58:11.368'!
doDepthFirst: aBlock startingAt: aNode
	"Depth-search."

	| nextChildren |
	nextChildren := (self childNodesFor: aNode) asOrderedCollection.
		
	[nextChildren notEmpty] whileTrue: [
		| nextChild |
		nextChild := nextChildren removeFirst.
		nextChildren addAllFirst: (self childNodesFor: nextChild).
		aBlock value: nextChild].! !

!UiItemModelFinder methodsFor: 'iterator api - signals' stamp: 'mt 8/8/2012 11:05:29.649'!
foundIndex: aModelIndex

	self emit.! !

!UiItemModelFinder methodsFor: 'iterator api - testing' stamp: 'mt 8/8/2012 11:04:45.763'!
hasPrevious

	^ self currentIndex ~= self rootIndex or: [self hasFinished]! !

!UiItemModelFinder methodsFor: 'iterator api - private' stamp: 'mt 8/8/2012 11:14:18.123'!
insertNextRows

	| newRows |
	newRows := self childrenFor: self currentIndex.

	self traversalMode = #depthFirst ifTrue: [
		newRows reverseDo: [:row |
			iteratorState add: row afterIndex: iteratorPosition]].
	self traversalMode = #breadthFirst ifTrue: [
		iteratorState addAll: newRows].! !

!UiItemModelFinder methodsFor: 'iterator api' stamp: 'mt 8/8/2012 11:09:40.15'!
next

	^ self nextIndex ifNotNil: [:index | index node]! !

!UiItemModelFinder methodsFor: 'iterator api - private' stamp: 'mt 8/8/2012 11:09:22.364'!
nextIndex

	"Already at end?"
	(iteratorPosition notNil and: [self currentIndex isNil])
		ifTrue: [^ self currentIndex "nil"].

	"Initialize after #reset."
	iteratorState ifNil: [iteratorState := OrderedCollection new].
	iteratorPosition ifNil: [iteratorPosition := 0].
	iteratorShadow ifNil: [iteratorShadow := 0].

	"Append new rows if necessary."
	iteratorPosition = iteratorShadow
		ifTrue: [self insertNextRows].
	
	self incrementIteratorPosition.
	
	^ self currentIndex! !

!UiItemModelFinder methodsFor: 'iterator api' stamp: 'mt 8/8/2012 11:12:37.654'!
nextSatisfying: aBlock forkAt: aPriority
	"Asynchronous version of #nextSatisfying:. The signal #indexFound: will be emitted when operation has finished."

	self fork: [
		| node |
		[(node := self next) notNil] whileTrue: [
			(aBlock value: node) ifTrue: [self found: node; foundIndex: self currentIndex]].
		self finished] at: aPriority.! !

!UiItemModelFinder methodsFor: 'iterator api' stamp: 'mt 8/8/2012 11:10:19.443'!
previous

	^ self previousIndex
		ifNil: [self root "the beginning"]
		ifNotNil: [:index | index node]! !

!UiItemModelFinder methodsFor: 'iterator api - private' stamp: 'mt 8/8/2012 11:10:27.701'!
previousIndex

	"Was resetted but not used yet?"
	iteratorPosition ifNil: [^ self rootIndex].
		
	self decrementIteratorPosition.
	
	^ self currentIndex! !

!UiItemModelFinder methodsFor: 'iterator api' stamp: 'mt 8/8/2012 11:13:15.792'!
previousSatisfying: aBlock forkAt: aPriority
	"Asynchronous version of #previousSatisfying:. The signal #indexFound: will be emitted when operation has finished."

	self fork: [
		| node |
		[(node := self previous) ~= self root] whileTrue: [
			(aBlock value: node) ifTrue: [self found: node; foundIndex: self currentIndex]].
		self finished] at: aPriority.! !

!UiItemModelFinder methodsFor: 'iterator api' stamp: 'mt 8/8/2012 13:00:04.099'!
reset

	iteratorState := nil.
	iteratorPosition := nil.
	iteratorShadow := nil.
	process ifNotNil: [
		process terminate.
		process := nil].! !

!UiItemModelFinder methodsFor: 'accessing' stamp: 'mt 2/7/2012 16:29:20.307'!
rootIndex

	^ rootIndex! !

!UiItemModelFinder methodsFor: 'accessing' stamp: 'mt 2/7/2012 16:34:29.816'!
rootIndex: aModelIndex

	rootIndex := aModelIndex.
	self root: aModelIndex node.! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:33.009'!
select: aBlock

	^ self select: aBlock startingAt: self root! !

!UiItemModelFinder methodsFor: 'collection api' stamp: 'mt 8/8/2012 11:02:33.097'!
select: aBlock startingAt: aNode

	| newCollection |
	newCollection := OrderedCollection new.
	self
		do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]]
		startingAt: aNode.
		
	^ newCollection! !

!UiItemModelFinder methodsFor: 'accessing' stamp: 'mt 6/23/2011 14:27:35.279'!
traversalMode

	^ traversalMode ifNil: [traversalMode := #depthFirst]! !

!UiItemModelFinder methodsFor: 'accessing' stamp: 'mt 2/7/2012 15:48:34.252'!
traversalMode: aSymbol
	"#depthFirst, #breadthFirst"

	traversalMode = aSymbol ifTrue: [^ self].
	traversalMode := aSymbol.
	self reset.! !

!UiIterator methodsFor: 'iterator api - signals' stamp: 'mt 8/8/2012 10:56:53.059'!
cancelled

	self emit.! !

!UiIterator methodsFor: 'iterator api' stamp: 'mt 8/8/2012 11:08:52.98'!
current

	(iteratorPosition isNil or: [iteratorPosition = 0])
		ifTrue: [^ self root].
		
	iteratorPosition > iteratorState size
		ifTrue: [^ nil "at end"].
	
	^ iteratorState at: iteratorPosition! !

!UiIterator methodsFor: 'iterator api - private' stamp: 'mt 8/8/2012 10:56:50.666'!
decrementIteratorPosition

	iteratorPosition := iteratorPosition - 1 max: 0.! !

!UiIterator methodsFor: 'iterator api - signals' stamp: 'mt 8/8/2012 10:56:53.178'!
finished

	self emit.! !

!UiIterator methodsFor: 'iterator api - private' stamp: 'mt 8/8/2012 10:56:50.751'!
fork: aBlock at: aPriority

	process ifNotNil: [
		process terminate.
		self cancelled].

	process := aBlock forkAt: aPriority.! !

!UiIterator methodsFor: 'iterator api - signals' stamp: 'mt 8/8/2012 10:56:53.263'!
found: aNode

	self emit.! !

!UiIterator methodsFor: 'iterator api - testing' stamp: 'mt 8/8/2012 10:56:55.198'!
hasFinished

	^ iteratorPosition notNil and: [iteratorPosition > iteratorState size]! !

!UiIterator methodsFor: 'iterator api - testing' stamp: 'mt 8/8/2012 10:56:55.329'!
hasNext

	^ self hasFinished not! !

!UiIterator methodsFor: 'iterator api - testing' stamp: 'mt 8/8/2012 11:05:15.654'!
hasPrevious

	^ self current ~= self root first or: [self hasFinished]! !

!UiIterator methodsFor: 'iterator api - private' stamp: 'mt 8/8/2012 10:56:50.836'!
incrementIteratorPosition

	iteratorPosition := iteratorPosition + 1 min: iteratorState size + 1.
	
	iteratorShadow < iteratorPosition
		ifTrue: [iteratorShadow := iteratorPosition].! !

!UiIterator methodsFor: 'iterator api - private' stamp: 'mt 8/8/2012 11:21:51.957'!
insertNextRows

	iteratorState addAll: (self sortBlock
		ifNil: [self root asOrderedCollection]
		ifNotNil: [:sb | self root sortBy: sb])
	! !

!UiIterator methodsFor: 'iterator api - testing' stamp: 'mt 8/8/2012 10:56:55.501'!
isRunning

	^ process notNil! !

!UiIterator methodsFor: 'iterator api' stamp: 'mt 8/8/2012 11:41:13.566'!
next

	"Already at end?"
	(iteratorPosition notNil and: [self current isNil])
		ifTrue: [^ self current "nil"].

	"Initialize after #reset."
	iteratorPosition ifNil: [iteratorPosition := 0].
	iteratorShadow ifNil: [iteratorShadow := 0].
	
	self incrementIteratorPosition.
	
	^ self current! !

!UiIterator methodsFor: 'iterator api' stamp: 'mt 8/8/2012 10:56:47.985'!
nextSatisfying: aBlock

	| node |
	[(node := self next) notNil] whileTrue: [
		(aBlock value: node) ifTrue: [^ node]].
	^ nil! !

!UiIterator methodsFor: 'iterator api' stamp: 'mt 8/8/2012 11:12:55.301'!
nextSatisfying: aBlock forkAt: aPriority
	"Asynchronous version of #nextSatisfying:. The signal #indexFound: will be emitted when operation has finished."

	self fork: [
		| node |
		[(node := self next) notNil] whileTrue: [
			(aBlock value: node) ifTrue: [self found: node]].
		self finished] at: aPriority.! !

!UiIterator methodsFor: 'iterator api' stamp: 'mt 8/8/2012 11:10:52.077'!
previous

	"Was resetted but not used yet?"
	iteratorPosition ifNil: [^ self root].
		
	self decrementIteratorPosition.
	
	^ self current! !

!UiIterator methodsFor: 'iterator api' stamp: 'mt 8/8/2012 10:56:48.284'!
previousSatisfying: aBlock

	| node |
	[(node := self previous) ~= self root] whileTrue: [
		(aBlock value: node) ifTrue: [^ node]].
	^ nil! !

!UiIterator methodsFor: 'iterator api' stamp: 'mt 8/8/2012 11:13:20.11'!
previousSatisfying: aBlock forkAt: aPriority
	"Asynchronous version of #previousSatisfying:. The signal #indexFound: will be emitted when operation has finished."

	self fork: [
		| node |
		[(node := self previous) ~= self root] whileTrue: [
			(aBlock value: node) ifTrue: [self found: node]].
		self finished] at: aPriority.! !

!UiIterator methodsFor: 'iterator api' stamp: 'mt 8/8/2012 11:38:30.11'!
reset

	iteratorState := (self sortBlock
		ifNil: [self root asOrderedCollection]
		ifNotNil: [:sb | self root sortBy: sb]).
	
	iteratorPosition := nil.
	iteratorShadow := nil.
	process ifNotNil: [
		process terminate.
		process := nil].! !

!UiIterator methodsFor: 'accessing' stamp: 'mt 8/8/2012 10:56:08.628'!
root

	^ root! !

!UiIterator methodsFor: 'accessing' stamp: 'mt 8/8/2012 10:56:10.689'!
root: aNode

	root = aNode ifTrue: [^ self].
	root := aNode.
	self reset.! !

!UiIterator methodsFor: 'accessing' stamp: 'mt 8/8/2012 10:56:13.772'!
sortBlock

	^ sortBlock ifNil: [sortBlock := [:node1 :node2 | true]]! !

!UiIterator methodsFor: 'accessing' stamp: 'mt 8/8/2012 10:56:15.841'!
sortBlock: aBlock

	sortBlock := aBlock.
	self reset.! !

Object subclass: #UiListWidgetModel
	uses: TUiItemModel
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiListWidgetModel commentStamp: 'mt 10/20/2010 14:12:24.921' prior: 0!
I am the hidden model used in the item-based UiListWidget.!

UiListWidgetModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!UiListWidgetModel methodsFor: 'add/remove items' stamp: 'mt 4/22/2012 16:08:52.662'!
addItem: aListWidgetItem

	self items add: aListWidgetItem.
	self connect: aListWidgetItem signal: #deleted toSelector: #removeItem: pattern: #(0).
	
	self childInserted: self childCount inGroup: #items.! !

!UiListWidgetModel methodsFor: 'add/remove items' stamp: 'mt 4/22/2012 16:09:04.862'!
addItems: someListWidgetItems

	self items addAll: someListWidgetItems.
	someListWidgetItems do: [:item |
		self connect: item signal: #deleted toSelector: #removeItem: pattern: #(0)].
	
	self
		childrenInsertedFrom: self childCount - someListWidgetItems size + 1
		to: self childCount
		inGroup: #items.! !

!UiListWidgetModel methodsFor: 'item model - hierarchy' stamp: 'mt 4/22/2012 16:08:25.685'!
groups
	
	^ #(items)! !

!UiListWidgetModel methodsFor: 'accessing' stamp: 'mt 11/2/2010 16:08:35.329'!
indexOf: anItem

	^ self items indexOf: anItem! !

!UiListWidgetModel methodsFor: 'add/remove items' stamp: 'mt 4/22/2012 16:09:13.731'!
insertItem: aListWidgetItem at: anIndex

	self items add: aListWidgetItem beforeIndex: anIndex.
	self connect: aListWidgetItem signal: #deleted toSelector: #removeItem: pattern: #(0).
	
	self childInserted: anIndex inGroup: #items.! !

!UiListWidgetModel methodsFor: 'accessing' stamp: 'mt 10/19/2010 19:37:20.66'!
items

	^ items ifNil: [items := OrderedCollection new]! !

!UiListWidgetModel methodsFor: 'add/remove items' stamp: 'mt 2/2/2012 16:17:22.404'!
removeItem: aListWidgetItem

	self removeItemAt: (self items indexOf: aListWidgetItem).! !

!UiListWidgetModel methodsFor: 'add/remove items' stamp: 'mt 4/22/2012 16:09:39.371'!
removeItemAt: anIndex

	self items removeAt: anIndex.
	self childRemoved: anIndex inGroup: #items.! !

Object subclass: #UiNullMutex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Events'!

!UiNullMutex commentStamp: 'mt 3/28/2011 10:14:51.28' prior: 0!
This is a null mutex that understands #critical: but does not secure anything.!

!UiNullMutex class methodsFor: 'critical' stamp: 'mt 3/28/2011 10:14:29.075'!
critical: aBlock

	^ aBlock value! !

Object subclass: #UiPainter
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Painter'!

UiPainter subclass: #UiGlossyPainter
	instanceVariableNames: 'orientation fraction highlight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Painter'!

!UiGlossyPainter methodsFor: 'colors' stamp: 'mt 1/6/2012 09:39:08.895'!
color

	self morph hasKeyboard
		ifTrue: [^ (Color r: 0.0 g: 0.0 b: 0.5) muchLighter paler].
		
	^ super color! !

!UiGlossyPainter methodsFor: 'colors' stamp: 'mt 1/2/2012 16:35:41.31'!
colorBorder
	"By default, the border color is computed from the base color."
	
	^ self color mixed: 0.65 with: Color black! !

!UiGlossyPainter methodsFor: 'colors' stamp: 'mt 1/6/2012 09:51:30.651'!
colorChanged

	^ Color yellow muchLighter paler! !

!UiGlossyPainter methodsFor: 'colors' stamp: 'mt 1/2/2012 16:40:59.129'!
colorHighlight
	"The highlight can be used to intensify the bevel effect."

	^ self morph
		valueOfProperty: #colorHighlight
		ifAbsentPut: [Color white]! !

!UiGlossyPainter methodsFor: 'highlight' stamp: 'mt 1/2/2012 16:46:41.465'!
disableHighlight

	fraction := 0.5.
	highlight := false.! !

!UiGlossyPainter methodsFor: 'drawing - specific' stamp: 'mt 1/5/2012 16:27:49.592'!
drawComboBoxEnabledOn: aCanvas

	self morph readOnly ifTrue: [^ self].
	
	self drawTextEdit: self morph on: aCanvas.! !

!UiGlossyPainter methodsFor: 'drawing - specific' stamp: 'mt 1/6/2012 09:54:58.584'!
drawComboBoxOverlayEnabledOn: aCanvas

	| b |
	self morph readOnly ifFalse: [
		(self morph arrowButton raised not
			and: [self morph arrowButton down not]
			and: [self morph arrowButton checked not]) ifTrue: [
			aCanvas
				fillRectangle: (self morph arrowButton topLeft - (2@0) corner: self morph arrowButton bottomLeft + (2@0))
				color: self color].
		
		^ self].
	
	
	b := self morph readOnly
		ifTrue: [self morph readOnlyButton outerBounds]
		ifFalse: [self morph lineEdit outerBounds].
	
	aCanvas
		line: b topCenter
		to: self morph button outerBounds topCenter
		width: 1
		color: (self color mixed: 0.65 with: Color black).
		
	aCanvas
		line: b bottomCenter - (0@1)
		to: self morph button outerBounds bottomCenter - (0@1)
		width: 1
		color: (self color mixed: 0.65 with: Color black).! !

!UiGlossyPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 11:29:38.667'!
drawLineEditEnabledOn: aCanvas

	| font |
	self drawTextEditEnabledOn: aCanvas.
	
	"Draw help text."
	(self morph helpText isEmpty or: [self morph textMorph contents notEmpty]) ifTrue: [^ self].

	font := self morph textMorph textStyle defaultFont.

	aCanvas
		drawString: self morph helpText 
		in: (self bounds translateBy: 5 @ (self bounds height - font height // 2))
		font: font
		color: (Color gray: 0.7).! !

!UiGlossyPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:29:19.824'!
drawPushButtonDisabledOn: aCanvas

	"Border outer"
	aCanvas
		frameRoundRect: self outerBounds radius: 3 width: 1
		color: ((self colorBorder mixed: 0.8 with: self colorLighten) alpha: 0.5).
	
	aCanvas
		frameRoundRect: self outerBounds radius: 4 width: 1
		color: (self colorBorder mixed: 0.8 with: self colorLighten).! !

!UiGlossyPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:32:03.882'!
drawPushButtonEnabledOn: aCanvas

	| upperFillStyleInnerBorder lowerFillStyleInnerBorder upperFillStyleBackground lowerFillStyleBackground colorBorder |
	upperFillStyleInnerBorder :=
		self morph down ifTrue: [
			self fillStyleUpper mixed: 0.8 with: self colorDarken] ifFalse: [
		self morph checked ifTrue: [
			self fillStyleUpper mixed: 0.85 with: self colorDarken] ifFalse: [
		"normal"
			self fillStyleUpper mixed: 0.3 with: self colorLighten]].
	lowerFillStyleInnerBorder :=
		self morph down ifTrue: [
			self fillStyleLower mixed: 0.85 with: self colorDarken] ifFalse: [
		self morph checked ifTrue: [
			self fillStyleLower mixed: 0.9 with: self colorDarken] ifFalse: [
		"normal"
			self fillStyleLower mixed: 0.65 with: self colorLighten]].
	upperFillStyleBackground :=
		self morph down ifTrue: [
			self fillStyleUpper mixed: 0.9 with: self colorDarken] ifFalse: [
		self morph checked ifTrue: [
			self fillStyleUpper mixed: 0.95 with: self colorDarken] ifFalse: [
		"normal"
			self fillStyleUpper]].
	lowerFillStyleBackground :=
		self morph down ifTrue: [
			self fillStyleLower mixed: 0.9 with: self colorDarken] ifFalse: [
		self morph checked ifTrue: [
			self fillStyleLower mixed: 0.95 with: self colorDarken] ifFalse: [
		"normal"
			self fillStyleLower]].
	colorBorder :=
		self morph down ifTrue: [
			self colorBorder mixed: 0.9 with: self colorDarken] ifFalse: [
		self morph checked ifTrue: [
			self colorBorder mixed: 0.95 with: self colorDarken] ifFalse: [
		"normal"
			self colorBorder]].	
	
	"Bevel --- Needs to be overdrawn by background due to limitations in Balloon engine."
	aCanvas fillRectangle: self upperBounds fillStyle: upperFillStyleInnerBorder.
	aCanvas fillRectangle: self lowerBounds fillStyle: lowerFillStyleInnerBorder.

	"Background"
	aCanvas fillRectangle: self innerUpperBounds fillStyle: upperFillStyleBackground.
	aCanvas fillRectangle: self innerLowerBounds fillStyle: lowerFillStyleBackground.

	"Border"
	aCanvas
		frameRoundRect: self outerBounds radius: 3 width: 1
		color: (colorBorder alpha: 0.5).
		
	aCanvas
		frameRoundRect: self outerBounds radius: 4 width: 1
		color: colorBorder.
! !

!UiGlossyPainter methodsFor: 'drawing - specific' stamp: 'mt 2/15/2012 15:49:47.119'!
drawTextEditEnabledOn: aCanvas

	| fillStyleLower fillStyleUpper c |.
	c := (self morph hasKeyboard not and: [self morph hasUnacceptedChanges])
		ifTrue: [self colorChanged]
		ifFalse: [self color].
	
	self morph outerBorderWidth > 0 ifTrue: [
		fillStyleLower := self fillStyleLower colorRamp:  {
			0.0 -> (c mixed: 0.81 with: self colorDarken).
			1.0 -> (c mixed: 0.85 with: self colorDarken)}.
		fillStyleUpper := self fillStyleUpper colorRamp: {
			0.0 -> (c mixed: 0.72 with: self colorDarken).
			1.0 -> (c mixed: 0.76 with: self colorDarken)}.

		aCanvas
			fillRectangle: (self upperBounds outsetBy: (1@0 corner: 1@0))
			fillStyle: fillStyleUpper.
		
		aCanvas
			fillRectangle: (self lowerBounds outsetBy: (1@0 corner: 1@0))
			fillStyle: fillStyleLower.
		
		aCanvas
			line: self outerBounds topLeft + (1@0)
			to: self outerBounds topRight - (2@0)
			width: 1
			color: fillStyleUpper colorRamp first value.

		aCanvas
			line: self outerBounds bottomLeft + (1@ -1)
			to: self outerBounds bottomRight - (2@ 1)
			width: 1
			color: fillStyleLower colorRamp last value.
	].

	"Fill background."
	aCanvas
		fillRoundRect: self bounds
		radius: 3
		fillStyle: (SolidFillStyle color: c).
! !

!UiGlossyPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:30:07.98'!
drawToolButtonEnabledOn: aCanvas

	"Consider #autoRaise flag."
	(self morph checked not
		and: [self morph autoRaise]
		and: [self morph raised not])
			ifTrue: [^ self].

	"Reuse drawing code from push buttons."
	self enableHighlight.
	self drawPushButtonEnabledOn: aCanvas.! !

!UiGlossyPainter methodsFor: 'highlight' stamp: 'mt 1/2/2012 16:46:51.295'!
enableHighlight

	fraction := 0.4.
	highlight := true.! !

!UiGlossyPainter methodsFor: 'colors - fillstyles' stamp: 'mt 1/2/2012 16:57:27.324'!
fillStyleHighlight

	^ (GradientFillStyle ramp: {
		0.0 -> (self color mixed: 0.6 with: self colorLighten).
		0.8 -> (self color mixed: 0.8 with: self colorDarken)})
	origin: (self orientation == #horizontal
		ifTrue: [self innerLowerBounds bottomCenter]
		ifFalse: [self innerLowerBounds rightCenter]);
	radial: true;
	direction: (self orientation == #horizontal
		ifTrue: [0 @ self innerLowerBounds height negated]
		ifFalse: [self innerLowerBounds width negated @ 0]);
	normal: (self orientation == #horizontal
		ifTrue: [(self innerLowerBounds width * 2) @ 0]
		ifFalse: [0 @ (self innerLowerBounds height * 2)])! !

!UiGlossyPainter methodsFor: 'colors - fillstyles' stamp: 'mt 1/2/2012 17:02:19.14'!
fillStyleLower

	highlight == true ifTrue: [^ self fillStyleHighlight].

	^ (GradientFillStyle ramp: {
		0.0 -> (self color mixed: 0.85 with: self colorDarken).
		1.0 -> (self color mixed: 0.8 with: self colorDarken)})
	origin: self lowerBounds topLeft;
	direction: (self orientation == #horizontal
		ifTrue: [0 @ self lowerBounds height]
		ifFalse: [self lowerBounds width @ 0])! !

!UiGlossyPainter methodsFor: 'colors - fillstyles' stamp: 'mt 1/2/2012 16:48:31.811'!
fillStyleUpper

	^ (GradientFillStyle ramp: {
		0.0 -> (self color mixed: 0.6 with: self colorLighten).
		1.0 -> (self color mixed: 0.9 with: self colorDarken)})
	origin: self upperBounds topLeft;
	direction: (self orientation == #horizontal
		ifTrue: [0 @ self upperBounds height]
		ifFalse: [self upperBounds width @ 0])! !

!UiGlossyPainter methodsFor: 'accessing' stamp: 'mt 12/15/2011 15:16:42.956'!
fraction

	^ fraction ifNil: [fraction := 0.5]! !

!UiGlossyPainter methodsFor: 'geometry' stamp: 'mt 1/2/2012 16:09:18.494'!
innerLowerBounds

	^ self lowerBounds insetBy: (
		(self orientation == #horizontal ifTrue: [1@0] ifFalse: [0@1]) corner: 1@1)! !

!UiGlossyPainter methodsFor: 'geometry' stamp: 'mt 1/2/2012 16:09:25.369'!
innerUpperBounds

	^ self upperBounds insetBy: (1@1 corner: 
		(self orientation == #horizontal ifTrue: [1@0] ifFalse: [0@1]))! !

!UiGlossyPainter methodsFor: 'geometry' stamp: 'mt 1/2/2012 16:08:34.379'!
lowerBounds

	| b |
	b := self bounds.
	^ self orientation == #horizontal
		ifTrue: [b insetBy: (0@(b height * self fraction) corner: 0@0)]
		ifFalse: [b insetBy: ((b width * self fraction)@0 corner: 0@0)]! !

!UiGlossyPainter methodsFor: 'accessing' stamp: 'mt 1/2/2012 17:01:41.212'!
orientation

	^ (self morph respondsTo: #orientation)
		ifTrue: [self morph orientation]
		ifFalse: [#horizontal]! !

!UiGlossyPainter methodsFor: 'geometry' stamp: 'mt 1/2/2012 16:08:02.77'!
upperBounds

	| b |
	b := self bounds.
	^ self orientation == #horizontal
		ifTrue: [b insetBy: (0@0 corner: 0@(b height * (1 - self fraction)))]
		ifFalse: [b insetBy: (0@0 corner: (b width * (1 - self fraction))@ 0)]! !

!UiPainter class methodsFor: 'default painter' stamp: 'mt 1/2/2012 16:58:44.393'!
default

	^ UiGlossyPainter! !

!UiPainter class methodsFor: 'code generation' stamp: 'mt 1/10/2012 10:28:17.227'!
generateDrawMethods

	(PackageInfo named: #Widgets) classes 
		select: [:cls | (cls inheritsFrom: Morph) and: [cls isWidgetClass]]
		thenDo: [:cls | | qname src msg |
			qname := cls name allButFirst: 2. "Remove 'Ui' prefix."
			msg := '"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."'.
			src := 'draw{1}: a{1} {2}: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: a{1}.
	a{1} enabled
		ifTrue: [self draw{1}{3}EnabledOn: aCanvas]
		ifFalse: [self draw{1}{3}DisabledOn: aCanvas].'.
	
			UiPainter
				compile: (src format: {qname. 'on'. ''})
				classified: #drawing;
				compile: (src format: {qname. 'overlayOn'. 'Overlay'})
				classified: #drawing;
				compile: ('draw{1}EnabledOn: aCanvas
	{2}' format: {qname. msg})
				classified: #'drawing - specific';
				compile: ('draw{1}DisabledOn: aCanvas
	{2}' format: {qname. msg})
				classified: #'drawing - specific';
				compile: ('draw{1}OverlayEnabledOn: aCanvas
	{2}' format: {qname. msg})
				classified: #'drawing - specific';
				compile: ('draw{1}OverlayDisabledOn: aCanvas
	{2}' format: {qname. msg})
				classified: #'drawing - specific'].! !

!UiPainter methodsFor: 'geometry' stamp: 'mt 1/2/2012 14:30:37.672'!
bounds

	^ self morph bounds! !

!UiPainter methodsFor: 'colors' stamp: 'mt 1/2/2012 16:30:53.124'!
color

	^ self morph color! !

!UiPainter methodsFor: 'colors' stamp: 'mt 1/2/2012 16:33:07.253'!
colorBorder

	^ self morph borderColor! !

!UiPainter methodsFor: 'colors' stamp: 'mt 1/6/2012 09:51:10.404'!
colorChanged
	"Indicate pending changes that have not been saved."

	^ self color! !

!UiPainter methodsFor: 'colors' stamp: 'mt 1/2/2012 16:35:02.762'!
colorDarken

	^ self morph
		valueOfProperty: #colorDarken
		ifAbsentPut: [Color black]! !

!UiPainter methodsFor: 'colors' stamp: 'mt 1/2/2012 16:35:13.358'!
colorLighten

	^ self morph
		valueOfProperty: #colorLighten
		ifAbsentPut: [Color white]! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:18.887'!
drawButtonGroup: aButtonGroup on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aButtonGroup.
	aButtonGroup enabled
		ifTrue: [self drawButtonGroupEnabledOn: aCanvas]
		ifFalse: [self drawButtonGroupDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:18.911'!
drawButtonGroup: aButtonGroup overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aButtonGroup.
	aButtonGroup enabled
		ifTrue: [self drawButtonGroupOverlayEnabledOn: aCanvas]
		ifFalse: [self drawButtonGroupOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:18.937'!
drawButtonGroupDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:18.928'!
drawButtonGroupEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:18.953'!
drawButtonGroupOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:18.945'!
drawButtonGroupOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:18.961'!
drawCheckBox: aCheckBox on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aCheckBox.
	aCheckBox enabled
		ifTrue: [self drawCheckBoxEnabledOn: aCanvas]
		ifFalse: [self drawCheckBoxDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:18.97'!
drawCheckBox: aCheckBox overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aCheckBox.
	aCheckBox enabled
		ifTrue: [self drawCheckBoxOverlayEnabledOn: aCanvas]
		ifFalse: [self drawCheckBoxOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:18.986'!
drawCheckBoxDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:18.978'!
drawCheckBoxEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.001'!
drawCheckBoxOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:18.993'!
drawCheckBoxOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.009'!
drawComboBox: aComboBox on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aComboBox.
	aComboBox enabled
		ifTrue: [self drawComboBoxEnabledOn: aCanvas]
		ifFalse: [self drawComboBoxDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.017'!
drawComboBox: aComboBox overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aComboBox.
	aComboBox enabled
		ifTrue: [self drawComboBoxOverlayEnabledOn: aCanvas]
		ifFalse: [self drawComboBoxOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.033'!
drawComboBoxDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.026'!
drawComboBoxEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.048'!
drawComboBoxOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.041'!
drawComboBoxOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.056'!
drawContainer: aContainer on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aContainer.
	aContainer enabled
		ifTrue: [self drawContainerEnabledOn: aCanvas]
		ifFalse: [self drawContainerDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.064'!
drawContainer: aContainer overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aContainer.
	aContainer enabled
		ifTrue: [self drawContainerOverlayEnabledOn: aCanvas]
		ifFalse: [self drawContainerOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.081'!
drawContainerDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.073'!
drawContainerEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.096'!
drawContainerOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.088'!
drawContainerOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.104'!
drawLabel: aLabel on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aLabel.
	aLabel enabled
		ifTrue: [self drawLabelEnabledOn: aCanvas]
		ifFalse: [self drawLabelDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.112'!
drawLabel: aLabel overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aLabel.
	aLabel enabled
		ifTrue: [self drawLabelOverlayEnabledOn: aCanvas]
		ifFalse: [self drawLabelOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.128'!
drawLabelDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.121'!
drawLabelEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.144'!
drawLabelOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.136'!
drawLabelOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.151'!
drawLineEdit: aLineEdit on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aLineEdit.
	aLineEdit enabled
		ifTrue: [self drawLineEditEnabledOn: aCanvas]
		ifFalse: [self drawLineEditDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.159'!
drawLineEdit: aLineEdit overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aLineEdit.
	aLineEdit enabled
		ifTrue: [self drawLineEditOverlayEnabledOn: aCanvas]
		ifFalse: [self drawLineEditOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.175'!
drawLineEditDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.167'!
drawLineEditEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.19'!
drawLineEditOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.183'!
drawLineEditOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.198'!
drawListView: aListView on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aListView.
	aListView enabled
		ifTrue: [self drawListViewEnabledOn: aCanvas]
		ifFalse: [self drawListViewDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.206'!
drawListView: aListView overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aListView.
	aListView enabled
		ifTrue: [self drawListViewOverlayEnabledOn: aCanvas]
		ifFalse: [self drawListViewOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.222'!
drawListViewDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.215'!
drawListViewEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.238'!
drawListViewOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.23'!
drawListViewOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.245'!
drawListWidget: aListWidget on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aListWidget.
	aListWidget enabled
		ifTrue: [self drawListWidgetEnabledOn: aCanvas]
		ifFalse: [self drawListWidgetDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.254'!
drawListWidget: aListWidget overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aListWidget.
	aListWidget enabled
		ifTrue: [self drawListWidgetOverlayEnabledOn: aCanvas]
		ifFalse: [self drawListWidgetOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.269'!
drawListWidgetDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.262'!
drawListWidgetEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.285'!
drawListWidgetOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.277'!
drawListWidgetOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.292'!
drawPushButton: aPushButton on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aPushButton.
	aPushButton enabled
		ifTrue: [self drawPushButtonEnabledOn: aCanvas]
		ifFalse: [self drawPushButtonDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.301'!
drawPushButton: aPushButton overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aPushButton.
	aPushButton enabled
		ifTrue: [self drawPushButtonOverlayEnabledOn: aCanvas]
		ifFalse: [self drawPushButtonOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.317'!
drawPushButtonDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.309'!
drawPushButtonEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.332'!
drawPushButtonOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.324'!
drawPushButtonOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.339'!
drawRadioButton: aRadioButton on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aRadioButton.
	aRadioButton enabled
		ifTrue: [self drawRadioButtonEnabledOn: aCanvas]
		ifFalse: [self drawRadioButtonDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.348'!
drawRadioButton: aRadioButton overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aRadioButton.
	aRadioButton enabled
		ifTrue: [self drawRadioButtonOverlayEnabledOn: aCanvas]
		ifFalse: [self drawRadioButtonOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.364'!
drawRadioButtonDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.356'!
drawRadioButtonEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.379'!
drawRadioButtonOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.371'!
drawRadioButtonOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.387'!
drawScrollArea: aScrollArea on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aScrollArea.
	aScrollArea enabled
		ifTrue: [self drawScrollAreaEnabledOn: aCanvas]
		ifFalse: [self drawScrollAreaDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.395'!
drawScrollArea: aScrollArea overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aScrollArea.
	aScrollArea enabled
		ifTrue: [self drawScrollAreaOverlayEnabledOn: aCanvas]
		ifFalse: [self drawScrollAreaOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.41'!
drawScrollAreaDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.403'!
drawScrollAreaEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.426'!
drawScrollAreaOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.418'!
drawScrollAreaOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.434'!
drawScrollBar: aScrollBar on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aScrollBar.
	aScrollBar enabled
		ifTrue: [self drawScrollBarEnabledOn: aCanvas]
		ifFalse: [self drawScrollBarDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.442'!
drawScrollBar: aScrollBar overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aScrollBar.
	aScrollBar enabled
		ifTrue: [self drawScrollBarOverlayEnabledOn: aCanvas]
		ifFalse: [self drawScrollBarOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.458'!
drawScrollBarDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.45'!
drawScrollBarEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.473'!
drawScrollBarOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.466'!
drawScrollBarOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.481'!
drawSlider: aSlider on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aSlider.
	aSlider enabled
		ifTrue: [self drawSliderEnabledOn: aCanvas]
		ifFalse: [self drawSliderDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.489'!
drawSlider: aSlider overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aSlider.
	aSlider enabled
		ifTrue: [self drawSliderOverlayEnabledOn: aCanvas]
		ifFalse: [self drawSliderOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.506'!
drawSliderDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.498'!
drawSliderEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.521'!
drawSliderOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.513'!
drawSliderOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.529'!
drawSpacer: aSpacer on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aSpacer.
	aSpacer enabled
		ifTrue: [self drawSpacerEnabledOn: aCanvas]
		ifFalse: [self drawSpacerDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.537'!
drawSpacer: aSpacer overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aSpacer.
	aSpacer enabled
		ifTrue: [self drawSpacerOverlayEnabledOn: aCanvas]
		ifFalse: [self drawSpacerOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.553'!
drawSpacerDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.545'!
drawSpacerEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.568'!
drawSpacerOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.56'!
drawSpacerOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.576'!
drawStackedWidget: aStackedWidget on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aStackedWidget.
	aStackedWidget enabled
		ifTrue: [self drawStackedWidgetEnabledOn: aCanvas]
		ifFalse: [self drawStackedWidgetDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.584'!
drawStackedWidget: aStackedWidget overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aStackedWidget.
	aStackedWidget enabled
		ifTrue: [self drawStackedWidgetOverlayEnabledOn: aCanvas]
		ifFalse: [self drawStackedWidgetOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.6'!
drawStackedWidgetDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.592'!
drawStackedWidgetEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.615'!
drawStackedWidgetOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.607'!
drawStackedWidgetOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.623'!
drawTableView: aTableView on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aTableView.
	aTableView enabled
		ifTrue: [self drawTableViewEnabledOn: aCanvas]
		ifFalse: [self drawTableViewDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.632'!
drawTableView: aTableView overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aTableView.
	aTableView enabled
		ifTrue: [self drawTableViewOverlayEnabledOn: aCanvas]
		ifFalse: [self drawTableViewOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.647'!
drawTableViewDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.64'!
drawTableViewEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.662'!
drawTableViewOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.655'!
drawTableViewOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.671'!
drawTableWidget: aTableWidget on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aTableWidget.
	aTableWidget enabled
		ifTrue: [self drawTableWidgetEnabledOn: aCanvas]
		ifFalse: [self drawTableWidgetDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.679'!
drawTableWidget: aTableWidget overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aTableWidget.
	aTableWidget enabled
		ifTrue: [self drawTableWidgetOverlayEnabledOn: aCanvas]
		ifFalse: [self drawTableWidgetOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.695'!
drawTableWidgetDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.687'!
drawTableWidgetEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.71'!
drawTableWidgetOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.703'!
drawTableWidgetOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.718'!
drawTextEdit: aTextEdit on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aTextEdit.
	aTextEdit enabled
		ifTrue: [self drawTextEditEnabledOn: aCanvas]
		ifFalse: [self drawTextEditDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.726'!
drawTextEdit: aTextEdit overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aTextEdit.
	aTextEdit enabled
		ifTrue: [self drawTextEditOverlayEnabledOn: aCanvas]
		ifFalse: [self drawTextEditOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.741'!
drawTextEditDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.734'!
drawTextEditEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.756'!
drawTextEditOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.749'!
drawTextEditOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.764'!
drawToolButton: aToolButton on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aToolButton.
	aToolButton enabled
		ifTrue: [self drawToolButtonEnabledOn: aCanvas]
		ifFalse: [self drawToolButtonDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.773'!
drawToolButton: aToolButton overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aToolButton.
	aToolButton enabled
		ifTrue: [self drawToolButtonOverlayEnabledOn: aCanvas]
		ifFalse: [self drawToolButtonOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.789'!
drawToolButtonDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.781'!
drawToolButtonEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.804'!
drawToolButtonOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.796'!
drawToolButtonOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.812'!
drawTreeView: aTreeView on: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aTreeView.
	aTreeView enabled
		ifTrue: [self drawTreeViewEnabledOn: aCanvas]
		ifFalse: [self drawTreeViewDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing' stamp: 'mt 1/10/2012 10:28:19.82'!
drawTreeView: aTreeView overlayOn: aCanvas
	"Auto-generated. Do not edit. See UiPainter>>generateDrawMethods."
	
	self morph: aTreeView.
	aTreeView enabled
		ifTrue: [self drawTreeViewOverlayEnabledOn: aCanvas]
		ifFalse: [self drawTreeViewOverlayDisabledOn: aCanvas].! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.836'!
drawTreeViewDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.828'!
drawTreeViewEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.851'!
drawTreeViewOverlayDisabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'drawing - specific' stamp: 'mt 1/10/2012 10:28:19.843'!
drawTreeViewOverlayEnabledOn: aCanvas
	"Auto-generated. Do not edit but override. See UiPainter>>generateDrawMethods."! !

!UiPainter methodsFor: 'geometry' stamp: 'mt 1/2/2012 16:12:39.926'!
innerBounds
	"Artificial. Could be used for bevel effect."
	
	^ self morph bounds insetBy: 1! !

!UiPainter methodsFor: 'accessing' stamp: 'mt 1/2/2012 16:13:03.943'!
morph

	^ morph! !

!UiPainter methodsFor: 'accessing' stamp: 'mt 1/2/2012 16:13:12.414'!
morph: aMorph

	morph := aMorph.! !

!UiPainter methodsFor: 'geometry' stamp: 'mt 1/2/2012 14:30:46.725'!
outerBounds

	^ self morph outerBounds! !

UiPainter subclass: #UiSqueakPainter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Painter'!

!UiSqueakPainter methodsFor: 'drawing' stamp: 'mt 1/2/2012 15:07:46.727'!
drawPushButton: aPushButton on: aCanvas
	"Adopted from PluggableButtonMorph>>draw:."
	
	| cc gradient borderColor |
	cc := aPushButton color.
	cc isTransparent ifTrue:[cc := Color gray: 0.9].
	aPushButton enabled ifFalse:[cc := Color lightGray].
	cc brightness > 0.9 ifTrue:[cc := cc adjustBrightness: 0.9 - cc brightness].
	aPushButton down ifTrue:[
		borderColor := cc muchDarker.
		gradient := GradientFillStyle ramp: {
			0.0 -> cc muchDarker.
			0.1-> (cc adjustBrightness: -0.2).
			0.5 -> cc.
			0.9-> (cc adjustBrightness: -0.1).
			1 -> cc muchDarker.
		}.
	] ifFalse:[
		borderColor := Color lightGray.
		gradient := GradientFillStyle ramp: {
			0.0 -> Color white.
			0.1-> (cc adjustBrightness: 0.05).
			0.6 -> (cc darker).
		}
	].
	gradient origin: aPushButton bounds topLeft.
	gradient direction: 0@self height.
	aCanvas 
		frameAndFillRoundRect: aPushButton bounds 
		radius: 8 
		fillStyle: gradient 
		borderWidth: 1 
		borderColor: borderColor.! !

Object subclass: #UiSmalltalkModel
	uses: TUiItemModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Examples'!

!UiSmalltalkModel commentStamp: 'mt 10/19/2010 11:04:26.59' prior: 0!
More complex model to navigate the Smalltalk system structure. See class-side examples.!

UiSmalltalkModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

UiSmalltalkModel subclass: #UiSmalltalkCategoryNode
	instanceVariableNames: 'category prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Examples'!

!UiSmalltalkCategoryNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:49:39.519'!
= aNode

	^ self species = aNode species
		and: [self category = aNode category]! !

!UiSmalltalkCategoryNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:17:04.93'!
category
	^ category! !

!UiSmalltalkCategoryNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:17:04.962'!
category: anObject
	category := anObject! !

!UiSmalltalkCategoryNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:46:03.253'!
childAt: index inGroup: groupName

	^ UiSmalltalkClassNode new
		theClass: (Smalltalk at: (self classNames at: index))! !

!UiSmalltalkCategoryNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:45:23.541'!
classNames

	^ (SystemOrganization listAtCategoryNamed: self category)! !

!UiSmalltalkCategoryNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:45:33.037'!
groups

	^ #(classNames)! !

!UiSmalltalkCategoryNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:49:53.88'!
hash

	^ self species hash bitXor: [self category hash]! !

!UiSmalltalkCategoryNode methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:02:03.201'!
label

	^ self category! !

!UiSmalltalkCategoryNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:19:36.923'!
prefix
	^ prefix! !

!UiSmalltalkCategoryNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:19:36.955'!
prefix: anObject
	prefix := anObject! !

UiSmalltalkModel subclass: #UiSmalltalkClassNode
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Examples'!

!UiSmalltalkClassNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:50:22.792'!
= aNode

	^ self species = aNode species
		and: [self theClass = aNode theClass]! !

!UiSmalltalkClassNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:46:48.356'!
childAt: index inGroup: groupname

	^ UiSmalltalkProtocolNode new
		protocol: (self protocols at: index);
		organization: self theClass organization! !

!UiSmalltalkClassNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:46:30.216'!
groups

	^ #(protocols)! !

!UiSmalltalkClassNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:50:37.179'!
hash

	^ self species hash bitXor: [self theClass hash]! !

!UiSmalltalkClassNode methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:02:10.244'!
label

	^ self theClass name! !

!UiSmalltalkClassNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:46:24.747'!
protocols

	^ self theClass organization categories! !

!UiSmalltalkClassNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:16:52.845'!
theClass
	^ theClass! !

!UiSmalltalkClassNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:16:52.873'!
theClass: anObject
	theClass := anObject! !

UiSmalltalkModel subclass: #UiSmalltalkMethodNode
	instanceVariableNames: 'theClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Examples'!

!UiSmalltalkMethodNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:51:20.818'!
= aNode

	^ self species = aNode species
		and: [self theClass = aNode theClass]
		and: [self selector = aNode selector]! !

!UiSmalltalkMethodNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:48:10.652'!
groups

	 ^ #()! !

!UiSmalltalkMethodNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:51:46.422'!
hash

	^ [self species hash
		bitXor: [self theClass hash]]
		bitXor: [self selector hash]! !

!UiSmalltalkMethodNode methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:02:20.077'!
label

	^ self selector! !

!UiSmalltalkMethodNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:16:20.707'!
selector
	^ selector! !

!UiSmalltalkMethodNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:16:20.739'!
selector: anObject
	selector := anObject! !

!UiSmalltalkMethodNode methodsFor: 'accessing' stamp: 'mt 2/7/2012 15:50:55.076'!
theClass
	^ theClass! !

!UiSmalltalkMethodNode methodsFor: 'accessing' stamp: 'mt 2/7/2012 15:50:55.109'!
theClass: anObject
	theClass := anObject! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 17:18:38.137'!
ex01iconicList

	UiListView new
		listOrientation: #vertical;
		listSpec: ((UiItemViewColumnSpec newFrom: {#text -> #yourself. #icon -> #yourself})
			textConverter: [:node | node package name];
			iconConverter: [:node | UiSilkIcons packageIcon];
			itemOrientation: #vertical);
		model: UiSmalltalkModel new;
		hAlignment: #center;		
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 17:16:07.248'!
ex02tree

	UiTreeView new
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #yourself. #icon -> #yourself})
			textConverter: [:node | ((Dictionary newFrom: {
				UiSmalltalkPackageNode -> [node package name].
				UiSmalltalkCategoryNode -> [node category].
				UiSmalltalkClassNode -> [node theClass name].
				UiSmalltalkProtocolNode -> [node protocol].
				UiSmalltalkMethodNode -> [node selector]}) at: node class) value];
			iconConverter: [:node | (node isKindOf: UiSmalltalkPackageNode) ifTrue: [UiSilkIcons packageIcon] ifFalse: []]);
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #childCount})
			textConverter: [:integer | ('<font color="#555555">', integer asString, '</font>') asHtmlText]);
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #yourself})
			textConverter: [:node | ('<font color="#555555">{1}</font>' format: {((Dictionary newFrom: {
				UiSmalltalkPackageNode -> ['package'].
				UiSmalltalkCategoryNode -> ['system category'].
				UiSmalltalkClassNode -> ['class'].
				UiSmalltalkProtocolNode -> ['protocol'].
				UiSmalltalkMethodNode -> ['method']}) at: node class) value}) asHtmlText]);
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 17:26:40.552'!
ex03table

	UiTableView new
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #yourself. #icon -> #yourself})
			textConverter: [:node | node package name];
			iconConverter: [:node | UiSilkIcons packageIcon]);
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #childCount})
			textConverter: [:integer | ('<font color="#555555">', integer asString, '</font>') asHtmlText]);
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #yourself})
			textConverter: [:node | '<font color="#555555">package</font>' asHtmlText]);
		model: UiSmalltalkModel new;
		setHAlignmentForColumn: 2 to: #right;
		setHAlignmentForColumn: 3 to: #center;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 17:27:38.833'!
ex04simpleList

	UiListView new
		listSpec: ((UiItemViewColumnSpec newFrom: {#text -> #yourself. #icon -> #yourself})
			textConverter: [:node | node package name];
			iconConverter: [:node | UiSilkIcons packageIcon]);
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 17:28:16.033'!
ex05horizontalList

	UiListView new
		listSpec: ((UiItemViewColumnSpec newFrom: {#text -> #yourself. #icon -> #yourself})
			textConverter: [:node | node package name];
			iconConverter: [:node | UiSilkIcons packageIcon]);
		listOrientation: #horizontal;
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:55:02.966'!
childAt: index inGroup: groupName
	
	^ UiSmalltalkPackageNode new
		package: ((self perform: groupName) at: index)! !

!UiSmalltalkModel methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:54:37.22'!
groups
	
	^ #(packagesForSeaside packagesForOtherProjects)! !

!UiSmalltalkModel methodsFor: 'initialization' stamp: 'mt 10/14/2010 19:36:09.409'!
initialize

	"SystemChangeNotifier uniqueInstance
		notify: self ofAllSystemChangesUsing: #processNotification:."! !

!UiSmalltalkModel methodsFor: 'testing' stamp: 'mt 2/6/2012 17:01:19.951'!
isPackageNode

	^ false! !

!UiSmalltalkModel methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:01:55.475'!
label

	self subclassResponsibility.! !

!UiSmalltalkModel methodsFor: 'accessing' stamp: 'mt 8/2/2012 10:34:16.902'!
packagesForOtherProjects

	^ PackageOrganizer default packages reject: [:pkg | pkg name beginsWith: #Seaside]! !

!UiSmalltalkModel methodsFor: 'accessing' stamp: 'mt 8/2/2012 10:34:19.216'!
packagesForSeaside

	^ PackageOrganizer default packages select: [:pkg | pkg name beginsWith: #Seaside]! !

!UiSmalltalkModel methodsFor: 'notifications' stamp: 'mt 10/14/2010 11:43:56.986'!
processNotification: anEvent

	| pkg pkgIndex sysIndex classIndex |
	(anEvent itemKind ~= #category and: [anEvent itemKind ~= #class])
		ifTrue: [^ self].
	
	pkg := PackageOrganizer default
		packageOfSystemCategory: anEvent itemCategory
		ifNone: [^ self].
	pkgIndex := (UiSimpleModelIndex
		row: (PackageOrganizer default packages indexOf: pkg)
		column: 1)
		model: self;
		setProperty: #package toValue: pkg.
	sysIndex := self
		indexRow: (pkg systemCategories indexOf: anEvent itemCategory)
		column: 1
		parent: pkgIndex.
	classIndex := self
		indexRow: ((SystemOrganization listAtCategoryNamed: anEvent itemCategory) indexOf: anEvent itemClass name)
		column: 1
		parent: sysIndex.
	
	anEvent itemKind = #category ifTrue: [
		anEvent isAdded ifTrue: [
			self rowsInsertedFor: pkgIndex from: sysIndex row to: sysIndex row.
			self rowsChangedFor: nil from: pkgIndex row to: pkgIndex row].
		anEvent isRemoved ifTrue: [
			self rowsRemovedFor: pkgIndex from: sysIndex row to: sysIndex row.
			self rowsChangedFor: nil from: pkgIndex row to: pkgIndex row].
		anEvent isRenamed ifTrue: [
			sysIndex := self
				indexRow: (pkg systemCategories indexOf: anEvent newName)
				column: 1
				parent: pkgIndex.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row]].

	anEvent itemKind = #class ifTrue: [
		anEvent isAdded ifTrue: [
			self rowsInsertedFor: sysIndex from: classIndex row to: classIndex row.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row].
		anEvent isRenamed ifTrue: [
			self rowsChangedFor: sysIndex from: classIndex row to: classIndex row].
		anEvent isRemoved ifTrue: [
			self rowsRemovedFor: sysIndex from: classIndex row to: classIndex row.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row]
		].
	
	anEvent itemKind = #method ifTrue: [
		].! !

UiSmalltalkModel subclass: #UiSmalltalkPackageNode
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Examples'!

!UiSmalltalkPackageNode methodsFor: 'comparing' stamp: 'mt 2/6/2012 17:29:57.178'!
= aNode

	^ self species = aNode species
		and: [self package = aNode package]! !

!UiSmalltalkPackageNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:44:51.231'!
childAt: index inGroup: groupName

	^ UiSmalltalkCategoryNode new
		category: (self systemCategories at: index);
		prefix: self package systemCategoryPrefix! !

!UiSmalltalkPackageNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:44:22.595'!
groups

	^ #(systemCategories)! !

!UiSmalltalkPackageNode methodsFor: 'comparing' stamp: 'mt 2/6/2012 17:30:21.507'!
hash

	^ self species hash bitXor: self package hash! !

!UiSmalltalkPackageNode methodsFor: 'testing' stamp: 'mt 2/6/2012 17:01:30.321'!
isPackageNode

	^ true! !

!UiSmalltalkPackageNode methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:02:26.178'!
label

	^ self package name! !

!UiSmalltalkPackageNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:15:27.765'!
package
	^ package! !

!UiSmalltalkPackageNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:15:27.791'!
package: anObject
	package := anObject! !

!UiSmalltalkPackageNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:44:11.264'!
systemCategories

	^ self package systemCategories! !

UiSmalltalkModel subclass: #UiSmalltalkProtocolNode
	instanceVariableNames: 'protocol organization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Examples'!

!UiSmalltalkProtocolNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:54:27.603'!
= aNode

	^ self species = aNode species
		and: [self organization = aNode organization]
		and: [self protocol = aNode protocol]! !

!UiSmalltalkProtocolNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:47:38.174'!
childAt: index inGroup: groupName

	^ UiSmalltalkMethodNode new
		theClass: self organization subject;
		selector: (self messages at: index)! !

!UiSmalltalkProtocolNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:47:18.768'!
groups

	^ #(messages)! !

!UiSmalltalkProtocolNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:54:54.011'!
hash

	^ [self species hash
		bitXor: [self organization hash]]
		bitXor: [self protocol hash]! !

!UiSmalltalkProtocolNode methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:02:34.042'!
label

	^ self protocol! !

!UiSmalltalkProtocolNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:47:12.315'!
messages

	^ self organization listAtCategoryNamed: self protocol! !

!UiSmalltalkProtocolNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:36:40.307'!
organization
	^ organization! !

!UiSmalltalkProtocolNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:36:40.342'!
organization: anObject
	organization := anObject! !

!UiSmalltalkProtocolNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:17:14.361'!
protocol
	^ protocol! !

!UiSmalltalkProtocolNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:17:14.389'!
protocol: anObject
	protocol := anObject! !

Object subclass: #UiTableWidgetModel
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiTableWidgetModel methodsFor: 'counts' stamp: 'mt 11/2/2010 13:40:38.646'!
columnCount

	self items ifEmpty: [^ 0].
	^ self items first size! !

!UiTableWidgetModel methodsFor: 'counts' stamp: 'mt 11/2/2010 15:58:28.051'!
columnCount: anInteger

	| oldSize |
	anInteger = self columnCount ifTrue: [^ self].
	
	oldSize := self columnCount.

	self items do: [:row | 
		[row size < anInteger] whileTrue: [row addLast: UiTableWidgetItem new].
		[row size > anInteger] whileTrue: [row removeLast]].

	oldSize > self columnCount
		ifTrue: [self columnsRemovedFor: nil from: self columnCount + 1 to: oldSize]
		ifFalse: [self columnsInsertedFor: nil from: oldSize + 1 to: self columnCount].! !

!UiTableWidgetModel methodsFor: 'model data' stamp: 'mt 11/2/2010 16:22:35.439'!
iconFor: aPoint

	(aPoint x = 0 or: [aPoint y = 0])
		ifTrue: [^ nil].

	^ (self itemAt: aPoint) icon! !

!UiTableWidgetModel methodsFor: 'accessing' stamp: 'mt 11/2/2010 16:12:19.839'!
indexOf: anItem

	| row column |
	row := self items detect: [:r | r includes: anItem].
	^ (row indexOf: anItem)! !

!UiTableWidgetModel methodsFor: 'accessing' stamp: 'mt 11/2/2010 16:02:48.304'!
itemAt: aPoint

	^ (self items at: aPoint y) at: aPoint x! !

!UiTableWidgetModel methodsFor: 'accessing' stamp: 'mt 11/3/2010 10:09:35.64'!
itemAt: aPoint put: aTableWidgetItem

	((self items at: aPoint y) at: aPoint x) put: aTableWidgetItem.
	self triggerItemChangedAt: aPoint.! !

!UiTableWidgetModel methodsFor: 'accessing' stamp: 'mt 1/4/2011 10:31:05.482'!
items
	"Two-dimensional array of UiTableWidgetItem instances."
	
	^ items ifNil: [items := OrderedCollection new]! !

!UiTableWidgetModel methodsFor: 'model data' stamp: 'mt 11/2/2010 16:22:26.377'!
menuFor: aPoint

	(aPoint x = 0 or: [aPoint y = 0])
		ifTrue: [^ nil].
		
	^ (self itemAt: aPoint) menu! !

!UiTableWidgetModel methodsFor: 'counts' stamp: 'mt 11/2/2010 13:40:23.294'!
rowCount

	^ self items size! !

!UiTableWidgetModel methodsFor: 'counts' stamp: 'mt 11/3/2010 10:15:49.239'!
rowCount: anInteger

	| oldSize |
	self rowCount = anInteger ifTrue: [^ self].
	
	oldSize := self rowCount.

	[self rowCount > anInteger] whileTrue: [self items removeLast].	
	[self rowCount < anInteger] whileTrue: [self items addLast: ((Array new: self columnCount) collect: [:e | UiTableWidgetItem new]) asOrderedCollection].

	oldSize > self rowCount
		ifTrue: [self rowsRemovedFor: nil from: self rowCount + 1 to: oldSize]
		ifFalse: [self rowsInsertedFor: nil from: oldSize + 1 to: self rowCount].! !

!UiTableWidgetModel methodsFor: 'model data' stamp: 'mt 11/2/2010 16:21:50.017'!
textFor: aPoint

	aPoint x = 0 ifTrue: [^ aPoint y asString].
	aPoint y = 0 ifTrue: [^ aPoint x asString].
	
	^ (self itemAt: aPoint) text! !

!UiTableWidgetModel methodsFor: 'signal triggering' stamp: 'mt 1/4/2011 10:32:32.793'!
triggerItemChangedAt: aPoint

	"KLUDGE: Optimze this!! Not the whole row but a single item changed..."
	self rowsChangedFor: nil from: aPoint y to: aPoint y.! !

Object subclass: #UiViewInfo
	instanceVariableNames: 'size items resizeMode headerItem visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewInfo commentStamp: 'mt 11/2/2010 12:54:36.518' prior: 0!
A information holder for columns and rows in a viewport. Stores extent and resizing behavior.

Represents an index of a viewports items.!

UiViewInfo subclass: #UiViewColumnInfo
	instanceVariableNames: 'vAlignment hAlignment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewColumnInfo commentStamp: 'mt 10/9/2010 11:38:45.048' prior: 0!
Useful index element for tree viewport.!

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:25.869'!
hAlignment

	^ hAlignment! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:34.152'!
hAlignment: aSymbol

	hAlignment := aSymbol.! !

!UiViewColumnInfo methodsFor: 'initialization' stamp: 'mt 10/14/2010 19:08:54.097'!
initialize

	super initialize.
	self
		resize: 150;
		vAlignment: #top;
		hAlignment: #left.! !

!UiViewColumnInfo methodsFor: 'geometry' stamp: 'mt 6/29/2012 10:28:13.586'!
optimalSize
	"Return the width of the largest item."
	
	| max |
	max := 0.
	items do: [:item | 
		((item hasProperty: #isGroupSeparator) or: [item hResizing == #spaceFill])
			ifFalse: [max := max max: (item width + (item valueOfProperty: #indent))]].
	self headerItem ifNotNil: [:hi | hi submorphs ifNotEmpty: [
		max := max max: self headerItem submorphBounds width + 5. "font rendering bugfix" ]].
	^ max! !

!UiViewColumnInfo methodsFor: 'printing' stamp: 'mt 4/26/2012 14:25:30.738'!
printString

	^ 'COL:', super printString! !

!UiViewColumnInfo methodsFor: 'geometry' stamp: 'mt 7/6/2012 11:07:04.802'!
updateItemSize

	self items do: [:item | 
		item hResizing = #spaceFill
			ifTrue: [item width: self width]].! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:11.098'!
vAlignment

	^ vAlignment! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:17.674'!
vAlignment: aSymbol

	vAlignment := aSymbol.! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/10/2010 12:52:12.794'!
width

	^ size! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:15:41.705'!
width: anInteger

	self resize: anInteger.! !

!UiViewInfo methodsFor: 'initialization' stamp: 'mt 10/11/2010 17:51:31.693'!
clear

	items removeAll.! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/10/2010 12:46:28.423'!
headerItem

	^ headerItem! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 3/23/2012 10:48:52.86'!
headerItem: aHeaderItem
	
	headerItem := aHeaderItem.
	aHeaderItem
		resizeable: self resizeMode == #rigid;
		resize: self pixelSize.! !

!UiViewInfo methodsFor: 'testing' stamp: 'mt 10/9/2010 19:57:43.188'!
includes: aModelIndex

	^ items anySatisfy: [:item | (item valueOfProperty: #modelIndex) = aModelIndex]! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 4/26/2012 13:26:19.981'!
indices

	^ (items collect: [:item | item valueOfProperty: #modelIndex])
		reject: [:index | index isNil]! !

!UiViewInfo methodsFor: 'initialization' stamp: 'mt 6/29/2012 10:30:05'!
initialize

	super initialize.
	
	items := OrderedCollection new.
	resizeMode := #shrinkWrap.! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/13/2010 15:42:39.671'!
itemAt: aModelIndex

	^ items detect: [:item | (item valueOfProperty: #modelIndex) = aModelIndex]! !

!UiViewInfo methodsFor: 'items query' stamp: 'mt 10/9/2010 18:19:16.151'!
itemBefore: anItem

	^ items before: anItem ifAbsent: []! !

!UiViewInfo methodsFor: 'items query' stamp: 'mt 10/9/2010 19:58:04.261'!
itemIndexFor: aModelIndex

	items withIndexDo: [:item :index |
		(item valueOfProperty: #modelIndex) = aModelIndex
			ifTrue: [^ index]].
	
	Error signal: 'Not found.'.! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:13:57.129'!
items

	^ items! !

!UiViewInfo methodsFor: 'geometry' stamp: 'mt 10/9/2010 18:16:09.336'!
optimalSize

	self subclassResponsibility.	! !

!UiViewInfo methodsFor: 'geometry' stamp: 'mt 3/23/2012 10:49:22.44'!
pixelSize

	^ size ifNil: [0]! !

!UiViewInfo methodsFor: 'printing' stamp: 'mt 4/26/2012 14:25:08.637'!
printString

	^ self firstModelIndex printString! !

!UiViewInfo methodsFor: 'geometry' stamp: 'mt 7/6/2012 11:19:35.224'!
resize: aNumber

	size = aNumber ifTrue: [^ self].
	
	size := aNumber.
	self headerItem ifNotNil: [:hi |
		hi resize: aNumber].
	
	self updateItemSize.! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:09:54.303'!
resizeMode

	^ resizeMode! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 6/29/2012 10:25:13.588'!
resizeMode: aSymbol
	"#rigid, #shrinkWrap, #spaceFill"

	resizeMode := aSymbol.
	self headerItem ifNotNil: [:hi |
		hi resizeable: resizeMode == #rigid].! !

!UiViewInfo methodsFor: 'geometry' stamp: 'mt 7/6/2012 11:14:43.445'!
updateItemSize
! !

!UiViewInfo methodsFor: 'geometry' stamp: 'mt 7/6/2012 11:19:52.032'!
updateSize

	self resizeMode == #shrinkWrap
		ifTrue: [self resize: self optimalSize]
		ifFalse: [self updateItemSize].! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 6/26/2012 16:26:55.266'!
visible

	^ visible ifNil: [true]! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 6/26/2012 16:27:04.874'!
visible: aBoolean
 
	visible := aBoolean.! !

UiViewInfo subclass: #UiViewRowInfo
	instanceVariableNames: 'height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewRowInfo commentStamp: 'mt 10/9/2010 11:38:35.657' prior: 0!
Useful index element for tree viewport.!

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:21:06.63'!
firstModelIndex
	
	^ items
		ifEmpty: [nil]
		ifNotEmpty: [(items first valueOfProperty: #modelIndex)]! !

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 10/10/2010 12:51:44.846'!
height

	^ size! !

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:20:41.803'!
height: anInteger

	self resize: anInteger.! !

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 4/27/2012 11:36:31.027'!
indent
	
	^ items
		ifEmpty: [0]
		ifNotEmpty: [(items first valueOfProperty: #indent ifAbsent: [0])]! !

!UiViewRowInfo methodsFor: 'initialization' stamp: 'mt 10/14/2010 18:47:11.649'!
initialize

	super initialize.
	self resize: Preferences standardListFont height.! !

!UiViewRowInfo methodsFor: 'testing' stamp: 'mt 10/10/2010 10:27:44.554'!
isCollapsed

	^ self isExpanded not! !

!UiViewRowInfo methodsFor: 'testing' stamp: 'mt 10/10/2010 10:27:36.67'!
isExpanded

	^ items notEmpty and: [items first valueOfProperty: #isExpanded]! !

!UiViewRowInfo methodsFor: 'testing' stamp: 'mt 4/23/2012 11:51:34.437'!
isRowFor: aModelIndex

	^ self firstModelIndex
		ifNil: [false "separator"]
		ifNotNil: [:index | index row = aModelIndex row]! !

!UiViewRowInfo methodsFor: 'testing' stamp: 'mt 4/26/2012 13:18:16.203'!
isSeparator

	^ self items first hasProperty: #isGroupSeparator! !

!UiViewRowInfo methodsFor: 'geometry' stamp: 'mt 7/6/2012 11:02:05.012'!
optimalSize
	"Return the height of the largest item."
	
	| max |
	max := 0.
	items do: [:item |
		item vResizing ~= #spaceFill
			ifTrue: [max := max max: item height]].
	self headerItem ifNotNil: [:hi | hi submorphs ifNotEmpty: [
		max := max max: self headerItem submorphBounds height]].
	^ max! !

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 6/26/2012 10:37:29.918'!
parentModelIndex
	"All items in a row should have the same parent model index. So take the first item to access."
	
	^ items
		ifEmpty: [nil]
		ifNotEmpty: [self isSeparator
			ifTrue: [items first valueOfProperty: #parentModelIndex]
			ifFalse: [(items first valueOfProperty: #modelIndex) ifNotNil: [:index | index parent]]]! !

!UiViewRowInfo methodsFor: 'printing' stamp: 'mt 4/26/2012 14:25:46.805'!
printString

	^ 'ROW:', super printString! !

!UiViewRowInfo methodsFor: 'geometry' stamp: 'mt 7/6/2012 11:14:59.892'!
updateItemSize

	self items do: [:item | 
		item vResizing = #spaceFill
			ifTrue: [item height: self height]].! !

Object subclass: #UiViewSelection
	instanceVariableNames: 'viewport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewSelection commentStamp: 'mt 4/6/2011 10:14:52.597' prior: 0!
A view selection keeps track of all selected cells in a viewport as well as the current cell which is normally only the last selected cell.

A reference to the viewport is needed to map cells to model indices.!

UiViewSelection subclass: #UiViewMultiSelection
	instanceVariableNames: 'cells currentCell cellToUnselect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

UiViewMultiSelection subclass: #UiViewExtendedSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewExtendedSelection methodsFor: 'add/remove' stamp: 'mt 8/9/2012 10:10:55.898'!
add: aCellIndex

	(self cells includes: aCellIndex)
		ifTrue: [
			"Prepare to unselect the cell."
			cellToUnselect := aCellIndex]
		ifFalse: [
			"Select cell. Discard old selection."
			self cells: {aCellIndex}].
	
	self currentCell: aCellIndex.! !

!UiViewExtendedSelection methodsFor: 'add/remove' stamp: 'mt 8/9/2012 10:09:15.682'!
add: aCellIndex event: aUserInputEvent

	aUserInputEvent shiftPressed
		ifTrue: [^ super add: aCellIndex].

	self add: aCellIndex.! !

!UiViewExtendedSelection methodsFor: 'add/remove' stamp: 'mt 8/9/2012 10:25:56.274'!
remove: aCellIndex

	cellToUnselect = aCellIndex
		ifTrue: [
			cellToUnselect := nil.
			self cells: {aCellIndex}].! !

!UiViewExtendedSelection methodsFor: 'add/remove' stamp: 'mt 8/9/2012 10:13:20.263'!
remove: aCellIndex event: aUserInputEvent

	aUserInputEvent shiftPressed
		ifTrue: [^ super remove: aCellIndex].
		
	self remove: aCellIndex.  ! !

!UiViewMultiSelection methodsFor: 'add/remove' stamp: 'mt 8/9/2012 10:07:16.998'!
add: aCellIndex

	| oldCells |
	
	(self cells includes: aCellIndex)
		ifTrue: [
			"Prepare to unselect the cell."
			cellToUnselect := aCellIndex]
		ifFalse: [
			"Select cell."
			oldCells := self cells copy.
			self cells add: aCellIndex.
			self selectionChangedFrom: oldCells to: self cells copy].
	
	self currentCell: aCellIndex.! !

!UiViewMultiSelection methodsFor: 'accessing' stamp: 'mt 6/26/2012 13:54:26.263'!
cells

	^ cells ifNil: [cells := Set new]! !

!UiViewMultiSelection methodsFor: 'accessing' stamp: 'mt 7/12/2012 15:23:08.885'!
cells: somePoints

	| oldCells |
	oldCells := self cells.
	
	cells := somePoints
		ifEmpty: [nil]
		ifNotEmpty: [somePoints asSet].
		
	self selectionChangedFrom: oldCells to: self cells.! !

!UiViewMultiSelection methodsFor: 'accessing' stamp: 'mt 6/26/2012 13:51:14.871'!
currentCell

	^ currentCell! !

!UiViewMultiSelection methodsFor: 'accessing' stamp: 'mt 6/26/2012 13:52:34.805'!
currentCell: aPoint

	| oldCell |
	aPoint = currentCell ifTrue: [^ self].

	oldCell := currentCell.
	currentCell := aPoint.

	self currentCellChangedFrom: oldCell to: currentCell.! !

!UiViewMultiSelection methodsFor: 'add/remove' stamp: 'mt 8/9/2012 10:25:35.307'!
remove: aCellIndex

	| oldCells |
	cellToUnselect = aCellIndex
		"Unselect the cell."
		ifTrue: [
			cellToUnselect := nil.
			oldCells := self cells copy.
			self cells remove: aCellIndex.
			self selectionChangedFrom: oldCells to: self cells copy].! !

!UiViewMultiSelection methodsFor: 'accessing - model index' stamp: 'mt 8/13/2012 10:44:46.029'!
selectedIndices

	^ ((self cells asOrderedCollection sortBy: [:cell1 :cell2 | cell1 y <= cell2 y or: [cell1 y == cell2 y and: [cell1 x <= cell2 x]]])
		collect: [:cellIndex | self viewport modelIndexFor: cellIndex])
		reject: [:modelindex | modelindex isNil]
! !

UiViewSelection subclass: #UiViewNullSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewNullSelection commentStamp: 'mt 10/11/2010 14:09:45.699' prior: 0!
No selection of cells possible.!

!UiViewNullSelection methodsFor: 'add/remove' stamp: 'mt 8/8/2012 15:53:23.817'!
add: aCellIndex

	"Ignore."! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:08:50.077'!
cells

	^ #()! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 2/2/2012 10:35:30.303'!
cells: somePoints

	! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/23/2010 10:00:00.921'!
currentCell

	^ nil! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/23/2010 10:00:08.721'!
currentCell: anIndex

! !

!UiViewSelection methodsFor: 'add/remove' stamp: 'mt 8/8/2012 15:51:25.672'!
add: aCellIndex! !

!UiViewSelection methodsFor: 'add/remove' stamp: 'mt 8/8/2012 15:51:34.375'!
add: aCellIndex event: aUserInputEvent

	self add: aCellIndex.! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 09:13:15.101'!
cells
	"Return an array with all selected cells."
	
	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 2/2/2012 10:30:49.742'!
cells: somePoints
	
	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'add/remove' stamp: 'mt 6/26/2012 14:27:00.825'!
clear

	self
		cells: #();
		currentCell: nil.! !

!UiViewSelection methodsFor: 'accessing - pixel' stamp: 'mt 8/13/2012 10:12:58.473'!
currentBounds
	"Returns the global bounds of the current cell bounds according to #selectionBehavior."
	
	| cb |
	cb := self viewport boundsFor: self currentCell.
	^ (self viewport localPointToGlobal: cb topLeft)
		extent: cb extent  ! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:15:39.961'!
currentCell
	"Return the current cell. Normally the last added one."

	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:23:46.96'!
currentCell: aPoint

	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'accessing - pixel' stamp: 'mt 8/13/2012 10:12:37.826'!
currentCellBounds
	"Returns the global bounds of the current cell bounds."
	
	| cb |
	cb := self viewport cellBoundsFor: self currentCell.
	^ (self viewport localPointToGlobal: cb topLeft)
		extent: cb extent  ! !

!UiViewSelection methodsFor: 'signals' stamp: 'mt 7/13/2011 14:25:23.278'!
currentCellChangedFrom: aPoint to: anotherPoint

	self emit.! !

!UiViewSelection methodsFor: 'accessing - model index' stamp: 'mt 4/6/2011 10:17:57.587'!
currentIndex

	^ self viewport modelIndexFor: self currentCell  ! !

!UiViewSelection methodsFor: 'accessing - model index' stamp: 'mt 6/23/2011 13:27:41.965'!
currentIndex: aModelIndex

	self currentCell:
		(self viewport cellIndexFromModelIndex: aModelIndex).
! !

!UiViewSelection methodsFor: 'add/remove' stamp: 'mt 8/9/2012 10:03:45.564'!
remove: aCellIndex! !

!UiViewSelection methodsFor: 'add/remove' stamp: 'mt 8/9/2012 10:03:36.028'!
remove: aCellIndex event: aUserInputEvent

	self remove: aCellIndex.! !

!UiViewSelection methodsFor: 'accessing - model index' stamp: 'mt 8/2/2012 14:32:37.786'!
selectedIndices

	^ (self cells collect: [:cellIndex | self viewport modelIndexFor: cellIndex])
		reject: [:modelindex | modelindex isNil]! !

!UiViewSelection methodsFor: 'accessing - model index' stamp: 'mt 2/2/2012 10:33:15.876'!
selectedIndices: someModelIndices

	self cells: (someModelIndices collect: [:index |
		self viewport cellIndexFromModelIndex: index]).
! !

!UiViewSelection methodsFor: 'signals' stamp: 'mt 7/13/2011 14:25:51.282'!
selectionChangedFrom: someOldPoints to: someNewPoints

	self emit.! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 4/6/2011 10:14:27.303'!
viewport

	^ viewport! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 4/6/2011 10:14:38.203'!
viewport: anItemViewport

	viewport := anItemViewport.! !

UiViewSelection subclass: #UiViewSingleSelection
	instanceVariableNames: 'selectedCell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewSingleSelection methodsFor: 'add/remove' stamp: 'mt 8/8/2012 15:53:32.938'!
add: aCellIndex

	| oldCell |
	aCellIndex ifNil: [^ self].
	aCellIndex = selectedCell ifTrue: [^ self].
	
	oldCell := selectedCell.
	
	self currentCell: aCellIndex.
	
	self selectionChangedFrom: {oldCell} to: {selectedCell}.! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:35:26.499'!
cells

	^ selectedCell
		ifNil: [#()]
		ifNotNil: [{selectedCell}]! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 6/26/2012 13:56:35.69'!
cells: somePoints

	| oldCell |
	oldCell := selectedCell.
	
	selectedCell := somePoints
		ifEmpty: [nil]
		ifNotEmpty: [somePoints first].
		
	self selectionChangedFrom: {oldCell} to: self cells.! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:16:06.717'!
currentCell

	^ selectedCell! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 7/13/2011 14:27:18.775'!
currentCell: aPoint

	| oldCell |
	aPoint = selectedCell ifTrue: [^ self].
	oldCell := selectedCell.
	
	selectedCell := aPoint.

	self currentCellChangedFrom: oldCell to: selectedCell.! !

Object subclass: #UserInterface
	instanceVariableNames: 'panel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UserInterface commentStamp: 'mt 6/27/2010 09:43:15.463' prior: 0!
I am the abstract base class of an auto-generated User Interface.!

UserInterface subclass: #UiSaveDesignUi
	instanceVariableNames: 'unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 okButton cancelButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiSaveDesignUi methodsFor: 'accessing' stamp: 'mt 12/30/2010 13:40:37.024'!
cancelButton
	"nil"
	
	^ cancelButton! !

!UiSaveDesignUi methodsFor: 'ui - private' stamp: 'mt 12/30/2010 13:40:37.105'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (713@450).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 extent: (705@415).
	unnamedMorph1 position: (4@4).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#spaceFill).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph2 := UiListView new.
	unnamedMorph2 extent: (389@217).
	unnamedMorph2 position: (171@117).
	unnamedMorph2 hResizing: (#rigid).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 modelClass: (nil).
	unnamedMorph2 horizontalHeaderVisible: (false).
	unnamedMorph2 verticalHeaderVisible: (false).
	unnamedMorph2 selectionBehavior: (#selectRows).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	panel addMorphBack: unnamedMorph1.
	unnamedMorph3 := UiContainer new.
	unnamedMorph3 changeTableLayout.
	unnamedMorph3 extent: (705@22).
	unnamedMorph3 position: (4@423).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#shrinkWrap).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#leftToRight).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph3 color: (Color transparent).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph4 := UiSpacer new.
	unnamedMorph4 extent: (581@20).
	unnamedMorph4 position: (4@424).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph4 color: (Color blue).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph4 orientation: (#horizontal).
	unnamedMorph3 addMorphBack: unnamedMorph4.
	okButton := UiPushButton new.
	okButton changeTableLayout.
	okButton extent: (50@21).
	okButton position: (589@423).
	okButton hResizing: (#shrinkWrap).
	okButton vResizing: (#shrinkWrap).
	okButton cellInset: (4).
	okButton cellPositioning: (#center).
	okButton cellSpacing: (#none).
	okButton layoutInset: (2@0 corner: 2@0).
	okButton listCentering: (#topLeft).
	okButton listDirection: (#leftToRight).
	okButton listSpacing: (#none).
	okButton maxCellSize: (1073741823).
	okButton minCellSize: (0).
	okButton wrapCentering: (#topLeft).
	okButton wrapDirection: (#none).
	okButton frameFractions: (0@0 corner: 1@1).
	okButton frameOffsets: (0@0 corner: 0@0).
	okButton balloonText: (nil).
	okButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	okButton setProperty: #iconByDesigner toValue: 'UiSilkIcons diskIcon'.
	okButton icon: (UiSilkIcons diskIcon).
	okButton text: ('Save').
	okButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	okButton checkable: (false).
	okButton checked: (false).
	okButton autoExclusive: (false).
	okButton setProperty: #objectName toValue: 'okButton'.
	unnamedMorph3 addMorphBack: okButton.
	cancelButton := UiPushButton new.
	cancelButton changeTableLayout.
	cancelButton extent: (62@21).
	cancelButton position: (645@423).
	cancelButton hResizing: (#shrinkWrap).
	cancelButton vResizing: (#shrinkWrap).
	cancelButton cellInset: (4).
	cancelButton cellPositioning: (#center).
	cancelButton cellSpacing: (#none).
	cancelButton layoutInset: (2@0 corner: 2@0).
	cancelButton listCentering: (#topLeft).
	cancelButton listDirection: (#leftToRight).
	cancelButton listSpacing: (#none).
	cancelButton maxCellSize: (1073741823).
	cancelButton minCellSize: (0).
	cancelButton wrapCentering: (#topLeft).
	cancelButton wrapDirection: (#none).
	cancelButton frameFractions: (0@0 corner: 1@1).
	cancelButton frameOffsets: (0@0 corner: 0@0).
	cancelButton balloonText: (nil).
	cancelButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	cancelButton setProperty: #iconByDesigner toValue: 'UiFugueIcons crossCircleIcon'.
	cancelButton icon: (UiFugueIcons crossCircleIcon).
	cancelButton text: ('Cancel').
	cancelButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	cancelButton checkable: (false).
	cancelButton checked: (false).
	cancelButton autoExclusive: (false).
	cancelButton setProperty: #objectName toValue: 'cancelButton'.
	unnamedMorph3 addMorphBack: cancelButton.
	panel addMorphBack: unnamedMorph3.
	panel setProperty: #uiClassName toValue: 'UiSaveDesign'.! !

!UiSaveDesignUi methodsFor: 'accessing' stamp: 'mt 12/30/2010 13:40:36.895'!
okButton
	"nil"
	
	^ okButton! !

!UserInterface class methodsFor: 'testing' stamp: 'mt 10/30/2010 13:10:11.609'!
isTemplate
	"This is an indicator for the designer to use this user interface as design template."
	
	^ false! !

!UserInterface methodsFor: 'ui - private' stamp: 'mt 6/27/2010 09:48:47.906'!
initializePanel
	"Subclass will contain auto-generated code for this."
	
	self subclassResponsibility.! !

!UserInterface methodsFor: 'ui - private' stamp: 'mt 6/27/2010 09:45:06.967'!
panel
	"Returns the root panel for this UI."
	
	^ panel! !

!UserInterface methodsFor: 'ui - general' stamp: 'mt 4/11/2011 14:20:53.767'!
setupUi: aMorph
	"Configures this UI to be used in the given morph."
	
	self panel ifNil: [self initializePanel].
	
	aMorph extent < self panel extent
		ifTrue: [aMorph extent: self panel extent].
	
	self panel
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	aMorph
		changeTableLayout;
		color: self panel color;
		addMorphBack: self panel.! !

Point subclass: #UiModelIndex
	instanceVariableNames: 'group groupIndex parent node spec isInEditMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiModelIndex commentStamp: 'mt 1/23/2012 14:12:54.254' prior: 0!
A model index is a wrapping help data structure for the item viewport. It should not be used outside this viewport.!

!UiModelIndex class methodsFor: 'instance creation' stamp: 'mt 4/23/2012 11:14:53.525'!
row: aRow column: aColumn group: aGroup groupIndex: aGroupIndex parent: aParentModelIndex node: anObject spec: aColumnSpec

	^ (self x: aColumn y: aRow)
		group: aGroup;
		groupIndex: aGroupIndex;
		parent: aParentModelIndex;
		node: anObject;
		spec: aColumnSpec! !

!UiModelIndex methodsFor: 'comparing' stamp: 'mt 4/22/2012 16:27:14.811'!
= anotherModelIndex

	^ super = anotherModelIndex
		and: [self group = anotherModelIndex group]
		and: [self parent = anotherModelIndex parent]! !

!UiModelIndex methodsFor: 'data' stamp: 'mt 1/23/2012 14:13:21.191'!
balloonText

	^ self spec balloonTextFor: self node! !

!UiModelIndex methodsFor: 'data' stamp: 'mt 7/5/2012 15:41:51.029'!
checkable

	^ self spec checkableFor: self node! !

!UiModelIndex methodsFor: 'data' stamp: 'mt 1/23/2012 14:13:36.771'!
checked

	^ self spec checkedFor: self node! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 18:41:30.667'!
column

	^ self x! !

!UiModelIndex methodsFor: 'signals - setup' stamp: 'mt 4/27/2012 11:05:26.544'!
connectNode
	"See UiAbstractItemView>>connectIndex:."
	
	self column = 1 ifTrue: [
		self connect: self node signal: #modelReset toSelector: #modelReset.
		self connect: self node signal: #childrenChangedFrom:to:inGroup: toSelector: #rowsChangedFrom:to:inGroup:.
		self connect: self node signal: #childrenInsertedFrom:to:inGroup: toSelector: #rowsInsertedFrom:to:inGroup:.
		self connect: self node signal: #childrenRemovedFrom:to:inGroup: toSelector: #rowsRemovedFrom:to:inGroup:.
		self connect: self node signal: #propertiesChanged toSelector: #rowChanged].
	
	self connect: self node signal: #propertiesChanged: toSelector: #onPropertiesChanged:.
! !

!UiModelIndex methodsFor: 'data' stamp: 'mt 7/6/2012 09:33:19.134'!
editable

	^ self spec editableFor: self node! !

!UiModelIndex methodsFor: 'building' stamp: 'mt 7/6/2012 10:22:34.571'!
editor

	^ self spec editorFor: self node! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 4/22/2012 11:20:59.187'!
group

	^ group! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 4/22/2012 11:21:06.402'!
group: anInteger

	group := anInteger.! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 4/23/2012 10:36:15.925'!
groupIndex

	^ groupIndex! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 4/23/2012 10:36:24.123'!
groupIndex: anInteger

	groupIndex := anInteger.! !

!UiModelIndex methodsFor: 'testing' stamp: 'mt 1/23/2012 15:54:13.748'!
hasChildren
	"Requires the node to have the model trait implemented."

	^ self node childCount > 0! !

!UiModelIndex methodsFor: 'comparing' stamp: 'mt 4/22/2012 16:27:26.813'!
hash

	^ (super hash
		bitXor: self group hash)
		bitXor: self parent hash! !

!UiModelIndex methodsFor: 'data' stamp: 'mt 6/26/2012 13:15:50.445'!
icon

	^ self spec iconFor: self node! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 7/6/2012 10:00:52.224'!
isInEditMode

	^ isInEditMode ifNil: [false]! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 7/6/2012 10:00:59.973'!
isInEditMode: aBoolean

	isInEditMode  := aBoolean.! !

!UiModelIndex methodsFor: 'building' stamp: 'mt 2/3/2012 11:24:35.558'!
item

	^ self spec itemFor: self node! !

!UiModelIndex methodsFor: 'signals' stamp: 'mt 2/3/2012 12:00:38.341'!
itemChanged

	self emitAlways.! !

!UiModelIndex methodsFor: 'data' stamp: 'mt 1/23/2012 14:12:15.013'!
menu

	^ self spec menuFor: self node! !

!UiModelIndex methodsFor: 'signals' stamp: 'mt 4/27/2012 11:04:04.275'!
modelReset

	self emitAlways.! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 1/23/2012 14:09:05.195'!
node

	^ node! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 4/26/2012 13:58:24.84'!
node: aNode

	node := aNode.
	aNode ifNotNil: [self connectNode].! !

!UiModelIndex methodsFor: 'signals - setup' stamp: 'mt 7/9/2012 17:15:42.898'!
onPropertiesChanged: someProperties

	(spec includesAnyProperty: someProperties inNode: self node)
		ifTrue: [self itemChanged].! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:24:15.322'!
parent
	"Return parent model index."
	
	^ parent! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:24:27.971'!
parent: aModelIndex
	
	parent := aModelIndex.! !

!UiModelIndex methodsFor: 'printing' stamp: 'mt 4/26/2012 14:21:36.215'!
printString
	"Print the complete hierarchy of this model index."
	
	^ self parent
		ifNil: [super printString, ' (', self group, ')']
		ifNotNil: [super printString, ' (', self group, ')', ' -> ', self parent printString]! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 18:41:24.938'!
row

	^ self y! !

!UiModelIndex methodsFor: 'signals' stamp: 'mt 2/3/2012 12:02:07.679'!
rowChanged

	self emitAlways.! !

!UiModelIndex methodsFor: 'signals' stamp: 'mt 4/22/2012 16:13:03.665'!
rowsChangedFrom: startIndex to: endIndex inGroup: groupName

	self emitAlways.! !

!UiModelIndex methodsFor: 'signals' stamp: 'mt 4/22/2012 16:13:17.123'!
rowsInsertedFrom: startIndex to: endIndex inGroup: groupName

	self emitAlways.! !

!UiModelIndex methodsFor: 'signals' stamp: 'mt 4/22/2012 16:13:25.954'!
rowsRemovedFrom: startIndex to: endIndex inGroup: groupName

	self emitAlways.! !

!UiModelIndex methodsFor: 'data' stamp: 'mt 6/26/2012 13:46:17.036'!
selectable

	^ self spec selectableFor: self node! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 1/23/2012 14:09:30.963'!
spec

	^ spec! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 1/23/2012 14:09:40.224'!
spec: aColumnSpec

	spec := aColumnSpec.! !

!UiModelIndex methodsFor: 'data' stamp: 'mt 1/23/2012 14:13:13.196'!
text

	^ self spec textFor: self node! !

TextMorph subclass: #UiMessage
	instanceVariableNames: 'killTime textColor closeButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiMessage commentStamp: 'mt 3/28/2011 12:25:57.85' prior: 0!
This is a textmorph that shows a short message for a short time and then disappears.!

!UiMessage class methodsFor: 'instance creation' stamp: 'mt 6/18/2010 10:11:19.893'!
error: aText

	^ self new
		contents: aText;
		color: Color red darker;
		textColor: Color yellow;
		fadeIn! !

!UiMessage class methodsFor: 'examples' stamp: 'mt 3/28/2011 12:20:31.259'!
example01Warning

	(UiMessage warning: 'Your <b>chocolate level</b> is <b>low</b>.' asHtmlText)
		center: ActiveWorld center;
		openInWorld.! !

!UiMessage class methodsFor: 'examples' stamp: 'mt 3/28/2011 12:22:01.003'!
example02Error

	(UiMessage error: '<b>Seriously...</b>
	
Do you really think you are working hard enough? =D' asHtmlText)
		center: ActiveWorld center;
		openInWorld.! !

!UiMessage class methodsFor: 'examples' stamp: 'mt 3/28/2011 12:22:47.475'!
example03Information

	(UiMessage information: 'Try to click on me and see what happens.')
		center: ActiveWorld center;
		openInWorld.! !

!UiMessage class methodsFor: 'instance creation' stamp: 'mt 6/18/2010 09:57:21.514'!
information: aText

	^ self new
		contents: aText;
		color: Color gray;
		fadeIn! !

!UiMessage class methodsFor: 'instance creation' stamp: 'mt 6/18/2010 10:11:24.471'!
warning: aText

	^ self new
		contents: aText;
		color: Color yellow darker;
		textColor: Color black;
		fadeIn! !

!UiMessage methodsFor: 'drawing' stamp: 'mt 3/28/2011 11:44:37.333'!
drawOn: aCanvas
	
	| gradient fauxBounds |	
	gradient := (GradientFillStyle ramp: {
			0.0 -> Color white.
			0.1-> (self color adjustBrightness: 0.05).
			0.6 -> (self color darker)})
		origin: self topLeft;
		direction: 0@ self height.
		
	aCanvas
		fillRoundRect: (self bounds insetBy: (1@1 corner: 1@1))
		radius: 3
		fillStyle: gradient;
		frameRoundRect: self bounds
		radius: 3
		width: 1
		color: self color muchDarker.
		
	self setDefaultContentsIfNil.
	(self startingIndex > text size)
		ifTrue: [self drawNullTextOn: aCanvas].
	"Hack here:  The canvas expects bounds to carry the location of the text, but we also need to communicate clipping."
	fauxBounds := self bounds topLeft corner: self innerBounds bottomRight.
	aCanvas paragraph: self paragraph bounds: fauxBounds color: textColor! !

!UiMessage methodsFor: 'actions' stamp: 'mt 6/19/2010 19:38:47.167'!
fadeOutAndDelete

	self fadeOutThen: [self delete].! !

!UiMessage methodsFor: 'initialization' stamp: 'mt 3/28/2011 12:13:29.182'!
initialize

	super initialize.
	killTime := Time now addSeconds: 5.
	
	self
		color: Color gray;
		textColor: Color white;
		margins: (3@1 corner: 3@0);
		startStepping.! !

!UiMessage methodsFor: 'event handling' stamp: 'mt 3/28/2011 12:13:17.647'!
mouseDown: aMouseEvent

	self stopFadeOut.
	super mouseDown: aMouseEvent.  ! !

!UiMessage methodsFor: 'open' stamp: 'mt 3/28/2011 12:24:49.34'!
popUp

	self
		topLeft: ActiveHand position + (ActiveHand width @ 0);
		openInWorld.! !

!UiMessage methodsFor: 'open' stamp: 'mt 3/28/2011 12:25:20.397'!
popUpAt: aPoint

	self
		topLeft: aPoint;
		openInWorld.! !

!UiMessage methodsFor: 'updating' stamp: 'mt 6/19/2010 19:38:56.537'!
step
	
	killTime <= Time now ifTrue: [self stopStepping; fadeOutAndDelete]! !

!UiMessage methodsFor: 'updating' stamp: 'mt 6/15/2010 20:08:09.113'!
stepTime

	^ 100! !

!UiMessage methodsFor: 'actions' stamp: 'mt 3/28/2011 12:17:46.602'!
stopFadeOut

	self stopStepping.

	closeButton ifNil: [closeButton :=
		UiToolButton new
			icon: (UiFugueIcons crossSmallIcon clippedTo: 10@16);
			buttonStyle: #iconOnly;
			color: Color transparent;
			autoRaise: true.
		self connect: closeButton signal: #clicked: toSelector: #fadeOutAndDelete.
		self addMorph: closeButton.
		
		closeButton center: self center - (((self width / 2) + (closeButton width / 2)) @ 0).
		closeButton fadeIn].! !

!UiMessage methodsFor: 'accessing' stamp: 'mt 6/18/2010 08:48:07.306'!
textColor: aColor

	textColor := aColor.! !

TextMorph subclass: #UiTextMorph
	instanceVariableNames: 'autoAccept autoConvert readOnly editView acceptOnCR revertOnEscape acceptOnFocusLost converter styler selection cursor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

UiTextMorph subclass: #UiTextLineMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiTextLineMorph methodsFor: 'private' stamp: 'mt 7/18/2012 16:04'!
editorClass

	^ UiTextLineEditor! !

!UiTextMorph class methodsFor: 'instance creation' stamp: 'mt 3/22/2011 18:09:32.392'!
on: aScrollArea

	^ self new editView: aScrollArea! !

!UiTextMorph methodsFor: 'editing' stamp: 'mt 4/19/2011 10:47:04.648'!
acceptContents

	super acceptContents.

	self
		convertText;
		accepted.! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:35:26.776'!
acceptOnCR

	^ acceptOnCR ifNil: [false]! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:35:40.691'!
acceptOnCR: aBoolean

	acceptOnCR := aBoolean.! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/23/2011 09:21:22.49'!
acceptOnFocusLost
	"Should the contents be accepted if the keyboard focus gets lost?"
	
	^ acceptOnFocusLost ifNil: [acceptOnFocusLost := false]! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/23/2011 09:21:04.688'!
acceptOnFocusLost: aBoolean

	acceptOnFocusLost := aBoolean.! !

!UiTextMorph methodsFor: 'signals' stamp: 'mt 3/23/2011 09:07:04.136'!
accepted

	self emit.! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:18:27.012'!
autoAccept

	^ autoAccept ifNil: [autoAccept := false]! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:18:32.127'!
autoAccept: anObject

	autoAccept := anObject.! !

!UiTextMorph methodsFor: 'converting - accessing' stamp: 'mt 3/22/2011 17:43:15.147'!
autoConvert

	^ autoConvert ifNil: [autoConvert := false]! !

!UiTextMorph methodsFor: 'converting - accessing' stamp: 'mt 3/22/2011 17:43:31.18'!
autoConvert: aBoolean
	"If enabled, converts the text after each keystroke that changes the contents."
	
	autoConvert := aBoolean.! !

!UiTextMorph methodsFor: 'converting' stamp: 'mt 3/23/2011 09:35:49.492'!
convertText
	
	| v |
	v := self convertedValue.

	self newContents: self convertedText.
	self editView updateScrollBars.
	
	self valueChanged: v.  ! !

!UiTextMorph methodsFor: 'converting' stamp: 'mt 4/19/2011 10:46:52.184'!
convertedText

	| v |
	v := self convertedValue.
	(v isString or: [v isText])
		ifTrue: [^ v]
		ifFalse: [^ v asString].
	! !

!UiTextMorph methodsFor: 'converting' stamp: 'mt 4/19/2011 10:43:16.211'!
convertedValue
	"Return the converted value nevertheless if it is a string or not."
	
	^ self converter value: self text! !

!UiTextMorph methodsFor: 'converting - accessing' stamp: 'mt 3/22/2011 17:44:16.966'!
converter
	"Used for conversion purposes of input data. The default converter is the indentity function."

	^ converter ifNil: [converter := [:raw | raw]]! !

!UiTextMorph methodsFor: 'converting - accessing' stamp: 'mt 3/22/2011 17:44:59.158'!
converter: aUnaryBlock
	"Sets the converter to a block that accepts one argument and returns a string."
	
	converter := aUnaryBlock.! !

!UiTextMorph methodsFor: 'drawing' stamp: 'mt 3/21/2011 16:28:02.463'!
drawNullTextOn: aCanvas

	"Invisible."! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/22/2011 17:37:49.311'!
editView
	"The associated scroll area that shows part of this text morph."
	
	^ editView! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/22/2011 17:38:03.872'!
editView: aScrollArea

	editView := aScrollArea.! !

!UiTextMorph methodsFor: 'private' stamp: 'mt 4/6/2011 14:54:02.557'!
editorClass

	^ UiTextEditor! !

!UiTextMorph methodsFor: 'signals' stamp: 'mt 7/8/2012 14:26:54.298'!
escapePressed: discardedText

	self emit.! !

!UiTextMorph methodsFor: 'signals' stamp: 'mt 3/22/2011 10:44:35.41'!
focusChanged: aRectangle
	"Signal the current area of interest."
	
	self emit.! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/24/2011 10:47:16.57'!
font: aFont

	super font: aFont.
	
	"Store given font index as default font in text style."
	textStyle defaultFontIndex: (textStyle fontIndexOf: aFont).
	
	self styler ifNotNil: [self styler font: aFont].! !

!UiTextMorph methodsFor: 'events-processing' stamp: 'mt 3/22/2011 17:41:12.909'!
handleKeystroke: anEvent 
	"Overridden to avoid tab handling."
	
	anEvent wasHandled
		ifTrue: [^ self].
	(self handlesKeyboard: anEvent)
		ifFalse: [^ self].
	anEvent wasHandled: true.
	^ self keyStroke: anEvent! !

!UiTextMorph methodsFor: 'initialization' stamp: 'mt 3/21/2011 16:59:22.374'!
initialize

	super initialize.
	self
		contents: '';
		autoFit: true;
		wrapFlag: true;
		margins: (3@0 corner: 3@0);
		installEditorToReplace: nil.! !

!UiTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/25/2011 17:41:37.82'!
installEditorToReplace: priorEditor

	| newEditor |
	newEditor := super installEditorToReplace: priorEditor.
	selection ifNotNil: [newEditor selectInterval: selection].

	"Completion."
	newEditor model: self editView.

	^ newEditor! !

!UiTextMorph methodsFor: 'event handling' stamp: 'mt 5/24/2011 10:04:34.358'!
keyDown: aKeyboardEvent

	self editView keyDown: aKeyboardEvent.
	^ super keyDown: aKeyboardEvent.! !

!UiTextMorph methodsFor: 'event handling' stamp: 'mt 7/18/2012 15:57'!
keyStroke: aKeyboardEvent

	| old textEdited |
	old := self text asString.
	
	"Mouse wheel handling in view only."
	(aKeyboardEvent isKeystroke and: [aKeyboardEvent controlKeyPressed] and: [
		aKeyboardEvent keyCharacter = Character arrowUp or: [
		aKeyboardEvent keyCharacter = Character arrowDown]])
		ifTrue: [^ self editView keyStroke: aKeyboardEvent].

	"Must be here and not in #handlesKeyboard: to catch mouse wheel input first. See above."
	self readOnly
		ifTrue: [^ self].
		
	super keyStroke: aKeyboardEvent.
	textEdited := self text ~= old.
	
	self autoConvert
		ifTrue: [self convertText].
	
	"Signal the new text (even if converted) if changed."
	textEdited ifTrue: [self textEdited: self text].
	
	self autoAccept
		ifTrue: [self editor accept].

	(self acceptOnCR and: [{Character lf. Character cr. Character enter} includes: aKeyboardEvent keyCharacter])
		ifTrue: [self editor accept. self returnPressed: self text].

	(self revertOnEscape and: [aKeyboardEvent keyCharacter == Character escape])
		ifTrue: [self revertContents. self escapePressed: self text].

	"Trigger keyboard navigation in scrollable view."
	self focusChanged: self editor pointBlock.
	
	textEdited ifTrue: [self style].
	
	"Allow view to handle short cuts too."
	self editView keyStroke: aKeyboardEvent.! !

!UiTextMorph methodsFor: 'event handling' stamp: 'mt 5/24/2011 10:04:57.838'!
keyUp: aKeyboardEvent

	self editView keyUp: aKeyboardEvent.
	^ super keyUp: aKeyboardEvent.! !

!UiTextMorph methodsFor: 'event handling' stamp: 'mt 4/22/2011 15:29:56.036'!
keyboardFocusChange: aBoolean

	self editView
		keyboardFocusChange: aBoolean.

	self readOnly
		ifTrue: [self stopBlinking. ^ self].

	paragraph ifNotNil: [:p | p focused: aBoolean].
	aBoolean
		ifTrue: [self editor; startBlinking]
		ifFalse: [self stopBlinking].
	
	(aBoolean not and: [self acceptOnFocusLost])
		ifTrue: [self editor accept].! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 4/28/2011 13:02:00.15'!
lineCount

	^ self text asString lines size! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 4/28/2011 13:48:54.043'!
lineCountComposed
	"Answer the visual lines which could differ from #lineCount because the text composer did some linebreaks."

	^ self height // self lineHeight! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 4/28/2011 14:00:07.33'!
lineHeight
	"Return the height of one line in pixel."
	
	self flag: #tofix. "calculation is wrong"
	^ self textStyle leading + self textStyle lineGrid + 1.1! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/24/2011 10:37:29.489'!
newContents: stringOrText
	"Replace all line ending characters if #acceptOnCR is true. This makes sense because the user cannot type these characters anyway."

	self acceptOnCR
		ifTrue: [super newContents: stringOrText asString withoutLineEndings]  
		ifFalse: [super newContents: stringOrText].! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:18:36.853'!
readOnly

	^ readOnly ifNil: [readOnly := false]! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:18:41.109'!
readOnly: aBoolean

	readOnly := aBoolean.! !

!UiTextMorph methodsFor: 'private' stamp: 'mt 4/18/2011 17:53:03.37'!
recompose
	"Re-compose the current contents."
	
	self
		releaseParagraph;
		paragraph.! !

!UiTextMorph methodsFor: 'signals' stamp: 'mt 7/8/2012 14:26:39.589'!
returnPressed: acceptedText

	self emit.! !

!UiTextMorph methodsFor: 'editing' stamp: 'mt 7/8/2012 14:16:53.773'!
revertContents

	self reverted.! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 7/8/2012 14:13:33.022'!
revertOnEscape

	^ revertOnEscape ifNil: [false]! !

!UiTextMorph methodsFor: 'accessing' stamp: 'mt 7/8/2012 14:13:48.719'!
revertOnEscape: aBoolean

	revertOnEscape := aBoolean.! !

!UiTextMorph methodsFor: 'signals' stamp: 'mt 7/8/2012 14:16:26.745'!
reverted

	self emit.! !

!UiTextMorph methodsFor: 'styling' stamp: 'mt 4/28/2011 10:49:59.607'!
style

	self styler ifNil: [^ self].
	
	selection := self editor selectionInterval.
	
	self newContents: (self styler format: self contents).
	
	self contents size < 4096
		ifTrue: [self styler style: self contents]
		ifFalse: [self styler styleInBackgroundProcess: self contents].! !

!UiTextMorph methodsFor: 'styling - accessing' stamp: 'mt 3/24/2011 10:07:52.802'!
styler

	^ styler! !

!UiTextMorph methodsFor: 'styling - accessing' stamp: 'mt 3/24/2011 10:21:28.406'!
styler: aTextStyler

	styler := aTextStyler.
	
	"Setup target for callback functinos."
	styler ifNotNil: [styler
			view: self;
			font: textStyle defaultFont].! !

!UiTextMorph methodsFor: 'styling' stamp: 'mt 5/20/2011 16:55:21.425'!
stylerStyled: styledText

	self contents runs: styledText runs.
	self updateFromParagraph.
	
	selection ifNotNil: [:s |
		self editor
			selectInvisiblyFrom: s first
			to: s last;
			storeSelectionInParagraph;
			setEmphasisHere].

	self editor blinkParen.

	self textStyled: self text.! !

!UiTextMorph methodsFor: 'styling' stamp: 'mt 3/24/2011 10:33:33.377'!
stylerStyledInBackground: styledText

	selection := nil.
	
	self contents string = styledText string
		ifTrue: [self stylerStyled: styledText].! !

!UiTextMorph methodsFor: 'signals' stamp: 'mt 3/22/2011 17:51:17.271'!
textEdited: text
	"Sent whenever text changes during user interaction."
	
	self emit.! !

!UiTextMorph methodsFor: 'signals' stamp: 'mt 5/20/2011 16:55:02.741'!
textStyled: text
	"Sent whenever text was styled."
	
	self emit.! !

!UiTextMorph methodsFor: 'private' stamp: 'mt 3/24/2011 10:22:26.21'!
updateFromParagraph

	| oldEditor |
	paragraph ifNil: [^self].
	wrapFlag ifNil: [wrapFlag := true].

	editor ifNotNil: 	[
		oldEditor := editor.
		editor storeSelectionInParagraph].

	text := paragraph text.

	paragraph textStyle ~= textStyle ifTrue: [
		self
			text: text textStyle: paragraph textStyle;
			releaseParagraph].

	self fit.

	"Reinstate selection after, eg, style change"
	editor ifNil: [self installEditorToReplace: oldEditor].! !

!UiTextMorph methodsFor: 'signals' stamp: 'mt 3/23/2011 09:34:32.707'!
valueChanged: convertedValue

	self emit.! !

!UiTextMorph methodsFor: 'event handling' stamp: 'mt 4/22/2011 16:01:19.394'!
yellowButtonActivity: shiftKeyState! !

LayoutPolicy subclass: #UiComboBoxLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Layouts'!

!UiComboBoxLayout methodsFor: 'as yet unclassified' stamp: 'mt 1/6/2012 10:46:28.532'!
layout: aComboBox in: newBounds

	aComboBox submorphsDo: [:s | s fullBounds].

	aComboBox button topRight: newBounds topRight.
	aComboBox arrowButton topRight: newBounds topRight.
	
	aComboBox lineEdit topLeft: newBounds topLeft.
	aComboBox readOnlyButton topLeft: newBounds topLeft.
	
	aComboBox readOnlyButton width: newBounds width - aComboBox button width - 1.
	aComboBox lineEdit width: newBounds width - aComboBox button width - 1.
	
	"vertical shrink wrap"
	aComboBox height: aComboBox readOnlyButton height.

	aComboBox button height: aComboBox readOnlyButton height.
	aComboBox arrowButton height: aComboBox readOnlyButton height.
	aComboBox lineEdit height: aComboBox readOnlyButton height.! !

TestCase subclass: #UiHtmlTextFormatterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Text'!

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/22/2010 23:06:07.373'!
test01bold

	| text |
	text := '<b>Hello</b>, World!!'.
	self assert: text equals: text asHtmlText printHtmlString.! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/22/2010 23:06:48.692'!
test02italic

	| text |
	text := 'Hel<i>lo</i>, W<i>orl</i>d!!'.
	self assert: text equals: text asHtmlText printHtmlString.! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/22/2010 23:09:02.375'!
test03mixed

	| text |
	text := '<u>Ahahaha!! <b>Hello</b></u>, <i><b>World</b></i>!!'.
	self assert: text ~= text asHtmlText printHtmlString. "Bad Squeak HTML generation."! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/23/2010 09:04:21.741'!
test04runs

	| runs |
	runs := '<u>A<b>B</b></u>C<i><b>D</b></i>E' asHtmlText runs.
	self
		assert: 5 equals: runs size;
		assert: 1 equals: (runs at: 1) size; "underlined"
		assert: 2 equals: (runs at: 2) size; "underlined, bold"
		assert: 0 equals: (runs at: 3) size;
		assert: 2 equals: (runs at: 4) size; "italic, bold"
		assert: 0 equals: (runs at: 5) size.! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/23/2010 09:05:50.632'!
test05color

	| text |
	text := '<font color="#FFFF00">A</font>' asHtmlText.
	self assert: Color yellow equals: (text runs first first color)! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 10/6/2010 17:08:06.834'!
test06size

	| text |
	text := '<font size="9">A</font>' asHtmlText.
	self assert: 9 equals: (text runs first first font pointSize)! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 10/6/2010 17:08:00.418'!
test07sizeAndColor

	| text |
	text := '<font color="#FFFF00" size="9">A</font>' asHtmlText.
	self
		assert: Color yellow equals: (text runs first first color);
		assert: 9 equals: (text runs first second font pointSize)! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 7/18/2012 15:36'!
test08overlapping
	"Open two tags at the beginning but close them deferred."

	| text |
	text := '<b><u>Hello</u> World</b>' asHtmlText.
	self assert: text equals: text asHtmlText printHtmlString.! !

TestCase subclass: #UiSliderTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox-Tests'!

!UiSliderTests methodsFor: 'as yet unclassified' stamp: 'mt 2/25/2011 10:52:00.775'!
setUp

	super setUp.
	sut := UiSlider new.! !

!UiSliderTests methodsFor: 'as yet unclassified' stamp: 'mt 2/25/2011 11:00:25.575'!
test01tracking

	sut
		tracking: true;
		sliderPosition: 0.  
	
	self
		assert: sut hasTracking;
		assert: 0 equals: sut sliderPosition;
		assert: sut sliderPosition = sut currentValue.
	
	sut sliderPosition: 10.
	
	self
		assert: 10 equals: sut sliderPosition;
		assert: sut sliderPosition = sut currentValue.
	
	sut
		tracking: false;
		sliderPosition: 0.
		
	self
		assert: sut hasTracking not;
		assert: sut sliderPosition ~= sut currentValue.    ! !

!UiSliderTests methodsFor: 'as yet unclassified' stamp: 'mt 2/25/2011 10:56:34.319'!
test02valueChange

	sut
		tracking: true;
		currentValue: 0. 
	
	self
		assert: 0 equals: sut currentValue;
		assert: sut sliderPosition = sut currentValue.
	
	sut currentValue: 10.
	
	self
		assert: 10 equals: sut currentValue;
		assert: sut sliderPosition = sut currentValue.
	
	"Should even work without tracking."
	sut
		tracking: false;
		currentValue: 0.
		
	self assert: sut sliderPosition = sut currentValue.    
	
	sut currentValue: 10.
	
	self assert: sut sliderPosition = sut currentValue.    ! !

!UiSliderTests methodsFor: 'as yet unclassified' stamp: 'mt 2/25/2011 10:59:37.261'!
test03range

	sut
		minimum: 0;
		maximum: 10.
		
	self assert: 10 equals: sut range extent.
	
	sut minimum: 5.
	
	self assert: 5 equals: sut range extent.
	
	sut range: (1 to: 9).
	
	self
		assert: 1 equals: sut minimum;
		assert: 9 equals: sut maximum;
		assert: 8 equals: sut range extent.! !

!UiSliderTests methodsFor: 'as yet unclassified' stamp: 'mt 2/25/2011 11:15:09.507'!
test04truncate

	sut
		truncate: false;
		minimum: 0.5;
		maximum: 9.5;
		currentValue: 4.5.
		
	self
		assert: 0.5 equals: sut minimum;
		assert: 9.5 equals: sut maximum;
		assert: 4.5 equals: sut currentValue.
	
	sut truncate: true.

	self
		assert: 1 equals: sut minimum;
		assert: 10 equals: sut maximum;
		assert: 5 equals: sut currentValue.
		
	sut
		minimum: 0.5;
		maximum: 9.5;
		currentValue: 4.5.
		
	self
		assert: 1 equals: sut minimum;
		assert: 10 equals: sut maximum;
		assert: 5 equals: sut currentValue.
! !

TestCase subclass: #UiTableWidgetTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox-Tests'!

!UiTableWidgetTests methodsFor: 'running' stamp: 'mt 1/4/2011 10:14:22.99'!
setUp

	super setUp.
	sut := UiTableWidget new.! !

!UiTableWidgetTests methodsFor: 'tests' stamp: 'mt 1/4/2011 10:39:00.552'!
test01rowCount

	| spy signal |
	spy := SignalSpy new
		addSender: sut model signal: #rowsRemovedFor:from:to:;
		addSender: sut model signal: #rowsInsertedFor:from:to:.

	self assert: 0 equals: sut rowCount.
	sut rowCount: 1.
	signal := spy waitForNextSignal.
	self
		assert: #rowsInsertedFor:from:to: equals: signal first;
		assert: 1 equals: signal second second; "from"
		assert: 1 equals: signal second third; "to"
		assert: 1 equals: sut rowCount;
		assert: 1 equals: sut viewport rows size.! !

SmalltalkEditor subclass: #UiTextEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiTextEditor class methodsFor: 'keyboard shortcut tables' stamp: 'mt 8/8/2012 17:54:29.7'!
initializeCmdKeyShortcuts
	"Make space for new shortcuts."
	super initializeCmdKeyShortcuts.

	#($u $t $f $o $e $y $g $w $h $k) do: [ :shortcut | cmdActions at: shortcut asciiValue + 1 put: #noop: ].
		
	cmdActions at: $t asciiValue + 1 put: #traceIt:! !

!UiTextEditor class methodsFor: 'keyboard shortcut tables' stamp: 'lt 8/2/2012 10:46:44.547'!
initializeShiftCmdKeyShortcuts

	super initializeShiftCmdKeyShortcuts.
	
	shiftCmdActions at: $f asciiValue + 1 put: #noop:! !

!UiTextEditor methodsFor: 'accessing' stamp: 'mt 7/18/2012 16:50:49.163'!
pointBlock

	^ pointBlock! !

!UiTextEditor methodsFor: 'actions' stamp: 'mt 5/5/2011 17:03:34.335'!
traceIt

	self lineSelectAndEmptyCheck: [^ ''].

	SystemChangeNotifier uniqueInstance
		traceSourceCode: self selection asString.! !

!UiTextEditor methodsFor: 'editing keys' stamp: 'mt 7/18/2012 16:57:13.703'!
traceIt: characterStream 
	"CMD+T"
	
	Sensor keyboard.	
	self traceIt.
	^ true! !

UiTextEditor subclass: #UiTextLineEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

Dictionary subclass: #UiPropertyItemNode
	uses: TUiItemModel
	instanceVariableNames: 'keys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiPropertyItemNode commentStamp: 'mt 2/12/2012 15:39:16.114' prior: 0!
This class can be used to build a lightweight adaptor for item views.

Keys are ordered. The key #children is ignored in this order.!

UiPropertyItemNode class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

UiPropertyItemNode subclass: #UiListWidgetItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiListWidgetItem commentStamp: 'mt 2/11/2011 14:49:11.463' prior: 0!
Container for item information to be used by item-based views.!

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 2/2/2012 16:55:40.603'!
balloonText

	^ self at: #balloonText ifAbsent: []! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 2/3/2012 13:25:37.241'!
balloonText: aString

	self at: #balloonText put: aString.
	self propertyChanged: #balloonText.! !

!UiListWidgetItem methodsFor: 'actions' stamp: 'mt 2/3/2012 13:38:28.717'!
delete

	self deleted.! !

!UiListWidgetItem methodsFor: 'signals' stamp: 'mt 2/3/2012 13:36:36.349'!
deleted

	self emit.! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 2/2/2012 16:55:51.876'!
enabled

	^ self at: #enabled ifAbsent: [true]! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 2/3/2012 13:25:52.385'!
enabled: aBoolean

	self at: #enabled put: aBoolean.
	self propertyChanged: #enabled.! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 2/2/2012 16:56:10.053'!
icon

	^ self at: #icon ifAbsent: []! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 2/3/2012 13:25:56.83'!
icon: anObject

	self at: #icon put: anObject.
	self propertyChanged: #icon.! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 2/2/2012 16:56:24.841'!
menu

	^ self at: #menu ifAbsent: []! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 2/3/2012 13:26:04.296'!
menu: aMenuMorph

	self at: #menu put: aMenuMorph.
	self propertyChanged: #menu.! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 2/2/2012 16:56:54.637'!
text

	^ self at: #text ifAbsent: []! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 2/3/2012 13:26:11.471'!
text: anObject

	self at: #text put: anObject.
	self propertyChanged: #text.! !

UiListWidgetItem subclass: #UiTableWidgetItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiPropertyItemNode class methodsFor: 'instance creation' stamp: 'mt 7/21/2012 16:38:11.499'!
newTreeFrom: someAssociations
	"Allow to create a tree structure by following the path of association values."

	| node |
	node := self new.
	someAssociations do: [:assoc |
		| child |
		child := self newTreeFrom: assoc value.
		child data: assoc key.
		node children add: child].
	
	^ node

"	UiPropertyItemNode newFrom: {#apple -> {#green -> {}. #yellow -> {}. #brown -> {#noWorm -> {}} }}.
"! !

!UiPropertyItemNode class methodsFor: 'instance creation' stamp: 'mt 7/21/2012 16:55:16.839'!
newTreeFromPaths: somePaths
	"Create a tree structure from given paths which are lists of nodes."

	^ self new
		addTreeFromPaths: somePaths;
		yourself  ! !

!UiPropertyItemNode class methodsFor: 'instance creation' stamp: 'mt 7/21/2012 17:11:09.524'!
newTreeFromPaths: somePaths withProperties: someBlocks
	"Create a tree structure from given paths which are lists of nodes."

	^ self new
		addTreeFromPaths: somePaths withProperties: someBlocks;
		yourself  ! !

!UiPropertyItemNode methodsFor: 'adding' stamp: 'mt 7/21/2012 17:18:16.822'!
addTreeFromPath: path

	self addTreeFromPath: path withProperties: {}.! !

!UiPropertyItemNode methodsFor: 'adding' stamp: 'mt 7/23/2012 16:15:12.681'!
addTreeFromPath: path withProperties: someBlocks

	| currentChild |
	path ifEmpty: [^ self].
	
	currentChild := self children 
		detect: [:child | child data = path first]  
		ifNone: [
			| newChild |
			newChild := self class new data: path first.
			someBlocks do: [:propertyBlock |
				| propKey propValue |
				propKey := propertyBlock key.
				propValue := propertyBlock value value: newChild data.
				propValue isCollection
					"list of associations"
					ifTrue: [(Dictionary newFrom: propValue) keysAndValuesDo: [:key :value |
						newChild at: propKey, key put: value]]
					"single association"
					ifFalse: [	newChild at: propKey, propValue key put: propValue value]].
			self children add: newChild].
		
	currentChild addTreeFromPath: path allButFirst withProperties: someBlocks.! !

!UiPropertyItemNode methodsFor: 'adding' stamp: 'mt 7/21/2012 17:18:33.446'!
addTreeFromPaths: somePaths

	self addTreeFromPaths: somePaths withProperties: {}! !

!UiPropertyItemNode methodsFor: 'adding' stamp: 'mt 7/21/2012 17:11:36.877'!
addTreeFromPaths: somePaths withProperties: someBlocks

	somePaths do: [:path | self addTreeFromPath: path withProperties: someBlocks].! !

!UiPropertyItemNode methodsFor: 'dictionary' stamp: 'mt 7/11/2012 15:01:34.565'!
at: key put: anObject

	| result wasChanged |
	(key == #children or: [self orderedKeys includes: key])
		ifFalse: [self orderedKeys add: key].
	
	wasChanged := (self at: key ifAbsent: []) ~= anObject.
	
	result := super at: key put: anObject.
	wasChanged ifTrue: [self propertyChanged: key].
	^ result! !

!UiPropertyItemNode methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 11:58:31.405'!
childAt: index
	
	^ self childAt: index inGroup: #children! !

!UiPropertyItemNode methodsFor: 'item model - hierarchy' stamp: 'mt 7/10/2012 11:03:12.655'!
childAt: index inGroup: groupName
	
	^ self children at: index! !

!UiPropertyItemNode methodsFor: 'item model - hierarchy' stamp: 'mt 7/10/2012 11:07:00.536'!
childCount

	^ self childCountInGroup: #children! !

!UiPropertyItemNode methodsFor: 'item model - hierarchy' stamp: 'mt 7/10/2012 13:36:45.058'!
childCountInGroup: groupName

	^ (self at: groupName ifAbsent: [#()]) size! !

!UiPropertyItemNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 15:57:13.789'!
children

	^ self at: #children ifAbsentPut: [OrderedCollection new]! !

!UiPropertyItemNode methodsFor: 'accessing' stamp: 'mt 2/9/2012 15:14:45.991'!
data
	"Universal data entry."
	
	^ self at: #data ifAbsent: []! !

!UiPropertyItemNode methodsFor: 'accessing' stamp: 'mt 2/9/2012 15:14:53.385'!
data: anObject
	"Universal data entry."
	
	self at: #data put: anObject.! !

!UiPropertyItemNode methodsFor: 'error handling' stamp: 'mt 7/5/2012 15:36:01.935'!
doesNotUnderstand: aMessage

	aMessage arguments size > 1 ifTrue: [
		^ super doesNotUnderstand: aMessage].
	
	aMessage arguments ifEmpty: [
		^ self at: aMessage selector].
	
	^ self
		at: aMessage selector allButLast
		put: aMessage arguments first! !

!UiPropertyItemNode methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 10:58:44.004'!
groups
	
	^ #(children)! !

!UiPropertyItemNode methodsFor: 'dictionary' stamp: 'mt 2/12/2012 15:44:57.939'!
orderedKeys

	^ keys ifNil: [keys := OrderedCollection new]! !

!UiPropertyItemNode methodsFor: 'item model - properties' stamp: 'mt 2/12/2012 15:45:29.8'!
properties
	"Return an ordered list of all known properties. This list can then be used to configure column specifications of item views more conveniently."
	
	^ self orderedKeys! !

!UiPropertyItemNode methodsFor: 'dictionary' stamp: 'mt 7/11/2012 11:58:44.517'!
removeKey: key ifAbsent: aBlock

	| result |
	self orderedKeys remove: key ifAbsent: [].
	
	result := super removeKey: key ifAbsent: aBlock.
	self propertyChanged: key.
	^ result! !

!UiPropertyItemNode methodsFor: 'testing' stamp: 'mt 7/5/2012 15:37:41.371'!
respondsTo: aSelector
	"Map keys to messages/accessors."

	^ (super respondsTo: aSelector) or: [(aSelector endsWith: ':')
		ifTrue: [self includesKey: aSelector allButLast]
		ifFalse: [self includesKey: aSelector]]! !

!AbstractEvent methodsFor: '*widgets-events' stamp: 'mt 5/5/2011 10:28:47.956'!
isTraceIt

	^ false! !

!Text methodsFor: '*widgets-text' stamp: 'mt 6/22/2010 23:13:43.314'!
asHtmlText
	"No change here."
	
	^ self! !

BorderedMorph subclass: #UiContainer
	instanceVariableNames: 'editMode focusRectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiContainer commentStamp: 'mt 7/13/2010 09:34:37.877' prior: 0!
I am a, normally invisible, container or owner morph for various UI elements. If I am in #editMode, I support drag&drop operations.!

UiContainer subclass: #UiButtonGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiButtonGroup commentStamp: 'mt 7/13/2010 09:32:47.81' prior: 0!
I am a container for buttons that make my submorphs/buttons auto-exclusive.!

!UiButtonGroup class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:52:38.557'!
widgetClassIcon

	^ UiFugueIcons uiGroupBoxIcon! !

!UiButtonGroup class methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:07:04.687'!
widgetClassName

	^ 'Button Group'! !

!UiButtonGroup methodsFor: 'submorphs-add/remove' stamp: 'mt 7/1/2010 08:23:06.023'!
addMorphBack: aButton

	super addMorphBack: aButton.
	
	aButton autoExclusive: true.
	
	self
		connect: aButton signal: #clicked: toSelector: #clickButton: pattern: #(0);
		connect: aButton signal: #pressed toSelector: #pressButton: pattern: #(0);
		connect: aButton signal: #released toSelector: #releaseButton: pattern: #(0).! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:16:04.263'!
button: anId

	 self submorphs withIndexDo: [:m :i | i = anId ifTrue: [^ m]].
	
	^ nil! !

!UiButtonGroup methodsFor: 'signals' stamp: 'mt 7/1/2010 08:11:14.563'!
buttonClicked: aButton id: anId

	self emit.! !

!UiButtonGroup methodsFor: 'signals' stamp: 'mt 7/1/2010 08:11:30.004'!
buttonPressed: aButton id: anId

	self emit.! !

!UiButtonGroup methodsFor: 'signals' stamp: 'mt 7/1/2010 08:11:48.494'!
buttonReleased: aButton id: anId

	self emit.! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:10:28.017'!
checkedButton

	^ self submorphs detect: [:m | m isChecked] ifNone: [nil]! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:10:20.631'!
checkedId

	self submorphs withIndexDo: [:m :i | m isChecked ifTrue: [^ i]].
	^ 0! !

!UiButtonGroup methodsFor: 'private' stamp: 'mt 7/1/2010 08:16:32.662'!
clickButton: aButton

	self buttonClicked: aButton id: (self id: aButton)! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:14:12.383'!
id: aButton

	self submorphs withIndexDo: [:m :i | m == aButton ifTrue: [^ i]].
	^ 0! !

!UiButtonGroup methodsFor: 'private' stamp: 'mt 7/1/2010 08:16:44.088'!
pressButton: aButton

	self buttonPressed: aButton id: (self id: aButton)! !

!UiButtonGroup methodsFor: 'private' stamp: 'mt 7/1/2010 08:16:54.688'!
releaseButton: aButton

	self buttonReleased: aButton id: (self id: aButton).! !

!UiButtonGroup methodsFor: 'dropping/grabbing' stamp: 'mt 7/9/2012 16:42:57.404'!
wantsDroppedMorph: aMorph event: evt

	(((aMorph isKindOf: TransferMorph)
		and: [UiButton subclasses includes: (aMorph passenger at: #class)])
		or: [aMorph isKindOf: UiButton])
		ifTrue: [^ super wantsDroppedMorph: aMorph event: evt].
	
	^ false! !

!UiContainer class methodsFor: 'testing' stamp: 'mt 6/28/2010 21:36:20.651'!
isWidgetClass

	^ true! !

!UiContainer class methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:45:30.19'!
widgetCategory
	
	^ 'Containers & Spacer'! !

!UiContainer class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:50:47.132'!
widgetClassIcon

	^ UiFugueIcons uiPanelIcon! !

!UiContainer class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:22:49.177'!
widgetClassName

	^ 'Widget Container'! !

!UiContainer class methodsFor: 'properties' stamp: 'mt 10/28/2010 16:52:48.311'!
widgetProperties

	^ super widgetProperties, {{'Container'. #yourself} -> {
		#color -> Object.
		#borderWidth -> Integer.
		#borderStyle2 -> #(simple inset raised).
		#borderColor -> Object}}! !

!UiContainer methodsFor: 'dropping/grabbing' stamp: 'mt 7/22/2012 09:22:01.902'!
acceptDroppingMorph: aMorph event: evt

	| result |
	(aMorph isKindOf: TransferMorph)
		"Hard-wired with UiWidgetModel. Baaaaad."
		ifTrue: [ (aMorph passenger first at: #class ifAbsent: []) ifNotNil: [:widgetClass |
			| widget |
			widget := widgetClass new position: evt position.
			self addMorphBack: widget.
			(widget isKindOf: UiContainer)
				ifTrue: [widget editMode: self editMode].

			self
				changeFocusTo: widget bounds;
				changeSelectionTo: widget.
				
			^ self]].

	result := super acceptDroppingMorph: aMorph event: evt.
	
	self
		changeFocusTo: aMorph bounds;
		changeSelectionTo: aMorph.
	
	^ result! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 10/28/2010 15:29:55.046'!
borderStyle2

	^ self borderColor isSymbol
		ifTrue: [self borderColor]
		ifFalse: [#simple]! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 10/28/2010 15:31:30.474'!
borderStyle2: aSymbol

	aSymbol ifNil: [^ self].
	
	aSymbol = #simple
		ifTrue: [^ self borderColor: Color transparent].
	
	^ self borderColor: aSymbol! !

!UiContainer methodsFor: 'focus' stamp: 'mt 10/23/2010 09:50:30.956'!
changeFocusTo: aRectangle

	(self owner isKindOf: UiContainer)
		ifTrue: [^ self owner changeFocusTo: aRectangle].
	
	aRectangle = self bounds
		ifTrue: [focusRectangle := nil].
	
	focusRectangle := aRectangle ifNotNil: [:r | r outsetBy: (2@2)].
	self redrawLater.! !

!UiContainer methodsFor: 'selection' stamp: 'mt 10/28/2010 16:17:10.322'!
changeSelectionTo: aMorph
	"Talk to root container."

	(self owner isKindOf: UiContainer)
		ifTrue: [self owner changeSelectionTo: aMorph]
		ifFalse: [	self selectionChanged: aMorph].
			
	aMorph addHalo.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/24/2010 11:07:59.575'!
click: evt

"	| clickedMorph |
	clickedMorph := self submorphs detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	evt yellowButtonPressed ifTrue: [
		self showContextMenuForMorph: clickedMorph atHand: evt hand]."
	
	| clickedMorph |
	clickedMorph := self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
		
	self
		changeFocusTo: clickedMorph bounds;
		changeSelectionTo: clickedMorph.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/27/2010 13:43:16.726'!
doubleClick: evt! !

!UiContainer methodsFor: 'drawing' stamp: 'mt 10/26/2010 20:20:20.839'!
drawFocusOn: aCanvas rectangle: aRect
	
"	aCanvas
		frameRectangle: (aRect insetBy: 1)
		color: (Color r: 0.5 g: 0.5 b: 1.0 alpha: 0.8) muchDarker.
		
	aCanvas
		frameRoundRect: aRect
		radius: 3
		width: 1
		color: (Color r: 0.5 g: 0.5 b: 1.0 alpha: 0.5) muchDarker."! !

!UiContainer methodsFor: 'drawing' stamp: 'mt 10/28/2010 11:08:59.269'!
drawOn: aCanvas

	self editMode
		ifFalse: [^ super drawOn: aCanvas].
	
	aCanvas
		fillRectangle: self bounds
		fillStyle: ((self color = Color transparent)
			ifTrue: [SolidFillStyle color: ((Color gray: 0.3) alpha: 0.1)]
			ifFalse: [self fillStyle])
		borderStyle: self borderStyle.

	focusRectangle ifNotNil: [self drawFocusOn: aCanvas rectangle: focusRectangle].! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:17:26.068'!
editMode

	^ editMode ifNil: [editMode := false]! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 10/28/2010 11:07:21.218'!
editMode: aBoolean

	editMode := aBoolean.
	
	self dropEnabled: editMode.
	self dragEnabled: editMode.
	
	self submorphs
		select: [:m | m isKindOf: UiContainer]
		thenDo: [:m | m editMode: aBoolean].! !

!UiContainer methodsFor: 'signals' stamp: 'mt 6/28/2010 11:03:51.082'!
focusChanged: aBoolean

	self emit.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/30/2010 09:18:46.354'!
handlesMouseDown: evt

	^ self editMode! !

!UiContainer methodsFor: 'initialization' stamp: 'mt 10/26/2010 20:01:29.289'!
initialize

	super initialize.
	self
		extent: 100@100;
		color: Color transparent;
		borderWidth: 0;
		cellInset: 4;
		layoutInset: 4.! !

!UiContainer methodsFor: 'testing' stamp: 'mt 10/27/2010 20:39:00.491'!
isUiContainer

	^ true! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/28/2010 11:03:39.618'!
keyboardFocusChange: aBoolean

	self focusChanged: aBoolean.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/23/2010 10:06:01.973'!
mouseDown: evt

	"| clickedMorph |
	clickedMorph := self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	self submorphs do: [:m |
		m ~~ clickedMorph
			ifTrue: [m setProperty: #hasFocus toValue: false]].
	self setProperty: #hasFocus toValue: false.
	
	clickedMorph setProperty: #hasFocus toValue: true.
	self changeSelectionTo: clickedMorph."

	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. nil. nil. #startDrag:}
		threshold: 1. "pixel threshold"
		
	"self redrawLater.
	(self owner isKindOf: UiContainer) ifTrue: [self owner redrawLater]."! !

!UiContainer methodsFor: 'events-processing' stamp: 'mt 6/30/2010 09:18:26.354'!
mouseDownPriority
	"Give me ALL events."
	
	self editMode ifFalse: [^ super mouseDownPriority].
	^ 100! !

!UiContainer methodsFor: 'geometry' stamp: 'mt 12/9/2011 13:26:25.452'!
outerBounds

	^ super outerBounds
	"(self owner isKindOf: UiContainer)
		ifTrue: [^ self bounds outsetBy: (3@3 corner: 3@3)]
		ifFalse: [^ self bounds]."! !

!UiContainer methodsFor: 'signals' stamp: 'mt 6/30/2010 09:29:37.854'!
selectionChanged: aMorph

	self emit.! !

!UiContainer methodsFor: 'context menu' stamp: 'mt 6/28/2010 11:13:33.993'!
showContextMenuForMorph: aMorph atHand: aHand

	| menu |
	menu := SBMenu new.
	
	self
		connect: (menu addAction: (SBAction new text: 'vResizing'))
		signal: #triggered
		to: aMorph
		selector: #vResizing:
		pattern: #(=#spaceFill).
	
	"Clean up the menu."
	menu connect: self signal: #focusChanged: toSelector: #delete.
	
	"Get focus and show menu."
	aHand newKeyboardFocus: self.
	menu popUp..! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/24/2010 11:08:08.144'!
startDrag: evt

	| morphToDrag |
	morphToDrag := self submorphs
		detect: [:m | m bounds containsPoint: evt position]
		ifNone: [self dragEnabled
			ifTrue: [self]
			ifFalse: [nil]].
	
	self changeFocusTo: nil.
			
	morphToDrag ifNil: [^ self].
	
	evt redButtonPressed
		ifTrue: [evt hand grabMorph: morphToDrag].! !

!UiContainer methodsFor: 'dropping/grabbing' stamp: 'mt 6/28/2010 16:46:21.331'!
wantsDroppedMorph: aMorph event: evt

	self redrawLater.
	^ super wantsDroppedMorph: aMorph event: evt! !

UiContainer subclass: #UiSpacer
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiSpacer class methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:44:49.988'!
widgetClassIcon

	^ UiFugueIcons uiAccordionIcon! !

!UiSpacer class methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:43:44.923'!
widgetClassName

	^ 'Spacer'! !

!UiSpacer class methodsFor: 'properties' stamp: 'mt 10/26/2010 20:07:37.101'!
widgetProperties

	^ super widgetProperties, {{'Spacer'. #yourself} -> {
		#orientation -> #(horizontal vertical)}}! !

!UiSpacer class methodsFor: 'properties' stamp: 'mt 10/27/2010 09:42:04.578'!
widgetPropertiesToIgnore

	^ #(hResizing vResizing 'TableLayout' 'ProportionalLayout')! !

!UiSpacer methodsFor: 'drawing' stamp: 'mt 10/28/2010 10:58:19.197'!
drawOn: aCanvas

	self editMode ifFalse: [^ self].
	
	self orientation = #horizontal ifTrue: [
		aCanvas
			line: self topLeft to: self bottomLeft color: self color;
			line: self topRight to: self bottomRight color: self color;
			line: self topLeft + (0@(self height // 2)) to: self topRight + (0@(self height // 2)) color: self color].
		
	self orientation = #vertical ifTrue: [
		aCanvas
			line: self topLeft to: self topRight color: self color;
			line: self bottomLeft to: self bottomRight color: self color;
			line: self topLeft + ((self width // 2) @ 0) to: self bottomLeft + ((self width // 2) @ 0) color: self color].! !

!UiSpacer methodsFor: 'initialization' stamp: 'mt 4/13/2011 12:48:43.871'!
initialize

	super initialize.
	self
		color: Color blue;
		orientation: #horizontal;
		extent: 50@20;
		layoutInset: 0;
		cellInset: 0.! !

!UiSpacer methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:57:59.594'!
orientation

	^ orientation! !

!UiSpacer methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:57:51.389'!
orientation: aSymbol
	"#horizontal, #vertical"

	orientation == aSymbol
		ifTrue: [^ self].
		
	orientation := aSymbol.
	self updateLayout.! !

!UiSpacer methodsFor: 'geometry' stamp: 'mt 10/26/2010 20:04:04.927'!
outerBounds

	^ self bounds outsetBy: (0@0 corner: 1@1)! !

!UiSpacer methodsFor: 'updating' stamp: 'mt 4/13/2011 12:48:05.116'!
updateLayout

	self orientation = #horizontal
		ifTrue: [self
			extent: self height @ self width;
			hResizing: #spaceFill;
			vResizing: #rigid].
		
	self orientation = #vertical
		ifTrue: [self
			extent: self height @ self width;
			hResizing: #rigid;
			vResizing: #spaceFill].
		
	self redrawLater.! !

!UiSpacer methodsFor: 'dropping/grabbing' stamp: 'mt 10/26/2010 19:37:26.982'!
wantsDroppedMorph: aMorph event: evt

	^ false! !

UiContainer subclass: #UiStackedWidget
	instanceVariableNames: 'pages nextPageButton previousPageButton addPageButton removePageButton currentIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiStackedWidget class methodsFor: 'testing' stamp: 'mt 2/12/2011 12:28:22.186'!
isExperimentalWidgetClass

	^ true! !

!UiStackedWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:53:08.176'!
widgetClassIcon

	^ UiFugueIcons uiLayeredPaneIcon! !

!UiStackedWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:05:23.132'!
widgetClassName

	^ 'Stacked Widget'! !

!UiStackedWidget methodsFor: 'dropping/grabbing' stamp: 'mt 10/26/2010 19:40:20.732'!
acceptDroppingMorph: aMorph event: evt

	(aMorph isKindOf: TransferMorph)
		ifTrue: [(aMorph passenger model widgetAt: aMorph passenger) ifNotNil: [:widgetClass |
			| widget |
			widget := widgetClass new position: evt position.
			self currentPage addMorphBack: widget.
			(widget isKindOf: UiContainer)
				ifTrue: [widget editMode: self editMode].
				
			self
				changeFocusTo: widget bounds;
				changeSelectionTo: widget]]
		ifFalse: [
			self currentPage addMorphBack: aMorph.
			
			self
				changeFocusTo: aMorph bounds;
				changeSelectionTo: aMorph].
		
	"self updateCurrentPage."! !

!UiStackedWidget methodsFor: 'add/remove' stamp: 'mt 7/14/2010 10:40:49.279'!
addPage

	self pages add: UiWidgetPage new.
	self currentIndex: self pages size.! !

!UiStackedWidget methodsFor: 'event handling' stamp: 'mt 10/23/2010 10:03:25.639'!
click: evt

	| clickedMorph |
	clickedMorph := self currentPage submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	clickedMorph == self
		ifTrue: [self
			changeFocusTo: self currentPage bounds;
			changeSelectionTo: self currentPage]
		ifFalse: [self
			changeFocusTo: clickedMorph bounds;
			changeSelectionTo: clickedMorph].! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 09:54:24.59'!
currentIndex

	^ currentIndex! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 10:00:45.703'!
currentIndex: anInteger

	(anInteger = currentIndex
		or: [anInteger < 1]
		or: [anInteger > self pages size]) ifTrue: [^ self].
	
	currentIndex := anInteger.
	
	self updateCurrentPage.! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 10:19:46.577'!
currentPage

	^ self pages at: self currentIndex.! !

!UiStackedWidget methodsFor: 'initialization' stamp: 'mt 7/16/2010 13:12:51.61'!
initialize

	| buttonContainer |
	super initialize.
	
	nextPageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons arrow000SmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Next Page'.

	self connect: nextPageButton signal: #clicked: toSelector: #nextPage.
		
	previousPageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons arrow180SmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Previous Page'.
	
	self connect: previousPageButton signal: #clicked: toSelector: #previousPage.

	addPageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons plusSmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Add Page'.

	self connect: addPageButton signal: #clicked: toSelector: #addPage.

	removePageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons minusSmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Remove Page'.

	self connect: removePageButton signal: #clicked: toSelector: #removeCurrentPage.
	
	buttonContainer := UiWidgetPageButtonContainer new.
	
	buttonContainer
		addMorphBack: addPageButton;
		addMorphBack: removePageButton;
		addMorphBack: previousPageButton;
		addMorphBack: nextPageButton.
	
	self changeTableLayout.
	self addMorphBack: buttonContainer.
	self addPage. "First empty page."! !

!UiStackedWidget methodsFor: 'navigation' stamp: 'mt 7/13/2010 10:15:59.084'!
nextPage

	self currentIndex: (self currentIndex + 1 min: self pages size).! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 09:36:45.708'!
pages

	^ pages ifNil: [pages := OrderedCollection new]! !

!UiStackedWidget methodsFor: 'navigation' stamp: 'mt 7/13/2010 10:16:13.279'!
previousPage

	self currentIndex: (self currentIndex - 1 max: 1).! !

!UiStackedWidget methodsFor: 'add/remove' stamp: 'mt 7/16/2010 13:13:05.39'!
removeCurrentPage

! !

!UiStackedWidget methodsFor: 'event handling' stamp: 'mt 7/13/2010 10:09:25.305'!
startDrag: evt

	| morphToDrag |
	morphToDrag := self currentPage submorphs
		detect: [:m | m bounds containsPoint: evt position]
		ifNone: [self dragEnabled
			ifTrue: [self]
			ifFalse: [nil]].
			
	morphToDrag ifNil: [^ self].
	
	evt redButtonPressed
		ifTrue: [evt hand grabMorph: morphToDrag].! !

!UiStackedWidget methodsFor: 'updating' stamp: 'mt 10/23/2010 09:39:13.865'!
updateCurrentPage

	| buttonContainer |
	buttonContainer := nextPageButton owner.
	
	self
		removeAllMorphs;
		addMorphBack: self currentPage;
		addMorphFront: buttonContainer;
		changeFocusTo: self currentPage bounds;
		changeSelectionTo: self currentPage.! !

TransformMorph subclass: #UiTransformMorph
	instanceVariableNames: 'drawCache usesDrawCache drawCacheActivationFlag drawCacheFlag drawCacheUpdateFlag drawCacheActive moveFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiTransformMorph commentStamp: 'mt 4/25/2011 08:34:54.693' prior: 0!
A transform morph that provides signals.

A draw cache offers an experimental feature that speeds-up redraw for large transform morphs with complex contents. Activate it via #drawCacheActive:.

A hand that contains submorphs (i.e., is dragging something) will trigger an offset change in corner areas.  !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 2/27/2011 17:02:46.165'!
angle: aNumber

	self angle = aNumber ifTrue: [^ self] .
	super angle: aNumber.
	self angleChanged: self angle.  ! !

!UiTransformMorph methodsFor: 'signals' stamp: 'mt 2/27/2011 17:00:55.169'!
angleChanged: aNumber

	self emit.! !

!UiTransformMorph methodsFor: 'signals' stamp: 'mt 3/24/2011 14:50:28.433'!
areaChanged
	"Sent whenever the feasible area, the offset can be used for, changed."

	self emit.! !

!UiTransformMorph methodsFor: 'caching' stamp: 'mt 4/20/2011 14:14:22.928'!
drawCacheActive
	"Indicate whether drawing should gain a speedup using a cache."	

	^ drawCacheActive ifNil: [false]! !

!UiTransformMorph methodsFor: 'caching' stamp: 'mt 4/20/2011 14:15:23.428'!
drawCacheActive: aBoolean

	aBoolean = drawCacheActive ifTrue: [^ self].

	drawCacheActive := aBoolean.
	
	drawCacheActive
		ifTrue: [self startStepping]
		ifFalse: [self
			stopStepping;
			redrawLater].! !

!UiTransformMorph methodsFor: 'drawing - cached' stamp: 'mt 4/20/2011 13:47:28.557'!
drawCacheOn: aCanvas
	
	aCanvas
		transformBy: transform
		clippingTo: self innerBounds
		during: [:myCanvas | myCanvas translucentImage: drawCache at: 0@0]
		smoothing: smoothing.! !

!UiTransformMorph methodsFor: 'drawing' stamp: 'mt 4/20/2011 13:47:36.915'!
drawSubmorphsOn: aCanvas

	(self usesDrawCache not or: [drawCache isNil])
		ifTrue: [^ super drawSubmorphsOn: aCanvas].

	self drawCacheOn: aCanvas.  ! !

!UiTransformMorph methodsFor: 'submorphs-accessing' stamp: 'mt 3/24/2011 15:06:05.221'!
firstSubmorph
	
	^ self submorphs
		ifEmpty: []
		ifNotEmpty: [self submorphs first]! !

!UiTransformMorph methodsFor: 'layout' stamp: 'mt 4/20/2011 14:16:25.082'!
fullBounds

	| result |
	fullBounds ifNotNil: [^ fullBounds].
	
	result := super fullBounds.

	"Force re-layouting of one an only submorph."	
	self firstSubmorph ifNotNil: [:m |
		m fullBounds.
		self areaChanged.
		
		"IS this the right place to invalidate the cache?"
		drawCacheUpdateFlag := #tryUpdateCache].

	^ result! !

!UiTransformMorph methodsFor: 'drawing - cached' stamp: 'mt 5/19/2011 15:13:27.463'!
fullDrawCacheOn: aCanvas
	"Update the cache if cache is nil. then use the cache to draw."
	
	self
		updateDrawCache;
		drawCacheOn: aCanvas.! !

!UiTransformMorph methodsFor: 'events-processing' stamp: 'mt 8/16/2012 09:46:49.365'!
handleMouseMove: anEvent
	"Receive any mouse move event."
	
	super handleMouseMove: anEvent.
	
	(anEvent hand hasSubmorphs and: [self firstSubmorph notNil] and: [self firstSubmorph dropEnabled])
		ifTrue: [moveFlag := #doMoveScrolling.
			self isStepping ifFalse: [self startStepping]]
		ifFalse: [moveFlag := #idle.
			self drawCacheActive ifFalse: [self stopStepping]].! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:33:49.654'!
horizontalOffset

	^ self offset x! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:36:11.99'!
horizontalOffset: aNumber

	aNumber = self horizontalOffset ifTrue: [^ self].
	
	self offset: aNumber @ self offset y.

	self horizontalOffsetChanged: self horizontalOffset.  ! !

!UiTransformMorph methodsFor: 'signals - specific' stamp: 'mt 3/7/2011 09:35:09.391'!
horizontalOffsetChanged: aNumber

	self emit.! !

!UiTransformMorph methodsFor: 'initialization' stamp: 'mt 4/22/2011 08:43:39.362'!
initialize

	super initialize.
	
	self
		color: Color white;
		drawCacheActive: false.  ! !

!UiTransformMorph methodsFor: 'testing' stamp: 'mt 6/13/2012 17:15:26.501'!
isTransformMorph

	^ true! !

!UiTransformMorph methodsFor: 'geometry' stamp: 'mt 4/27/2011 17:14:43.927'!
layoutChanged

	localBounds := nil.
	fullBounds := nil.! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 6/14/2012 09:34:21.145'!
offset: aPoint

	| tPoint |
	tPoint := aPoint truncated max: 0@0.
	
	tPoint = self offset ifTrue: [^ self].

	self drawCacheActive ifTrue: [
		drawCacheFlag := #raised.
		drawCache
			ifNil: [self scheduleDrawCacheUpdate]
			ifNotNil: [self usesDrawCache: true]].
	
	"super offset: tPoint."
	transform := transform withOffset: tPoint - self innerBounds topLeft.
	self redraw.

	self
		offsetChanged: self offset;
		horizontalOffsetChanged: self offset x;
		verticalOffsetChanged: self offset y.! !

!UiTransformMorph methodsFor: 'signals' stamp: 'mt 2/27/2011 17:00:35.308'!
offsetChanged: aPoint

	self emit.! !

!UiTransformMorph methodsFor: 'caching' stamp: 'mt 5/16/2011 17:38:03.529'!
processCacheFlags

	self drawCacheActive
		ifFalse: [^ self].

	self usesDrawCache ifFalse: [
		"If cache update is already defered, schedule it now."
		drawCacheUpdateFlag = #deferUpdateCache
			ifTrue: ["self scheduleDrawCacheUpdate"
				self flag: #tofix.
				drawCache := nil].
		
		"If someone wants to update the cache, try to defer it."
		drawCacheUpdateFlag = #tryUpdateCache
			ifTrue: [drawCacheUpdateFlag := #deferUpdateCache].
		
		] ifTrue: [
		drawCacheFlag = #raised
			ifTrue: [drawCacheFlag := #cleared]
			ifFalse: [	self usesDrawCache: false]].! !

!UiTransformMorph methodsFor: 'drag scrolling' stamp: 'mt 4/25/2011 10:49:07.838'!
processMoveFlag

	self firstSubmorph ifNil: [^ self].

	(ActiveHand hasSubmorphs and: [moveFlag = #doMoveScrolling])
		ifTrue: [self updateOffsetByHand: ActiveHand]
		ifFalse: [moveFlag := #idle.
			self drawCacheActive ifFalse: [self stopStepping]].! !

!UiTransformMorph methodsFor: 'drawing' stamp: 'mt 3/22/2012 15:21:52.755'!
redraw
	"Override to use double buffering with BitBlt."
	
	(self usesDrawCache not or: [drawCache isNil])
		ifTrue: [^ self redrawLater].
	
	Display deferUpdates: true.	
	self fullDrawOn: Display getCanvas.
	Display forceToScreen: (self visibleBounds insetBy: (0@0 corner: 1@1)).! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 2/27/2011 17:03:04.995'!
scale: aNumber

	self scale = aNumber ifTrue: [^ self] .
	super scale: aNumber.
	self scaleChanged: self scale.! !

!UiTransformMorph methodsFor: 'signals' stamp: 'mt 2/27/2011 17:00:48.104'!
scaleChanged: aNumber

	self emit.! !

!UiTransformMorph methodsFor: 'caching' stamp: 'mt 5/19/2011 14:15:03.752'!
scheduleDrawCacheUpdate

	drawCache := nil.
	drawCacheUpdateFlag := #idle.

	WorldState addDeferredUIMessage: [
		self usesDrawCache ifFalse: [self updateDrawCache]].! !

!UiTransformMorph methodsFor: 'stepping' stamp: 'mt 4/25/2011 08:31:49.851'!
step

	self
		processCacheFlags;
		processMoveFlag.! !

!UiTransformMorph methodsFor: 'stepping' stamp: 'mt 4/20/2011 13:38:06.041'!
stepTime

	^ 100! !

!UiTransformMorph methodsFor: 'drawing - cached' stamp: 'mt 6/19/2012 18:07:05.607'!
updateDrawCache

	| cacheCanvas |
	drawCache ifNotNil: [^ self].
	
	drawCache := Form extent: self firstSubmorph extent depth: 32.
	cacheCanvas := drawCache getCanvas.
	cacheCanvas fillColor: (Color gray: 0.3).
	submorphs reverseDo: [:m | m fullDrawCacheOn: cacheCanvas].
	
	drawCacheUpdateFlag := #idle.! !

!UiTransformMorph methodsFor: 'drag scrolling' stamp: 'mt 5/2/2011 11:30:37.883'!
updateOffsetByHand: aHand

	| threshold pos dx dy maxDelta |
	threshold := 50. "in pixel"
	maxDelta := 30. "will be interpolated linear in threshold"
	pos := self globalPointToLocal: aHand position.
	dx := 0. "horizontal offset delta"
	dy := 0. "vertical offset delta"
	
	(self bounds containsPoint: pos) ifTrue: [
		dx := dx - (((1.0 - ((pos - self left) x / threshold)) max: 0) * maxDelta).
		dx := dx + (((1.0 - ((self right - pos) x / threshold)) max: 0) * maxDelta).
		dy := dy - (((1.0 - ((pos - self top) y / threshold)) max: 0) * maxDelta).
		dy := dy + (((1.0 - ((self bottom - pos) y / threshold)) max: 0) * maxDelta)].
	
	self offset: ((self offset + (dx @ dy))
		min: self firstSubmorph extent - self extent
		max: 0@0).! !

!UiTransformMorph methodsFor: 'caching' stamp: 'mt 4/20/2011 14:14:35.12'!
usesDrawCache
	"Indicate if a cache is used just now."
	
	^ usesDrawCache ifNil: [usesDrawCache := false]! !

!UiTransformMorph methodsFor: 'caching' stamp: 'mt 5/3/2011 13:53:18.125'!
usesDrawCache: aBoolean

	aBoolean = usesDrawCache ifTrue: [^ self].

	usesDrawCache := aBoolean.
	
	usesDrawCache ifFalse: [self redraw].! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:33:57.533'!
verticalOffset

	^ self offset y! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:36:39.622'!
verticalOffset: aNumber

	aNumber = self verticalOffset ifTrue: [^ self].
	
	self offset: self offset x @ aNumber.
	
	self verticalOffsetChanged: self verticalOffset.  ! !

!UiTransformMorph methodsFor: 'signals - specific' stamp: 'mt 3/7/2011 09:35:04.739'!
verticalOffsetChanged: aNumber

	self emit.! !

!OrderedCollection methodsFor: '*widgets-support' stamp: 'mt 10/9/2010 15:41:33.496'!
reverseDetect: aBlock

	^ self reverseDetect: aBlock ifNone: [self errorNotFound: aBlock]! !

!OrderedCollection methodsFor: '*widgets-support' stamp: 'mt 10/9/2010 15:41:12.167'!
reverseDetect: aBlock ifNone: exceptionBlock

	self reverseDo: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value	! !

!Form methodsFor: '*widgets-support' stamp: 'mt 8/16/2012 14:34:32.226'!
adjustBrightness: aFloat

	^ self collectColors: [:color | color adjustBrightness: aFloat]! !

!Form methodsFor: '*widgets-support' stamp: 'mt 9/2/2010 11:52:12.191'!
asGrayScale2

	^ self collectColors: [:c | c isTransparent
		ifTrue: [c]
		ifFalse: [Color gray: c luminance]]! !

!Form methodsFor: '*widgets-support' stamp: 'mt 8/16/2012 16:28:27.096'!
asWireframe

	^ self collectColors: [:c | Color black alpha: c alpha]! !

!Form methodsFor: '*widgets-support' stamp: 'mt 8/16/2012 16:49:26.441'!
asWireframe2

	^ self collectColors: [:c |
		c brightness > 0.8
			ifTrue: [Color transparent]
			ifFalse: [Color black alpha: c alpha]]! !

!Form methodsFor: '*widgets-support' stamp: 'mt 7/16/2010 13:08:02.826'!
clippedTo: aPoint
 	"Return a copy of this form that is clipped to the given size around the center."
	
	| newForm |
	newForm := self class extent: aPoint depth: depth.
	^ newForm copyBits: ((0@0 corner: aPoint) translateBy: (self extent - aPoint) // 2) from: self at: 0@0
		clippingBox: newForm boundingBox rule: Form over fillColor: nil! !

!Form methodsFor: '*widgets-support' stamp: 'mt 8/16/2012 14:35:03.067'!
muchLighter

	^ self collectColors: [:color | color adjustBrightness: 0.4]! !

MouseEvent subclass: #UiMouseWheelEvent
	instanceVariableNames: 'direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Events'!

!UiMouseWheelEvent commentStamp: 'mt 3/11/2011 16:34:25.021' prior: 0!
A mouse event generated by intercepting the keyboard events (ctrl+up/down arrow) generated by the VM in response to mouse wheel activity.!

!UiMouseWheelEvent methodsFor: 'accessing' stamp: 'mt 4/16/2010 13:52:21.616'!
direction
	^ direction! !

!UiMouseWheelEvent methodsFor: 'accessing' stamp: 'mt 4/16/2010 13:52:21.706'!
direction: anObject
	direction := anObject! !

!UiMouseWheelEvent methodsFor: 'testing' stamp: 'mt 4/16/2010 13:52:40.662'!
isMouseWheel

	^ true! !

!UiMouseWheelEvent methodsFor: 'dispatching' stamp: 'mt 4/16/2010 13:54:16.355'!
sentTo: anObject
	"Dispatch the receiver into anObject"
	
	type == #mouseWheel ifTrue:[^anObject handleMouseWheel: self].
	^super sentTo: anObject.! !

!UiMouseWheelEvent methodsFor: 'dispatching' stamp: 'mt 4/16/2010 13:54:24.836'!
setType: evtType position: evtPos direction: dirSymbol buttons: evtButtons hand: evtHand stamp: stamp
	"Set the state for the receiver."
	
	type := evtType.
	position := evtPos.
	buttons := evtButtons.
	source := evtHand.
	wasHandled := false.
	direction := dirSymbol.
	timeStamp := stamp.! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 2/12/2011 12:26:11.435'!
isExperimentalWidgetClass
	"Indicate whether this widget CAN NOT be expected as feature-complete and stable and therefore SHOULD NOT BE USED."
	
	^ false! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 6/28/2010 21:31:27.001'!
isWidgetClass

	^ false! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/19/2010 13:31:11.159'!
widgetCategory
	
	^ 'Classic Morphs'! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/19/2010 11:46:11.254'!
widgetClassIcon

	^ nil! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/19/2010 13:38:38.799'!
widgetClassName

	^ self name! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/28/2010 16:54:01.158'!
widgetProperties
	"Describe custom properties for this type of widget."
	
	^ {{'Morph'. #yourself} -> {
		#balloonText -> String.
		#balloonColor -> Object}}! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 7/16/2010 11:22:50.821'!
widgetPropertiesToIgnore
	"Describe properties that should not appear in the designer."
	
	^ #()! !

!Morph methodsFor: '*widgets' stamp: 'mt 4/29/2011 15:07:55.523'!
balloonText: stringOrText

	^ self setBalloonText: (stringOrText
		ifNotNil: [:s | s ifEmpty: []])! !

!Morph methodsFor: '*widgets-signals-processing' stamp: 'mt 6/14/2012 09:09:15.465'!
disconnectAllSignals

	self removeProperty: #signalConnections.! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 1/2/2012 17:24:01.244'!
enabled
	"Check whether this morph is capable of proecssing user input events."
	
	^ self
		valueOfProperty: #enabled
		ifAbsentPut: [true]! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 1/2/2012 17:23:37.826'!
enabled: aBoolean

	self setProperty: #enabled toValue: aBoolean.
	self redrawLater.! !

!Morph methodsFor: '*widgets-geometry-override' stamp: 'mt 6/14/2012 09:18:57.546'!
extent: aPoint

	(bounds extent closeTo: aPoint) ifTrue: [^ self].
	self changed.
	bounds := bounds topLeft extent: aPoint.
	self layoutChanged.
	self changed.

	"Widgets: Emit extent change."
	self extentChanged: aPoint.! !

!Morph methodsFor: '*widgets-signals' stamp: 'mt 6/14/2012 09:18:29.676'!
extentChanged: aPoint

	self emit.! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:21:50.604'!
frameFractions

	self layoutFrame ifNil: [^ 0@0 corner: 1@1].
	^ self layoutFrame leftFraction @ self layoutFrame topFraction
		corner:
		self layoutFrame rightFraction @ self layoutFrame bottomFraction! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:29:01.842'!
frameFractions: aRectangle

	| frame |
	frame := self layoutFrame ifNil: [LayoutFrame new].
	frame
		topFraction: aRectangle top;
		bottomFraction: aRectangle bottom;
		leftFraction: aRectangle left;
		rightFraction: aRectangle right.
	self layoutFrame: frame.
	self layoutChanged.! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/28/2010 10:48:13.066'!
frameOffsets

	self layoutFrame ifNil: [^ 0@0 corner: 0@0].
	^ (self layoutFrame leftOffset ifNil: [0]) @ (self layoutFrame topOffset ifNil: [0])
		corner:
		(self layoutFrame rightOffset ifNil: [0]) @ (self layoutFrame bottomOffset ifNil: [0])! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:28:56.456'!
frameOffsets: aRectangle

	| frame |
	frame := self layoutFrame ifNil: [LayoutFrame new].
	frame
		topOffset: aRectangle top;
		bottomOffset: aRectangle bottom;
		leftOffset: aRectangle left;
		rightOffset: aRectangle right.
	self layoutFrame: frame.
	self layoutChanged.! !

!Morph methodsFor: '*widgets' stamp: 'mt 4/20/2011 13:41:23.07'!
fullDrawCacheOn: aCanvas

	^ self fullDrawOn: aCanvas  ! !

!Morph methodsFor: '*widgets-geometry' stamp: 'mt 6/14/2012 10:19:21.276'!
globalBounds

	^ (self localPointToGlobal: self topLeft) extent: self extent! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 5/11/2011 11:45:11.168'!
grabKeyboard

	self hasKeyboard ifTrue: [^ self].
	
	self activeHand newKeyboardFocus: self.  ! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 2/26/2011 14:10:23.137'!
grabMouse

	self activeHand newMouseFocus: self.! !

!Morph methodsFor: '*widgets-events-testing' stamp: 'mt 6/22/2011 14:17:34.896'!
hasAnyKeyboard

	^ self hasKeyboard or: [self hasSubmorphKeyboard]! !

!Morph methodsFor: '*widgets-events-testing' stamp: 'mt 2/26/2011 14:14:31.513'!
hasKeyboard

	^ self activeHand keyboardFocus = self! !

!Morph methodsFor: '*widgets-events-testing' stamp: 'mt 2/26/2011 14:14:44.687'!
hasMouse

	^ self activeHand mouseFocus = self! !

!Morph methodsFor: '*widgets-signals-processing' stamp: 'mt 6/14/2012 09:08:56.887'!
hasSignalConnections

	^ true! !

!Morph methodsFor: '*widgets-events-testing' stamp: 'mt 6/22/2011 14:17:56.099'!
hasSubmorphKeyboard

	^ self submorphs anySatisfy: [:morph | morph hasAnyKeyboard]! !

!Morph methodsFor: '*widgets' stamp: 'mt 7/22/2012 09:38:21.432'!
hideFull
	"The hidden morph will not be drawn AND does not consume space in table layouts."
	
	self
		hide;
		disableTableLayout: true.
	
	"Workaround if #fullBounds are nil. See Morph>>#layoutChanged. Owner MUST BE notified."
	self owner ifNotNil: [:o |
		o layoutChanged].! !

!Morph methodsFor: '*widgets' stamp: 'mt 6/13/2012 17:15:16.643'!
isTransformMorph

	^ false! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:38:40.152'!
isUiContainer

	^ false! !

!Morph methodsFor: '*widgets-events-override' stamp: 'mt 2/26/2011 13:51:41.519'!
keyDown: anEvent
	"Handle a key down event. "
	
	self eventHandler isEventHandler
		ifTrue: [self eventHandler keyDown: anEvent fromMorph: self].! !

!Morph methodsFor: '*widgets-events-override' stamp: 'mt 2/26/2011 13:51:26.514'!
keyUp: anEvent
	"Handle a key up event. "
	
	self eventHandler isEventHandler
		ifTrue: [self eventHandler keyUp: anEvent fromMorph: self].! !

!Morph methodsFor: '*widgets-events-override' stamp: 'mt 2/26/2011 14:03:16.929'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus change. The given argument indicates that the receiver is gaining keyboard focus (versus losing) the keyboard focus. Morphs that accept keystrokes should change their appearance in some way when they are the current keyboard focus."
	
	self eventHandler isEventHandler
		ifTrue: [self eventHandler keyboardFocusChange: aBoolean fromMorph: self].! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 5/6/2011 10:29:18.815'!
keyboardFocusChange: aBoolean inSubmorph: aMorph
	"Give the owner a chance to update appearance if child changes focus."
	
	self eventHandler isEventHandler
		ifTrue: [self eventHandler
			keyboardFocusChange: aBoolean
			inSubmorph: aMorph
			fromMorph: self]
		ifFalse: [self owner ifNotNil: [:owner |
			owner
				keyboardFocusChange: aBoolean
				inSubmorph: aMorph]].! !

!Morph methodsFor: '*widgets-events-override' stamp: 'mt 2/26/2011 13:46:30.171'!
mouseDown: evt 
	"Overridden to suppress #yellowButtonActivity for specific event handlers."

	self eventHandler isEventHandler
		ifTrue: [^ self eventHandler mouseDown: evt fromMorph: self].

	evt yellowButtonPressed
		ifTrue: ["First check for option (menu) click"
			^ self yellowButtonActivity: evt shiftPressed].
	self eventHandler
		ifNotNil: [self eventHandler mouseDown: evt fromMorph: self]
! !

!Morph methodsFor: '*widgets-events-override' stamp: 'mt 2/26/2011 14:27:52.602'!
mouseDownPriority
	"Return the default mouse down priority for the receiver"

	self eventHandler isEventHandler
		ifTrue: [^ self eventHandler mouseDownPriority].

	^ (self isPartsDonor or: [self isPartsBin])
		ifTrue:	[50]
		ifFalse:	[0]

	"The above is a workaround for the complete confusion between parts donors and parts bins. Morphs residing in a parts bin may or may not have the parts donor property set; if they have they may or may not actually handle events. To work around this, parts bins get an equal priority to parts donors so that when a morph in the parts bin does have the property set but does not handle the event we still get a copy from picking it up through the parts bin. Argh. This just *cries* for a cleanup."
	"And the above comment is Andreas's from 10/2000, which was formerly retrievable by a #flag: call which however caused a problem when trying to recompile the method from decompiled source."! !

!Morph methodsFor: '*widgets-signals' stamp: 'mt 6/14/2012 09:14:46.869'!
positionChanged: aPoint

	self emit.! !

!Morph methodsFor: '*widgets-geometry-override' stamp: 'mt 6/14/2012 09:15:10.514'!
privateMoveBy: delta 
	"Private!! Use 'position:' instead."
	| fill |
	self player ifNotNil: ["Most cases eliminated fast by above test"
		self getPenDown ifTrue: [
			"If this is a costume for a player with its 
			pen down, draw a line."
			self moveWithPenDownBy: delta]].
	bounds := bounds translateBy: delta.
	fullBounds ifNotNil: [fullBounds := fullBounds translateBy: delta].
	fill := self fillStyle.
	fill isOrientedFill ifTrue: [fill origin: fill origin + delta].
	
	"Widgets: Emit position change."
	self positionChanged: self position.! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 2/26/2011 14:11:25.922'!
releaseKeyboard

	self activeHand newKeyboardFocus: nil.! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 2/26/2011 14:11:13.349'!
releaseMouse

	self activeHand newMouseFocus: nil.! !

!Morph methodsFor: '*widgets' stamp: 'mt 7/22/2012 09:38:31.54'!
showFull
	"The morph is visible again and considered in table layouts."
	
	self
		show;
		disableTableLayout: false.
	
	"Workaround if #fullBounds are nil. See Morph>>#layoutChanged. Owner MUST BE notified."
	self owner ifNotNil: [:o |
		o layoutChanged].! !

!Morph methodsFor: '*widgets-signals-processing' stamp: 'mt 6/15/2012 10:26:49.45'!
signalConnections

	^ self
		valueOfProperty: #signalConnections
		ifAbsentPut: [Dictionary new]! !

!Morph methodsFor: '*widgets-signals-processing' stamp: 'mt 6/14/2012 09:07:46.521'!
signalMutex

	^ UiNullMutex! !

!Morph methodsFor: '*widgets-geometry' stamp: 'mt 6/14/2012 10:19:28.83'!
visibleBounds
	"Computes the rectangle that is not occluded and actually visible on the screen."

	| globalBounds |
	globalBounds := self globalBounds.
	  
	^ self owner
		ifNotNil: [self owner visibleBounds intersect: globalBounds]
		ifNil: [globalBounds]! !

Morph subclass: #UiAbstractSlider
	instanceVariableNames: 'currentValue minimum maximum orientation pageStep singleStep sliderDown sliderPosition tracking truncate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiAbstractSlider commentStamp: 'mt 2/11/2011 15:21:00.539' prior: 0!
This is a Squeak port of QAbstractSlider from the Nokia/Qt framework.!

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 10:44:02.309'!
currentValue

	^ currentValue ifNil: [0]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:09:53.675'!
currentValue: aNumber

	| guardedValue |
	guardedValue := self guardedValue: aNumber.
	
	guardedValue = self currentValue ifTrue: [^ self].

	currentValue := guardedValue.
	
	self
		sliderChange: #valueChange;
		valueChanged: self currentValue.! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 14:37:43.316'!
decreaseValueByPageStep

	self currentValue: self currentValue - self pageStep.  ! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 14:37:32.985'!
decreaseValueBySingleStep

	self currentValue: self currentValue - self singleStep.  ! !

!UiAbstractSlider methodsFor: 'guarding' stamp: 'mt 2/25/2011 11:15:26.423'!
guardedValue: aNumber

	^ (self truncate
		ifTrue: [aNumber ceiling asInteger]
		ifFalse: [aNumber])
		min: self maximum
		max: self minimum! !

!UiAbstractSlider methodsFor: 'testing' stamp: 'mt 2/11/2011 16:30:22.079'!
hasTracking
	"Is #valueChanged: being emitted while the slider is dragged?"
	
	^ tracking! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 14:37:48.965'!
increaseValueByPageStep

	self currentValue: self currentValue + self pageStep.  ! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 14:37:26.474'!
increaseValueBySingleStep

	self currentValue: self currentValue + self singleStep.  ! !

!UiAbstractSlider methodsFor: 'initialization' stamp: 'mt 3/25/2011 14:21:27.102'!
initialize

	super initialize.
	
	tracking := true.
	orientation := #horizontal.
	minimum := 0.
	maximum := 100.
	pageStep := 10.
	currentValue := 0.
	sliderPosition := 0.
	singleStep := 1.
	
	self
		color: Color transparent;
		extent: 100@14.! !

!UiAbstractSlider methodsFor: 'testing' stamp: 'mt 2/11/2011 16:19:29.364'!
isSliderDown

	^ sliderDown! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 10:44:12.921'!
maximum

	^ maximum ifNil: [0]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:14:42.57'!
maximum: aNumber

	| guardedValue |
	guardedValue := self truncate
		ifTrue: [aNumber ceiling asInteger]
		ifFalse: [aNumber].
	
	guardedValue = self maximum ifTrue: [^ self].
	
	maximum := guardedValue.
	
	self
		sliderChange: #rangeChange;
		rangeChanged: self range.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 10:44:17.153'!
minimum

	^ minimum ifNil: [0]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:14:39.382'!
minimum: aNumber

	| guardedValue |
	guardedValue := self truncate
		ifTrue: [aNumber ceiling asInteger]
		ifFalse: [aNumber].
		
	guardedValue = self minimum ifTrue: [^ self].
	
	minimum := guardedValue.
	
	self
		sliderChange: #rangeChange;
		rangeChanged: self range.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/11/2011 15:30:01.97'!
orientation

	^ orientation! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/11/2011 15:59:09.449'!
orientation: aSymbol
	"#horizontal, #vertical"

	aSymbol = self orientation ifTrue: [^ self].

	orientation := aSymbol.
	
	self sliderChange: #orientationChange.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 3/1/2011 14:22:00.471'!
pageStep

	^ pageStep ifNil: [0]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 4/12/2011 11:32:46.858'!
pageStep: anInteger

	| guardedValue |
	guardedValue := anInteger max: 0.
	
	guardedValue = self pageStep ifTrue: [^ self].

	pageStep := guardedValue.
	
	self sliderChange: #stepsChange.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/11/2011 15:47:10.587'!
range
	
	^ self minimum to: self maximum! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:14:31.742'!
range: anInterval

	| guardedValue |
	guardedValue := self truncate
		ifTrue: [anInterval first ceiling asInteger to: anInterval last ceiling asInteger]
		ifFalse: [anInterval].
		
	guardedValue = self range ifTrue: [^ self].
	
	minimum := guardedValue first.
	maximum := guardedValue last.
	
	self
		sliderChange: #rangeChange;
		rangeChanged: self range.! !

!UiAbstractSlider methodsFor: 'signals' stamp: 'mt 2/11/2011 15:42:27.109'!
rangeChanged: anInterval

	self emit.! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 17:17:26.272'!
setValueToMaximum
	
	self currentValue: self maximum.  ! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 17:17:18.761'!
setValueToMinimum
	
	self currentValue: self minimum.  ! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/11/2011 15:30:02.221'!
singleStep

	^ singleStep! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/11/2011 16:18:02.19'!
singleStep: anInteger

	anInteger = self singleStep ifTrue: [^ self].

	singleStep := anInteger.
	
	self sliderChange: #stepsChange.! !

!UiAbstractSlider methodsFor: 'updating' stamp: 'mt 3/5/2011 12:14:02.902'!
sliderChange: aSliderChange
	"This is a local callback. Possible values: #rangeChange, #orientationChange, #stepsChange, #valueChange"
	
	aSliderChange = #valueChange ifTrue: [
		self sliderPosition: self currentValue].
	
	aSliderChange = #rangeChange ifTrue: [
		self sliderPosition: self sliderPosition.
		self currentValue: self currentValue].
	
	aSliderChange = #orientationChange ifTrue: [
		self extent: self height @ self width].! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/19/2011 14:13:04.16'!
sliderDown: aBoolean

	aBoolean = self isSliderDown ifTrue: [^ self].

	sliderDown := aBoolean.
	
	"Synchronize on slider release."
	aBoolean
		ifFalse: [self currentValue: self sliderPosition].
	
	aBoolean
		ifTrue: [self sliderPressed]
		ifFalse: [self sliderReleased].! !

!UiAbstractSlider methodsFor: 'signals' stamp: 'mt 2/11/2011 15:43:18.329'!
sliderMoved: anInteger

	self emit.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 10:44:22.745'!
sliderPosition

	^ sliderPosition ifNil: [0]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:10:16.198'!
sliderPosition: aNumber

	| guardedValue |
	guardedValue := self guardedValue: aNumber.
	
	guardedValue = self sliderPosition ifTrue: [^ self].
	
	sliderPosition := guardedValue.
	
	self hasTracking ifTrue: [
		self currentValue: self sliderPosition].
	
	self sliderMoved: self sliderPosition.! !

!UiAbstractSlider methodsFor: 'signals' stamp: 'mt 2/11/2011 15:43:27.704'!
sliderPressed

	self emit.! !

!UiAbstractSlider methodsFor: 'signals' stamp: 'mt 2/11/2011 15:43:33.933'!
sliderReleased

	self emit.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:24:46.16'!
tracking
	
	^ tracking! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/19/2011 11:11:08.734'!
tracking: aBoolean
	"Lock the #sliderPosition to the #currentValue."
	
	tracking := aBoolean.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:05:58.445'!
truncate
	"Are only integer values allowed?"
	
	^ truncate ifNil: [true]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:07:12.284'!
truncate: aBoolean

	aBoolean = truncate ifTrue: [^ self].

	truncate := aBoolean.
	
	self truncate ifTrue: [
		self
			range: self range;
			currentValue: self currentValue].! !

!UiAbstractSlider methodsFor: 'signals' stamp: 'mt 2/11/2011 15:43:43.887'!
valueChanged: anInteger

	self emit.! !

UiAbstractSlider subclass: #UiSlider
	instanceVariableNames: 'pagingMorph sliderButton mouseDownSliderPosition mouseDownEventPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiSlider commentStamp: 'mt 2/27/2011 16:32:16.852' prior: 0!
pagingMorph ... a simple morph in background that indicates the range of this slider
sliderButton ... a button that can be dragged to change the slider position and the current slider value

Used to compute the new slider position during the dragging operation:

mouseDownSliderPosition ... value of the slider when the mouseDown event occured
mouseDownEventPosition ... pixel position of the mouseDown event when it occured

Morphic stepping is used for automatic page-step moving.

[Hold Left Click] ... scroll by page step up to click position
[Shift] + [Left Click] ... jump to specific value!

UiSlider subclass: #UiScrollBar
	instanceVariableNames: 'decreaseValueButton1 decreaseValueButton2 increaseValueButton outerBorderWidth buttonMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiScrollBar commentStamp: 'mt 2/27/2011 16:31:15.05' prior: 0!
!!!!!! Rename to UiScrollBar !!!!!!

A scroll bar is like a slider that as additional buttons to modify the current value. In addition, the slider extent is changed with respect to the current scroll bar #extent, #orientation, and #pageStep.!

!UiScrollBar class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:19:57.856'!
widgetClassIcon

	^ UiFugueIcons uiScrollBarHorizontalIcon! !

!UiScrollBar class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:18:27.526'!
widgetClassName

	^ 'Scroll Bar'! !

!UiScrollBar class methodsFor: 'accessing' stamp: 'mt 4/5/2011 15:58:43.309'!
widgetProperties

	^ super widgetProperties, {{'Scroll Bar'. #yourself} -> {
		#buttonMode -> #(none distant adjacent both).
		}}! !

!UiScrollBar methodsFor: 'accessing' stamp: 'mt 5/16/2012 10:28:50.47'!
buttonMode

	^ buttonMode! !

!UiScrollBar methodsFor: 'accessing' stamp: 'mt 5/16/2012 09:52:27.669'!
buttonMode: aSymbol
	"Specifiies how many arrow buttons are visible to modify the value with mouse clicks
	#distant ... one arrow button at each end of the scroll bar
	#adjacent ... both arrow buttons at the higher end of the scroll bar (like on Mac OS X)
	#both ... all three arrow buttons (like Cleanlooks in Gnome/Linux)
	#none ... hide all buttons"

	buttonMode = aSymbol ifTrue: [^ self].

	buttonMode := aSymbol.
	
	self
		initializeButtons;
		updateSupportMorphs.! !

!UiScrollBar methodsFor: 'geometry' stamp: 'mt 5/16/2012 10:07:21.643'!
defaultThickness

	^ 14! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 3/2/2011 09:17:57.288'!
doSliderMovement: aMouseMoveEvent
	"Only allow integer steps with mouse dragging."
	
	| value |
	self isStepping
		ifTrue: [^ mouseDownEventPosition := aMouseMoveEvent position].
	
	value := self orientation = #horizontal
		ifTrue: [self pixelToValue: aMouseMoveEvent position x - mouseDownEventPosition x]
		ifFalse: [self pixelToValue: aMouseMoveEvent position y - mouseDownEventPosition y].

	self sliderPosition: mouseDownSliderPosition + (self truncate
		ifTrue: [value reduce asInteger]
		ifFalse: [value]).
		
	self raiseButtons.! !

!UiScrollBar methodsFor: 'drawing' stamp: 'mt 3/22/2011 17:18:11.583'!
drawOn: aCanvas

	super drawOn: aCanvas.
	
	self outerBorderWidth > 0 ifTrue: [
		aCanvas
			frameRectangle: self outerBounds
			width: self outerBorderWidth
			color: self color darker].! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 3/2/2011 09:21:30.987'!
finishSliderMovement: aMouseEvent

	super finishSliderMovement: aMouseEvent.  
	
	(self innerBounds containsPoint: aMouseEvent position)
		ifFalse: [self flattenButtons].! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 5/16/2012 10:24:13.597'!
flattenButtons

	mouseDownEventPosition ifNotNil: [^ self].

	{decreaseValueButton1. decreaseValueButton2. increaseValueButton}
		do: [:btn | btn ifNotNil: [btn fadeOut]].! !

!UiScrollBar methodsFor: 'initialization' stamp: 'mt 5/16/2012 10:29:00.174'!
initialize

	buttonMode := #none.
	
	super initialize.
	self color: (Color gray: 0.85).
! !

!UiScrollBar methodsFor: 'initialization' stamp: 'mt 5/16/2012 09:51:35.228'!
initializeButtons

	self buttonMode == #none
		ifTrue: [^ self].

	self initializeIncreaseValueButton.

	{#(adjacent both) -> [self initializeDecreaseValueButton2].
	#(distant both) -> [self initializeDecreaseValueButton1]} do: [:assoc |
		(assoc key includes: self buttonMode)
			ifTrue: [assoc value value]].! !

!UiScrollBar methodsFor: 'initialization' stamp: 'mt 5/16/2012 10:17:48.318'!
initializeDecreaseValueButton1

	decreaseValueButton1 ifNil: [
		decreaseValueButton1 := UiScrollBarArrowButton new.
		self connect: decreaseValueButton1 signal: #pressed toSelector: #decreaseValueBySingleStep.
		self addMorphFront: decreaseValueButton1.
		decreaseValueButton1]! !

!UiScrollBar methodsFor: 'initialization' stamp: 'mt 5/16/2012 10:18:06.922'!
initializeDecreaseValueButton2

	decreaseValueButton2 ifNil: [
		decreaseValueButton2 := UiScrollBarArrowButton new.
		self connect: decreaseValueButton2 signal: #pressed toSelector: #decreaseValueBySingleStep.
		self addMorph: decreaseValueButton2 after: pagingMorph.
		decreaseValueButton2]! !

!UiScrollBar methodsFor: 'initialization' stamp: 'mt 4/7/2011 14:25:49.362'!
initializeEventHandler

	super initializeEventHandler.
	
	self connect: self eventHandler signal: #mouseEntered: toSelector: #raiseButtons.
	self connect: self eventHandler signal: #mouseLeft: toSelector: #flattenButtons.

	"Keyboard interaction."
	self eventHandler on: Character arrowDown send: #increaseValueBySingleStep to: self.
	self eventHandler on: Character arrowUp send: #decreaseValueBySingleStep to: self.
	
	self eventHandler on: Character pageUp send: #decreaseValueByPageStep to: self.
	self eventHandler on: Character pageDown send: #increaseValueByPageStep to: self.! !

!UiScrollBar methodsFor: 'initialization' stamp: 'mt 5/16/2012 10:17:35.919'!
initializeIncreaseValueButton

	increaseValueButton ifNil: [
		increaseValueButton := UiScrollBarArrowButton new.
		self connect: increaseValueButton signal: #pressed toSelector: #increaseValueBySingleStep.
		self addMorphBack: increaseValueButton.
		increaseValueButton]! !

!UiScrollBar methodsFor: 'initialization' stamp: 'mt 5/16/2012 09:51:53.683'!
initializeSupportMorphs

	pagingMorph := Morph new
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
			
	sliderButton := UiScrollBarSliderButton new.! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 2/26/2011 20:50:37.799'!
jumpToValue: aMouseEvent
	"Jumps to the value under the mouse cursor if shift was pressed."
	
	| value |
	aMouseEvent shiftPressed ifFalse: [^ self].
	
	self orientation = #horizontal
		ifTrue: [value := self pixelToValue: aMouseEvent position x - pagingMorph left - (sliderButton width / 2)]
		ifFalse: [value := self pixelToValue: aMouseEvent position y - pagingMorph top - (sliderButton height / 2)].
		
	self sliderPosition: value.! !

!UiScrollBar methodsFor: 'accessing' stamp: 'mt 3/22/2011 17:17:23.628'!
outerBorderWidth

	^ outerBorderWidth ifNil: [outerBorderWidth := 1]! !

!UiScrollBar methodsFor: 'accessing' stamp: 'mt 3/22/2011 17:17:47.691'!
outerBorderWidth: anInteger

	anInteger = outerBorderWidth ifTrue: [^ self].

	outerBorderWidth := anInteger.
	
	self redrawLater.! !

!UiScrollBar methodsFor: 'geometry' stamp: 'mt 1/4/2012 14:08:13.631'!
outerBounds

	^ self bounds outsetBy: self outerBorderWidth! !

!UiScrollBar methodsFor: 'converting' stamp: 'mt 3/7/2011 15:39:49.883'!
preferredSliderSize
	"Like #valueToPixel. Ignores the extent of the slider button."

	| abs |
	abs := self pageStep = 0
		ifFalse: [self pageStep / (self range extent + self pageStep)]
		ifTrue: [1].
	
	self orientation = #horizontal
		ifTrue: [^ abs * pagingMorph width].
		
	self orientation = #vertical
		ifTrue: [^ abs * pagingMorph height].
		
	^ 0! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 5/16/2012 10:24:23.568'!
raiseButtons

	{decreaseValueButton1. decreaseValueButton2. increaseValueButton}
		do: [:btn | btn ifNotNil: [btn fadeIn]].! !

!UiScrollBar methodsFor: 'updating' stamp: 'mt 2/27/2011 15:32:23.619'!
sliderChange: aSliderChange

	super sliderChange: aSliderChange.
	  
	"Slider button extent indicates pageStep."
	aSliderChange = #stepsChange
		ifTrue: [self updateSliderButton].! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 2/26/2011 19:59:15.607'!
startSliderMovement: aMouseEvent

	mouseDownEventPosition := aMouseEvent position.
	
	(sliderButton innerBounds containsPoint: aMouseEvent position) ifTrue: [
		"Start slider dragging."
		mouseDownSliderPosition := self sliderPosition.
		^ self sliderDown: true].
		
	(pagingMorph innerBounds containsPoint: aMouseEvent position)	 ifTrue: [
		"Start slider stepping."
		^ self startStepping].! !

!UiScrollBar methodsFor: 'stepping' stamp: 'mt 2/26/2011 20:51:22.19'!
step
	"Automatically move the slider page-step-wise."
	
	| value |
	mouseDownEventPosition ifNil: [^ self stopStepping].
	
	self orientation = #horizontal
		ifTrue: [value := self pixelToValue: mouseDownEventPosition x - pagingMorph left - (sliderButton width / 2)]
		ifFalse: [value := self pixelToValue: mouseDownEventPosition y - pagingMorph top - (sliderButton height / 2)].
		
	value < self sliderPosition
		ifTrue: [self sliderPosition: (self sliderPosition - self pageStep max: value)]
		ifFalse: [self sliderPosition: (self sliderPosition + self pageStep min: value)].! !

!UiScrollBar methodsFor: 'updating' stamp: 'mt 4/12/2011 09:46:59.45'!
updateSliderButton
	"Reposition the support morph for the slider to #sliderPosition."
	
	| pt |
	self sliderPosition ifNil: [^ self].
	
	sliderButton orientation: self orientation.
	
	self orientation = #horizontal	ifTrue: [
		sliderButton
			width: self preferredSliderSize;
			height: self height.

		pt := ((self valueToPixel: self sliderPosition)
			"Add the offset considering the current position."
			+ pagingMorph left)
			@ self top.
			
		sliderButton topLeft: pt].
		
	self orientation = #vertical ifTrue: [
		sliderButton
			width: self width;
			height: self preferredSliderSize.
		
		pt := self left @(
			(self valueToPixel: self sliderPosition)
			+ pagingMorph top).
			
		sliderButton topLeft: pt].! !

!UiScrollBar methodsFor: 'updating' stamp: 'mt 5/16/2012 10:15:32.02'!
updateSupportMorphs

	"General layout."
	self orientation = #horizontal ifTrue: [
		self listDirection: #leftToRight.
		(#(distant both) includes: self buttonMode) ifTrue: [self layoutInset: (-1@0 corner: -1@0)].
		self buttonMode == #adjacent ifTrue: [self layoutInset: (0@0 corner: -1@0)].
		self buttonMode == #none ifTrue: [self layoutInset: 0]]. 
	self orientation = #vertical ifTrue: [
		self listDirection: #topToBottom.
		(#(distant both) includes: self buttonMode) ifTrue: [self layoutInset: (0@ -1 corner: 0@ -1)].
		self buttonMode == #adjacent ifTrue: [self layoutInset: (0@0 corner: 0@ -1)].
		self buttonMode == #none ifTrue: [self layoutInset: 0]].

	"Button visibility."
	{#(distant both) -> decreaseValueButton1.
	#(adjacent both) -> decreaseValueButton2} do: [:assoc |
		(assoc key includes: self buttonMode)
			ifTrue: [assoc value ifNotNil: [:btn | btn showFull]]
			ifFalse: [assoc value ifNotNil: [:btn | btn hideFull]]].

	self buttonMode = #none
		ifTrue: [increaseValueButton ifNotNil: [:btn | btn hideFull]]
		ifFalse: [increaseValueButton ifNotNil: [:btn | btn showFull]].

	"Other geometry."
	self
		updateValueButtons;
		updateSliderButton.! !

!UiScrollBar methodsFor: 'updating' stamp: 'mt 5/16/2012 10:23:24.248'!
updateValueButtons

	self orientation = #horizontal
		ifTrue: [
			decreaseValueButton1 ifNotNil: [:btn | btn direction: #left; width: self defaultThickness].
			decreaseValueButton2 ifNotNil: [:btn | btn direction: #left; width: self defaultThickness].
			increaseValueButton ifNotNil: [:btn | btn direction: #right; width: self defaultThickness]]
		ifFalse: [
			decreaseValueButton1 ifNotNil: [:btn | btn direction: #up; height: self defaultThickness].
			decreaseValueButton2 ifNotNil: [:btn | btn direction: #up; height: self defaultThickness].
			increaseValueButton ifNotNil: [:btn | btn direction: #down; height: self defaultThickness]].
! !

!UiSlider class methodsFor: 'testing' stamp: 'mt 2/27/2011 16:17:38.592'!
isWidgetClass

	^ true! !

!UiSlider class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:18:00.811'!
widgetCategory

	^ 'Input Widgets'! !

!UiSlider class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:19:41.058'!
widgetClassIcon

	^ UiFugueIcons uiSlider050Icon! !

!UiSlider class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:18:19.955'!
widgetClassName

	^ 'Slider'! !

!UiSlider class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:25:51.081'!
widgetProperties

	^ super widgetProperties, {{'Slider'. #yourself} -> {
		#orientation -> #(horizontal vertical).
		#minimum -> Integer.
		#maximum -> Integer.
		#currentValue -> Integer.
		#sliderPosition -> Integer.
		#tracking -> Boolean.
		#singleStep -> Integer.
		#pageStep -> Integer.
		#truncate -> Boolean.
		}}! !

!UiSlider class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:20:57.046'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout' cellPositioning cellSpacing listCentering listSpacing minCellSize maxCellSize wrapCentering wrapDirection)! !

!UiSlider methodsFor: 'layout' stamp: 'mt 2/27/2011 15:55:22.353'!
adjustLayoutBounds

	super adjustLayoutBounds.
	self updateSliderButton. "Excluded from automatic layouting, so do it manually here."! !

!UiSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 17:14:05.103'!
doSliderMovement: aMouseMoveEvent
	"Only allow integer steps with mouse dragging."
	
	| value |
	self isStepping
		ifTrue: [^ mouseDownEventPosition := aMouseMoveEvent position].
	
	value := self orientation = #horizontal
		ifTrue: [self pixelToValue: aMouseMoveEvent position x - mouseDownEventPosition x]
		ifFalse: [self pixelToValue: mouseDownEventPosition y - aMouseMoveEvent position y].

	self sliderPosition: mouseDownSliderPosition + (self truncate
		ifTrue: [value reduce asInteger]
		ifFalse: [value]).! !

!UiSlider methodsFor: 'geometry' stamp: 'mt 2/19/2011 11:59:01.107'!
extent: aPoint

	super extent: aPoint.	
	self updateSliderButton.! !

!UiSlider methodsFor: 'actions' stamp: 'mt 3/1/2011 14:13:25.91'!
finishSliderMovement: aMouseEvent

	self sliderDown: false.
	self stopStepping.
	
	mouseDownEventPosition := nil.! !

!UiSlider methodsFor: 'initialization' stamp: 'mt 2/26/2011 17:01:11.001'!
initialize

	self
		initializeSupportMorphs;
		initializeEventHandler.

	super initialize.

	self
		changeTableLayout;
		listCentering: #center.
		
	self
		addMorphBack: pagingMorph;
		addMorphFront: sliderButton.! !

!UiSlider methodsFor: 'initialization' stamp: 'mt 3/1/2011 14:07:28.021'!
initializeEventHandler

	self eventHandler: UiEventHandler new.

	self connect: self eventHandler signal: #mousePressed: toSelector: #startSliderMovement:.
	self connect: self eventHandler signal: #mouseMoved: toSelector: #doSliderMovement:.
	self connect: self eventHandler signal: #mouseReleased: toSelector: #finishSliderMovement:.

	self connect: self eventHandler signal: #mousePressed: toSelector: #jumpToValue:.

	"Keyboard interaction."
	self eventHandler on: Character arrowLeft send: #decreaseValueBySingleStep to: self.
	self eventHandler on: Character arrowRight send: #increaseValueBySingleStep to: self.
	self eventHandler on: Character arrowDown send: #decreaseValueBySingleStep to: self.
	self eventHandler on: Character arrowUp send: #increaseValueBySingleStep to: self.
	
	self eventHandler on: Character pageUp send: #increaseValueByPageStep to: self.
	self eventHandler on: Character pageDown send: #decreaseValueByPageStep to: self.
	
	self eventHandler on: Character home send: #setValueToMinimum to: self.
	self eventHandler on: Character end send: #setValueToMaximum to: self.! !

!UiSlider methodsFor: 'initialization' stamp: 'mt 2/27/2011 15:50:36.457'!
initializeSupportMorphs

	pagingMorph := Morph new
		borderStyle: (BorderStyle inset width: 1);
		color: (Color gray: 0.85);
		hResizing: #spaceFill;
		height: 5.  
			
	sliderButton := UiSliderButton new.! !

!UiSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 17:09:05.644'!
jumpToValue: aMouseEvent
	"Jumps to the value under the mouse cursor if shift was pressed."
	
	| value |
	aMouseEvent shiftPressed ifFalse: [^ self].
	
	self orientation = #horizontal
		ifTrue: [value := self pixelToValue: aMouseEvent position x - self left - (sliderButton width / 2)]
		ifFalse: [value := self pixelToValue: self bottom - aMouseEvent position y - (sliderButton height / 2)].
		
	self sliderPosition: value.! !

!UiSlider methodsFor: 'converting' stamp: 'mt 2/27/2011 15:27:16.273'!
pixelToValue: anInteger

	self range extent = 0 ifTrue: [^ 0].

	self orientation = #horizontal
		ifTrue: [^ anInteger / ((pagingMorph width - sliderButton width) max: 1) * self range extent].
		
	self orientation = #vertical
		ifTrue: [^ anInteger / ((pagingMorph height - sliderButton height) max: 1) * self range extent].
		
	^ 0! !

!UiSlider methodsFor: 'updating' stamp: 'mt 2/19/2011 14:19:35.439'!
sliderChange: aSliderChange

	super sliderChange: aSliderChange.
	  
	aSliderChange = #orientationChange
		ifTrue: [self updateSupportMorphs].
	
	(#(rangeChange valueChange) includes: aSliderChange)
		ifTrue: [self updateSliderButton].! !

!UiSlider methodsFor: 'accessing' stamp: 'mt 2/19/2011 13:00:27.935'!
sliderDown: aBoolean
	"Overridden to pass it to the slider button."
	
	super sliderDown: aBoolean.
	sliderButton down: aBoolean.  ! !

!UiSlider methodsFor: 'actions' stamp: 'mt 3/1/2011 14:11:52.387'!
startSliderMovement: aMouseEvent

	mouseDownEventPosition := aMouseEvent position.
	
	((self orientation = #horizontal and: [aMouseEvent position x between: sliderButton left and: sliderButton right])
		or: [self orientation = #vertical and: [aMouseEvent position y between: sliderButton top and: sliderButton bottom]])
		ifTrue: [
			"Start slider dragging."
			mouseDownSliderPosition := self sliderPosition.
			self sliderDown: true]
		ifFalse: [
			"Start slider stepping."
			self startStepping]

! !

!UiSlider methodsFor: 'stepping' stamp: 'mt 3/1/2011 14:17:50.008'!
step
	"Automatically move the slider page-step-wise."
	
	| value |
	mouseDownEventPosition ifNil: [^ self stopStepping].
	
	self orientation = #horizontal
		ifTrue: [value := self pixelToValue: mouseDownEventPosition x - self left - (sliderButton width / 2)]
		ifFalse: [value := self pixelToValue: self bottom - mouseDownEventPosition y - (sliderButton height / 2)].
		
	value < self sliderPosition
		ifTrue: [self sliderPosition: (self sliderPosition - self pageStep max: value)]
		ifFalse: [self sliderPosition: (self sliderPosition + self pageStep min: value)].! !

!UiSlider methodsFor: 'stepping' stamp: 'mt 2/25/2011 11:19:16.835'!
stepTime

	^ 100! !

!UiSlider methodsFor: 'updating' stamp: 'mt 2/19/2011 12:44:26.793'!
updatePagingMorph

	pagingMorph
		extent: 5@5.

	self orientation = #horizontal ifTrue: [
		pagingMorph
			hResizing: #spaceFill;
			vResizing: #rigid].
		
	self orientation = #vertical ifTrue: [
		pagingMorph
			hResizing: #rigid;
			vResizing: #spaceFill].! !

!UiSlider methodsFor: 'updating' stamp: 'mt 2/27/2011 15:42:53.077'!
updateSliderButton
	"Reposition the support morph for the slider to #sliderPosition."
	
	| pt |
	self sliderPosition ifNil: [^ self].
	
	sliderButton orientation: self orientation.
	
	self orientation = #horizontal	ifTrue: [
		sliderButton extent: 10@self height.

		pt := ((self valueToPixel: self sliderPosition)
			"Add the offset considering the current position."
			+ self left + (sliderButton width / 2))
			@ self center y.
			
		sliderButton center: pt].
		
	self orientation = #vertical ifTrue: [
		sliderButton extent: self width@10.
		
		pt := self center x @(
			self bottom
			- (self valueToPixel: self sliderPosition)
			- (sliderButton height / 2)).
			
		sliderButton center: pt].! !

!UiSlider methodsFor: 'updating' stamp: 'mt 2/26/2011 17:01:19.52'!
updateSupportMorphs

	self orientation = #horizontal ifTrue: [self listDirection: #topToBottom].  		
	self orientation = #vertical ifTrue: [self listDirection: #leftToRight].

	self
		updatePagingMorph;
		updateSliderButton.! !

!UiSlider methodsFor: 'converting' stamp: 'mt 2/27/2011 15:27:35.001'!
valueToPixel: aNumber
	"Converts a given number to a portion of the extent of this slider."

	| abs |
	self range extent = 0 ifTrue: [^ 0].

	abs := ((aNumber - self minimum) / self range extent).
	
	self orientation = #horizontal
		ifTrue: [^ abs * (pagingMorph width - sliderButton width)].
		
	self orientation = #vertical
		ifTrue: [^ abs * (pagingMorph height - sliderButton height)].
		
	^ 0! !

Morph subclass: #UiButton
	instanceVariableNames: 'checkable checked down icon text autoExclusive enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiButton commentStamp: 'mt 6/20/2010 20:42:54.272' prior: 0!
Abstract button.!

!UiButton class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:28:38.684'!
widgetCategory
	
	^ 'Buttons'! !

!UiButton class methodsFor: 'properties' stamp: 'mt 2/19/2011 12:56:08.001'!
widgetProperties

	^ super widgetProperties, {{'Button'. #yourself} -> {
		#enabled -> Boolean.
		#icon -> Form.
		#text -> String.
		#color -> Object.
		#checkable -> Boolean.
		#checked -> Boolean.
		#autoExclusive -> Boolean}}! !

!UiButton class methodsFor: 'properties' stamp: 'mt 11/14/2010 15:58:39.299'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout' cellPositioning cellSpacing listSpacing minCellSize maxCellSize wrapCentering wrapDirection)! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/21/2010 10:28:44.532'!
autoExclusive

	^ autoExclusive ifNil: [autoExclusive := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/21/2010 10:31:03.542'!
autoExclusive: aBoolean

	autoExclusive == aBoolean ifTrue: [^ self].
	
	autoExclusive := aBoolean.
	
	aBoolean ifTrue: [self checkable: true].! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:51:52.944'!
checkable

	^ checkable ifNil: [checkable := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:48:57.047'!
checkable: aBoolean

	aBoolean == checkable ifTrue: [^ self].

	checkable := aBoolean.
	
	aBoolean ifFalse: [checked := false].! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:51:46.981'!
checked

	^ checked ifNil: [checked := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 10/27/2010 10:10:10.273'!
checked: aBoolean

	(aBoolean == checked or: [self checkable not])
		ifTrue: [^ self].	
	
	checked := aBoolean.
	
	self toggled: aBoolean.
	
	self redrawLater.
	
	"Handle auto-exclusiveness."
	(self autoExclusive and: [self checked])
		ifTrue: [self owner ifNotNil: [:group |
			group submorphs
				select: [:m | (m isKindOf: UiButton) and: [m ~= self]]
				thenDo: [:m | m checked: false]]].! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:35:59.853'!
clicked: isChecked

	self emit.! !

!UiButton methodsFor: 'actions' stamp: 'mt 3/2/2011 11:27:17.367'!
doClick
	"#click is reserved for morphic event handling. Simulate a button click."
	
	self toggle.
	self clicked: self checked.! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:51:42.188'!
down

	^ down ifNil: [down := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 21:21:04.758'!
down: aBoolean

	aBoolean == down ifTrue: [^ self].
	
	down := aBoolean.
	
	self redrawLater.
	
	aBoolean
		ifFalse: [self toggle].! !

!UiButton methodsFor: 'accessing' stamp: 'mt 11/22/2010 10:44:41.643'!
enabled

	^ enabled ifNil: [enabled := true]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 11/22/2010 10:44:56.115'!
enabled: aBoolean

	enabled := aBoolean.! !

!UiButton methodsFor: 'drawing' stamp: 'mt 2/26/2011 16:07:11.041'!
gradient
	"Generate a gradient based on the current color and geometry."

	| inverted baseColor |
	inverted := self down or: [self checked].
	baseColor := 	self hasKeyboard
		ifTrue: [(Color r: 0.5 g: 0.5 b: 1.0) muchLighter]
		ifFalse: [self color].
	baseColor := inverted
		ifTrue: [baseColor darker]
		ifFalse: [baseColor].
	
	^ (GradientFillStyle ramp: {
			0.0 -> (baseColor adjustBrightness: 0.1).
			0.1-> (baseColor adjustBrightness: 0.05).
			0.6 -> (baseColor darker)})
		origin: (inverted
			ifTrue: [self innerBounds bottomLeft]
			ifFalse: [self innerBounds topLeft]);
		direction: (inverted
			ifTrue: [0 @ self innerBounds height negated]
			ifFalse: [0 @ self innerBounds height]).! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:34:04.67'!
icon

	^ icon! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:07:08.152'!
icon: aForm

	icon := aForm.! !

!UiButton methodsFor: 'initialization' stamp: 'mt 4/12/2011 13:53:59.122'!
initialize

	super initialize.
	
	self initializeEventHandler.
	
	self
		color: (Color gray: 0.85);
		borderColor: (Color gray: 0.3);
		borderWidth: 1;
		extent: 50@25.! !

!UiButton methodsFor: 'initialization' stamp: 'mt 4/14/2011 17:17:04.172'!
initializeEventHandler

	self eventHandler: UiEventHandler new.
	
	self eventHandler setProperty: #handlesMouseDown toValue: [self enabled].
	self eventHandler setProperty: #handlesMouseUp toValue: [self enabled].
	
	self connect: self eventHandler signal: #mousePressed: toSelector: #grabKeyboard.
	
	self connect: self eventHandler signal: #mousePressed: toSelector: #press:.
	self connect: self eventHandler signal: #mouseReleased: toSelector: #release:.
	
	self connect: self eventHandler signal: #returnPressed toSelector: #doClick.! !

!UiButton methodsFor: 'actions' stamp: 'mt 3/2/2011 11:04:58.085'!
press: aMouseEvent

	self
		down: true;
		pressed.! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:36:09.523'!
pressed

	self emit.! !

!UiButton methodsFor: 'actions' stamp: 'mt 3/29/2011 09:59:15.687'!
release: aMouseEvent

	(self bounds containsPoint: aMouseEvent position)
		ifTrue: [self down: false; released; clicked: self checked]
		ifFalse: [down := false. self redrawLater].! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:36:14.649'!
released

	self emit.! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:34:55.971'!
text

	^ text! !

!UiButton methodsFor: 'accessing' stamp: 'mt 10/27/2010 10:05:52.788'!
text: aStringOrText

	text := aStringOrText.! !

!UiButton methodsFor: 'actions' stamp: 'mt 6/21/2010 10:39:00.668'!
toggle

	(self autoExclusive and: [self checked])
		ifTrue: ["Must not toggle." ^ self].
	
	self checked: self checked not.! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:36:30.246'!
toggled: isChecked

	self emit.! !

UiButton subclass: #UiCompositeButton
	instanceVariableNames: 'box'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiCompositeButton commentStamp: 'mt 3/5/2011 11:53:19.193' prior: 0!
This is a button that has an additional button embedded.!

UiCompositeButton subclass: #UiCheckBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiCheckBox class methodsFor: 'testing' stamp: 'mt 6/29/2010 10:04:30.463'!
isWidgetClass

	^ true! !

!UiCheckBox class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:45:56.946'!
widgetClassIcon

	^ UiFugueIcons uiCheckBoxesIcon! !

!UiCheckBox class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:23:28.921'!
widgetClassName

	^ 'Check Box'! !

!UiCheckBox class methodsFor: 'properties' stamp: 'mt 10/28/2010 09:51:08.562'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #('checkable')! !

!UiCheckBox methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:55:37.001'!
boxClass

	^ UiCheckButtonBox! !

!UiCheckBox methodsFor: 'accessing' stamp: 'mt 3/22/2011 08:12:55.763'!
checked: aBoolean
	"Add explicit switching behavior with new signals."
	
	| old |
	old := self checked.
	
	super checked: aBoolean.
	
	old ~= aBoolean ifTrue: [
		aBoolean
			ifTrue: [self turnedOn]
			ifFalse: [self turnedOff]].
! !

!UiCheckBox methodsFor: 'drawing' stamp: 'mt 2/26/2011 15:33:20.135'!
fullDrawOn: aCanvas

	super fullDrawOn: aCanvas.
	
	"Indicate checking state with an additional tick."
	box notNil & self checked ifTrue: [
		aCanvas
			line: box topLeft + (0@(box height // 2)) + (2@0)
			to: box bottomLeft + ((box width // 2)@0) - (0@2)
			width: 2
			color: (Color gray: 0.3).
		aCanvas
			line: box bottomLeft + ((box width // 2)@0) - (0@2)
			to: box topRight - (2@ -2)
			width: 2
			color: (Color gray: 0.3)].! !

!UiCheckBox methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:57:22.644'!
initialize

	super initialize.
		
	self text: 'CheckBox'.! !

!UiCheckBox methodsFor: 'initialization' stamp: 'mt 7/16/2011 17:06:23.754'!
initializeNoText
	"UiCheckBox basicNew initializeNoText. Performance reasons."
	
	super initialize.! !

!UiCheckBox methodsFor: 'signals' stamp: 'mt 3/22/2011 08:06:03.894'!
turnedOff
	"Emitted whenever the #checked: state changes. In contrast to #toggled:, explicitly maps the state to the signal name."
	
	self emit.! !

!UiCheckBox methodsFor: 'signals' stamp: 'mt 3/22/2011 08:05:56.578'!
turnedOn
	"Emitted whenever the #checked: state changes. In contrast to #toggled:, explicitly maps the state to the signal name."

	self emit.! !

!UiCheckBox methodsFor: 'updating' stamp: 'mt 2/16/2012 16:03:59.912'!
updateSubmorphs

	super updateSubmorphs.
	box autoRaise: false.! !

!UiCompositeButton methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:53:57.984'!
boxClass

	^ self subclassResponsibility! !

!UiCompositeButton methodsFor: 'accessing' stamp: 'mt 3/5/2011 11:55:43.574'!
checked: aBoolean

	super checked: aBoolean.
	box ifNotNil: [:b | b down: aBoolean].! !

!UiCompositeButton methodsFor: 'accessing' stamp: 'mt 3/5/2011 11:55:47.699'!
down: aBoolean

	super down: aBoolean.
	box ifNotNil: [:b | b down: aBoolean | self checked].! !

!UiCompositeButton methodsFor: 'drawing' stamp: 'mt 3/5/2011 11:56:17.88'!
drawOn: aCanvas

	"Invisible."! !

!UiCompositeButton methodsFor: 'accessing' stamp: 'mt 2/7/2012 16:03:35.243'!
enabled: aBoolean

	enabled = aBoolean ifTrue: [^ self].
	super enabled: aBoolean.
	box ifNotNil: [:b | b enabled: aBoolean].
	self updateSubmorphs.! !

!UiCompositeButton methodsFor: 'accessing' stamp: 'mt 4/17/2011 15:33:29.467'!
icon: aForm

	aForm == icon ifTrue: [^ self].

	super icon: aForm.
	self updateSubmorphs.! !

!UiCompositeButton methodsFor: 'initialization' stamp: 'mt 3/5/2011 12:00:36.429'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
		
	self 
		checkable: true;
		updateSubmorphs.! !

!UiCompositeButton methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:56:43.076'!
initializeEventHandler

	super initializeEventHandler.
	
	self eventHandler mouseDownPriority: 1.! !

!UiCompositeButton methodsFor: 'accessing' stamp: 'mt 3/5/2011 11:55:56.181'!
text: aText

	super text: aText.
	self updateSubmorphs.! !

!UiCompositeButton methodsFor: 'updating' stamp: 'mt 3/5/2011 11:57:45.947'!
updateSubmorphs

	self removeAllMorphs.
	
	box ifNil: [box := self boxClass new].
	
	self addMorphBack: box.
	self icon ifNotNil: [:i |
		self enabled
				ifTrue: [self addMorphBack: i asMorph]
				ifFalse: [self addMorphBack: i asGrayScale2 asMorph]].
	self text ifNotNil: [:t | 
		self enabled
				ifTrue: [self addMorphBack: t asHtmlText asMorph lock]
				ifFalse: [self addMorphBack: ('<font color="#444444>', t asString, '</font>') asHtmlText asMorph lock]].! !

UiCompositeButton subclass: #UiRadioButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiRadioButton class methodsFor: 'testing' stamp: 'mt 3/5/2011 12:00:58.832'!
isWidgetClass

	^ true! !

!UiRadioButton class methodsFor: 'accessing' stamp: 'mt 3/5/2011 12:01:38.119'!
widgetClassIcon

	^ UiFugueIcons uiRadioButtonsIcon! !

!UiRadioButton class methodsFor: 'accessing' stamp: 'mt 3/5/2011 12:01:47.229'!
widgetClassName

	^ 'Radio Button'! !

!UiRadioButton class methodsFor: 'properties' stamp: 'mt 3/5/2011 12:02:08.606'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #(checkable autoExclusive)! !

!UiRadioButton methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:58:48.539'!
boxClass

	^ UiRadioButtonBox! !

!UiRadioButton methodsFor: 'drawing' stamp: 'mt 3/5/2011 11:59:23.645'!
fullDrawOn: aCanvas

	super fullDrawOn: aCanvas.
	
	box notNil & self checked ifTrue: [
		aCanvas
			fillOval: (box bounds insetBy: 3)
			color: (Color gray: 0.3)].! !

!UiRadioButton methodsFor: 'initialization' stamp: 'mt 3/5/2011 12:00:06.306'!
initialize

	super initialize.
		
	self
		autoExclusive: true;
		text: 'RadioButton'.! !

UiButton subclass: #UiPushButton
	instanceVariableNames: 'outerBorderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiPushButton commentStamp: 'mt 12/1/2011 11:24:09.953' prior: 0!
This button triggers regular user interactions. Usually, it is used for confirmation or cancellation in dialog boxes.!

!UiPushButton class methodsFor: 'testing' stamp: 'mt 6/28/2010 21:57:11.625'!
isWidgetClass

	^ true! !

!UiPushButton class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:49:23.805'!
widgetClassIcon

	^ UiFugueIcons uiButtonIcon! !

!UiPushButton class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:10:37.376'!
widgetClassName

	^ 'Push Button'! !

!UiPushButton methodsFor: 'drawing' stamp: 'mt 1/2/2012 16:59:04.168'!
drawOn: aCanvas

	UiPainter default new
		drawPushButton: self on: aCanvas.! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 2/7/2012 16:03:21.39'!
enabled: aBoolean

	enabled = aBoolean ifTrue: [^ self].
	super enabled: aBoolean.
	self updateSubmorphs.! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 4/17/2011 15:32:44.867'!
icon: aForm

	aForm == icon ifTrue: [^ self].

	super icon: aForm.
	self updateSubmorphs.! !

!UiPushButton methodsFor: 'initialization' stamp: 'mt 5/18/2011 13:48:30.291'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
	
	self
		color: (Color gray: 0.8);
		text: 'PushButton'.! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 2/26/2011 20:07:00.698'!
outerBorderWidth

	^ outerBorderWidth ifNil: [outerBorderWidth := 1]! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 2/26/2011 20:07:27.461'!
outerBorderWidth: anInteger

	outerBorderWidth = anInteger ifTrue: [^ self].
	outerBorderWidth := anInteger.
	self redrawLater.! !

!UiPushButton methodsFor: 'geometry' stamp: 'mt 2/26/2011 20:07:46.451'!
outerBounds
	"Used for extra outline. See #draw."
	
	^ self bounds outsetBy: self outerBorderWidth! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 6/28/2010 22:03:18.543'!
text: aString

	super text: aString.
	self updateSubmorphs.! !

!UiPushButton methodsFor: 'updating' stamp: 'mt 5/18/2011 13:48:21.805'!
updateSubmorphs

	self submorphs ifNotEmpty: [self removeAllMorphs].
		
	self icon ifNotNil: [:i | 
		self enabled
				ifTrue: [self addMorphBack: i asMorph]
				ifFalse: [self addMorphBack: i asGrayScale2 asMorph]].
	self text ifNotNil: [:t | 
		self enabled
				ifTrue: [self addMorphBack: t asHtmlText asMorph lock]
				ifFalse: [self addMorphBack: ('<font color="#444444>', t asString, '</font>') asHtmlText asMorph lock]].! !

UiPushButton subclass: #UiScrollBarArrowButton
	instanceVariableNames: 'fadeAnimation direction'
	classVariableNames: 'Arrows'
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiScrollBarArrowButton class methodsFor: 'testing' stamp: 'mt 2/27/2011 16:16:58.913'!
isWidgetClass

	^ false! !

!UiScrollBarArrowButton methodsFor: 'initialization' stamp: 'mt 5/18/2011 14:09:09.497'!
arrow: aSymbol
	"#up, #down, #left, #right"
	
	Arrows ifNil: [ | formDown formUp |
		Arrows := Dictionary new.
		formDown := (UiSilkIcons bulletArrowDownIcon
			clippedTo: 8@8)
			collectColors: [:c | c darker].
		formUp := (UiSilkIcons bulletArrowUpIcon
			clippedTo: 8@8)
			collectColors: [:c | c darker].
		Arrows at: #left put:
			(formDown rotateBy: #right centerAt: 4@4).
		Arrows at: #up put: formUp.
		Arrows at: #right put:
			(formUp rotateBy: #right centerAt: 4@4).
		Arrows at: #down put: formDown].
	
	^ Arrows at: aSymbol! !

!UiScrollBarArrowButton methodsFor: 'accessing' stamp: 'mt 3/28/2011 13:37:22.086'!
direction

	^ direction! !

!UiScrollBarArrowButton methodsFor: 'accessing' stamp: 'mt 5/18/2011 14:09:07.559'!
direction: aSymbol

	aSymbol = direction ifTrue: [^ self].
	
	direction := aSymbol.
	
	self submorphs ifNotEmpty: [self removeAllMorphs].
	self addMorph: ((self arrow: aSymbol) asMorph
		frameFractions: (0@0 corner: 1@1);
		ignoresColorMappings: true).  
	
	(#(left right) includes: aSymbol)
		ifTrue: [
			self
				hResizing: #rigid;
				vResizing: #spaceFill;
				layoutInset: (2@0 corner: 2@0)]
		ifFalse: ["up down"
			self
				hResizing: #spaceFill;
				vResizing: #rigid;
				layoutInset: (0@2 corner: 0@2)].! !

!UiScrollBarArrowButton methodsFor: 'animations' stamp: 'mt 4/5/2011 16:00:16.928'!
fadeIn

	self visible ifFalse: [^ self].
	
	fadeAnimation
		ifNil: [^ self]
		ifNotNil: [:anim |
			anim unregister.
			fadeAnimation := nil].
	
	super fadeIn.! !

!UiScrollBarArrowButton methodsFor: 'animations' stamp: 'mt 4/5/2011 16:00:33.533'!
fadeOut

	self visible ifFalse: [^ self].
	
	fadeAnimation ifNil: [fadeAnimation := (AnimAlphaBlendAnimation
		fadeOutOn: self
		duration: 200)
		register;
		start: #keepWhenFinished].! !

!UiScrollBarArrowButton methodsFor: 'animations' stamp: 'mt 5/18/2011 13:54:08.466'!
fadeOutInstantly

	self fadeOut.
	
	fadeAnimation ifNotNil: [fadeAnimation
		stop;
		toEnd].! !

!UiScrollBarArrowButton methodsFor: 'initialization' stamp: 'mt 1/2/2012 17:30:20.525'!
initialize

	super initialize.
	
	self
		color: (Color gray: 0.9);
		changeProportionalLayout;
		listCentering: #center;
		fadeOutInstantly.
		
	self eventHandler setProperty: #handlesMouseStillDown toValue: [true].
	self eventHandler setProperty: #handlesKeyboard toValue: [false].
	
	self connect: self eventHandler signal: #focusReceived toSelector: #passFocusToOwner.! !

!UiScrollBarArrowButton methodsFor: 'accessing' stamp: 'mt 1/2/2012 17:26:40.231'!
orientation

	^ (self direction == #left or: [self direction == #right])
		ifTrue: [#horizontal]
		ifFalse: [#vertical]! !

!UiScrollBarArrowButton methodsFor: 'initialization' stamp: 'mt 2/26/2011 21:07:13.055'!
passFocusToOwner

	self owner grabKeyboard.! !

!UiScrollBarArrowButton methodsFor: 'updating' stamp: 'mt 5/18/2011 14:01:07.175'!
updateSubmorphs

	"Ignore."! !

UiPushButton subclass: #UiSliderButton
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiSliderButton commentStamp: 'mt 2/27/2011 15:45:52.758' prior: 0!
Special push button to be used in slider.!

UiSliderButton subclass: #UiScrollBarSliderButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiScrollBarSliderButton commentStamp: 'mt 2/26/2011 17:45:21.609' prior: 0!
Special push button to be used in scrollbar.!

!UiScrollBarSliderButton methodsFor: 'drawing' stamp: 'mt 5/20/2011 08:52:38.69'!
drawGripOn: aCanvas at: aPoint
	"Draws a single grip. Considers orientation."
	
	| rect |
	rect := (aPoint extent: (
		self orientation == #horizontal
			ifTrue: [6 @ self height]
			ifFalse: [self width @ 6])) insetBy: 2.
	
	aCanvas
		frameRectangle: rect
		color: (Color gray: 0.3).
	
		aCanvas
			line: rect bottomLeft + (1@ -1)
			to: rect bottomRight - (1@1)
			color: (Color gray: 0.6).
		
		aCanvas
			line: rect bottomRight - (1@1)
			to: rect topRight + (-1@1)
			color: (Color gray: 0.6).! !

!UiScrollBarSliderButton methodsFor: 'drawing' stamp: 'mt 1/4/2012 14:16:21.46'!
drawGripsOn: aCanvas

	1 to: 3 do: [:index |
		self
			drawGripOn: aCanvas
			at: (self orientation == #horizontal
				ifTrue: [self center x - 6 +
					(index - 1 * 3) @ self top]
				ifFalse: [self left @ (self center y - 6 +
					(index - 1 * 3))])]! !

!UiScrollBarSliderButton methodsFor: 'drawing' stamp: 'mt 1/4/2012 14:15:35.75'!
drawOn: aCanvas

	super drawOn: aCanvas.
	
	"Draw grips."
	((self orientation == #horizontal
		and: [self width >= 16]) or: [
		(self orientation == #vertical
			and: [self height >= 16])])
				ifTrue: [self drawGripsOn: aCanvas].! !

!UiScrollBarSliderButton methodsFor: 'geometry' stamp: 'mt 5/18/2011 14:37:28.164'!
extent: aPoint
	
	self orientation = #horizontal ifTrue: [
		super extent: (aPoint max: 10@0)].
	
	self orientation = #vertical ifTrue: [
		super extent: (aPoint max: 0@10)].! !

!UiSliderButton class methodsFor: 'testing' stamp: 'mt 2/27/2011 16:17:13.969'!
isWidgetClass

	^ false! !

!UiSliderButton methodsFor: 'initialization' stamp: 'mt 1/2/2012 17:29:40.021'!
initialize

	super initialize.
	
	self
		color: (Color gray: 0.9);
		listCentering: #center;
		cellInset: 1;
		layoutInset: 2;  
		orientation: #horizontal;
		disableTableLayout: true.
		
	self eventHandler setProperty: #handlesMouseDown toValue: [false].! !

!UiSliderButton methodsFor: 'accessing' stamp: 'mt 2/27/2011 15:41:01.067'!
orientation

	^ orientation ifNil: [#horizontal]! !

!UiSliderButton methodsFor: 'accessing' stamp: 'mt 2/27/2011 15:41:02.552'!
orientation: aSymbol
	"#horizontal, #vertical"
	
	aSymbol = orientation ifTrue: [^ self].
	
	orientation := aSymbol.
	
	self update.! !

!UiSliderButton methodsFor: 'updating' stamp: 'mt 2/27/2011 15:41:34.974'!
update

	self extent: 14@14.
	
	self orientation = #horizontal
		ifTrue: [self
			listDirection: #leftToRight;
			hResizing: #rigid;
			vResizing: #spaceFill].
		
	self orientation = #vertical
		ifTrue: [self
			listDirection: #topToBottom;
			hResizing: #spaceFill;
			vResizing: #rigid].! !

!UiSliderButton methodsFor: 'updating' stamp: 'mt 5/18/2011 14:15:25.46'!
updateSubmorphs

	"Ignore."! !

UiButton subclass: #UiRadioButtonBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiRadioButtonBox methodsFor: 'drawing' stamp: 'mt 3/5/2011 11:44:52.361'!
drawBorderOn: aCanvas

	| color1 color2 |
	(self down or: [self checked])
		ifTrue: [
			color1 := self color twiceDarker.
			color2 := self color twiceLighter]
		ifFalse: [
			color1 := self color twiceLighter.
			color2 := self color twiceDarker].
		
	aCanvas
		frameOval: self bounds
		color: color1.
		
	aCanvas clipBy: (self bounds translateBy: 0 @ (self bounds height * 0.75)) during: [:c1 |
		c1
			frameOval: self bounds
			color: color2].
		
	aCanvas clipBy: (self bounds translateBy: (self bounds width * 0.75) @ 0) during: [:c1 |
		c1
			frameOval: self bounds
			color: color2].! !

!UiRadioButtonBox methodsFor: 'drawing' stamp: 'mt 3/5/2011 12:04:13.007'!
drawOn: aCanvas

	self setProperty: #fillStyle toValue: self gradient.
	
	aCanvas
		fillOval: self bounds
		fillStyle: self fillStyle.

	self drawBorderOn: aCanvas.! !

!UiRadioButtonBox methodsFor: 'initialization' stamp: 'mt 3/5/2011 12:03:48.215'!
initialize

	super initialize.
	self extent: 12@12.! !

UiButton subclass: #UiToolButton
	instanceVariableNames: 'raised autoRaise buttonStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiToolButton commentStamp: 'mt 3/5/2011 11:22:33.102' prior: 0!
Supports #autoRaise and aligns icon and text according to different #buttonStyle.!

UiToolButton subclass: #UiCheckButtonBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiCheckButtonBox class methodsFor: 'testing' stamp: 'mt 3/5/2011 12:15:45.982'!
isWidgetClass

	^ false! !

!UiCheckButtonBox methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:55:14.331'!
initialize

	super initialize.
	
	self 
		checkable: false;
		hResizing: #rigid;
		vResizing: #rigid;
		icon: nil; text: nil;
		extent: 12@12.! !

!UiToolButton class methodsFor: 'testing' stamp: 'mt 6/28/2010 21:32:01.69'!
isWidgetClass

	^ true! !

!UiToolButton class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:50:15.247'!
widgetClassIcon

	^ UiFugueIcons uiButtonToggleIcon! !

!UiToolButton class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:11:24.018'!
widgetClassName

	^ 'Tool Button'! !

!UiToolButton class methodsFor: 'properties' stamp: 'mt 10/22/2010 11:40:45.982'!
widgetProperties

	^ super widgetProperties, {{'Tool Button'. #yourself} -> {
		#autoRaise -> Boolean.
		#buttonStyle -> #(iconOnly textOnly textBesideIcon textUnderIcon)}}! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:08:09.225'!
autoRaise

	^ autoRaise ifNil: [autoRaise := false]! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:36:20.019'!
autoRaise: aBoolean

	aBoolean == autoRaise ifTrue: [^ self].

	autoRaise := aBoolean.
	
	self raised: aBoolean not.! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/28/2010 22:36:21.335'!
buttonStyle

	^ buttonStyle ifNil: [buttonStyle := #textBesideIcon]! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/28/2010 22:37:57.741'!
buttonStyle: aStyle
	"#iconOnly #textOnly #textBesideIcon #textUnderIcon"

	aStyle = buttonStyle ifTrue: [^ self].
	
	buttonStyle := aStyle.
	
	self updateSubmorphs.! !

!UiToolButton methodsFor: 'drawing' stamp: 'mt 1/2/2012 16:59:24.803'!
drawOn: aCanvas

	UiPainter default new
		drawToolButton: self on: aCanvas.! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 2/7/2012 16:03:26.031'!
enabled: aBoolean

	enabled = aBoolean ifTrue: [^ self].
	super enabled: aBoolean.
	self updateSubmorphs.! !

!UiToolButton methodsFor: 'actions' stamp: 'mt 2/26/2011 15:16:50.685'!
flatten

	self autoRaise ifTrue: [self raised: false].! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 4/17/2011 15:33:06.665'!
icon: aForm

	aForm == icon ifTrue: [^ self].

	super icon: aForm.
	self updateSubmorphs.! !

!UiToolButton methodsFor: 'initialization' stamp: 'mt 12/16/2011 11:53:36.773'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
	
	self
		color: (Color r: 1.0 g: 222/255 b: 0);
		raised: true;
		autoRaise: true;
		text: 'ToolButton';
		updateSubmorphs.! !

!UiToolButton methodsFor: 'initialization' stamp: 'mt 1/6/2012 10:11:15.868'!
initializeEventHandler

	super initializeEventHandler.
	self eventHandler setProperty: #handlesMouseOver toValue: [self enabled].
	
	self connect: self eventHandler signal: #mouseEntered: toSelector: #raise.
	self connect: self eventHandler signal: #mouseLeft: toSelector: #flatten.
	
	"No keyboard focus for tool buttons."
	self eventHandler disconnectSignal: #mousePressed: from: self selector: #grabKeyboard.! !

!UiToolButton methodsFor: 'geometry' stamp: 'mt 12/16/2011 11:49:10.929'!
outerBounds

	^ self bounds outsetBy: 1! !

!UiToolButton methodsFor: 'actions' stamp: 'mt 2/26/2011 15:17:01.592'!
raise

	self autoRaise ifTrue: [self raised: true].! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:20:48.182'!
raised

	^ raised ifNil: [raised := true]! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:55:53.198'!
raised: aBoolean

	aBoolean == raised ifTrue: [^ self].

	raised := aBoolean.
	self redrawLater.! !

!UiToolButton methodsFor: 'actions' stamp: 'mt 2/26/2011 15:17:36.308'!
release: aMouseEvent

	(self bounds containsPoint: aMouseEvent position)
		ifFalse: [self flatten].
		
	super release: aMouseEvent.! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:16:46.914'!
text: aString

	super text: aString.
	self updateSubmorphs.! !

!UiToolButton methodsFor: 'updating' stamp: 'mt 7/19/2012 11:38:20.766'!
updateSubmorphs

	self removeAllMorphs.
	
	self buttonStyle = #textUnderIcon
		ifTrue: [self listDirection: #topToBottom]
		ifFalse: [self listDirection: #leftToRight].
	
	self icon ifNotNil: [:i | (self buttonStyle ~= #textOnly 
		or: [self text isNil]) ifTrue: [
			self enabled
				ifTrue: [self addMorphBack: i asMorph]
				ifFalse: [self addMorphBack: i asGrayScale2 asMorph]]].
	self text ifNotNil: [:t | (self buttonStyle ~= #iconOnly
		or: [self icon isNil]) ifTrue: [
			| preparedText |
			preparedText := self enabled
				ifTrue: [t asHtmlText]
				ifFalse: [('<font color="#444444>', t asString, '</font>') asHtmlText].
			preparedText addAttribute: (TextFontReference toFont: Preferences standardButtonFont).
			self addMorphBack: preparedText asMorph lock]].! !

Morph subclass: #UiComboBox
	instanceVariableNames: 'button readOnlyButton arrowButton lineEdit listWidget converter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiComboBox commentStamp: 'mt 1/6/2012 09:53:49.843' prior: 0!
A combo box is a mixture of a list and a line edit field. It can be #readOnly in which case the edit field becomes a clickable button.

Use combo boxes to present choices.!

!UiComboBox class methodsFor: 'testing' stamp: 'mt 6/29/2010 16:31:40.618'!
isWidgetClass

	^ true! !

!UiComboBox class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:29:17.438'!
widgetCategory
	
	^ 'Input Widgets'! !

!UiComboBox class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:50:28.366'!
widgetClassIcon

	^ UiFugueIcons uiComboBoxIcon! !

!UiComboBox class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:23:12.475'!
widgetClassName

	^ 'Combo Box'! !

!UiComboBox class methodsFor: 'properties' stamp: 'mt 10/28/2010 16:52:41.237'!
widgetProperties

	^ super widgetProperties, {{'Combo Box'. #yourself} -> {
		#readOnly -> Boolean}}! !

!UiComboBox class methodsFor: 'properties' stamp: 'mt 12/17/2011 14:37:40.505'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout' vResizing)! !

!UiComboBox methodsFor: 'adding' stamp: 'mt 3/29/2011 18:21:08.755'!
addIcon: anIcon text: aLabel

	listWidget addIcon: anIcon text: aLabel.
		
	(listWidget items size = 1 and: [self readOnly])
		ifTrue: [self currentIndex: 1]! !

!UiComboBox methodsFor: 'adding' stamp: 'mt 1/5/2012 15:39:05.183'!
addItemListFrom: someObjects using: aBlock
	"myComboBox addItemListFrom: #(a b c) using: [:symbol :listItem | listItem text: symbol]."

	| wasEmpty |
	wasEmpty := listWidget items isEmpty.

	listWidget
		addItemListFrom: someObjects
		using: aBlock.
		
	(wasEmpty and: [self readOnly])
		ifTrue: [self currentIndex: 1].! !

!UiComboBox methodsFor: 'adding' stamp: 'mt 3/29/2011 18:21:03.793'!
addText: aLabel

	listWidget addText: aLabel.
	
	(listWidget items size = 1 and: [self readOnly])
		ifTrue: [self currentIndex: 1]! !

!UiComboBox methodsFor: 'adding' stamp: 'mt 3/30/2011 10:06:01.265'!
addTextList: someLabels

	| wasEmpty |
	wasEmpty := listWidget items isEmpty.
	
	listWidget addTextList: someLabels.
	
	(wasEmpty and: [self readOnly])
		ifTrue: [self currentIndex: 1]! !

!UiComboBox methodsFor: 'accessing - private' stamp: 'mt 1/5/2012 16:20:10.654'!
arrowButton

	^ arrowButton! !

!UiComboBox methodsFor: 'accessing - private' stamp: 'mt 12/17/2011 14:10:56.951'!
button

	^ button! !

!UiComboBox methodsFor: 'initialization' stamp: 'mt 2/14/2012 16:18:23.562'!
changeTableLayout

	"Ignore."
	self flag: #workaround. "Backward compatibility with old UIs."! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:19:31.999'!
clear

	listWidget clear.
	self updateCurrentRow: nil.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 1/6/2012 09:37:43.674'!
color
	"Return button color if in read-only mode."

	^ self readOnly
		ifTrue: [readOnlyButton color]
		ifFalse: [super color]! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 1/6/2012 09:38:08.774'!
color: aColor
	"Base color of this combo box cannot be overridden. It should always be white."

	readOnlyButton color: aColor.
	arrowButton color: aColor.
	button color: aColor.
	listWidget borderColor: aColor muchDarker.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:57:53.22'!
converter

	^ converter ifNil: [converter := [:item | item]]! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:57:11.326'!
converter: aBlock

	converter := aBlock.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 08:19:30.874'!
currentIndex

	^ listWidget currentRow! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2011 10:59:50.545'!
currentIndex: anIndex

	listWidget currentRow: anIndex.! !

!UiComboBox methodsFor: 'signals' stamp: 'mt 6/29/2010 17:11:28.048'!
currentIndexChanged: index text: text

	self emit.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 5/17/2011 13:28:57.881'!
currentItem

	^ listWidget currentItem! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2011 10:55:23.408'!
currentItem: aListWidgetItem

	listWidget currentItem: aListWidgetItem.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:58:02.404'!
currentText

	^ self converter value: lineEdit theText! !

!UiComboBox methodsFor: 'signals' stamp: 'mt 3/29/2011 11:36:54.865'!
currentTextChanged: text

	self emitAlways.! !

!UiComboBox methodsFor: 'drawing' stamp: 'mt 1/5/2012 16:24:08.142'!
drawOn: aCanvas

	UiPainter default new
		drawComboBox: self on: aCanvas.! !

!UiComboBox methodsFor: 'drawing' stamp: 'mt 1/5/2012 16:02:15.687'!
drawOverlayOn: aCanvas

	UiPainter default new
		drawComboBox: self overlayOn: aCanvas.! !

!UiComboBox methodsFor: 'events' stamp: 'mt 6/23/2011 10:38:46.144'!
hasKeyboard

	^ super hasKeyboard or: [listWidget hasKeyboard]! !

!UiComboBox methodsFor: 'testing' stamp: 'mt 1/6/2012 09:47:31.166'!
hasUnacceptedChanges

	^ self readOnly not and: [lineEdit hasUnacceptedChanges]! !

!UiComboBox methodsFor: 'private' stamp: 'mt 1/6/2012 10:00:02.37'!
hideList

	button checked: false.
	arrowButton checked: false.
	readOnlyButton checked: false.

	"listWidget fadeOutThen: [listWidget show; delete]."
	listWidget delete.! !

!UiComboBox methodsFor: 'initialization' stamp: 'mt 1/6/2012 10:27:57.962'!
initialize

	super initialize.
	
	self
		initializeSupportMorphs;
		initializeEventHandler.
	
	self
		width: 150;
		layoutPolicy: UiComboBoxLayout new.
	super color: Color white.
		
	"Initialize the submorphs the first time."
	self readOnly: true.
		
	self connect: listWidget signal: #currentRowChanged: toSelector: #updateCurrentRow:.
	self connect: listWidget signal: #currentRowChanged: toSelector: #hideList.
	
	"TODO: use other signals for changing text"
	self connect: lineEdit signal: #returnPressed: toSelector: #currentTextChanged:.! !

!UiComboBox methodsFor: 'initialization' stamp: 'mt 1/6/2012 10:24:12.895'!
initializeEventHandler

	self eventHandler: UiEventHandler new.
	
	self connect: self eventHandler signal: #mousePressed: to: button selector: #press:.
	self connect: self eventHandler signal: #mousePressed: to: arrowButton selector: #press:.
	self connect: self eventHandler signal: #mousePressed: to: readOnlyButton selector: #press:.

	self connect: self eventHandler signal: #mouseReleased: toSelector: #passMouseUp:.
	self connect: self eventHandler signal: #mouseReleased: toSelector: #toggleList.! !

!UiComboBox methodsFor: 'initialization' stamp: 'mt 1/6/2012 10:25:22.617'!
initializeSupportMorphs
	
	button := UiPushButton new
		text: nil;
		checkable: true;
		vResizing: #rigid;
		icon: ((UiSilkIcons bulletArrowDownIcon clippedTo: 8@8) collectColors: [:c | c darker]);
		layoutInset: (3@4 corner: 3@4).
		
	arrowButton := UiToolButton new "for #autoRaise in read-write-mode"
		buttonStyle: #iconOnly; "no text"
		checkable: true;
		vResizing: #rigid;
		icon: ((UiSilkIcons bulletArrowDownIcon clippedTo: 8@8) collectColors: [:c | c darker]);
		color: (Color gray: 0.85);
		layoutInset: (3@4 corner: 3@4).
	self connect: arrowButton signal: #toggled: toSelector: #toggleList.

	lineEdit := UiLineEdit new
		outerBorderWidth: 1.

	listWidget := UiListWidget new
		outerBorderWidth: 1.
	"The list widget behaves like a submorph for keyboard focus change."
	self connect: listWidget eventHandler signal: #focusReceivedInSubmorph: toSelector: #keyboardFocusChange:inSubmorph: pattern: #(=true 1).
	self connect: listWidget eventHandler signal: #focusLostInSubmorph: toSelector: #keyboardFocusChange:inSubmorph: pattern: #(=false 1).
	
	readOnlyButton := UiPushButton new
		text: ' ';
		icon: nil;
		checkable: true;
		hResizing: #spaceFill.! !

!UiComboBox methodsFor: 'accessing - private' stamp: 'mt 12/17/2011 14:11:17.62'!
lineEdit

	^ lineEdit! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2011 10:53:41.053'!
list

	^ listWidget! !

!UiComboBox methodsFor: 'geometry' stamp: 'mt 1/5/2012 16:30:56.239'!
outerBounds

	^ self bounds outsetBy: 1! !

!UiComboBox methodsFor: 'event handling' stamp: 'mt 1/6/2012 09:57:03.293'!
passMouseUp: aMouseEvent
	"Modify the event position so that the buttons will not ignore the mouse up."
	
	| oldPos |
	(self bounds containsPoint: aMouseEvent position)
		ifFalse: [^ false].
	
	oldPos := aMouseEvent position.
	
	aMouseEvent setPosition: button center.
	button release: aMouseEvent.
	aMouseEvent setPosition: arrowButton center.
	arrowButton release: aMouseEvent.
	
	aMouseEvent setPosition: readOnlyButton center.    
	readOnlyButton release: aMouseEvent.
	
	aMouseEvent setPosition: oldPos.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/29/2010 16:38:37.021'!
readOnly

	^ lineEdit readOnly! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 1/6/2012 10:25:32.079'!
readOnly: aBoolean

	lineEdit readOnly: aBoolean.
	
	self eventHandler mouseDownPriority: (aBoolean ifTrue: [1] ifFalse: [0]).
	
	self updateSubmorphs.! !

!UiComboBox methodsFor: 'accessing - private' stamp: 'mt 12/17/2011 14:11:04.989'!
readOnlyButton

	^ readOnlyButton! !

!UiComboBox methodsFor: 'private' stamp: 'mt 3/29/2011 10:32:20.376'!
showList

	listWidget size = 0
		ifTrue: [^ self].
	
	listWidget
		useOptimalSize;
		width: (self width max: listWidget width);
		height: (listWidget height min: 100);
		topLeft: (self localPointToGlobal: self bottomLeft);
		openInWorld.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:11:32.602'!
size

	^ listWidget size! !

!UiComboBox methodsFor: 'private' stamp: 'mt 1/6/2012 09:59:13.53'!
toggleList

	(button checked or: [arrowButton checked])
		ifTrue: [self showList]
		ifFalse: [self hideList].! !

!UiComboBox methodsFor: 'updating' stamp: 'mt 5/20/2011 09:52:00.318'!
updateCurrentRow

	self updateCurrentRow: self currentIndex.! !

!UiComboBox methodsFor: 'updating' stamp: 'mt 5/17/2011 10:19:31.707'!
updateCurrentRow: anIndex

	lineEdit theText: listWidget currentText.
	
	readOnlyButton text: listWidget currentText.
	readOnlyButton icon: listWidget currentIcon.
	
	self currentIndexChanged: anIndex text: (self converter value: lineEdit theText).
	self currentTextChanged: (self converter value: lineEdit theText).! !

!UiComboBox methodsFor: 'updating' stamp: 'mt 1/6/2012 10:29:30.531'!
updateSubmorphs

	self removeAllMorphs.
	
	self
		addMorphBack: (self readOnly ifTrue: [button] ifFalse: [arrowButton]);
		addMorphBack: (self readOnly ifTrue: [readOnlyButton] ifFalse: [lineEdit]).! !

Morph subclass: #UiItemViewMorph
	instanceVariableNames: 'form formPosition label labelColor labelPosition font'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiItemViewMorph commentStamp: 'mt 6/29/2012 16:24:47.693' prior: 0!
This is a simple version of an item.!

!UiItemViewMorph methodsFor: 'drawing' stamp: 'mt 6/29/2012 18:08:35.874'!
drawOn: aCanvas

	self form ifNotNil: [
		aCanvas
			translucentImage: self form
			at: self formPosition + self topLeft].
	
	self label ifNotNil: [	
		aCanvas
			drawString: self label
			at: self labelPosition + self topLeft
			font: self font
			color: self labelColor].! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:28:27.288'!
font
	^ font! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:28:27.304'!
font: anObject
	font := anObject! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:28:27.194'!
form
	^ form! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:28:27.238'!
form: anObject
	form := anObject! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:30:02.805'!
formPosition
	^ formPosition! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:30:02.852'!
formPosition: anObject
	formPosition := anObject! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:28:27.257'!
label
	^ label! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:28:27.273'!
label: anObject
	label := anObject! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:30:32.089'!
labelColor
	^ labelColor! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:30:32.138'!
labelColor: anObject
	labelColor := anObject! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:30:02.875'!
labelPosition
	^ labelPosition! !

!UiItemViewMorph methodsFor: 'accessing' stamp: 'mt 6/29/2012 16:30:02.89'!
labelPosition: anObject
	labelPosition := anObject! !

Morph subclass: #UiItemViewport
	instanceVariableNames: 'rows columns hoveredCell hoveredDropMode selectionColor selection selectionMode selectionBehavior verticalHeader horizontalHeader rowOrder columnOrder isLayoutBeingModified groupSpec cellToBounds drawCache drawCacheActive dragDropSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiItemViewport commentStamp: 'mt 11/2/2010 12:48:55.736' prior: 0!
An item viewport represents the whole area where a model's items are layouted. Usually, items (just morphs) are created by using an item delegate that reads a model index and therefore model data. A viewport handles item selection.

There is a difference between a model index and a cell index. Cell indices are numbered in visual order (e.g., according to the current sorting) and may change as the sorting order changes, whereas model indices always address some data in the model and are not changed by the viewport (or view) only by the model itself. Additionally, cell indices to not have a hierarchy, i.e. a parent cell index, and are always two-dimensional.

All item morphs get additional properties, e.g., #modelIndex, #hasChildren, #isExpanded, to track different state or information changed or needed by event handling or drawing routines in the viewport.!

!UiItemViewport methodsFor: 'drag/drop' stamp: 'mt 7/22/2012 08:42:08.714'!
acceptDroppingMorph: aTransformMorph event: event

	| cell |
	cell := self cellIndexFromPoint: event position.
	cell ifNil: [^ self].
	
	self dragDropSpec dropMode == #over ifTrue: [
		self
			objectDropped: aTransformMorph passenger
			type: aTransformMorph dragTransferType
			from: aTransformMorph source
			on: (self modelIndexFor: cell)].
		
	self dragDropSpec dropMode == #between ifTrue: [
		| cellBounds |
		cellBounds := self cellBoundsFor: cell.
		
		event position y < (cellBounds top + (cellBounds height // 2))
			ifTrue: [
				self
					objectDropped: aTransformMorph passenger
					type: aTransformMorph dragTransferType
					from: aTransformMorph source
					before: (self modelIndexFor: cell)	]
			ifFalse: [
				self
					objectDropped: aTransformMorph passenger
					type: aTransformMorph dragTransferType
					from: aTransformMorph source
					after: (self modelIndexFor: cell)]].! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 7/10/2012 11:22:36.37'!
activateCurrentCell

	self selection currentIndex ifNil: [^ self].

	self selection currentCell ifNotNil: [
		self
			activated: self selection currentIndex;
			returnPressed: self selection currentIndex].! !

!UiItemViewport methodsFor: 'signals - model index' stamp: 'mt 10/19/2010 10:28:08.197'!
activated: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'add/remove - appending' stamp: 'mt 6/26/2012 09:43:54.699'!
appendGroupSeparator: aGroupSeparator

	| row |
	row := rows add: UiViewRowInfo new.
	self columns do: [:column |
		column items addLast: aGroupSeparator.
		row items add: aGroupSeparator.
		self addMorphBack: aGroupSeparator].! !

!UiItemViewport methodsFor: 'add/remove - appending' stamp: 'mt 7/1/2012 11:00:21.281'!
appendItemRows: data
	"group -> row -> column -> model index -> item/morph"
	
	data withIndexDo: [:group :groupIndex |
		self appendGroupSeparator: group key.
		
		group value do: [:row | row do: [:indexToItem |
			self
				appendMorph: indexToItem value
				inRow: (self appendRowFor: indexToItem key)
				forIndex: indexToItem key]]].! !

!UiItemViewport methodsFor: 'add/remove - appending' stamp: 'mt 7/1/2012 11:02:16.873'!
appendMorph: aMorph forIndex: aModelIndex
	
	self
		appendMorph: aMorph
		inRow: (self appendRowFor: aModelIndex)
		forIndex: aModelIndex.! !

!UiItemViewport methodsFor: 'add/remove - appending' stamp: 'mt 7/1/2012 11:00:03.761'!
appendMorph: aMorph inRow: aRowInfo forIndex: aModelIndex
	"Optimized insertion method that assumes that the view is filled row-by-row from left to right."
	
	| col row |
	aMorph setProperty: #modelIndex toValue: aModelIndex.
	aMorph setProperty: #isExpanded toValue: false.
	aMorph setProperty: #hasChildren toValue: aModelIndex hasChildren.
	
	row := aRowInfo.
	row items add: aMorph.
	
	col := self columnFor: aModelIndex.
	col items addLast: aMorph.
	
	self addMorphBack: aMorph.
	
	aMorph
		setProperty: #indent
		toValue: (self calculateIndentFor: aMorph atIndex: aModelIndex column: col).! !

!UiItemViewport methodsFor: 'add/remove - appending' stamp: 'mt 4/23/2012 11:51:44.338'!
appendRowFor: aModelIndex
	"Optimized method that only appends a new row at the end of all rows."
	
	aModelIndex parent ifNotNil: [self error: 'You cannot use this method for non-toplevel indices.'].
	
	^ (rows notEmpty and: [rows last isRowFor: aModelIndex])
		ifTrue: [rows last "used for column-wise appending. see #appendItemRows:."]
		ifFalse: [rows add: UiViewRowInfo new].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 3/7/2011 14:42:08.321'!
beginChangeLayout

	isLayoutBeingModified := true.! !

!UiItemViewport methodsFor: 'events - in-place editing' stamp: 'mt 7/6/2012 11:55:04.375'!
beginEditCell: aCell

	| rowIndex columnIndex item |
	rowIndex := self rowOrder mapAt: aCell y.
	columnIndex := self columnOrder mapAt: aCell x.
	item := (self rows at: rowIndex) items at: columnIndex.
	
	^ self beginEditItem: item! !

!UiItemViewport methodsFor: 'events - in-place editing' stamp: 'mt 7/8/2012 14:54:45.397'!
beginEditItem: anItem

	| index editor |
	index := anItem valueOfProperty: #modelIndex.
	
	(index editable not or: [index isInEditMode])
		ifTrue: [^ false "no further editing possible"].
	
	editor := index editor.
	
	self replaceMorphWith: editor atIndex: index.
	
	index spec editorAcceptSignal ifNotNil: [:s |
		self connect: editor signal: s toSelector: #endEditItem:acceptChanges: pattern: #(0 =true)].
	index spec editorRevertSignal ifNotNil: [:s |
		self connect: editor signal: s toSelector: #endEditItem:acceptChanges: pattern: #(0 =false)].
	
	index isInEditMode: true.
	
	self updateLayout.
	
	editor grabKeyboard.
	
	^ true! !

!UiItemViewport methodsFor: 'geometry - cached' stamp: 'mt 7/3/2012 11:41:26.842'!
boundsAt: aCell

	| boundsData |
	boundsData := (cellToBounds at: aCell y) at: aCell x.
	^ boundsData first extent: boundsData second! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 6/30/2012 16:01:49.568'!
boundsFor: aCellIndex
	"Returns the relevant bounds for a given cell index based on the current selection behavior."

	aCellIndex ifNil: [^ 0@0 extent: 0@0].

	^ self selectionBehavior == #selectCells
		ifTrue: [self cellBoundsFor: aCellIndex]
		ifFalse: [self selectionBehavior == #selectRows
			ifTrue: [self rowBoundsFor: aCellIndex y]
			ifFalse: [self selectionBehavior == #selectColumns
				ifTrue: [self columnBoundsFor: aCellIndex x]
				ifFalse: [0@0 extent: 0@0]]]! !

!UiItemViewport methodsFor: 'add/remove - private' stamp: 'mt 6/26/2012 10:26:20.83'!
calculateIndentFor: aMorph atIndex: aModelIndex column: col

	| indent itemBefore |
	aModelIndex column = 1 ifFalse: [^ 0].
	
	indent := 0.
	itemBefore := aMorph.

	[(itemBefore := col itemBefore: itemBefore)
		ifNil: [indent := self indent. false] "root"
		ifNotNil: [:item |
			(item hasProperty: #isGroupSeparator) "== special sibling"
			ifTrue: ["Just skip group separators." true]
			ifFalse: ["The item before is my parent. Add additional indentation."
				(item valueOfProperty: #modelIndex) = aModelIndex parent
					ifTrue: [indent := (item valueOfProperty: #indent) + self indent. false]
					ifFalse: ["The item before is my sibling. Use its indentation."
						(item valueOfProperty: #modelIndex) parent = aModelIndex parent
							ifTrue: [indent := item valueOfProperty: #indent. false]
							ifFalse: [true]]]].
	] whileTrue.
	
	^ indent! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 6/30/2012 16:31:16.4'!
cellBoundsFor: aCellIndex

	(cellToBounds at: aCellIndex y ifAbsent: [^ 0@0 extent: 0@0])
		ifNil: [^ 0@0 extent: 0@0]
		ifNotNil: [:rowBounds | (rowBounds at: aCellIndex x ifAbsent: [^ 0@0 extent: 0@0])
			ifNil: [^ 0@0 extent: 0@0]
			ifNotNil: [:data | ^ data first extent: data second]].! !

!UiItemViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 7/6/2012 10:40:23.802'!
cellIndexAt: colAndRow

	| row column |
	row := colAndRow y.
	column := colAndRow x.

	^ (self columnOrder mapIndexOf: column)
		@ (self rowOrder mapIndexOf: row)! !

!UiItemViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 6/30/2012 11:44:01.136'!
cellIndexFromColumn: aColumnInfo

	^ self cellIndexAt: (columns indexOf: aColumnInfo) @ 1! !

!UiItemViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 7/6/2012 10:39:59.967'!
cellIndexFromModelIndex: aModelIndex

	| row column |
	aModelIndex ifNil: [^ nil].

	row := rows indexOf: (self rowFor: aModelIndex).
	column := columns indexOf: (self columnFor: aModelIndex).

	^ (self columnOrder mapIndexOf: column)
		@ (self rowOrder mapIndexOf: row)! !

!UiItemViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 7/19/2012 10:32:37.914'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| origin cellIndex |
	origin := self topLeft.
	cellIndex := 0@0.
	self rowsDo: [:rowInfo |
		cellIndex := 0 @ (cellIndex y + 1).
		rowInfo visible ifTrue: [
			self columnsDo: [:colInfo |
				cellIndex := cellIndex + (1@0).
				colInfo visible ifTrue: [
					(origin <= aPoint and: [aPoint < (origin + (colInfo width @ rowInfo height))])
						ifTrue: [^ cellIndex].
					origin := origin translateBy: colInfo width @ 0]].
			origin := self left @ (origin y + rowInfo height)]].
	
	^ nil! !

!UiItemViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 6/30/2012 11:44:24.376'!
cellIndexFromRow: aRowInfo

	^ self cellIndexAt: 1 @ (rows indexOf: aRowInfo)! !

!UiItemViewport methodsFor: 'geometry - cached' stamp: 'mt 7/3/2012 11:40:24.421'!
cellToBounds

	^ cellToBounds! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 7/10/2012 11:17:49.913'!
changeCheckedByKey: aKeyboardEvent

	| cell index |
	aKeyboardEvent keyCharacter ~= Character space
		ifTrue: [^ self].
	
	cell := self selection currentCell ifNil: [^ self].
	index := self modelIndexFor: cell.

	index checkable
		ifTrue: [((self morphAt: cell) valueOfProperty: #checkBox) ifNotNil: [:chk | chk toggle]]
		ifFalse: [index editable
			ifTrue: [self beginEditCell: cell]].! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 3/23/2012 10:18:38.055'!
clear

	self selection clear.
	
	columns do: [:col | col clear]. "Keep column-specific settings." self flag: #inconsistency.
	rows removeAll.
	
	self
		removeAllMorphs;
		extent: 1@1.! !

!UiItemViewport methodsFor: 'signals - model index' stamp: 'mt 10/8/2010 16:05:54.303'!
clicked: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 6/30/2012 15:58:06.383'!
columnAt: index

	^ self columnOrder items: columns at: index! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 6/26/2012 17:16:50.12'!
columnBoundsFor: aColIndex

	| col |
	aColIndex > columns size
		ifTrue: [^ 0@0 extent: 0@0].
		
	col := self columnAt: aColIndex.
	
	col visible ifFalse: [^ 0@0 extent: 0@0].
	
	^ (self leftForColumn: col) @ self top
		extent: col width @ self height! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 4/21/2011 10:29:09.758'!
columnCount

	^ columns size! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 7/19/2012 11:12:55.845'!
columnCountVisible

	^ self columns count: [:columnInfo | columnInfo visible]! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/9/2010 11:26:53.355'!
columnFor: aModelIndex

	^ columns
		at: aModelIndex column
		ifAbsentPut: [UiViewColumnInfo new]! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:00:57.992'!
columnOrder

	^ columnOrder! !

!UiItemViewport methodsFor: 'accessing - private' stamp: 'mt 1/4/2011 10:23:35.14'!
columns
	"Returns all columns IGNORING CURRENT SORT ORDER."
	
	^ columns! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/17/2010 08:20:05.896'!
columnsDo: aBlock

	self columnOrder items: columns do: aBlock.! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/17/2010 08:20:10.134'!
columnsWithIndexDo: aBlock

	self columnOrder items: columns withIndexDo: aBlock.! !

!UiItemViewport methodsFor: 'signals - model index' stamp: 'mt 10/20/2010 13:54:10.953'!
currentIndexChanged: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 8/16/2012 15:11:13.279'!
doHoverCell: evt

	self hoveredDropMode: #none.
	
	(self cellIndexFromPoint: evt position) ifNotNil: [:cell |		
		((self morphAt: cell) valueOfProperty: #selectable) ifTrue: [
			
		(evt hand submorphs notEmpty and: [self wantsDroppedMorph: evt hand submorphs first event: evt]) ifTrue: [

			"visualize drop target"
			self dragDropSpec ifNotNil: [:spec |
				spec dropMode == #over ifTrue: [
					self hoveredDropMode: #over].
				spec dropMode == #between ifTrue: [
					| cellBounds |
					cellBounds := self cellBoundsFor: cell.
					evt position y < (cellBounds top + (cellBounds height // 2))
						ifTrue: [self hoveredDropMode: #inFrontOf]
						ifFalse: [self hoveredDropMode: #after]]]].
			
		(evt hand submorphs isEmpty or: [self dropEnabled])
			ifTrue: [self hoveredCell: cell]]].! !

!UiItemViewport methodsFor: 'signals - model index' stamp: 'mt 10/8/2010 16:05:00.799'!
doubleClicked: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 7/18/2012 10:19:04.808'!
dragDropSpec
	^ dragDropSpec! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 7/18/2012 10:19:04.854'!
dragDropSpec: anObject
	dragDropSpec := anObject! !

!UiItemViewport methodsFor: 'drag/drop' stamp: 'mt 7/18/2012 10:05:24.441'!
dragEnabled

	^ self dragDropSpec
		ifNil: [false]
		ifNotNil: [:spec | spec dragEnabled]! !

!UiItemViewport methodsFor: 'drawing - cached' stamp: 'mt 7/3/2012 11:04:19.284'!
drawCacheActive

	^ drawCacheActive ifNil: [false]! !

!UiItemViewport methodsFor: 'drawing - cached' stamp: 'mt 7/3/2012 11:06:24.82'!
drawCacheActive: aBoolean

	aBoolean = drawCacheActive ifTrue: [^ self].
	
	drawCacheActive := aBoolean.
	
	drawCacheActive
		ifTrue: [self updateDrawCache].! !

!UiItemViewport methodsFor: 'drawing - cached' stamp: 'mt 7/3/2012 11:50:57.267'!
drawCell: aCell on: aCanvas
	
	aCell ifNil: [^ self].
	
	self selectionBehavior == #selectCells ifTrue: [
		aCanvas
			clipBy: (self boundsAt: aCell)
			during: [:c | c fullDrawMorph: (self morphAt: aCell)]].
		
	self selectionBehavior == #selectRows ifTrue: [
		self columnOrder items: (self rowAt: aCell y) items withIndexDo: [:morph :colIndex |
			aCanvas
				clipBy: (self boundsAt: colIndex @ aCell y)
				during: [:c | c fullDrawMorph: morph]]].
		
	self selectionBehavior == #selectColumns ifTrue: [
		self rowOrder items: (self columnAt: aCell x) items withIndexDo: [:morph :rowIndex |
			aCanvas
				clipBy: (self boundsAt: aCell x @ rowIndex)
				during: [:c | c fullDrawMorph: morph]]].! !

!UiItemViewport methodsFor: 'drawing - cached' stamp: 'mt 7/3/2012 11:55:08.352'!
drawCell: aCell whiteOn: aCanvas
	
	aCell ifNil: [^ self].
	
	self selectionBehavior == #selectCells ifTrue: [
		aCanvas
			clipBy: (self boundsAt: aCell)
			during: [:c | c fillColor: Color white]].
		
	self selectionBehavior == #selectRows ifTrue: [
		1 to: self columnCount do: [:colIndex |
			aCanvas
				clipBy: (self boundsAt: colIndex @ aCell y)
				during: [:c | c fillColor: Color white]]].
		
	self selectionBehavior == #selectColumns ifTrue: [
		1 to: self rowCount do: [:rowIndex |
			aCanvas
				clipBy: (self boundsAt: aCell x @ rowIndex)
				during: [:c | c fillColor: Color white]]].! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 8/9/2012 10:24:23.299'!
drawCurrentCellOn: aCanvas

	self selection currentCell ifNil: [^ self].
	
	((self selectionBehavior == #selectRows and: [self selection currentCell x > 1]) or: [
		self selectionBehavior == #selectColumns and: [self selection currentCell y > 1]])
		ifTrue: [^ self
			drawHighlightOn: aCanvas
			bounds: (self cellBoundsFor: self selection currentCell)
			color: self selectionColor darker].
	
	(self selection cells noneSatisfy: [:cell | cell y = self selection currentCell y])
		ifTrue: [^ self
			drawHighlightFrameOn: aCanvas
			bounds: (self boundsFor: self selection currentCell)
			color: self selectionColor darker].
	
	self
		drawHighlightOn: aCanvas
		bounds: (self boundsFor: self selection currentCell)
		color: self selectionColor darker.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 7/19/2012 09:36:16.847'!
drawDropTargetOn: aCanvas

	| cellBounds |
	self hoveredDropMode == #none ifTrue: [^ self].
	cellBounds := self boundsFor: self hoveredCell.
	
	"Visualize drop target."
	self hoveredDropMode == #over ifTrue: [
		aCanvas
			frameRoundRect: cellBounds
			radius: 3
			width: 2
			color: self selectionColor muchDarker].
		
	self hoveredDropMode == #inFrontOf ifTrue: [
		aCanvas
			line: cellBounds topLeft + (2@0)
			to: cellBounds topRight - (2@0)
			width: 3
			color: self selectionColor muchDarker].
		
	self hoveredDropMode == #after ifTrue: [
		aCanvas
			line: cellBounds bottomLeft + (2@0)
			to: cellBounds bottomRight - (2@0)
			width: 3
			color: self selectionColor muchDarker].! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 7/22/2012 08:57:34.133'!
drawGroupSeparator: aMorph on: aCanvas
	"Draw something that expands the group separator item to the whole width."
	
	aCanvas fullDrawMorph: aMorph.
	
	(aMorph valueOfProperty: #drawLine) == true ifTrue: [
		aCanvas
			line: aMorph right @ aMorph center y
			to: self right @ aMorph center y
			color: (self groupSpec lineColor alpha: 0.4)].! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 8/9/2012 10:21:11.343'!
drawHighlightFrameOn: aCanvas bounds: drawBounds color: aColor
	
	aCanvas
		frameRoundRect: (drawBounds outsetBy: (0@0 corner: 0@1))
		radius: 3
		width: 1
		color: aColor muchDarker.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 8/9/2012 10:21:36.213'!
drawHighlightOn: aCanvas bounds: drawBounds color: aColor
	
	| gradient |

	gradient := (GradientFillStyle ramp: {
			0.0 -> Color white.
			0.1-> (aColor adjustBrightness: 0.05).
			0.6 -> (aColor darker)})
		origin: drawBounds topLeft;
		direction: 0 @ drawBounds height.
		
	aCanvas
		fillRoundRect: (drawBounds insetBy: (1@1 corner: 1@1))
		radius: 3
		fillStyle: gradient.
		
	self drawHighlightFrameOn: aCanvas bounds: drawBounds color: aColor.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 7/19/2012 09:17:57.45'!
drawHoveredCellOn: aCanvas

	self hoveredCell ifNil: [^ self].

	self
		drawHighlightOn: aCanvas
		bounds: (self boundsFor: self hoveredCell)
		color: self selectionColor muchLighter.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 8/7/2012 11:18:00.124'!
drawOn: aCanvas
	
	super drawOn: aCanvas.
	
	self drawCacheActive ifFalse: [		
		self
			drawHoveredCellOn: aCanvas;
			drawSelectionOn: aCanvas;
			drawCurrentCellOn: aCanvas].! !

!UiItemViewport methodsFor: 'drawing - cached' stamp: 'mt 7/19/2012 09:18:28.959'!
drawOverlayOn: aCanvas
	
	self drawCacheActive ifTrue: [
		| importantCells |		
		importantCells := (self selection cells, {self selection currentCell}, {self hoveredCell}) asSet.
		
		"Restore background."
		importantCells do: [:cell | self drawCell: cell whiteOn: aCanvas].
			
		self
			drawHoveredCellOn: aCanvas;
			drawSelectionOn: aCanvas;
			drawCurrentCellOn: aCanvas.
		
		"Fill foreground."	
		importantCells do: [:cell | self drawCell: cell on: aCanvas]].
		
	super drawOverlayOn: aCanvas.
	
	self drawDropTargetOn: aCanvas.  ! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 7/13/2011 15:13:48.409'!
drawSelectionOn: aCanvas

	self selection cells do: [:cell |
		self
			drawHighlightOn: aCanvas
			bounds: (self boundsFor: cell)
			color: self selectionColor].! !

!UiItemViewport methodsFor: 'drawing - cached' stamp: 'mt 7/12/2012 15:52:27.609'!
drawSubmorphsCachedOn: aCanvas
	
	aCanvas
		image: drawCache
		at: 0@0
		sourceRect: drawCache boundingBox
		rule: Form blend.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 7/3/2012 11:03:58.924'!
drawSubmorphsOn: aCanvas
	"Ignores sort order."
	
	| drawBlock |
	self drawCacheActive
		ifTrue: [^ self drawSubmorphsCachedOn: aCanvas].
		
	drawBlock := [:canvas :morphs |
		morphs withIndexDo: [:morph :rowIndex |
			| rowInfo |
			rowInfo := (self rows at: rowIndex).
			rowInfo visible ifTrue: [
				rowInfo isSeparator
					ifTrue: [self drawGroupSeparator: morph on: canvas ]
					ifFalse: [canvas fullDrawMorph: morph]]]].
	
	"Column-wise drawing with clipping."
	self columnsDo: [:columnInfo | 
		columnInfo visible ifTrue: [
			aCanvas clipBy: ((self leftForColumn: columnInfo) @ self top extent: columnInfo width @ self height)
			during: [:c | drawBlock value: c value: columnInfo items]]].! !

!UiItemViewport methodsFor: 'drag/drop' stamp: 'mt 7/18/2012 10:09:04.313'!
dropEnabled

	^ self dragDropSpec
		ifNil: [false]
		ifNotNil: [:spec | spec dropEnabled]! !

!UiItemViewport methodsFor: 'signals - model index' stamp: 'mt 7/8/2012 14:08:08.569'!
edited: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 3/25/2011 09:48:08.986'!
endChangeLayout

	isLayoutBeingModified := false.
	self updateLayout.! !

!UiItemViewport methodsFor: 'events - in-place editing' stamp: 'mt 7/11/2012 14:48:50.078'!
endEditItem: anItem acceptChanges: aBoolean

	| index editedItem |
	index := anItem valueOfProperty: #modelIndex.
	
	index isInEditMode ifFalse: [^ false].

	aBoolean ifTrue: [	
		"Write changes to model."
		index spec editorFinisher
			value: anItem
			value: index node].

	aBoolean ifFalse: [
		"Abort editing."
		editedItem := index item.
		self replaceMorphWith: editedItem atIndex: index.
		self updateLayout].

	index isInEditMode: false.
	aBoolean ifTrue: [self edited: index].
	
	self grabKeyboard.
	
	^ true! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 3/23/2012 10:21:39.279'!
ensureColumnCount: numberOfColumns
	"Create columns on-the-fly."
	
	numberOfColumns > columns size
		ifTrue: [numberOfColumns - columns size timesRepeat: [columns add: UiViewColumnInfo new]].! !

!UiItemViewport methodsFor: 'add/remove - private' stamp: 'mt 6/26/2012 11:56:25.365'!
ensureFirstRowFor: aParentModelIndex
	
	^ rows
		add: UiViewRowInfo new
		afterIndex: (rows indexOf: (rows detect: [:row | row firstModelIndex = aParentModelIndex]))! !

!UiItemViewport methodsFor: 'add/remove - private' stamp: 'mt 7/5/2012 17:03:56.117'!
ensureRowFor: aModelIndex
	"Adds a new row if needed. Returns the correct one if possible."
	
	| row rowIndex isCorrectRow isPreviousSibling isParentRow isFirstInGroup currentPath |
	isCorrectRow := [:r | r parentModelIndex = aModelIndex parent
		and: [r firstModelIndex group = aModelIndex group]
		and: [r firstModelIndex row = aModelIndex row]].
	isPreviousSibling := [:r | r parentModelIndex = aModelIndex parent
		and: [(r firstModelIndex group = aModelIndex group and: [r firstModelIndex row = (aModelIndex row - 1)])
			"A simple check for group switch should be sufficient here because of enumeration order."
			or: [r firstModelIndex groupIndex = (aModelIndex groupIndex - 1)]]].
	isParentRow := [:r | r firstModelIndex = aModelIndex parent].
	isFirstInGroup := [:separator | separator parentModelIndex = aModelIndex parent
		and: [(separator items first valueOfProperty: #groupIndex) = aModelIndex groupIndex]
		and: [aModelIndex row = 1]
		and: [aModelIndex column = 1]].
	
	rowIndex := 0.
	
	currentPath := Stack new.
	rows detect: [:r | rowIndex := rowIndex + 1.
		
		r isSeparator ifTrue: [
			(isFirstInGroup value: r)
				ifTrue: [
					row := rows add: UiViewRowInfo new afterIndex: rowIndex.
					true]
				ifFalse: [false]] ifFalse: [
		(isCorrectRow value: r)
			ifTrue: [row := r. true]
			ifFalse: [(currentPath isEmpty and: [(isParentRow value: r) or: [isPreviousSibling value: r]])
				ifTrue: [currentPath push: r. false]
				ifFalse: [	currentPath isEmpty ifTrue: [false] ifFalse: [
					[currentPath isEmpty not and: [currentPath top firstModelIndex ~= r parentModelIndex]]
						whileTrue: [currentPath pop].
					
					currentPath isEmpty
						ifTrue: [
							row := rows add: UiViewRowInfo new beforeIndex: (
								(rows at: rowIndex - 1) isSeparator
									ifTrue: [rowIndex - 1]
									ifFalse: [rowIndex]).
							true "first child of parent"]
						ifFalse: [(isPreviousSibling value: r)
							ifTrue: [currentPath := Stack new. currentPath push: r. false]
							ifFalse: [currentPath push: r. false]]]]]]
		] ifNone: [row := rows add: UiViewRowInfo new].
	
	^ row! !

!UiItemViewport methodsFor: 'geometry' stamp: 'mt 7/10/2012 12:13:23.542'!
extent: aPoint

	super extent: aPoint.
	self resizedToWidth: aPoint x height: aPoint y.! !

!UiItemViewport methodsFor: 'signals - to view' stamp: 'mt 10/11/2010 17:18:00.533'!
focusChanged: aRectangle
	"Indicate that a scrollable container should ensure the given area as visible."
	
	self emit.! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 6/26/2012 10:56:44.548'!
groupSpec

	^ groupSpec! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 6/26/2012 10:56:53.843'!
groupSpec: aGroupSpec

	groupSpec := aGroupSpec.! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 3/18/2011 11:08:13.203'!
handleMouseMove: anEvent
	"Receive any mouse move event."
	
	super handleMouseMove: anEvent.
	
	anEvent wasHandled not
		ifTrue: [self mouseMove: anEvent. anEvent wasHandled: true].! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 14:00:05.566'!
horizontalHeader

	^ horizontalHeader! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 14:00:11.666'!
horizontalHeader: aMorph

	horizontalHeader := aMorph.! !

!UiItemViewport methodsFor: 'signals - model index' stamp: 'mt 8/16/2012 14:42:39.107'!
hovered: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'geometry' stamp: 'mt 8/16/2012 14:49:14.138'!
hoveredBounds

	| hb |
	hb := self boundsFor: self hoveredCell.
	^ (self localPointToGlobal: hb topLeft)
		extent: hb extent  ! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:39:13.856'!
hoveredCell

	^ hoveredCell! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 8/16/2012 15:42:48.777'!
hoveredCell: newCellIndex
		
	newCellIndex = hoveredCell
		ifTrue: [^ self].
				
	self
		invalidRect: (self boundsFor: newCellIndex);
		invalidRect: (self boundsFor: hoveredCell).

	"Show/hide checkboxes."
	self updateVisibilityForCheckBoxesFor: newCellIndex old: hoveredCell.
	
	"Set new value."
	hoveredCell := newCellIndex.
	
	self hovered: (self modelIndexFor: hoveredCell).! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 7/18/2012 11:04:28.575'!
hoveredDropMode
	"#inFrontOf, #after, #over, #none"
	
	^ hoveredDropMode ifNil: [#none]! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 7/19/2012 09:13:45.09'!
hoveredDropMode: aSymbol

	hoveredDropMode == aSymbol ifTrue: [^ self].
	
	"Need some extra pixels in the vertical to visizualize #between."
	self invalidRect: ((self boundsFor: self hoveredCell) outsetBy: (0@2 corner: 0@2)).
	
	hoveredDropMode := aSymbol.! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:01:57.895'!
indent
	"Defines how much items of the first column will be moved to the left for each level - including the first one."
	
	^ 0! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 1/18/2012 10:37:56.468'!
initialize

	super initialize.
	
	self initializeEventHandler.
	
	self color: Color transparent.
		
	rows := OrderedCollection new.
	columns := OrderedCollection new.
	
	rowOrder := UiItemOrder new.
	columnOrder := UiItemOrder new.
	
	self selectionMode: UiViewSingleSelection.! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 8/13/2012 10:23:28.362'!
initializeEventHandler

	self eventHandler: UiEventHandler new.

	self eventHandler
		mouseDownPriority: 25; "Catch all clicks for my cells to trigger context menu."
		setProperty: #handlesMouseWheel toValue: [true];
		grabKeyboardOnMouseEnter: true.
	
	self connect: self eventHandler signal: #mouseLeft: toSelector: #hoveredCell: pattern: #(=nil).
	self connect: self eventHandler signal: #mouseLeft: toSelector: #hoveredDropMode: pattern: #(=none).
	self connect: self eventHandler signal: #mouseLeftDragging: toSelector: #hoveredCell: pattern: #(=nil).
	self connect: self eventHandler signal: #mouseLeftDragging: toSelector: #hoveredDropMode: pattern: #(=none).

	self connect: self eventHandler signal: #mousePressed: toSelector: #mousePressCell:.
	self connect: self eventHandler signal: #mouseReleased: toSelector: #mouseReleaseCell:.
	self connect: self eventHandler signal: #mouseClicked: toSelector: #mouseClickCell:.
	self connect: self eventHandler signal: #mouseDoubleClicked: toSelector: #mouseDoubleClickCell:.
	self connect: self eventHandler signal: #mouseDragStarted: toSelector: #mouseStartDragCell:.
	self connect: self eventHandler signal: #mouseMoved: toSelector: #doHoverCell:.
	
	self connect: self eventHandler signal: #returnStroked toSelector: #activateCurrentCell.
	self connect: self eventHandler signal: #keyStroked: toSelector: #navigateByKey:.
	self connect: self eventHandler signal: #keyStroked: toSelector: #changeCheckedByKey:.

	"Pass some events back to the view."
	self connect: self eventHandler signal: #mouseWheelUp: toSelector: #mouseWheelUp.
	self connect: self eventHandler signal: #mouseWheelDown: toSelector: #mouseWheelDown.

	self connect: self eventHandler signal: #keyStroked: toSelector: #onKeyStroked:.
	self connect: self eventHandler signal: #keyPressed: toSelector: #onKeyPressed:.	

	"Keyboard shortcuts"
	self eventHandler on: #cmd -> $a send: #selectAll to: self.! !

!UiItemViewport methodsFor: 'add/remove - inserting' stamp: 'mt 6/26/2012 09:37:53.458'!
insertGroupSeparator: aGroupSeparator at: aRowIndex

	| row |
	row := rows at: aRowIndex.
	self columns do: [:column |
		"Insert separator in column."
		column items 
			add: aGroupSeparator
			beforeIndex: aRowIndex.
		
		"Row was empty so just append."
		row items add: aGroupSeparator.
		
		self addMorphBack: aGroupSeparator].! !

!UiItemViewport methodsFor: 'add/remove - inserting' stamp: 'mt 6/26/2012 12:02:04.455'!
insertItemRows: data
	"group -> row -> column -> (model index -> item/morph)"
	
	| firstRow firstRowIndex newRowsCount newItems tail rowOffset indent |
	
	"Step 1 - Add as much rows as needed."
	firstRow := data first value
		ifEmpty: [self ensureFirstRowFor: (data first key valueOfProperty: #parentModelIndex)]
		ifNotEmpty: [self ensureRowFor: data first value "group" first "row" first "column" key "model index"].

	firstRowIndex := rows indexOf: firstRow.
	newRowsCount := (data inject: 0 into: [:sum :group | sum + 1 "separator for each group" + group value size]).

	newRowsCount - 1 "first row already there"
		timesRepeat: [rows add: UiViewRowInfo new afterIndex: firstRowIndex].
	
	"Step 2 - Prepare items."
	newItems := Array new: (newRowsCount - data size "see #insertGroupSeparatorAt:") * self columnCount.
	tail := 1. "Next slot to fill. Just real items. No group separators."
	rowOffset := 0.
	data withIndexDo: [:group :groupIndex |
		self
			insertGroupSeparator: group key "separator item"
			at: firstRowIndex + rowOffset.
		rowOffset := rowOffset + 1 "separator row".
		
		group value do: [:itemRow | 
			itemRow do: [:indexToItem | | col |
				newItems
					at: tail
					put: indexToItem value.
				tail := tail + 1.
					
				(rows at: firstRowIndex + rowOffset)
					items add: indexToItem value. "column-wise filing left-to-right"
				
				col := self columnFor: indexToItem key.
				col items
					add: indexToItem value
					beforeIndex: firstRowIndex + rowOffset.
			
				"Same indent for all items."
				indent ifNil: [indent := self
					calculateIndentFor: indexToItem value
					atIndex: indexToItem key
					column: col].
			
				indexToItem value
					setProperty: #modelIndex toValue: indexToItem key;
					setProperty: #isExpanded toValue: false;
					setProperty: #hasChildren toValue: indexToItem key hasChildren;
					setProperty: #indent toValue: (indexToItem key column = 1 ifTrue: [indent] ifFalse: [0])].
			rowOffset := rowOffset + 1. "next row"]].
	
	"Step 3 - Add new submorphs."
	self addAllMorphs: newItems.! !

!UiItemViewport methodsFor: 'add/remove - inserting' stamp: 'mt 7/5/2012 16:56:53.58'!
insertMorph: aMorph forIndex: aModelIndex

	| col row |
	aMorph setProperty: #modelIndex toValue: aModelIndex.
	aMorph setProperty: #isExpanded toValue: false.
	aMorph setProperty: #hasChildren toValue: aModelIndex hasChildren.
	
	row := self ensureRowFor: aModelIndex.
	row items add: aMorph.
	
	col := self columnFor: aModelIndex.
	col items add: aMorph beforeIndex: (rows indexOf: row).
	
	self addMorphBack: aMorph.
	
	aMorph
		setProperty: #indent
		toValue: (self calculateIndentFor: aMorph atIndex: aModelIndex column: col).! !

!UiItemViewport methodsFor: 'testing' stamp: 'bs 8/3/2011 14:49:34.565'!
isExpanded: aModelIndex

	aModelIndex ifNil: [^ true] "the root is always expanded".
	^ (self isExpanded: aModelIndex parent) 
		and: [(self rowFor: aModelIndex) isExpanded]! !

!UiItemViewport methodsFor: 'signals - to view' stamp: 'mt 1/18/2012 10:52:00.937'!
keyPressed: aKeyboardEvent on: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'signals - to view' stamp: 'mt 7/22/2012 10:41:15.847'!
keyStroked: aKeyboardEvent on: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'geometry - cached' stamp: 'mt 7/3/2012 11:42:29.934'!
leftAt: aCell

	^ ((cellToBounds at: aCell y) at: aCell x) first x! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 6/30/2012 15:59:22.992'!
leftForColumn: aColumnInfo

	| result |
	aColumnInfo visible ifFalse: [^ 0].
	
	result := self left.
	self columnsDo: [:col |
		col visible ifTrue: [
			col = aColumnInfo ifTrue: [^ result].
			result := result + col width]].
	
	Error signal: 'Column info not found!!'.! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 3/23/2012 10:25:04.47'!
limitColumnCount: numberOfColumns
	"Remove unnecessary columns."
	
	self ensureColumnCount: numberOfColumns.
	columns := columns first: numberOfColumns.! !

!UiItemViewport methodsFor: 'signals - to view' stamp: 'mt 2/16/2012 10:32:55.566'!
menuRequestedAt: aPoint on: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/17/2010 09:23:15.593'!
modelIndexFor: aCellIndex

	aCellIndex ifNil: [^ nil].

	^ (self rowOrder items: (self columnAt: aCellIndex x) items at: aCellIndex y)
		valueOfProperty: #modelIndex! !

!UiItemViewport methodsFor: 'rows/columns - to morph' stamp: 'mt 7/3/2012 11:36:59.782'!
morphAt: aCellIndex

	^ self columnOrder items: (self rowAt: aCellIndex y) items at: aCellIndex x! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 7/6/2012 10:00:25.703'!
mouseClickCell: evt

	| index cell |
	cell := self cellIndexFromPoint: evt position.
	index := self modelIndexFor: cell.
	index ifNil: [^ self].
	
	self
		clicked: index;
		activated: index.
	
	"Open context menu."
	evt yellowButtonPressed ifTrue: [self menuRequestedAt: evt position on: index].
	
	"Handle click on checkbox."
	self flag: #ugly.
	index checkable ifTrue: [((self morphAt: cell) valueOfProperty: #checkBox) ifNotNil: [:chk |
		(chk bounds containsPoint: evt position) ifTrue: [chk toggle]]].! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 7/6/2012 11:53:13.49'!
mouseDoubleClickCell: evt

	| cell |
	cell := self cellIndexFromPoint: evt position.
	
	"Only signal a double click to the outside if no editing was possible."
	(self beginEditItem: (self morphAt: cell)) ifFalse: [
		(self modelIndexFor: cell) ifNotNil: [:index |
			self
				doubleClicked: index;
				activated: index]].! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 7/3/2012 11:36:59.921'!
mousePressCell: evt

	| cell morph |
	cell := self cellIndexFromPoint: evt position.
	cell ifNil: [^ self].
	
	
	morph := self morphAt: cell.
	
	(morph valueOfProperty: #selectable) ifTrue: [
		self selection add: cell event: evt.
		(morph hasProperty: #isGroupSeparator) ifTrue: [
			self selection cells: (
				self selection cells, 
				((self selectChildrenForGroup: (self rowAt: cell y))
					select: [:rowInfo | rowInfo visible]
					thenCollect: [:rowInfo | self cellIndexFromRow: rowInfo]))]].
	
	"Pass event to item."
	morph mouseDown: evt.! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 8/9/2012 10:04:10.364'!
mouseReleaseCell: evt

	| cell morph |
	cell := self cellIndexFromPoint: evt position.
	cell ifNil: [^ self].
	morph := self morphAt: cell.

	(morph valueOfProperty: #selectable) ifTrue: [
		self selection remove: cell event: evt].

	"Pass event to item."
	morph mouseUp: evt.! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 7/24/2012 15:13:40.782'!
mouseStartDragCell: evt 
	
	evt hand hasSubmorphs ifTrue: [^ self].
	self dragEnabled ifFalse: [^ self].
	
	[ | nodes |

	"unboxing to not give model index to the outside"	
	(nodes := self selection selectedIndices collect: [:index | index node])
		ifEmpty: [^ self].

	evt hand grabMorph: (self dragDropSpec transferItemFor: nodes asOrderedCollection)]
		ensure: [Cursor normal show.
			evt hand releaseMouseFocus: self]! !

!UiItemViewport methodsFor: 'signals - to view' stamp: 'mt 1/18/2012 10:43:34.324'!
mouseWheelDown

	self emitAlways.! !

!UiItemViewport methodsFor: 'signals - to view' stamp: 'mt 1/18/2012 10:43:39.028'!
mouseWheelUp

	self emitAlways.! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 7/10/2012 11:42:21.534'!
navigateByKey: aKeyboardEvent

	| cc keyToActionMap |
	cc := self selection currentCell
		ifNil: [^ self selection add: 1@1 event: aKeyboardEvent].

	keyToActionMap := Dictionary newFrom: {
		Character arrowUp    -> #up.
		Character arrowDown  -> #down.
		Character arrowLeft  -> #left.
		Character arrowRight -> #right.
		Character pageUp     -> #pageUp.
		Character pageDown   -> #pageDown.
		Character home       -> #home.
		Character end        -> #end}.

	(keyToActionMap at: aKeyboardEvent keyCharacter ifAbsent: [])
		ifNotNil: [:direction |
			self selection add: (self nextCellFor: cc direction: direction) event: aKeyboardEvent].! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 8/8/2012 13:07:40.27'!
nextCellFor: currentCell direction: aSymbol

	| deltaMap nextCellBlock skipBlock nextCell oldCell |	
	deltaMap := Dictionary newFrom: {
		#up       -> [:cell | cell - (0@1)].
		#down     -> [:cell | cell + (0@1)].
		#left     -> [:cell | ((self morphAt: cell) valueOfProperty: #hasChildren)
			ifTrue: [cell "collapse sub-tree"] ifFalse: [cell - (1@0)]].
		#right    -> [:cell | ((self morphAt: cell) valueOfProperty: #hasChildren)
			ifTrue: [cell "expand sub-tree"] ifFalse: [cell + (1@0)]].
		#pageUp   -> [:cell | cell - (0@3)].
		#pageDown -> [:cell | cell + (0@3)].
		#home     -> [:cell | cell x @ 2]. "first row; current column; skip separator"
		#end      -> [:cell | cell x @ rows size] "last row; current column"}.
	nextCellBlock := [:cell | ((deltaMap at: aSymbol) value: cell) min: columns size @ rows size max: 1@1].
	nextCell := nextCellBlock value: currentCell.
	
	"Skip separators but only if there are enough cells left."
	skipBlock := [((self morphAt: nextCell) valueOfProperty: #selectable) not
		or: [(self rowAt: nextCell y) visible not] or: [(self columnAt: nextCell x) visible not]].
	[skipBlock value and: [nextCell ~= oldCell]] whileTrue: [
		oldCell := nextCell.
		nextCell := nextCellBlock value: nextCell].

	^ skipBlock value
		ifTrue: [currentCell]
		ifFalse: [nextCell]! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 8/8/2012 16:48:45.733'!
nextCellInDirection: aSymbol

	^ self selection currentCell
		ifNil: [self rowCount < 2
			ifTrue: []
			ifFalse: [1@2 "skip separator"]]
		ifNotNil: [:cc | self nextCellFor: cc direction: aSymbol]! !

!UiItemViewport methodsFor: 'signals - to view' stamp: 'mt 7/18/2012 11:23:45.822'!
objectDropped: anObject type: aSymbol from: aSourceObject after: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'signals - to view' stamp: 'mt 7/19/2012 10:17:12.593'!
objectDropped: anObject type: aSymbol from: aSourceObject before: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'signals - to view' stamp: 'mt 7/18/2012 11:23:29.712'!
objectDropped: anObject type: aSymbol from: aSourceObject on: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 7/16/2011 19:07:31.956'!
onCurrentCellChangedFrom: oldCellIndex to: newCellIndex

	self
		invalidRect: (self boundsFor: oldCellIndex);
		invalidRect: (self boundsFor: newCellIndex).
		
	self updateVisibilityForCheckBoxesFor: newCellIndex old: oldCellIndex.

	self
		updateFocus;
		currentIndexChanged: self selection currentIndex.! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 1/18/2012 10:50:40.505'!
onKeyPressed: aKeyboardEvent

	self keyPressed: aKeyboardEvent on: self selection currentIndex.! !

!UiItemViewport methodsFor: 'events' stamp: 'mt 7/22/2012 10:42:23.682'!
onKeyStroked: aKeyboardEvent

	self keyStroked: aKeyboardEvent on: self selection currentIndex.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 7/17/2012 16:16:36.254'!
onSelectionChangedFrom: oldCells to: newCells

	oldCells do: [:c | self invalidRect: (self boundsFor: c)].
	newCells do: [:c | self invalidRect: (self boundsFor: c)].

	self
		"updateFocus;" "never call here -> only on current cell change"
		selectionChanged: self selection selectedIndices.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 6/26/2012 15:31:35.916'!
removeChildrenForRow: aRowInfo
	"Used for tree viewports."
	
	(self selectChildrenForRow: aRowInfo)
		do: [:row | self removeRow: row].! !

!UiItemViewport methodsFor: 'add/remove - private' stamp: 'mt 10/14/2010 11:37:04.05'!
removeRow: aRowInfo

	aRowInfo items withIndexDo: [:item :index |
		(columns at: index) items remove: item].
	
	self removeAllMorphsIn: aRowInfo items.
	rows remove: aRowInfo.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 4/26/2012 14:40:34.034'!
removeRowFor: aParentModelIndex at: rowIndex inGroup: groupName

	self removeRow: (rows detect: [:row |
		row isSeparator not
			and: [row parentModelIndex = aParentModelIndex]
			and: [row firstModelIndex group = groupName]
			and: [row firstModelIndex row = rowIndex]])! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 7/21/2012 14:33:31.641'!
replaceMorphWith: aMorph atIndex: aModelIndex

	| oldMorph col row |
	oldMorph := (rows detect: [:rowInfo | rowInfo includes: aModelIndex] ifNone: [^ self]) itemAt: aModelIndex.
		
	aMorph setProperty: #modelIndex toValue: aModelIndex.
	aMorph setProperty: #isExpanded toValue: (oldMorph valueOfProperty: #isExpanded).
	aMorph setProperty: #hasChildren toValue: aModelIndex hasChildren.
	
	row := self rowFor: aModelIndex.
	row items
		add: aMorph after: oldMorph;
		remove: oldMorph.
	
	col := self columnFor: aModelIndex.
	col items
		add: aMorph after: oldMorph;
		remove: oldMorph.
	
	self
		removeMorph: oldMorph;
		addMorphBack: aMorph.
	
	aMorph
		setProperty: #indent
		toValue: (self
			calculateIndentFor: aMorph
			atIndex: aModelIndex
			column: col).! !

!UiItemViewport methodsFor: 'signals - to view' stamp: 'mt 10/10/2010 13:02:41.787'!
resizedToWidth: newWidth height: newHeight

	self emit.! !

!UiItemViewport methodsFor: 'signals - model index' stamp: 'mt 2/28/2011 13:19:02.384'!
returnPressed: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/16/2010 19:56:47.691'!
rowAt: index

	^ self rowOrder items: rows at: index! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 6/30/2012 16:44:13.685'!
rowBoundsFor: aRowIndex

	| row top |
	aRowIndex > rows size
		ifTrue: [^ 0@0 extent: 0@0].
	
	top := ((cellToBounds at: aRowIndex)
		detect: [:cellBounds | cellBounds notNil] "skip hidden columns"
		ifNone: [^ 0@0 extent: 0@0]) first y.
		
	row := self rowAt: aRowIndex.
	
	row visible ifFalse: [^ 0@0 extent: 0@0].
	
	^ self left @ top
		extent: self width @ row height! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 4/21/2011 10:28:59.349'!
rowCount

	^ rows size! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 7/19/2012 11:12:38.389'!
rowCountVisible

	^ self rows count: [:rowInfo | rowInfo visible]! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/9/2010 16:12:41.64'!
rowFor: aModelIndex

	^ rows detect: [:row | row includes: aModelIndex]! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:00:50.256'!
rowOrder

	^ rowOrder! !

!UiItemViewport methodsFor: 'accessing - private' stamp: 'mt 1/4/2011 10:23:22.573'!
rows
	"Returning all rows IGNORING CURRENT SORT ORDER."
	
	^ rows! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/16/2010 19:06:41.893'!
rowsDo: aBlock

	self rowOrder items: rows do: aBlock.! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/16/2010 19:49:38.102'!
rowsWithIndexDo: aBlock

	self rowOrder items: rows withIndexDo: aBlock.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 8/13/2012 10:28:26.869'!
selectAll

	| cells |
	cells := OrderedCollection new.
	self rowsWithIndexDo: [:rowInfo :index |
		(rowInfo visible
			and: [rowInfo isSeparator not]
			and: [rowInfo items first valueOfProperty: #selectable])
				ifTrue: [cells add: 1@index]].
	self selection cells: cells.! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 6/26/2012 16:24:06.621'!
selectChildrenForGroup: aSeparatorRow
	
	| foundFirst predecessors rowsToSelect parentIndex groupIndex |
	aSeparatorRow isSeparator ifFalse: [^ self].
	
	parentIndex := aSeparatorRow parentModelIndex.
	groupIndex := aSeparatorRow items first valueOfProperty: #groupIndex.
	
	foundFirst := false.
	predecessors := {aSeparatorRow} asOrderedCollection.
	rowsToSelect := OrderedCollection new.

	rows anySatisfy: [:row |
		foundFirst
			ifTrue: [((row isSeparator not and: [row parentModelIndex = parentIndex] and: [row firstModelIndex groupIndex = groupIndex])
				or: [self flag: #slow. predecessors anySatisfy: [:pred | row parentModelIndex = pred firstModelIndex and: [row isSeparator or: [row firstModelIndex groupIndex = groupIndex]]]])
					ifTrue: [
						row isSeparator ifFalse: [predecessors add: row].
						rowsToSelect add: row.
						false]
					ifFalse: [true]]
			ifFalse: [row = aSeparatorRow ifTrue: [foundFirst := true]. false]].

	^ rowsToSelect! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 6/26/2012 16:23:52.89'!
selectChildrenForRow: aRowInfo
	
	| foundFirst predecessors rowsToSelect |
	foundFirst := false.
	predecessors := {aRowInfo} asOrderedCollection.
	rowsToSelect := OrderedCollection new.

	rows anySatisfy: [:row |
		self flag: #slow.
		(predecessors anySatisfy: [:pred | row parentModelIndex = pred firstModelIndex])
			ifTrue: [
				foundFirst := true.
				row isSeparator ifFalse: [predecessors add: row].
				rowsToSelect add: row.
				false]
			ifFalse: [foundFirst]].

	^ rowsToSelect! !

!UiItemViewport methodsFor: 'selection - convenience' stamp: 'mt 8/8/2012 15:56:18.84'!
selectNextColumn

	self selection add: (self nextCellInDirection: #right).! !

!UiItemViewport methodsFor: 'selection - convenience' stamp: 'mt 8/8/2012 15:55:54.636'!
selectNextRow

	self selection add: (self nextCellInDirection: #down).! !

!UiItemViewport methodsFor: 'selection - convenience' stamp: 'mt 8/8/2012 15:56:09.635'!
selectPreviousColumn

	self selection add: (self nextCellInDirection: #left).! !

!UiItemViewport methodsFor: 'selection - convenience' stamp: 'mt 8/8/2012 15:56:03.791'!
selectPreviousRow

	self selection add: (self nextCellInDirection: #up).! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/10/2010 20:03:34.835'!
selection

	^ selection! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 7/13/2011 14:34:02.764'!
selection: aSelection

	selection := aSelection.

	selection viewport: self.
	
	self connect: aSelection signal: #selectionChangedFrom:to: toSelector: #onSelectionChangedFrom:to:.
	self connect: aSelection signal: #currentCellChangedFrom:to: toSelector: #onCurrentCellChangedFrom:to:.
	
	self redrawLater.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/14/2010 13:50:42.369'!
selectionBehavior

	^ selectionBehavior ifNil: [selectionBehavior := #selectCells]! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 09:28:20.274'!
selectionBehavior: aSymbol
	"#selectCells, #selectRows, #selectColumns"

	selectionBehavior := aSymbol.
	self redrawLater.! !

!UiItemViewport methodsFor: 'signals - model index' stamp: 'mt 10/20/2010 13:45:49.758'!
selectionChanged: someModelIndices

	self emit.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 8/9/2012 09:50:30.944'!
selectionColor

	selectionColor ifNil: [selectionColor := Color r: 0.772 g: 0.858 b: 1.0].
	
	^ self hasKeyboard
		ifFalse: [selectionColor alpha: 0.3]
		ifTrue: [selectionColor]! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/8/2010 14:37:57.041'!
selectionColor: aColor

	selectionColor := aColor.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 09:04:47.949'!
selectionMode

	^ selectionMode! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 09:04:07.606'!
selectionMode: aSelectionClass

	selectionMode := aSelectionClass.
	self selection: aSelectionClass new.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 6/30/2012 15:57:59.481'!
setHeaderItem: aMorph atColumn: anInteger

	(columns at: anInteger) headerItem: aMorph.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 10/12/2010 11:50:38.889'!
setHeaderItem: aMorph atRow: anInteger

	(rows at: anInteger) headerItem: aMorph.! !

!UiItemViewport methodsFor: 'geometry - cached' stamp: 'mt 7/3/2012 11:42:06.004'!
topAt: aCell

	^ ((cellToBounds at: aCell y) at: aCell x) first y! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 6/30/2012 15:59:33.029'!
topForRow: aRowInfo

	| result |
	aRowInfo visible ifFalse: [^ 0].
	
	result := self top.
	self rowsDo: [:row |
		row visible ifTrue: [
			row = aRowInfo ifTrue: [^ result].
			result := result + row height]].
	
	Error signal: 'Row info not found!!'.! !

!UiItemViewport methodsFor: 'layouting - deprecated' stamp: 'mt 6/26/2012 16:38:28.465'!
updateColumnsLayout

	| offset |
	self columnsDo: [:colInfo |
		colInfo visible ifTrue: [
			offset := 0.
			self rowOrder items: colInfo items withIndexDo: [:item :rowIndex |
				| height row |
				row := rows at: rowIndex.
				row visible ifTrue: [
					height := row height.
					colInfo vAlignment = #top
						ifTrue: [item top: offset].
					colInfo vAlignment = #center
						ifTrue: [item top: offset + (height - item height // 2)].
					colInfo vAlignment = #bottom
						ifTrue: [item bottom: offset + height].
							
					offset := offset + height]]]].! !

!UiItemViewport methodsFor: 'drawing - cached' stamp: 'mt 7/12/2012 15:46:00.292'!
updateDrawCache

	| canvas oldCacheFlag |
	oldCacheFlag := drawCacheActive.
	drawCacheActive := false.
	
	canvas := FormCanvas extent: self extent depth: 32 origin: 0@0 clipRect: (0@0 extent: self extent).
	canvas fillColor: Color white.
	self drawSubmorphsOn: canvas.
	drawCache := canvas form.

	drawCacheActive := oldCacheFlag.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 18:00:37.584'!
updateFirstColumnIndent

	columns first items do: [:item |
		item left: item left + (item valueOfProperty: #indent)].! !

!UiItemViewport methodsFor: 'updating' stamp: 'mt 10/16/2010 08:23:31.568'!
updateFocus
	"The important part is always the current cell."
	
	self selection currentCell ifNotNil: [:cc |
		self focusChanged: (self cellBoundsFor: cc)].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 6/29/2012 10:28:47.865'!
updateHeaderLayout
	"Relayout changed header items."
	
	self horizontalHeader ifNotNil: [:hh |
		hh removeAllMorphs.
		self columnsDo: [:colInfo | colInfo headerItem ifNotNil: [:hi |
			hh addMorphBack: hi]]].
	self verticalHeader ifNotNil: [:vh |
		vh removeAllMorphs.
		self rowsDo: [:rowInfo | rowInfo headerItem ifNotNil: [:hi |
			vh addMorphBack: hi]]].! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 1/23/2012 10:56:06.884'!
updateIndex: newModelIndex oldIndex: formerModelIndex

	| morph |
	morph := (rows reverseDetect: [:rowInfo | rowInfo includes: formerModelIndex]) itemAt: formerModelIndex.
	morph setProperty: #modelIndex toValue: newModelIndex.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 7/19/2012 09:20:55.069'!
updateItemLayout

	| vOffset hOffset cell |
	cellToBounds := Array new: self rowCount.
	cell := 0@0.
	
	vOffset := 0.
	hOffset := 0.
	self rowsDo: [:rowInfo |
		| deltaHeight |
		deltaHeight := rowInfo height.
		hOffset := 0.
		
		"Prepare bounds cache for current row."
		cell := 0 @ (cell y + 1).
		cellToBounds at: cell y put: (Array new: self columnCount).
		
		rowInfo visible ifTrue: [
			self columnOrder items: rowInfo items withIndexDo: [:item :colIndex |
				| deltaWidth columnInfo |
				columnInfo := columns at: colIndex.
				deltaWidth := columnInfo width.
				
				"Advance cell."
				cell := cell + (1@0).
				
				columnInfo visible ifTrue: [
					columnInfo hAlignment == #left ifTrue: [item left: hOffset].
					columnInfo hAlignment == #center ifTrue: [item left: hOffset + (deltaWidth - item width // 2)].
					columnInfo hAlignment == #right ifTrue: [item right: hOffset + deltaWidth].
					columnInfo vAlignment == #top ifTrue: [item top: vOffset].
					columnInfo vAlignment == #center ifTrue: [item top: vOffset + (deltaHeight - item height // 2)].
					columnInfo vAlignment == #bottom ifTrue: [item bottom: vOffset + deltaHeight].
					
					"Fill bounds cache."
					(cellToBounds at: cell y) at: cell x put: {hOffset@vOffset.deltaWidth@deltaHeight}.

					hOffset := hOffset + deltaWidth]].
			rowInfo isSeparator ifTrue: [rowInfo items first left: 0].
			vOffset := vOffset + deltaHeight]].

	self extent: hOffset@(vOffset+2).! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 4/28/2012 18:33:39.85'!
updateItemOrder

	"Sort after first column for now."
	self rowOrder updateWith: columns first items.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 7/3/2012 11:01:59.537'!
updateLayout

	columns ifEmpty: [^ self].
	
	self
		updateRowsVisibility;
		updateSizesOfRowsAndColumns;
		updateItemOrder;
		updateItemLayout;
"		updateColumnsLayout;
		updateRowsLayout;"
		updateFirstColumnIndent;
		updateHeaderLayout.
"		updateExtent."
	
	self drawCacheActive
		ifTrue: [self updateDrawCache].! !

!UiItemViewport methodsFor: 'layouting - deprecated' stamp: 'mt 6/26/2012 16:39:05.641'!
updateRowsLayout

	| offset |
	self rowsDo: [:rowInfo |
		rowInfo visible ifTrue: [
			rowInfo isSeparator
				ifTrue: [rowInfo items first left: 0]
				ifFalse: [
					offset := 0.
					self columnOrder items: rowInfo items withIndexDo: [:item :colIndex |
						| width hAlignment column |
						column := columns at: colIndex.
						column visible ifTrue: [
							width := column width.
							hAlignment := (columns at: colIndex) hAlignment.
							hAlignment = #left
								ifTrue: [item left: offset].
							hAlignment = #center
								ifTrue: [item left: offset + (width - item width // 2)].
							hAlignment = #right
								ifTrue: [item right: offset + width].
				
							offset := offset + width]]]]].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 6/29/2012 18:07:46.663'!
updateRowsVisibility

	self rows ifEmpty: [^ self].
	
	self rows first isSeparator ifTrue: [
		((self rows first items first valueOfProperty: #hideAlways) == true
			or: [(self rows first items first valueOfProperty: #hideIfFirst) == true])
			ifTrue: [self rows first visible: false]].
	
	self rows overlappingPairsDo: [:rowInfo1 :rowInfo2 |
		(rowInfo2 isSeparator
			and: [(rowInfo2 items first valueOfProperty: #hideAlways) == true])
			ifTrue: [rowInfo2 visible: false].
			
		(rowInfo1 isSeparator
			and: [rowInfo2 isSeparator or: [rowInfo1 parentModelIndex ~= rowInfo2 parentModelIndex]]
			and: [(rowInfo1 items first valueOfProperty: #hideIfEmpty) == true])
			ifTrue: [rowInfo1 visible: false].
		
		(rowInfo1 parentModelIndex ~= rowInfo2 parentModelIndex
			and: [rowInfo2 isSeparator]
			and: [(rowInfo2 items first valueOfProperty: #hideIfFirst) == true])
			ifTrue: [rowInfo2 visible: false]].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 7/5/2012 16:07:42.927'!
updateSizesOfRowsAndColumns

	columns do: [:column | column updateSize].
	rows do: [:row | row updateSize].! !

!UiItemViewport methodsFor: 'updating' stamp: 'mt 6/30/2012 11:55:40.942'!
updateVisibilityForCheckBoxesFor: newCell old: oldCell

	(oldCell notNil and: [oldCell y <= rows size]) ifTrue: [
		(self rowAt: oldCell y) items do: [:item | (item valueOfProperty: #checkBox)
			ifNotNil: [:chk | chk checked ifFalse: [chk hide]]]].

	(newCell notNil and: [newCell y <= rows size]) ifTrue: [
		(self rowAt: newCell y) items do: [:item | (item valueOfProperty: #checkBox)
			ifNotNil: [:chk | chk show]]].! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 13:59:56.367'!
verticalHeader

	^ verticalHeader! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 13:59:50.126'!
verticalHeader: aMorph

	verticalHeader := aMorph.! !

!UiItemViewport methodsFor: 'drag/drop' stamp: 'mt 7/19/2012 09:34:03.701'!
wantsDroppedMorph: aMorph event: event

	^ (super wantsDroppedMorph: aMorph event: event)
		and: [aMorph isKindOf: TransferMorph]
		and: [self dragDropSpec acceptBlock value: aMorph]! !

UiItemViewport subclass: #UiListViewport
	instanceVariableNames: 'orientation maxItemExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiListViewport commentStamp: 'mt 11/2/2010 12:46:22.16' prior: 0!
A specialized item viewport that has different layout strategies for its items as they are only a list. See the #orientation: commment for more information about possible layouting.!

!UiListViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/14/2010 17:21:49.457'!
cellBoundsFor: aCellIndex

	self orientation = #default
		ifTrue: [^ super cellBoundsFor: aCellIndex].

	^ (((aCellIndex - (1@1)) * maxItemExtent) + self topLeft)
		extent: maxItemExtent! !

!UiListViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 7/19/2012 11:15:40.235'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| cell |
	self orientation = #default ifTrue: [
		| offset cellIndex |
		offset := self topLeft.
		cellIndex := 1@0.
		self rowsDo: [:rowInfo | 
			cellIndex := cellIndex + (0@1).
			rowInfo visible ifTrue: [
				(offset <= aPoint and: [aPoint < (offset + (self width @ rowInfo height))])
					ifTrue: [^ cellIndex].
				offset := offset translateBy: 0 @ rowInfo height]].
	
		^ nil].
	
	cell := ((aPoint - self topLeft) // (maxItemExtent)) + (1@1).
	
	self orientation = #vertical
		ifTrue: [
			(cell x > self maxItemsPerLine
				or: [cell y - 1 * self maxItemsPerLine + cell x > self rowCount])
				ifTrue: [^ nil]]
		ifFalse: [
			(cell y > self maxItemsPerLine
				or: [cell x - 1 * self maxItemsPerLine + cell y > self rowCount])
				ifTrue: [^ nil]].
	
	^ cell! !

!UiListViewport methodsFor: 'drawing' stamp: 'mt 1/13/2012 10:18:43.293'!
drawSubmorphsOn: aCanvas
	
	self
		perform: #drawSubmorphsOn:
		withArguments: {aCanvas}
		inSuperclass: Morph.
	! !

!UiListViewport methodsFor: 'add/remove - private' stamp: 'mt 6/28/2012 17:02:29.232'!
ensureRowFor: aModelIndex
	"Adds a new row if needed. Returns the correct one if possible."
	
	| row isCorrectRow isPreviousSibling |
	isCorrectRow := [:r | r parentModelIndex = aModelIndex parent
		and: [r firstModelIndex row = aModelIndex row]].
	isPreviousSibling := [:r | r parentModelIndex = aModelIndex parent 
		and: [r firstModelIndex row = (aModelIndex row - 1)]].
	
	rows reverseDetect: [:r |
		r isSeparator ifTrue: [false] ifFalse: [
			(isCorrectRow value: r)
				ifTrue: [row := r. true]
				ifFalse: [(isPreviousSibling value: r)
					ifTrue: [row := rows add: UiViewRowInfo new after: r. true]
					ifFalse: [false]]
		]] ifNone: [row := rows add: UiViewRowInfo new].
	
	^ row! !

!UiListViewport methodsFor: 'geometry' stamp: 'mt 7/21/2012 13:22:18.468'!
extent: aPoint

	| shouldUpdateLayout |
	shouldUpdateLayout := self extent ~= aPoint.
	super extent: aPoint.
	(shouldUpdateLayout and: [self orientation ~~ #default])
		ifTrue: [self updateLayout].! !

!UiListViewport methodsFor: 'initialization' stamp: 'mt 10/14/2010 20:57:45.903'!
initialize

	super initialize.
	maxItemExtent := 1@1.
	self orientation: #default.! !

!UiListViewport methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:33:09.036'!
maxItemExtent

	^ maxItemExtent! !

!UiListViewport methodsFor: 'calculation' stamp: 'mt 10/14/2010 15:23:06.979'!
maxItemsPerLine

	self orientation = #vertical
		ifTrue: [^ self width // maxItemExtent x]
		ifFalse: [^ self height // maxItemExtent y]! !

!UiListViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 4/13/2011 11:11:09.226'!
modelIndexFor: aCellIndex

	| rowIndex |
	self orientation = #default
		ifTrue: [^ super modelIndexFor: aCellIndex].

	aCellIndex ifNil: [^ nil].
	
	rowIndex := (self orientation = #vertical
		ifTrue: [((aCellIndex y - 1) * self maxItemsPerLine) + aCellIndex x]
		ifFalse: [((aCellIndex x - 1) * self maxItemsPerLine) + aCellIndex y]).
		
	rowIndex > rows size ifTrue: [^ nil].
		
	^ (self rowAt: rowIndex) firstModelIndex! !

!UiListViewport methodsFor: 'rows/columns - to morph' stamp: 'mt 7/19/2012 11:14:55.152'!
morphAt: aCellIndex

	self orientation == #default
		ifTrue: [^ super morphAt: aCellIndex].

	aCellIndex ifNil: [^ nil].
	
	^ (self orientation = #vertical
		ifTrue: [self rowAt: aCellIndex y - 1 * self maxItemsPerLine + aCellIndex x]
		ifFalse: [self rowAt: aCellIndex x - 1 * self maxItemsPerLine + aCellIndex y]) items first! !

!UiListViewport methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:53:11.793'!
optimalSize

	columns ifEmpty: [^ 1@1].

	self orientation = #default ifTrue: [
		^ columns first optimalSize @ self height].
	
	self orientation = #vertical ifTrue: [
		^ maxItemExtent x @ self height].
	
	self orientation = #horizontal ifTrue: [
		^ self width @ maxItemExtent y].! !

!UiListViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:21:19.074'!
orientation

	^ orientation! !

!UiListViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:30:02.272'!
orientation: aSymbol
	"#vertical ... items go from left to right and break at width -> vertical scrolling
	#horizontal ... items go from top to bottom and break at height -> horizontal scrolling"

	aSymbol = orientation ifTrue: [^ self].
	orientation := aSymbol.
	
	orientation = #default
		ifTrue: [self selectionBehavior: #selectRows]
		ifFalse: [self selectionBehavior: #selectCells].! !

!UiListViewport methodsFor: 'layouting' stamp: 'mt 7/19/2012 10:39:39.367'!
updateLayout

	"There is no list wrapping in #default layout. Just use the super implementation."
	self orientation = #default
		ifTrue: [^ super updateLayout].	
	
	columns ifEmpty: [^ self].
	
	self
		updateRowsVisibility;
		updateItemOrder;
		updateMaxItemExtent;
		updateSingleColumnLayout.! !

!UiListViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 18:06:54.189'!
updateMaxItemExtent

	maxItemExtent := 1@1.
	columns first items do: [:item | maxItemExtent := maxItemExtent max: item extent].! !

!UiListViewport methodsFor: 'layouting' stamp: 'mt 7/19/2012 10:42:51.877'!
updateRowsVisibility

	self orientation = #default
		ifTrue: [^ super updateRowsVisibility].
	
	"No separators for other orientations."
	self rows do: [:rowInfo |
		rowInfo isSeparator ifTrue: [rowInfo visible: false]].! !

!UiListViewport methodsFor: 'layouting' stamp: 'mt 7/21/2012 13:25:05.312'!
updateSingleColumnLayout
	"Only for #vertical and #horizontal orientation. NOT for the #default one."
	
	| offset hAlignment |
	offset := self topLeft.
	hAlignment := columns first hAlignment.

	self rowsDo: [:rowInfo |
		"rowInfo visible ifTrue: ["
			| item |
			item := rowInfo items first.
			
			hAlignment = #left
				ifTrue: [item topLeft: offset].
			hAlignment == #center
				ifTrue: [item topLeft: offset + ((maxItemExtent x - item width)//2 @0)].
			hAlignment == #right
				ifTrue: [item topRight: offset + (maxItemExtent x @ 0)].

			self orientation == #vertical ifTrue: [
				offset := offset + (maxItemExtent x @ 0).
				(offset x + maxItemExtent x)  > (self width - 5)
					"new row"
					ifTrue: [offset := self left @ (offset y + maxItemExtent y)]].
			self orientation == #horizontal ifTrue: [
				offset := offset + (0 @ maxItemExtent y).
				(offset y + maxItemExtent y)  > (self height - 5)
					"new column"
					ifTrue: [offset := (offset x + maxItemExtent x) @ self top]]].
	"Update extent."
	self orientation == #vertical
		ifTrue: [self height: self submorphBounds height].
	self orientation == #horizontal
		ifTrue: [self width: self submorphBounds width].! !

UiItemViewport subclass: #UiTableViewport
	instanceVariableNames: 'showGrid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiTableViewport commentStamp: 'mt 11/2/2010 12:46:43.653' prior: 0!
A specialized viewport that can draw a grid.!

!UiTableViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 14:00:23.706'!
drawGridOn: aCanvas

	| offset |
	offset := self left.
	self columnsDo: [:colInfo | 
		offset := offset  + colInfo width.
		aCanvas
			line: offset @ self top
			to: offset @ self bottom
			color: (Color gray: 0.9)].
		
	offset := self top.
	self rowsDo: [:rowInfo | 
		offset := offset  + rowInfo height.
		aCanvas
			line: self left @ offset
			to: self right @ offset
			color: (Color gray: 0.9)].! !

!UiTableViewport methodsFor: 'drawing' stamp: 'mt 8/7/2012 11:05:27.644'!
drawOn: aCanvas

	self showGrid ifTrue: [self drawGridOn: aCanvas].
	super drawOn: aCanvas.! !

!UiTableViewport methodsFor: 'accessing' stamp: 'mt 8/7/2012 11:05:17.45'!
showGrid
	^ showGrid ifNil: [true]! !

!UiTableViewport methodsFor: 'accessing' stamp: 'mt 8/7/2012 11:05:11.599'!
showGrid: anObject
	showGrid := anObject! !

UiItemViewport subclass: #UiTreeViewport
	instanceVariableNames: 'indent rootIsDecorated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiTreeViewport commentStamp: 'mt 11/2/2010 12:47:08.195' prior: 0!
A specialized item viewport that handles hierarchical items in the first column.!

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 6/26/2012 16:46:47.224'!
bottomMostVisibleCellIndex: aCanvas
	| bottomLeftCell bottomLeft |
	bottomLeft := self bounds pointNearestTo: aCanvas clipRect bottomLeft.
	bottomLeftCell := self cellIndexFromPoint: bottomLeft.
	^ bottomLeftCell
		ifNil: [self rows size]
		ifNotNil: [:cell | cell y]! !

!UiTreeViewport methodsFor: 'signals' stamp: 'mt 10/14/2010 13:13:30.709'!
decorationClicked: aModelIndex
	"Whenever the user clicks the expand/collapse decoration in front of an item."
	
	self emit.! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 7/21/2012 18:14:45.585'!
drawOn: aCanvas
	
	super drawOn: aCanvas.
	
	self drawCacheActive ifFalse: [
		self drawTreeStructureOn: aCanvas].! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 7/21/2012 18:14:22.742'!
drawOverlayOn: aCanvas

	super drawOverlayOn: aCanvas.
	  
	self drawCacheActive ifTrue: [
		self drawTreeStructureOn: aCanvas].! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 6/26/2012 17:39:29.55'!
drawTreeStructureOn: aCanvas
	
	columns ifEmpty: [^ self].
	
	(self columnBoundsFor: 1) right < aCanvas clipRect left
		ifTrue: [^ self].
	
	((self visibleRowsIndices: aCanvas)
		collect: [:rowIndex | rowIndex -> (self rowAt: rowIndex)])
		select: [:rowAssoc | rowAssoc value visible
			and: [self rootIsDecorated or: [rowAssoc value parentModelIndex notNil]]]
		thenDo: [:rowAssoc |
		| colIndex item cellBounds form |
		colIndex := self columnOrder unmapIndex: 1.
		cellBounds := self cellBoundsFor: colIndex@rowAssoc key.
		item := self columnOrder items: rowAssoc value items at: colIndex.
		form := UiSilkIcons bulletArrowDownIcon.
		form := (item valueOfProperty: #hasChildren)
			ifFalse: [nil]
			ifTrue: [(item valueOfProperty: #isExpanded)
				ifFalse: [form rotateBy: #left centerAt: 8@8]
				ifTrue: [form]].

		form ifNotNil: [
			aCanvas
				translucentImage: form
				at: (cellBounds left + ((item valueOfProperty: #indent) - 12))
					@ (cellBounds top + (cellBounds height - form height // 2))]].! !

!UiTreeViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 13:14:25.565'!
indent

	^ indent ifNil: [indent := 12]! !

!UiTreeViewport methodsFor: 'initialization' stamp: 'mt 10/18/2010 19:09:04.846'!
initialize

	super initialize.
	
	rowOrder := UiTreeItemOrder new.
	
	self selectionBehavior: #selectRows.! !

!UiTreeViewport methodsFor: 'initialization' stamp: 'mt 1/18/2012 11:30:35.395'!
initializeEventHandler

	super initializeEventHandler.
	
	self connect: self eventHandler signal: #mouseClicked: toSelector: #mouseClickDecoration:.! !

!UiTreeViewport methodsFor: 'event handling' stamp: 'mt 3/18/2011 11:25:54.178'!
mouseClickDecoration: evt

	| cell item |
	cell := self cellIndexFromPoint: evt position.
	cell ifNil: [^ self].
	
	item := (self rowAt: cell y) items at: 1.

	"Recognize a click on the decoration."
	(evt position x < item left
		and: [evt position x >= (item left - self indent)])
		ifTrue: [self decorationClicked: (item valueOfProperty: #modelIndex)].! !

!UiTreeViewport methodsFor: 'accessing' stamp: 'mt 6/26/2012 17:21:42.471'!
rootIsDecorated

	^ rootIsDecorated ifNil: [true]! !

!UiTreeViewport methodsFor: 'accessing' stamp: 'mt 6/28/2012 16:17:34.398'!
rootIsDecorated: aBoolean

	aBoolean = rootIsDecorated ifTrue: [^ self].
	
	rootIsDecorated := aBoolean.
	
	rootIsDecorated
		ifTrue: [
			indent := nil. "auto"
			"Add root indent to all items in first column."
			self columns first items do: [:morph |
				(morph hasProperty: #isGroupSeparator) ifFalse: [
					morph
						setProperty: #indent
						toValue: (morph valueOfProperty: #indent) + self indent]]]
		ifFalse: [
			| oldIndent |
			oldIndent := self indent.
			indent := 0.
			"Remove root indent to all items in first column."
			self columns first items do: [:morph |
				(morph hasProperty: #isGroupSeparator) ifFalse: [
					morph
						setProperty: #indent
						toValue: (morph valueOfProperty: #indent) - oldIndent]]].

	self updateLayout.
! !

!UiTreeViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 6/26/2012 17:43:30.866'!
rowBoundsFor: aRowIndex

	| rowBounds indent row |
	rowBounds := super rowBoundsFor: aRowIndex.
	rowBounds width = 0 ifTrue: [^ rowBounds].
	
	row := self rowAt: aRowIndex.
	
	indent := (self rootIsDecorated or: [row parentModelIndex notNil])
		ifTrue: [(row items first valueOfProperty: #indent) - 12]
		ifFalse: [row items first valueOfProperty: #indent].
	
	^ rowBounds insetBy: (indent @ 0 corner: 0 @ 0)! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 6/26/2012 16:47:03.261'!
topMostVisibleCellIndex: aCanvas
	| topLeft topLeftCell | 
	topLeft := self bounds pointNearestTo: aCanvas clipRect topLeft.
	topLeftCell := self cellIndexFromPoint: topLeft.
	^ topLeftCell
		ifNil: [1]
		ifNotNil: [:cell | cell y]! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 6/26/2012 16:49:43.663'!
visibleRowsIndices: aCanvas

	^ (self topMostVisibleCellIndex: aCanvas)
		to: (self bottomMostVisibleCellIndex: aCanvas)! !

Morph subclass: #UiLabel
	instanceVariableNames: 'form text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiLabel commentStamp: 'mt 7/4/2010 08:53:31.639' prior: 0!
I am a descriptive widget that explains some content of another widget near me. I can show a form or a text.!

!UiLabel class methodsFor: 'testing' stamp: 'mt 6/29/2010 19:06:41.567'!
isWidgetClass

	^ true! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:29:53.936'!
widgetCategory
	
	^ 'Display Widgets'! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:53:48.403'!
widgetClassIcon

	^ UiFugueIcons uiLabelIcon! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:22:24.431'!
widgetClassName

	^ 'Label'! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 10/28/2010 16:52:55.134'!
widgetProperties

	^ super widgetProperties, {{'Label'. #yourself} -> {
		#text -> String.
		#form -> Form}}! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 5/1/2011 12:21:40.506'!
color: aColor

	self text addAttribute: (TextColor color: aColor).! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:35:24.982'!
form

	^ form! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:36:48.648'!
form: aForm

	form := aForm.
	self updateSubmorphs.! !

!UiLabel methodsFor: 'initialization' stamp: 'mt 5/1/2011 12:01:37.953'!
initialize

	super initialize.
	
	text := TextMorph new.
	text contents: 'Label'.
	text lock.
	
	super color: Color transparent.
	
	self
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		updateSubmorphs.! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:33:10.538'!
text

	^ text contents! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:44:15.376'!
text: aText

	text contents: aText asHtmlText.
	self updateSubmorphs.! !

!UiLabel methodsFor: 'accessing - private' stamp: 'mt 7/4/2010 08:46:07.552'!
textMorph

	^ text! !

!UiLabel methodsFor: 'updating' stamp: 'mt 4/29/2011 10:32:39.437'!
updateSubmorphs

	(self submorphs notEmpty and: [self form isNil] and: [self submorphs first == text])
		ifTrue: [^ self].

	self removeAllMorphs.
	
	self form
		ifNil: [self addMorphBack: text]
		ifNotNil: [self addMorphBack: form asMorph].! !

Morph subclass: #UiScrollArea
	instanceVariableNames: 'horizontalScrollBar horizontalScrollBarPolicy verticalScrollBar verticalScrollBarPolicy cornerWidget transformMorph outerBorderWidth widgetResizable areaResizable scrollBarThickness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiScrollArea commentStamp: 'mt 3/7/2011 14:29:02.055' prior: 0!
Just set a #widget: and use it. :)!

UiScrollArea subclass: #UiAbstractItemView
	instanceVariableNames: 'model columnSpecs verticalHeader horizontalHeader vHeaderScroller hHeaderScroller animated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

UiAbstractItemView class
	instanceVariableNames: 'signalConnections'!

!UiAbstractItemView commentStamp: 'mt 1/17/2012 13:40:22.701' prior: 0!
There is a difference between nodes and model indices. A node is an element in a tree-structured database. A model index corresponds to a node and one of multiple properties of a node. Model indices are tree-structured as well. (A cell in the viewport is a flattened model index for drawing and sorting reasons.)

The view should do node boxing and unboxing - not the viewport or the client.!

UiAbstractItemView class
	instanceVariableNames: 'signalConnections'!

!UiAbstractItemView class methodsFor: 'testing' stamp: 'mt 3/7/2011 14:34:32.325'!
isWidgetClass

	^ false! !

!UiAbstractItemView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:33:18.144'!
widgetCategory
	
	^ 'Item Views (Model-Based)'! !

!UiAbstractItemView class methodsFor: 'properties' stamp: 'mt 4/6/2011 14:06:52.44'!
widgetProperties

	^ super widgetProperties, {{'Item View'. #yourself} -> {
		#modelClass -> Object.
		#horizontalHeaderVisible -> Boolean.
		#verticalHeaderVisible -> Boolean.
		#selectionBehavior -> #(selectCells selectRows selectColumns).
		#selectionColor -> Object.
		#selectionMode -> Object}}! !

!UiAbstractItemView class methodsFor: 'properties' stamp: 'mt 4/6/2011 14:08:30.911'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout' widgetResizable)! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 2/2/2012 10:37:43.479'!
activated: aNode
	"Single mouse click or pressing the return key."
	
	self emit.! !

!UiAbstractItemView methodsFor: 'rows/columns - specs' stamp: 'mt 1/23/2012 13:52:18.38'!
addColumn: aColumnSpec
	"Append a new column according to the given specification. Make sure that your model satisfies this specification."
	
	self addColumns: {aColumnSpec}.! !

!UiAbstractItemView methodsFor: 'rows/columns - specs - convenience' stamp: 'bs 1/26/2012 20:39:25.86'!
addColumn: headerText for: aColumnSpec
	
	self addColumn: (
		aColumnSpec 
			headerText: headerText;
			yourself).! !

!UiAbstractItemView methodsFor: 'rows/columns - specs - convenience' stamp: 'bs 1/26/2012 20:39:29.342'!
addColumn: headerText textSelector: aSymbol
	
	self addColumn: (UiItemViewColumnSpec new
		headerText: headerText;
		textSelector: aSymbol).! !

!UiAbstractItemView methodsFor: 'rows/columns - specs - convenience' stamp: 'bs 1/23/2012 16:36:24.376'!
addColumn: headerText textSelector: aSymbol and: selectorMap
	"This is a convenient method for adding a new column that just displays text."
	
	self addColumn: (
		(UiItemViewColumnSpec newFrom: selectorMap)
			headerText: headerText;
			textSelector: aSymbol).! !

!UiAbstractItemView methodsFor: 'rows/columns - specs - convenience' stamp: 'bs 1/26/2012 20:40:05.89'!
addColumnFor: aColumnSpec
	
	self addColumn: aColumnSpec! !

!UiAbstractItemView methodsFor: 'rows/columns - specs' stamp: 'mt 1/23/2012 13:47:53.468'!
addColumns: someColumnSpecs
	
	self columnSpecs addAll: someColumnSpecs.
	self reset.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 4/12/2011 10:58:36.739'!
addHorizontalHeader

	self addMorph: hHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - specs - convenience' stamp: 'bs 1/26/2012 20:40:00.992'!
addTextColumn: headerText selector: aSymbol
	
	self addColumn: (UiItemViewColumnSpec new
		headerText: headerText;
		textSelector: aSymbol).! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:36.704'!
addVerticalHeader

	self addMorph: vHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'accessing' stamp: 'mt 1/18/2012 09:51:24.607'!
animated

	^ animated ifNil: [animated := false]! !

!UiAbstractItemView methodsFor: 'accessing' stamp: 'mt 2/20/2011 18:49:46.161'!
animated: aBoolean

	animated := aBoolean.! !

!UiAbstractItemView methodsFor: 'rows/columns - sorting' stamp: 'mt 7/22/2012 10:02:40.445'!
autoSortBlock
	
	^ self viewport rowOrder sortBlock! !

!UiAbstractItemView methodsFor: 'rows/columns - sorting' stamp: 'mt 3/25/2011 09:35:55.905'!
autoSortBlock: aBlock
	"Specify the way rows will be sorted"
	
	self viewport rowOrder sortBlock: aBlock.
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'model - callbacks' stamp: 'mt 2/3/2012 14:14:44.68'!
changeAllItems
	"Update all visible items."

	| item |
	self columnSpecs withIndexDo: [:spec :id |
		(self viewport columns at: id) indices do: [:index |
			item := index item.
			self viewport replaceMorphWith: item atIndex: index.
			item fadeIn]].
	
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'model - callbacks' stamp: 'mt 2/3/2012 14:15:32.779'!
changeAllItemsWithProperties: someProperties
	"Update all columns that contain at least one of the given properties."
	
	| item |
	self columnSpecs withIndexDo: [:spec :id |
		(spec includesAnyProperty: someProperties) ifTrue: [
			(self viewport columns at: id) indices do: [:index |
				item := index item.
				self viewport replaceMorphWith: item atIndex: index.
				item fadeIn]]].
	
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'model - callbacks' stamp: 'mt 7/20/2012 16:23:27.529'!
changeItemFor: aModelIndex

	| item |
	"Check if node is visible."
	(self viewport isExpanded: aModelIndex parent)
		ifFalse: [^ self].
	
	item := aModelIndex item.
	self viewport replaceMorphWith: item atIndex: aModelIndex.
	self isAnimated ifTrue: [item fadeIn].
	
	self
		updateViewportLayout;
		changed: aModelIndex node.! !

!UiAbstractItemView methodsFor: 'model - callbacks' stamp: 'mt 4/26/2012 13:27:06.863'!
changeRowFor: aModelIndex

	"Check if node is visible."
	(self viewport isExpanded: aModelIndex parent)
		ifFalse: [^ self].
	
	self columnSpecs withIndexDo: [:spec :id |
		| item index |
		index := UiModelIndex
			row: aModelIndex row
			column: id
			group: aModelIndex group
			groupIndex: aModelIndex groupIndex
			parent: aModelIndex parent
			node: aModelIndex node
			spec: spec.
		self connectIndex: index.
				
		item := index item.
		self viewport replaceMorphWith: item atIndex: index.
		self isAnimated ifTrue: [item fadeIn]].
	
	self
		updateViewportLayout;
		changed: aModelIndex node.! !

!UiAbstractItemView methodsFor: 'model - callbacks' stamp: 'mt 7/19/2012 10:54:34.331'!
changeRowsFor: aParentModelIndex from: start to: end inGroup: groupName

	| index item node |
	(self viewport isExpanded: aParentModelIndex)
		ifFalse: [^ self].
		
	"node unboxing"
	node := aParentModelIndex
		ifNil: [self model]
		ifNotNil: [aParentModelIndex node].
	
	start to: end do: [:row |
		| nextChild |
		self flag: #ugly. "Reuse child nodes from present indices? How to access those nodes?"
		nextChild := node childAt: row inGroup: groupName.
		
		self columnSpecs withIndexDo: [:spec :id |
			index := UiModelIndex
				row: row
				column: id
				group: groupName
				groupIndex: (node groups indexOf: groupName)
				parent: aParentModelIndex
				node: nextChild
				spec: spec.
			self connectIndex: index.
				
			item := index item.
			self viewport replaceMorphWith: item atIndex: index.
			self isAnimated ifTrue: [item fadeIn]]].
	
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 2/16/2012 16:30:37.612'!
changed: aNode
	"Emitted whenever a node changes. These changes are manifested in model code."
		
	self emit.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 2/2/2012 10:37:47.454'!
clicked: aNode

	self emit.! !

!UiAbstractItemView methodsFor: 'accessing' stamp: 'mt 3/23/2011 11:01:43.037'!
color: aColor

	self transformMorph ifNotNil: [:tm |
		tm color: aColor].! !

!UiAbstractItemView methodsFor: 'rows/columns - specs' stamp: 'mt 1/23/2012 09:32:26.118'!
columnSpecs

	^ columnSpecs ifNil: [columnSpecs := OrderedCollection new]! !

!UiAbstractItemView methodsFor: 'model - initialization' stamp: 'mt 4/27/2012 11:04:53.805'!
connectIndex: index

	"For all columns resp. whole rows."
	index column = 1 ifTrue: [
		self connect: index signal: #modelReset toSelector: #resetChildrenFor: pattern: #(0).
		self connect: index signal: #rowsInsertedFrom:to:inGroup: toSelector: #insertRowsFor:from:to:inGroup: pattern: #(0 1 2 3).
		self connect: index signal: #rowsChangedFrom:to:inGroup: toSelector: #changeRowsFor:from:to:inGroup: pattern: #(0 1 2 3).
		self connect: index signal: #rowsRemovedFrom:to:inGroup: toSelector: #removeRowsFor:from:to:inGroup: pattern: #(0 1 2 3).
		self connect: index signal: #rowChanged toSelector: #changeRowFor: pattern: #(0)].
	
	"For a single column resp. a single cell."
	self connect: index signal: #itemChanged toSelector: #changeItemFor: pattern: #(0).
! !

!UiAbstractItemView methodsFor: 'model - initialization' stamp: 'mt 4/22/2012 16:11:59.008'!
connectRoot

	self model ifNotNil: [:m |
		"root signals"
		self connect: m signal: #modelReset toSelector: #reset.
		self connect: m signal: #childrenInsertedFrom:to:inGroup: toSelector: #insertRowsFor:from:to:inGroup: pattern: {#=. nil. 1. 2. 3}.
		self connect: m signal: #childrenChangedFrom:to:inGroup: toSelector: #changeRowsFor:from:to:inGroup: pattern: {#=. nil. 1. 2. 3}.
		self connect: m signal: #childrenRemovedFrom:to:inGroup: toSelector: #removeRowsFor:from:to:inGroup: pattern: {#=. nil. 1. 2. 3}.
		
		self connect: m signal: #propertiesChanged toSelector: #changeAllItems.
		self connect: m signal: #propertiesChanged: toSelector: #changeAllItemsWithProperties:].! !

!UiAbstractItemView methodsFor: 'selection - manual' stamp: 'mt 2/2/2012 10:44:25.981'!
currentNode

	^ self selection currentIndex
		ifNotNil: [:index | index node]! !

!UiAbstractItemView methodsFor: 'selection - manual' stamp: 'mt 2/6/2012 17:28:56.97'!
currentNode: aNode

	| indices |
	indices := self modelIndicesFor: aNode.
	self selection currentIndex: (indices
		ifEmpty: []
		ifNotEmpty: [indices first]).! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 2/7/2012 16:25:07.193'!
currentNodeChanged: aNode

	self emit.! !

!UiAbstractItemView methodsFor: 'rows/columns - sorting' stamp: 'mt 3/25/2011 09:36:39.029'!
disableAutoSort
	"No row sorting."
	
	self viewport rowOrder sortBlock: nil.
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 2/2/2012 10:38:17.895'!
doubleClicked: aNode

	self emit.! !

!UiAbstractItemView methodsFor: 'accessing' stamp: 'mt 7/18/2012 11:32:18.728'!
dragDropSpec

	^ self viewport dragDropSpec! !

!UiAbstractItemView methodsFor: 'accessing' stamp: 'mt 7/18/2012 11:32:34.493'!
dragDropSpec: aDragDropSpec

	self viewport dragDropSpec: aDragDropSpec.! !

!UiAbstractItemView methodsFor: 'model - actions' stamp: 'mt 7/6/2012 11:35:31.221'!
edit: aNode property: aProperty
	"Start the edit mode for the property in the given node."

	| rowIndex columnIndex |
	rowIndex := self rowIndexFor: aNode.
	columnIndex := self viewport columnOrder mapIndexOf: (self columnSpecs indexOf: (self columnSpecs detect: [:spec | spec includesProperty: aProperty])).

	self viewport beginEditCell: columnIndex @ rowIndex.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 7/8/2012 14:08:59.029'!
edited: aNode
	"Emitted whenever the user edits an item via in-place editors in the view."
	
	self emit.! !

!UiAbstractItemView methodsFor: 'rows/columns - sorting' stamp: 'mt 7/12/2012 09:34:36.929'!
enableAutoSort
	"Sort rows alphabetically in ascending order."
	
	self viewport rowOrder sortBlock: [:node1 :node2 | node1 asString <= node2 asString].
	
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'model - initialization' stamp: 'mt 6/28/2012 16:10:19.007'!
fillViewportFor: aModelIndex animated: aBoolean

	| index item groupItem newRows node |
	"Node unboxing"
	node := aModelIndex
		ifNil: [self model "root addressed"]
		ifNotNil: [aModelIndex node].
	
	"Create row-specific data as nested array:
	group -> row -> column -> model index -> item/morph."
	newRows := node groups withIndexCollect: [:group :groupIndex |
		groupItem := self groupSpec itemFor: node groupIndex: groupIndex isTopLevel: aModelIndex isNil.
		groupItem
			setProperty: #isGroupSeparator toValue: true;
			setProperty: #indent toValue: 0;
			setProperty: #hasChildren toValue: false;
			setProperty: #parentModelIndex toValue: aModelIndex;
			setProperty: #groupIndex toValue: groupIndex.
		
		groupItem -> (
		(1 to: (node childCountInGroup: group)) collect: [:row |
			| nextChild |
			"share instance of next child among all columns in one row"
			nextChild := node childAt: row inGroup: group.

			self columnSpecs withIndexCollect: [:spec :id |
				"Node boxing"
				index := UiModelIndex
					row: row
					column: id
					group: group
					groupIndex: groupIndex
					parent: aModelIndex
					node: nextChild
					spec: spec.
				self connectIndex: index.

				item := index item.
				aBoolean ifTrue: [item fadeIn].
				index -> item]])].
	
	newRows ifEmpty: [^ self].
	
	aModelIndex
		ifNil: [self viewport appendItemRows: newRows] "top-level"
		ifNotNil: [self viewport insertItemRows: newRows].! !

!UiAbstractItemView methodsFor: 'events' stamp: 'mt 5/24/2011 16:13:00.1'!
grabKeyboard

	self viewport grabKeyboard.! !

!UiAbstractItemView methodsFor: 'accessing' stamp: 'mt 6/26/2012 11:28:53.334'!
groupSpec

	^ self viewport groupSpec! !

!UiAbstractItemView methodsFor: 'accessing' stamp: 'mt 6/26/2012 11:29:50.737'!
groupSpec: aGroupSpec
	"Configure the way how group separator items are drawn or groups behave."
	
	self viewport groupSpec: aGroupSpec.
	self reset.! !

!UiAbstractItemView methodsFor: 'headers - testing' stamp: 'mt 10/14/2010 13:04:29.063'!
hasHorizontalHeader

	^ hHeaderScroller owner notNil! !

!UiAbstractItemView methodsFor: 'headers - testing' stamp: 'mt 10/14/2010 13:03:13.199'!
hasVerticalHeader

	^ vHeaderScroller owner notNil! !

!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 1/13/2012 11:02:45.578'!
horizontalAlignmentForColumn: anIndex

	^ (self viewport columnAt: anIndex)
		hAlignment! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:07:05.122'!
horizontalHeaderVisible
		
	^ self hasHorizontalHeader! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:06:33.964'!
horizontalHeaderVisible: aBoolean

	aBoolean
		ifTrue: [self addHorizontalHeader]
		ifFalse: [self removeHorizontalHeader].! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 8/16/2012 14:44:00.851'!
hovered: aNode

	self emit.! !

!UiAbstractItemView methodsFor: 'initialization' stamp: 'mt 8/16/2012 14:55:04.262'!
initialize

	"Initialize headers."
	verticalHeader := Morph new color: Color transparent; changeTableLayout; listDirection: #topToBottom; hResizing: #shrinkWrap; cellInset: -1 "hacky".
	horizontalHeader := Morph new color: Color transparent; changeTableLayout; listDirection: #leftToRight; vResizing: #shrinkWrap.
	vHeaderScroller := UiTransformMorph new.
	hHeaderScroller := UiTransformMorph new.

	super initialize.
	
	self
		borderWidth: 0;
		color: Color white.
	super color: Color transparent.
		
	self
		verticalScrollBarPolicy: #asNeeded;
		horizontalScrollBarPolicy: #asNeeded.
		
	"Initialize viewport."
	self widget: self viewportClass new.
	self widget groupSpec: UiItemViewGroupSpec new. "for creating group separator items"
	
	self connect: self viewport signal: #focusChanged: toSelector: #scrollToShow:.
	self connect: self viewport signal: #hovered: toSelector: #onHovered:.
	self connect: self viewport signal: #clicked: toSelector: #onClicked:.
	self connect: self viewport signal: #doubleClicked: toSelector: #onDoubleClicked:.
	self connect: self viewport signal: #selectionChanged: toSelector: #onSelectionChanged:.
	self connect: self viewport signal: #currentIndexChanged: toSelector: #onCurrentIndexChanged:.
	self connect: self viewport signal: #activated: toSelector: #onActivated:.
	self connect: self viewport signal: #returnPressed: toSelector: #onReturnPressed:.
	self connect: self viewport signal: #menuRequestedAt:on: toSelector: #showMenuAt:on:.
	self connect: self viewport signal: #edited: toSelector: #onEdited:.
	self connect: self viewport signal: #objectDropped:type:from:on: toSelector: #onObjectDropped:type:from:on:.
	self connect: self viewport signal: #objectDropped:type:from:before: toSelector: #onObjectDropped:type:from:before:.
	self connect: self viewport signal: #objectDropped:type:from:after: toSelector: #onObjectDropped:type:from:after:.

	self connect: self viewport signal: #keyStroked:on: toSelector: #onKeyStroked:on:.

	"Needs to be redefined here beacuse the viewport catches keyboard and mouse events."
	self connect: self viewport signal: #mouseWheelUp to: self verticalScrollBar selector: #decreaseValueBySingleStep.
	self connect: self viewport signal: #mouseWheelDown to: self verticalScrollBar selector: #increaseValueBySingleStep.

	self viewport verticalHeader: verticalHeader.
	self viewport horizontalHeader: horizontalHeader.
	
	"Vertical scrolling is dependent from default item height."
	self verticalScrollBar singleStep: UiItemViewColumnSpec defaultItemExtent y.
	
	"Initialize headers - Finish."
	verticalHeader connect: self viewport signal: #resizedToWidth:height: toSelector: #height: pattern: #(2).
	vHeaderScroller connect: self transformMorph signal: #verticalOffsetChanged: toSelector: #verticalOffset:.
	self connect: vHeaderScroller signal: #areaChanged toSelector: #resizeVerticalHeaderScroller.
	vHeaderScroller addMorph: verticalHeader.

	horizontalHeader connect: self viewport signal: #resizedToWidth:height: toSelector: #width:.
	hHeaderScroller connect: self transformMorph signal: #horizontalOffsetChanged: toSelector: #horizontalOffset:.
	self connect: hHeaderScroller signal: #areaChanged toSelector: #resizeHorizontalHeaderScroller.
	hHeaderScroller addMorph: horizontalHeader.! !

!UiAbstractItemView methodsFor: 'model - callbacks' stamp: 'mt 7/5/2012 16:32:07.916'!
insertRowsFor: aParentModelIndex from: start to: end inGroup: groupName

	| index item isTopLevelAppending node |
	end < start ifTrue: [^ self].
	
	(self viewport isExpanded: aParentModelIndex)
		ifFalse: [^ self].
		
	"Node unboxing."
	node := aParentModelIndex
		ifNil: [self model]
		ifNotNil: [aParentModelIndex node].

	"Update trailing model indices."
	end + 1 to: (node childCountInGroup: groupName) do: [:row |
		| nextChild |
		self flag: #ugly. "Reuse child nodes from trailing indices? How to access those nodes?"
		nextChild := node childAt: row inGroup: groupName.
		
		self columnSpecs withIndexDo: [:spec :id | | oldIndex |
			index := UiModelIndex
				row: row column: id group: groupName
				groupIndex: (node groups indexOf: groupName)
				parent: aParentModelIndex
				node: nextChild
				spec: spec.
			oldIndex := UiModelIndex
				row: row - 1 - (end - start)
				column: id
				group: groupName
				groupIndex: (node groups indexOf: groupName)
				parent: aParentModelIndex
				node: nil
				spec: spec.
			
			self connectIndex: index.
			self viewport updateIndex: index oldIndex: oldIndex]].

	"Insert new rows."
	isTopLevelAppending := aParentModelIndex isNil and: [self viewport rowCount < start].
	start to: end do: [:row |
		| nextChild |
		nextChild := node childAt: row inGroup: groupName.
		
		self columnSpecs withIndexDo: [:spec :id |
			index := UiModelIndex
				row: row column: id group: groupName
				groupIndex: (node groups indexOf: groupName)
				parent: aParentModelIndex
				node: nextChild
				spec: spec.
			self connectIndex: index.

			item := index item.
			isTopLevelAppending
				ifTrue: [self viewport appendMorph: item forIndex: index]
				ifFalse: [self viewport insertMorph: item forIndex: index].
			self isAnimated ifTrue: [item fadeIn]]].
		
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'testing' stamp: 'mt 2/20/2011 18:50:39.894'!
isAnimated
	"Show fading animations for item updates?"
	
	^ self animated! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 7/20/2012 17:29:10.429'!
keyStroked: aKeyboardevent on: aNode

	self emit.! !

!UiAbstractItemView methodsFor: 'model - accessing' stamp: 'mt 3/7/2011 11:47:04.514'!
model

	^ model! !

!UiAbstractItemView methodsFor: 'model - accessing' stamp: 'mt 2/16/2012 10:49:09.459'!
model: aModel

	self model ifNotNil: [:m |
		m disconnectAllSignals].
	
	model := aModel.

	self
		reset;
		connectRoot.! !

!UiAbstractItemView methodsFor: 'model - accessing' stamp: 'mt 10/28/2010 10:04:51.755'!
modelClass

	^ self model
		ifNil: [nil]
		ifNotNil: [:m | m class]! !

!UiAbstractItemView methodsFor: 'model - accessing' stamp: 'bs 1/20/2012 13:02:07.612'!
modelClass: aClass

	aClass
		ifNil: [self model: nil]
		ifNotNil: [:c | self model: c new].! !

!UiAbstractItemView methodsFor: 'model - to index' stamp: 'mt 5/2/2012 13:18:10.183'!
modelIndicesFor: aNode
	"Return a list of all model indices that are associated with the given node."
	
	self viewport rows ifEmpty: [^ #()].

	self viewport rows do: [:row |
		"Model index in a row can be nil for group separators."
		row firstModelIndex ifNotNil: [:index |
			index node = aNode ifTrue: [^ row indices]]].
	
	^ #()! !

!UiAbstractItemView methodsFor: 'rows/columns - sorting' stamp: 'mt 1/18/2012 11:43:31.377'!
moveColumn: sourceIndex to: targetIndex
	"Allows resorting of columns. Indices apply to ACTUALLY VISIBLE indices - not real model data indices."
	
	| map |
	map := self viewport columnOrder map
		ifNil: [(1 to: (self model columnCountFor: nil)) collect: [:i | i]].
	
	map
		at: targetIndex put: sourceIndex;
		at: sourceIndex put: targetIndex.
		
	self viewport columnOrder map: map.
	
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 7/18/2012 11:46:41.132'!
objectDropped: anObject type: aSymbol from: aSourceObject afterNode: aNode

	self emit.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 7/19/2012 10:18:19.233'!
objectDropped: anObject type: aSymbol from: aSourceObject beforeNode: aNode

	self emit.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 7/18/2012 11:46:45.04'!
objectDropped: anObject type: aSymbol from: aSourceObject onNode: aNode

	self emit.! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 2/2/2012 10:36:39.198'!
onActivated: aModelIndex

	self activated: aModelIndex node.! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 2/2/2012 10:36:46.451'!
onClicked: aModelIndex

	self clicked: aModelIndex node.! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 2/6/2012 17:33:20.361'!
onCurrentIndexChanged: aModelIndex

	self currentNodeChanged: (aModelIndex ifNotNil: [:index | index node]).! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 2/2/2012 10:37:05.079'!
onDoubleClicked: aModelIndex

	self doubleClicked: aModelIndex node.! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 7/8/2012 14:08:36.707'!
onEdited: aModelIndex

	self edited: aModelIndex node.! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 8/16/2012 15:43:27.032'!
onHovered: aModelIndex

	self hovered: (aModelIndex ifNotNil: [:mi | mi node]).! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 7/20/2012 17:36:12.359'!
onKeyStroked: aKeyboardEvent on: aModelIndex

	aModelIndex ifNil: [^ self].
	self keyStroked: aKeyboardEvent on: aModelIndex node.! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 7/18/2012 11:28:31.733'!
onObjectDropped: anObject type: aSymbol from: aSourceObject after: aModelIndex

	self objectDropped: anObject type: aSymbol from: aSourceObject afterNode: aModelIndex node.! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 7/19/2012 10:18:12.145'!
onObjectDropped: anObject type: aSymbol from: aSourceObject before: aModelIndex

	self objectDropped: anObject type: aSymbol from: aSourceObject beforeNode: aModelIndex node.! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 7/18/2012 11:27:41.986'!
onObjectDropped: anObject type: aSymbol from: aSourceObject on: aModelIndex

	self objectDropped: anObject type: aSymbol from: aSourceObject onNode: aModelIndex node.! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 2/2/2012 10:37:11.951'!
onReturnPressed: aModelIndex

	self returnPressed: aModelIndex node.! !

!UiAbstractItemView methodsFor: 'signals - unboxing' stamp: 'mt 2/2/2012 10:37:26.324'!
onSelectionChanged: someModelIndices

	self selectionChanged: (someModelIndices collect: [:index | index node]).! !

!UiAbstractItemView methodsFor: 'model - callbacks' stamp: 'mt 2/16/2012 11:47:28.902'!
overrideMenuTarget: aMenuItem

	aMenuItem target: self model.
	aMenuItem subMenu ifNotNil: [:menu |
		menu items do: [:item | self overrideMenuTarget: item]].! !

!UiAbstractItemView methodsFor: 'rows/columns - specs' stamp: 'mt 1/25/2012 13:25:51.385'!
removeAllColumns

	self columnSpecs removeAll.
	self reset.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:54.15'!
removeHorizontalHeader

	self removeMorph: hHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model - callbacks' stamp: 'mt 4/27/2012 09:29:48.263'!
removeRowsFor: aParentModelIndex from: start to: end inGroup: groupName

	| index node |
	(self viewport isExpanded: aParentModelIndex)
		ifFalse: [^ self].
	
	start to: end do: [:row |
		self viewport removeRowFor: aParentModelIndex at: row inGroup: groupName].
	
	"node unboxing"
	node := aParentModelIndex
		ifNil: [self model]
		ifNotNil: [aParentModelIndex node].
	
	"Update trailing model indices."
	start to: (node childCountInGroup: groupName) do: [:row |
		| nextChild |
		self flag: #ugly. "Reuse child nodes from trailing indices? How to access those nodes?"
		nextChild := node childAt: row inGroup: groupName.
		
		self columnSpecs withIndexDo: [:spec :id | | oldIndex |
			index := UiModelIndex
				row: row column: id group: groupName
				groupIndex: (node groups indexOf: groupName)
				parent: aParentModelIndex
				node: nextChild
				spec: spec.
			oldIndex := UiModelIndex
				row: row + 1 + (end - start)
				column: id
				group: groupName
				groupIndex: (node groups indexOf: groupName)
				parent: aParentModelIndex
				node: nil
				spec: spec.
			
			self connectIndex: index.
			self viewport updateIndex: index oldIndex: oldIndex]].
	
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:43.32'!
removeVerticalHeader

	self removeMorph: vHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model - initialization' stamp: 'mt 8/6/2012 17:16:26.609'!
reset

	| selectedIndices |
	selectedIndices := self selection selectedIndices.

	self viewport clear.
	
	"Ensure the correct number of columns."
	self viewport limitColumnCount: self columnSpecs size.
	self resetHeaderItems.
	
	(self model notNil and: [self columnSpecs notEmpty]) ifTrue: [		
		self fillViewportFor: nil animated: false].

	"Restore selection if any."
	selectedIndices
		ifEmpty: [self updateViewportLayout]
		ifNotEmpty: [ | parentIndices |
			parentIndices := ((selectedIndices collect: [:i | i parent]) reject: [:i | i isNil]) asSet.

			self flag: #expensive. "mt: Improve performance here?"
			parentIndices
				ifEmpty: [self updateViewportLayout]
				ifNotEmpty: [self expandIndices: parentIndices].
			
			[self selection selectedIndices: selectedIndices] on: Error do: []].! !

!UiAbstractItemView methodsFor: 'model - callbacks' stamp: 'mt 4/27/2012 11:12:24.555'!
resetChildrenFor: aParentModelIndex

	| row |
	row := self viewport rowFor: aParentModelIndex.
	row isExpanded ifFalse: [^ self].
		
	self viewport beginChangeLayout.
	
	self viewport removeChildrenForRow: row.
	
	self
		fillViewportFor: aParentModelIndex
		animated: self isAnimated.
	
	self viewport endChangeLayout.! !

!UiAbstractItemView methodsFor: 'model - initialization' stamp: 'mt 7/5/2012 16:04:45.272'!
resetHeaderItems
	
	"Vertical Header - just a default implementation"
	self flag: #buggy. "Layout/Height is wrong and increases height of top-level rows somehow... See UiItemRowInfo>>#optimalSize."
	"(1 to: self model childCount) do: [:row | | item |
		item := UiViewHeaderItem new orientation: #vertical.
		item addMorph: row asString asText asMorph lock.
		self viewport setHeaderItem: item atRow: row.
		
		self connect: item signal: #resized: toSelector: #setHeightForRow:to: pattern: {#=. row. 1}.
		self connect: item signal: #resizedToShrinkWrap toSelector: #setOptimalHeightForRow: pattern: {#=. row}.]."
	
	"Horizontal Header"
	self columnSpecs withIndexDo: [:spec :id | | item |
		item := UiViewHeaderItem new orientation: #horizontal.
		item addMorph: spec headerItem.
		self viewport setHeaderItem: item atColumn: id.
		
		self connect: item signal: #resized: toSelector: #setWidthForColumn:to: pattern: {#=. id. 1}.
		self connect: item signal: #resizedToShrinkWrap toSelector: #setOptimalWidthForColumn: pattern: {#=. id}].! !

!UiAbstractItemView methodsFor: 'headers - geometry' stamp: 'mt 3/25/2011 10:28:43.826'!
resizeHorizontalHeaderScroller

	hHeaderScroller
		height: horizontalHeader height.! !

!UiAbstractItemView methodsFor: 'headers - geometry' stamp: 'mt 3/25/2011 10:29:05.826'!
resizeVerticalHeaderScroller

	vHeaderScroller
		width: verticalHeader width.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 2/2/2012 10:38:23.483'!
returnPressed: aNode

	self emit.! !

!UiAbstractItemView methodsFor: 'model - to index' stamp: 'mt 7/6/2012 11:30:54.412'!
rowIndexFor: aNode
	
	self viewport rowsWithIndexDo: [:row :rowIndex |
		"Model index in a row can be nil for group separators."
		row firstModelIndex ifNotNil: [:index |
			index node = aNode ifTrue: [^ rowIndex]]].
	
	^ nil! !

!UiAbstractItemView methodsFor: 'selection - manual' stamp: 'mt 8/8/2012 15:58:34.853'!
selectNextColumn

	self viewport selectNextColumn.! !

!UiAbstractItemView methodsFor: 'selection - manual' stamp: 'mt 8/8/2012 15:58:28.412'!
selectNextRow

	self viewport selectNextRow.! !

!UiAbstractItemView methodsFor: 'selection - manual' stamp: 'mt 8/8/2012 15:58:44.321'!
selectPreviousColumn

	self viewport selectPreviousColumn.! !

!UiAbstractItemView methodsFor: 'selection - manual' stamp: 'mt 8/8/2012 15:58:50.532'!
selectPreviousRow

	self viewport selectPreviousRow.! !

!UiAbstractItemView methodsFor: 'selection - manual' stamp: 'mt 6/26/2012 14:04:29.478'!
selectedNodes

	^ (self selection selectedIndices collect: [:index |
		index node]) asSet asOrderedCollection! !

!UiAbstractItemView methodsFor: 'selection - manual' stamp: 'mt 2/2/2012 14:10:57.401'!
selectedNodes: someNodes

	^ self selection selectedIndices: (
		someNodes
			inject: OrderedCollection new
			into: [:indices :node | indices, (self modelIndicesFor: node)])! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 4/6/2011 10:20:24.432'!
selection
	
	^ self viewport selection! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 2/20/2011 19:20:28.508'!
selectionBehavior
	
	^ self viewport selectionBehavior! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/19/2010 10:21:08.2'!
selectionBehavior: aSymbol
	"#selectCells, #selectRows, #selectColumns"
	
	self viewport selectionBehavior: aSymbol.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 2/2/2012 10:38:28.683'!
selectionChanged: someNodes

	self emit.! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 2/20/2011 19:21:34.624'!
selectionColor

	^ self viewport selectionColor! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/19/2010 10:24:52.272'!
selectionColor: aColor

	self viewport selectionColor: aColor.! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 2/20/2011 19:23:16.66'!
selectionMode

	^ self viewport selectionMode! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/19/2010 10:26:27.009'!
selectionMode: aSelectionClass
	"Use can use all subclasses of UiViewSelection here."

	self viewport selectionMode: aSelectionClass.! !

!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 3/25/2011 09:39:31.722'!
setHAlignmentForColumn: anIndex to: aSymbol
	"#left, #center, #right"
	
	(self viewport columnAt: anIndex)
		hAlignment: aSymbol.
		
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 7/6/2012 10:59:48.376'!
setHAlignmentTo: aSymbol
	"#left, #center, #right"
	
	self viewport columns do: [:columnInfo |
		columnInfo hAlignment: aSymbol].
		
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 3/25/2011 09:39:45.526'!
setHeightForRow: anIndex to: anInteger

	| row |
	row := self viewport rowAt: anIndex.
	row resizeMode ~= #rigid
		ifTrue: [^ self].
		
	row height: anInteger.
		
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 1/18/2012 09:40:43.874'!
setOptimalHeightForRow: anIndex
	"Resize a row to its contents."

	| row |
	row := self viewport rowAt: anIndex.
	row resizeMode ~= #rigid
		ifTrue: [^ self].
		
	row height: row optimalSize.
		
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 1/10/2012 17:24:11.118'!
setOptimalWidthForColumn: anIndex

	| col |
	col := self viewport columnAt: anIndex.
	col resizeMode ~= #rigid
		ifTrue: [^ self].
		
	col width: col optimalSize.
		
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 3/25/2011 09:39:51.324'!
setResizeModeForColumn: anIndex to: aSymbol

	(self viewport columnAt: anIndex)
		resizeMode: aSymbol.
		
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 3/25/2011 09:39:56.474'!
setResizeModeForRow: anIndex to: aSymbol

	(self viewport rowAt: anIndex)
		resizeMode: aSymbol.
		
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 3/25/2011 09:40:01.69'!
setVAlignmentForColumn: anIndex to: aSymbol
	"#top, #center, #bottom"
	
	(self viewport columnAt: anIndex)
		vAlignment: aSymbol.
		
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 7/6/2012 11:00:03.987'!
setVAlignmentTo: aSymbol
	"#top, #center, #bottom"
	
	self viewport columns do: [:columnInfo |
		columnInfo vAlignment: aSymbol].
		
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 3/25/2011 09:40:07.794'!
setWidthForColumn: anIndex to: anInteger

	| col |
	col := self viewport columnAt: anIndex.
	col resizeMode ~= #rigid
		ifTrue: [^ self].
		
	col width: anInteger.
		
	self updateViewportLayout.! !

!UiAbstractItemView methodsFor: 'model - callbacks' stamp: 'mt 2/16/2012 11:47:44.377'!
showMenuAt: aPoint on: aModelIndex

	aModelIndex menu ifNotNil: [:menu |
		"Overwrite target of menu items. Really good?"
		menu items do: [:item | self overrideMenuTarget: item].
		menu popUpNoKeyboard].! !

!UiAbstractItemView methodsFor: 'layouting' stamp: 'mt 4/12/2011 11:00:59.847'!
updateLayout
	
	super updateLayout.

	hHeaderScroller
		extent: self transformMorph width @ horizontalHeader height;
		topLeft: self transformMorph left @ self top.
		
	vHeaderScroller
		extent: verticalHeader width @ self transformMorph height;
		topLeft: self left @ self transformMorph top.

	self verticalScrollBar
		height: self transformMorph bottom - self top.
		
	self horizontalScrollBar
		width: self transformMorph right - self left.
! !

!UiAbstractItemView methodsFor: 'layouting' stamp: 'mt 3/25/2011 09:34:25.29'!
updateViewportLayout

	self viewport ifNotNil: [:v | v updateLayout].! !

!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 1/13/2012 11:02:57.85'!
verticalAlignmentForColumn: anIndex
	
	^ (self viewport columnAt: anIndex)
		vAlignment! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:06:51.888'!
verticalHeaderVisible

	^ self hasVerticalHeader! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:06:21.13'!
verticalHeaderVisible: aBoolean

	aBoolean
		ifTrue: [self addVerticalHeader]
		ifFalse: [self removeVerticalHeader].! !

!UiAbstractItemView methodsFor: 'accessing - private' stamp: 'mt 3/7/2011 11:50:41.566'!
viewport
	"Return the morph that is scrolled."
	
	^ self widget! !

!UiAbstractItemView methodsFor: 'geometry' stamp: 'mt 3/25/2011 10:17:15.12'!
viewportBounds

	| rect |
	rect := super viewportBounds.
	
	self hasVerticalHeader ifTrue: [
		rect := rect insetBy: (verticalHeader width @ 0 corner: 0@0)].

	self hasHorizontalHeader ifTrue: [
		rect := rect insetBy: (0 @ horizontalHeader height corner: 0@0)].

	^ rect! !

!UiAbstractItemView methodsFor: 'accessing - private' stamp: 'mt 10/14/2010 12:08:54.27'!
viewportClass

	self subclassResponsibility.! !

!UiAbstractItemView methodsFor: 'accessing - indices' stamp: 'mt 2/16/2012 17:00:17.665'!
visibleIndicesIn: aColumnNumber

	self flag: #badStyle.
	^ (self viewport columns at: aColumnNumber) indices! !

!UiAbstractItemView methodsFor: 'accessing - indices' stamp: 'mt 2/16/2012 17:00:24.076'!
visibleItemsIn: aColumnNumber

	self flag: #badStyle.
	^ (self viewport columns at: aColumnNumber) items! !

UiAbstractItemView subclass: #UiListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiListView commentStamp: 'mt 10/20/2010 14:02:59.798' prior: 0!
I am a list view that is able to break the line of items in one direction and shows as many items as possible.

I map some signals to ones that only indicate row indices, e.g., selected row indices instead of whole model indices.!

!UiListView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:39.613'!
isWidgetClass

	^ true! !

!UiListView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:03:20.427'!
widgetClassIcon

	^ UiFugueIcons uiListBoxIcon! !

!UiListView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:06:46.933'!
widgetClassName

	^ 'List View'! !

!UiListView methodsFor: 'selection - manual' stamp: 'mt 6/28/2012 17:11:21.108'!
currentRow

	self flag: #groupsMissing. "Needs groups support."
	^ self selection currentIndex
		ifNotNil: [:index | index row]! !

!UiListView methodsFor: 'selection - manual' stamp: 'mt 6/28/2012 17:11:16.56'!
currentRow: aRowIndex

	| numSeparators |
	self flag: #groupsMissing. "Needs groups support."
	numSeparators := 0.
	self viewport rows withIndexDo: [:rowInfo :rowIndex |
		rowInfo isSeparator ifTrue: [numSeparators := numSeparators  + 1].
		rowIndex - numSeparators = aRowIndex ifTrue: [
			self selection currentIndex: rowInfo firstModelIndex.
			^ self]].! !

!UiListView methodsFor: 'signals' stamp: 'mt 10/20/2010 13:53:08.525'!
currentRowChanged: newRowIndex

	self emit.! !

!UiListView methodsFor: 'model - initialization' stamp: 'mt 5/18/2012 11:32:04.866'!
fillViewportFor: aModelIndex animated: aBoolean
	"Optimized for performance."
	
	self model ifNil: [^ self].
	
	^ super fillViewportFor: aModelIndex animated: aBoolean! !

!UiListView methodsFor: 'accessing' stamp: 'mt 1/13/2012 11:03:23.32'!
hAlignment

	^  self horizontalAlignmentForColumn: 1! !

!UiListView methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:19:09.581'!
hAlignment: aSymbol

	self setHAlignmentForColumn: 1 to: aSymbol.! !

!UiListView methodsFor: 'initialization' stamp: 'mt 7/21/2012 12:37:09.495'!
initialize

	super initialize.	
		
	self
		widgetResizable: true;
		listOrientation: #default;
		groupSpec: UiListViewGroupSpec new.! !

!UiListView methodsFor: 'accessing' stamp: 'mt 10/14/2010 15:27:12.646'!
listOrientation

	^ self viewport orientation! !

!UiListView methodsFor: 'accessing' stamp: 'mt 7/21/2012 13:19:54.112'!
listOrientation: aSymbol
	"#default ... no breaks, vertical scrolling if needed, full row selection
	#vertical ... items go from left to right and break at width -> vertical scrolling
	#horizontal ... items go from top to bottom and break at height -> horizontal scrolling"

"	self listOrientation = aSymbol
		ifTrue: [^ self].
"	
	self viewport orientation: aSymbol.
	
	aSymbol = #default
		ifTrue: [self
			horizontalScrollBarPolicy: #alwaysOff;
			verticalScrollBarPolicy: #asNeeded].
		
	aSymbol = #vertical
		ifTrue: [self
			horizontalScrollBarPolicy: #alwaysOff;
			verticalScrollBarPolicy: #asNeeded].
		
	aSymbol = #horizontal
		ifTrue: [self
			horizontalScrollBarPolicy: #asNeeded;
			verticalScrollBarPolicy: #alwaysOff].
		
	self updateViewportLayout.! !

!UiListView methodsFor: 'rows/columns - specs' stamp: 'mt 1/23/2012 15:13:28.575'!
listSpec

	^ self columnSpecs
		ifEmpty: []
		ifNotEmpty: [self columnSpecs first]! !

!UiListView methodsFor: 'rows/columns - specs' stamp: 'mt 1/23/2012 15:13:04.047'!
listSpec: aColumnSpec

	columnSpecs := {aColumnSpec}.
	self reset.! !

!UiListView methodsFor: 'signals -unboxing' stamp: 'mt 1/17/2012 13:55:51.308'!
onCurrentIndexChanged: aModelIndex
	"Map to the row index. Ignore the column in a list."
	
	super onCurrentIndexChanged: aModelIndex.
	self currentRowChanged: (aModelIndex ifNotNil: [:m | m row]).! !

!UiListView methodsFor: 'signals -unboxing' stamp: 'mt 1/17/2012 13:55:41.348'!
onSelectionChanged: someModelIndices

	super onSelectionChanged: someModelIndices.
	self selectedRowsChanged: (someModelIndices collect: [:i | i row]).! !

!UiListView methodsFor: 'signals' stamp: 'mt 10/20/2010 14:00:30.024'!
selectedRowsChanged: someRowIndices

	self emit.! !

!UiListView methodsFor: 'geometry' stamp: 'mt 4/6/2011 12:03:16.96'!
useOptimalSize
	"Change the size of the view that only one kind/direction of scrolling is needed."

	self listOrientation = #default ifTrue: [
		self height: self viewport optimalSize y.
		self width: self viewport optimalSize x + self scrollBarThickness + 5 + 
			(self hasVerticalHeader ifTrue: [verticalHeader width] ifFalse: [0])].
		
	self listOrientation = #vertical ifTrue: [
		self height: self viewport optimalSize y.
		self width: self viewport s x + self scrollBarThickness + 5 +
			(self hasVerticalHeader ifTrue: [verticalHeader width] ifFalse: [0])].

	self listOrientation = #horizontal ifTrue: [
		self width: self viewport optimalSize x.
		self height: self viewport optimalSize y + self scrollBarThickness +
			(self hasHorizontalHeader ifTrue: [horizontalHeader width] ifFalse: [0])].! !

!UiListView methodsFor: 'accessing' stamp: 'mt 1/13/2012 11:03:37.427'!
vAlignment

	^ self verticalAlignmentForColumn: 1! !

!UiListView methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:19:17.877'!
vAlignment: aSymbol

	self setVAlignmentForColumn: 1 to: aSymbol.! !

!UiListView methodsFor: 'accessing - private' stamp: 'mt 11/2/2010 13:26:33.658'!
viewportClass

	^ UiListViewport! !

UiListView subclass: #UiListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiListWidget commentStamp: 'mt 10/19/2010 19:32:52.216' prior: 0!
Simple list. Item based. No model required.!

!UiListWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:33:00.509'!
widgetCategory
	
	^ 'Item Widgets (Item-Based)'! !

!UiListWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:54:17.534'!
widgetClassIcon

	^ UiFugueIcons uiListBoxBlueIcon! !

!UiListWidget class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:21:46.085'!
widgetClassName

	^ 'List Widget'! !

!UiListWidget class methodsFor: 'properties' stamp: 'mt 4/6/2011 14:08:09.843'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #(modelClass horizontalHeaderVisible verticalHeaderVisible selectionBehavior)! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 13:33:58.778'!
addIcon: anIcon text: aLabel

	self model addItem: (self itemClass new text: aLabel; icon: anIcon).! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 13:34:09.151'!
addIcon: anIcon text: aLabel at: anIndex

	self model insertItem: (self itemClass new text: aLabel; icon: anIcon) at: anIndex.! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 4/13/2011 16:16:58.089'!
addItem: aListWidgetItem

	self model addItem: aListWidgetItem.! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 4/13/2011 14:22:04.857'!
addItemList: someListWidgetItems

	self model addItems: someListWidgetItems.! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 5/17/2011 10:11:03.51'!
addItemListFrom: someObjects using: aBlock
	"Constructs list widget items for each given objects and gives the chance to configure those items using the binary block. The string representation of an object will be used by default.
	
	self
		addItemListFrom: PackageOrganizer default packageNames
		using: [:pName :item | | mc |
			mc := MCPackage named: pName.
			mc hasWorkingCopy ifTrue: [item text: mc workingCopy description]]"
	
	self model addItems: (someObjects collect: [:obj |
		aBlock
			value: obj
			value: (self itemClass new text: obj asString)]).! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 13:34:16.387'!
addText: aLabel

	self model addItem: (self itemClass new text: aLabel).! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 13:34:22.67'!
addText: aLabel at: anIndex

	self model insertItem: (self itemClass new text: aLabel) at: anIndex.! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 3/29/2011 18:18:18.709'!
addTextList: someTexts

	self model addItems: (someTexts collect: [:text | self itemClass new text: text]).! !

!UiListWidget methodsFor: 'collection api' stamp: 'mt 6/30/2011 10:42:42.096'!
allSatisfy: aBlock

	self do: [:index | (aBlock value: index) ifFalse: [^ false]].
	^ true! !

!UiListWidget methodsFor: 'collection api' stamp: 'mt 6/30/2011 10:42:28.725'!
anySatisfy: aBlock

	self do: [:index | (aBlock value: index) ifTrue: [^ true]].
	^ false! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 4/14/2011 11:20:50.763'!
clear

	self model: UiListWidgetModel new.
	self transformMorph offset: 0@0.! !

!UiListWidget methodsFor: 'collection api' stamp: 'mt 6/30/2011 10:42:12.144'!
count: aBlock

	| sum |
	sum := 0.
	self do: [:each | (aBlock value: each) ifTrue: [sum := sum + 1]].
	^ sum! !

!UiListWidget methodsFor: 'selection - convenience' stamp: 'mt 10/20/2010 14:15:08.334'!
currentIcon

	^ self currentItem ifNotNil: [:i | i icon]! !

!UiListWidget methodsFor: 'selection' stamp: 'mt 10/20/2010 10:30:03.07'!
currentItem

	^ self currentRow ifNotNil: [:cc | self items at: cc]! !

!UiListWidget methodsFor: 'selection' stamp: 'mt 2/3/2012 13:28:57.127'!
currentItem: aListWidgetItem

	self currentRow: (self model indexOf: aListWidgetItem).! !

!UiListWidget methodsFor: 'selection - convenience' stamp: 'mt 10/20/2010 14:14:43.107'!
currentText

	^ self currentItem ifNotNil: [:i | i text]! !

!UiListWidget methodsFor: 'signals' stamp: 'mt 6/29/2010 09:53:38.414'!
currentTextChanged: aLabel

	self emit.! !

!UiListWidget methodsFor: 'collection api' stamp: 'mt 6/30/2011 10:23:27.492'!
detect: aBlock

	self do: [:index | (aBlock value: index) ifTrue: [^ index]].
	^ nil! !

!UiListWidget methodsFor: 'collection api' stamp: 'mt 6/30/2011 10:22:12.51'!
do: aBlock

	self model items do: [:item | aBlock value: item].! !

!UiListWidget methodsFor: 'initialization' stamp: 'mt 2/2/2012 16:34:18.047'!
initialize
	
	super initialize.
	self
		listSpec: (UiItemViewColumnSpec newFrom: {
			#text -> #text.
			#icon -> #icon.
			#balloonText -> #balloonText.
			#menu -> #menu});
		clear.! !

!UiListWidget methodsFor: 'testing' stamp: 'mt 2/2/2012 16:30:33.535'!
isEmpty

	^ self items isEmpty! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 2/2/2012 16:48:29.279'!
itemClass

	^ UiListWidgetItem! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/19/2010 19:40:25.443'!
items

	^ self model items! !

!UiListWidget methodsFor: 'signals - unboxing' stamp: 'mt 4/6/2011 13:28:49.453'!
onCurrentIndexChanged: aModelIndex

	super onCurrentIndexChanged: aModelIndex.
	self currentTextChanged: self currentText.! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 10:17:41.688'!
removeLastRow

	self model removeItemAt: self size.! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 09:32:32.761'!
removeRowAt: anIndex

	self model removeItemAt: anIndex.! !

!UiListWidget methodsFor: 'collection api' stamp: 'mt 6/30/2011 10:23:03.193'!
select: aBlock

	| newCollection |
	newCollection := OrderedCollection new.
	self do: [:each | (aBlock value: each)
		ifTrue: [newCollection add: each]].
	^ newCollection! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:11:43.237'!
size

	^ self items size! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 4/6/2011 13:53:27.838'!
textList

	^ self items collect: [:item | item text]! !

UiAbstractItemView subclass: #UiTableView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiTableView commentStamp: 'mt 10/19/2010 10:51:11.46' prior: 0!
I have a vertical header by default and are used for table-like models.!

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:43.968'!
isWidgetClass

	^ true! !

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:07:06.235'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneTableIcon! !

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:32:09.963'!
widgetClassName

	^ 'Table View'! !

!UiTableView methodsFor: 'initialization' stamp: 'mt 6/28/2012 16:53:09.266'!
initialize

	super initialize.
		
	self groupSpec: UiTableViewGroupSpec new.
		
	self
		addMorph: vHeaderScroller;
		addMorph: hHeaderScroller;
		updateLayout.! !

!UiTableView methodsFor: 'accessing' stamp: 'mt 8/8/2012 10:36:20.461'!
showGrid

	^ self viewport showGrid! !

!UiTableView methodsFor: 'accessing' stamp: 'mt 8/8/2012 10:36:26.335'!
showGrid: aBoolean

	self viewport showGrid: aBoolean.! !

!UiTableView methodsFor: 'accessing - private' stamp: 'mt 10/14/2010 13:57:19.079'!
viewportClass

	^ UiTableViewport! !

UiTableView subclass: #UiTableWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiTableWidget commentStamp: 'mt 1/4/2011 10:12:59.4' prior: 0!
Item-based table. No model required.!

!UiTableWidget class methodsFor: 'testing' stamp: 'mt 2/12/2011 12:28:28.334'!
isExperimentalWidgetClass

	^ true! !

!UiTableWidget class methodsFor: 'accessing' stamp: 'mt 11/11/2010 10:16:46.704'!
widgetCategory
	
	^ 'Item Widgets (Item-Based)'! !

!UiTableWidget class methodsFor: 'accessing' stamp: 'mt 11/11/2010 10:32:33.588'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneTableIcon! !

!UiTableWidget class methodsFor: 'accessing' stamp: 'mt 11/11/2010 10:32:52.199'!
widgetClassName

	^ 'Table Widget'! !

!UiTableWidget class methodsFor: 'accessing' stamp: 'mt 11/11/2010 10:33:02.755'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #(modelClass)! !

!UiTableWidget methodsFor: 'items add/remove' stamp: 'mt 11/3/2010 09:09:07.8'!
clear

	| oldExtent |
	oldExtent := self columnCount @ self rowCount.
	self model: UiTableWidgetModel new.
	self columnCount: oldExtent x.
	self rowCount: oldExtent y.! !

!UiTableWidget methodsFor: 'accessing' stamp: 'mt 11/3/2010 09:09:30.342'!
columnCount

	^ self model columnCount! !

!UiTableWidget methodsFor: 'accessing' stamp: 'mt 11/3/2010 09:09:20.102'!
columnCount: anInteger

	self model columnCount: anInteger.! !

!UiTableWidget methodsFor: 'initialization' stamp: 'mt 11/3/2010 09:13:44.342'!
initialize

	super initialize.
	self model: UiTableWidgetModel new.
	self connect: self viewport signal: #activated: toSelector: #onActivated:.! !

!UiTableWidget methodsFor: 'signals' stamp: 'mt 11/3/2010 09:10:31.601'!
itemActivated: aTableWidgetItem

	self emit.! !

!UiTableWidget methodsFor: 'items add/remove' stamp: 'mt 11/3/2010 10:07:41.427'!
itemAt: aPoint

	^ self model itemAt: aPoint! !

!UiTableWidget methodsFor: 'items add/remove' stamp: 'mt 11/3/2010 10:08:08.994'!
itemAt: aPoint put: aTableWidgetItem

	^ self model itemAt: aPoint put: aTableWidgetItem! !

!UiTableWidget methodsFor: 'updating' stamp: 'mt 11/3/2010 09:12:07.054'!
onActivated: aModelIndex

	self itemActivated: (aModelIndex
		ifNotNil: [self model itemAt: aModelIndex row]).! !

!UiTableWidget methodsFor: 'accessing' stamp: 'mt 11/3/2010 09:09:40.789'!
rowCount

	^ self model rowCount! !

!UiTableWidget methodsFor: 'accessing' stamp: 'mt 11/3/2010 09:09:53.214'!
rowCount: anInteger

	self model rowCount: anInteger.! !

UiAbstractItemView subclass: #UiTreeView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiTreeView commentStamp: 'mt 10/19/2010 10:51:34.42' prior: 0!
I am a view that supports tree-like models and a tree in the first column.!

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:46.249'!
isWidgetClass

	^ true! !

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:04:01.037'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneTreeIcon! !

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:32:03.461'!
widgetClassName

	^ 'Tree View'! !

!UiTreeView methodsFor: 'expand/collapse - model index' stamp: 'mt 7/10/2012 12:12:33.224'!
collapseIndex: aModelIndex

	| row |
	(aModelIndex isNil or: [aModelIndex hasChildren not])
		ifTrue: [^ self].
	
	row := self viewport rowFor: aModelIndex.
	row isExpanded ifFalse: [^ self].
		
	row items first setProperty: #isExpanded toValue: false.
	
	self viewport beginChangeLayout.
	self viewport removeChildrenForRow: row.
	self viewport endChangeLayout.! !

!UiTreeView methodsFor: 'expand/collapse' stamp: 'mt 2/3/2012 14:54:20.427'!
collapseNode: aNode

	self collapseIndex: (self modelIndicesFor: aNode) first.! !

!UiTreeView methodsFor: 'expand/collapse - model index' stamp: 'mt 3/25/2011 09:47:07.083'!
expandAllIndices: aModelIndex
	"Expand the given model index and all sub-indices."
	
	self viewport beginChangeLayout.
	self expandAllIndicesSilently: {aModelIndex}. 
	self viewport endChangeLayout.! !

!UiTreeView methodsFor: 'expand/collapse - private' stamp: 'mt 4/23/2012 10:24:42.771'!
expandAllIndicesSilently: someModelIndices

	self flag: #broken.
	someModelIndices do: [:index |
		self expandIndexSilently: index.
		self expandAllIndicesSilently: ((1 to: (index model rowCountFor: index))
			collect: [:row |	index model indexRow: row column: 1 parent: index])].! !

!UiTreeView methodsFor: 'expand/collapse - convenience' stamp: 'mt 5/2/2012 13:22:54.891'!
expandAllTopLevelNodes

	| firstGroup |
	firstGroup := self model groups first.
	self viewport beginChangeLayout.

	(1 to: (self model childCountInGroup: firstGroup)) do: [:row |
		self expandIndexSilently: (self modelIndicesFor: (self model childAt: row inGroup: firstGroup)) first].
	
	self viewport endChangeLayout.! !

!UiTreeView methodsFor: 'expand/collapse - model index' stamp: 'mt 7/10/2012 13:26:42.002'!
expandIndex: aModelIndex
	"Any given index can be expanded. Collapsed parents will be expanded automatically."
	
	self flag: #asynch. "mt: Should use cached values from morph in item view?"
	(aModelIndex isNil or: [aModelIndex hasChildren not]) ifTrue: [^ self].
	
	self viewport beginChangeLayout.
	
	self
		expandIndexSilently: aModelIndex
		checkParents: true.
	
	self viewport endChangeLayout.! !

!UiTreeView methodsFor: 'expand/collapse - private' stamp: 'mt 7/10/2012 11:52:14.78'!
expandIndexSilently: aModelIndex

	^ self
		expandIndexSilently: aModelIndex
		checkParents: false! !

!UiTreeView methodsFor: 'expand/collapse - private' stamp: 'mt 7/12/2012 17:53:39.105'!
expandIndexSilently: aModelIndex checkParents: aBoolean

	| row |
	aModelIndex ifNil: [^ self].
	
	aBoolean ifTrue: [
		"Ensure that all parent indices are expanded too."
		aModelIndex parent ifNotNil: [:parent |
			self expandIndexSilently: parent checkParents: true]].
	
	row := self viewport rowFor: aModelIndex.
	row isExpanded ifTrue: [ ^ self].

	row items first setProperty: #isExpanded toValue: true.

	self
		fillViewportFor: row firstModelIndex
		animated: self isAnimated.
		
	^ self! !

!UiTreeView methodsFor: 'expand/collapse - model index' stamp: 'mt 8/3/2012 11:19:27.05'!
expandIndices: someModelIndices

	self flag: #asynch. "mt: Should use cached values from morph in item view?"
	(someModelIndices select: [:index | index hasChildren]) ifEmpty: [^ self].

	self viewport beginChangeLayout.

	someModelIndices do: [:index | self
			expandIndexSilently: index checkParents: true]. 

	self viewport endChangeLayout.! !

!UiTreeView methodsFor: 'expand/collapse' stamp: 'mt 2/3/2012 14:54:33.87'!
expandNode: aNode

	self expandIndex: (self modelIndicesFor: aNode) first.! !

!UiTreeView methodsFor: 'expand/collapse - convenience' stamp: 'mt 5/2/2012 13:22:02.858'!
expandTopLevelRows: someRows

	self viewport beginChangeLayout.

	someRows do: [:row |
		self expandIndexSilently: (self modelIndicesFor: (self model childAt: row inGroup: self model groups first)) first].

	self viewport endChangeLayout.! !

!UiTreeView methodsFor: 'initialization' stamp: 'mt 7/20/2012 17:29:35.511'!
initialize

	super initialize.
	
	self connect: self signal: #doubleClicked: toSelector: #toggleNode:.
	
	self connect: self viewport signal: #decorationClicked: toSelector: #toggleIndex:.
	
	self addHorizontalHeader.! !

!UiTreeView methodsFor: 'event handling' stamp: 'mt 7/20/2012 17:30:27.712'!
onKeyStroked: aKeyboardEvent on: aModelIndex
	"Default keyboard interaction."

	aKeyboardEvent keyCharacter = $*
		ifTrue: [self expandAllIndices: aModelIndex].
	aKeyboardEvent keyCharacter = Character arrowRight
		ifTrue: [self expandIndex: aModelIndex].
	aKeyboardEvent keyCharacter = Character arrowLeft
		ifTrue: [self collapseIndex: aModelIndex].
		
	super onKeyStroked: aKeyboardEvent on: aModelIndex.! !

!UiTreeView methodsFor: 'accessing' stamp: 'mt 7/5/2012 17:28:57.25'!
rootIsDecorated
	"Should toplevel-items visualize expand/collapse operations?"

	^ self viewport rootIsDecorated! !

!UiTreeView methodsFor: 'accessing' stamp: 'mt 7/5/2012 17:28:50.976'!
rootIsDecorated: aBoolean

	self viewport rootIsDecorated: aBoolean.! !

!UiTreeView methodsFor: 'expand/collapse - model index' stamp: 'mt 6/26/2012 14:08:51.055'!
toggleIndex: aModelIndex

	| row |
	aModelIndex ifNil: [^ self].
	aModelIndex hasChildren ifFalse: [^ self].
	
	row := self viewport rowFor: aModelIndex.
	
	self viewport beginChangeLayout.
	
	row isExpanded
		ifTrue: [
			row items first setProperty: #isExpanded toValue: false.
			self viewport removeChildrenForRow: row]
		ifFalse: [
			row items first setProperty: #isExpanded toValue: true.
			self
				fillViewportFor: row firstModelIndex
				animated: self isAnimated].
	
	self viewport endChangeLayout.! !

!UiTreeView methodsFor: 'expand/collapse' stamp: 'mt 2/3/2012 14:53:36.991'!
toggleNode: aNode
	"The given node has to be visible."
	
	self toggleIndex: (self modelIndicesFor: aNode) first.! !

!UiTreeView methodsFor: 'expand/collapse - convenience' stamp: 'mt 4/23/2012 10:25:43.369'!
toggleTopLevelRow: aRowIndex

	self flag: #broken.
	self toggleIndex: (self model indexRow: aRowIndex column: 1 parent: nil).! !

!UiTreeView methodsFor: 'accessing - private' stamp: 'mt 10/14/2010 13:21:16.162'!
viewportClass

	^ UiTreeViewport! !

!UiScrollArea class methodsFor: 'testing' stamp: 'mt 3/7/2011 14:11:32.14'!
isWidgetClass

	^ true! !

!UiScrollArea class methodsFor: 'accessing' stamp: 'mt 3/7/2011 14:26:02.526'!
widgetCategory

	^ 'Containers & Spacer'! !

!UiScrollArea class methodsFor: 'accessing' stamp: 'mt 3/7/2011 14:15:49.82'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneBothIcon! !

!UiScrollArea class methodsFor: 'accessing' stamp: 'mt 3/7/2011 14:12:38.791'!
widgetClassName

	^ 'Scroll Area'! !

!UiScrollArea class methodsFor: 'properties' stamp: 'mt 4/18/2011 17:38:27.532'!
widgetProperties

	^ super widgetProperties, {{'Scroll Area'. #yourself} -> {
		#widgetResizable -> Boolean.
		#horizontalScrollBarPolicy -> #(asNeeded alwaysOn alwaysOff).
		#verticalScrollBarPolicy -> #(asNeeded alwaysOn alwaysOff).
		#outerBorderWidth -> Integer.
		#scrollBarThickness -> Integer}}! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 4/4/2011 16:21:32.334'!
areaResizable
	"Check whether width or height of this area can be adapted to when scroll bars are #alwaysOff."
	
	^ areaResizable ifNil: [false]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 4/4/2011 16:21:06.845'!
areaResizable: aBoolean

	aBoolean = areaResizable ifTrue: [^ false].
	
	areaResizable := aBoolean.
	
	self updateLayout.! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.512'!
cornerWidget

	^ cornerWidget! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/21/2011 09:51:58.442'!
cornerWidget: anObject

	anObject ifNil: [^ self cornerWidget: (Morph new color: Color transparent)].

	cornerWidget := anObject.

	self updateLayout.! !

!UiScrollArea methodsFor: 'drawing' stamp: 'mt 1/2/2012 17:19:14.402'!
drawBorderOn: aCanvas

	self outerBorderWidth = 0 ifTrue: [^ self].
		
	aCanvas
		frameRoundRect: self outerBounds
		radius: 3
		width: self outerBorderWidth
		color: (Color gray: 0.3).! !

!UiScrollArea methodsFor: 'drawing' stamp: 'mt 7/1/2011 22:32:45.937'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self drawBorderOn: aCanvas.! !

!UiScrollArea methodsFor: 'geometry' stamp: 'mt 4/5/2011 14:09:09.387'!
extent: aPoint

	| extentWasChanged |
	extentWasChanged := self extent ~= aPoint.
	super extent: aPoint.

	extentWasChanged ifTrue: [self updateLayout].! !

!UiScrollArea methodsFor: 'layout-properties' stamp: 'mt 3/29/2011 15:22:52.221'!
hResizing: aSymbol

	aSymbol = self hResizing
		ifTrue: [^ self].
		
	super hResizing: aSymbol.
	self updateLayout.  ! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.015'!
horizontalScrollBar

	^ horizontalScrollBar! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.1'!
horizontalScrollBar: anObject

	horizontalScrollBar := anObject.! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:47:50.482'!
horizontalScrollBarPolicy

	^ horizontalScrollBarPolicy ifNil: [#alwaysOn]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 10:56:19.44'!
horizontalScrollBarPolicy: aSymbol
	"#asNeeded, #alwaysOn, #alwaysOff"
	
	aSymbol = self horizontalScrollBarPolicy ifTrue: [^ self].
	
	horizontalScrollBarPolicy := aSymbol.
	
	self
		updateLayout;
		updateScrollBars.! !

!UiScrollArea methodsFor: 'initialization' stamp: 'mt 12/22/2011 11:53:28.232'!
initialize

	super initialize.
	
	self
		horizontalScrollBar: (UiScrollBar new orientation: #horizontal; buttonMode: #none; color: Color white; outerBorderWidth: 0);
		verticalScrollBar: (UiScrollBar new orientation: #vertical; buttonMode: #none; color: Color white; outerBorderWidth: 0);
		transformMorph: self transformMorphClass new.
		
	cornerWidget := Morph new color: Color white.
	
	self initializeEventHandler.
	
	self connect: self transformMorph signal: #areaChanged toSelector: #updateLayout.
	self connect: self transformMorph signal: #areaChanged toSelector: #updateScrollBars.

	self connect: self transformMorph signal: #verticalOffsetChanged: to: self verticalScrollBar selector: #currentValue:.
	self connect: self transformMorph signal: #horizontalOffsetChanged: to: self horizontalScrollBar selector: #currentValue:.

	self connect: self horizontalScrollBar signal: #valueChanged: to: self transformMorph selector: #horizontalOffset:.
	self connect: self verticalScrollBar signal: #valueChanged: to: self transformMorph selector: #verticalOffset:.
	
	self
		color: Color transparent;
		addMorphBack: self transformMorph;
		extent: 160@100.! !

!UiScrollArea methodsFor: 'initialization' stamp: 'mt 4/13/2011 10:51:11.794'!
initializeEventHandler

	self eventHandler: UiEventHandler new.
	
	self eventHandler setProperty: #handlesMouseWheel toValue: [true].
	
	self connect: self eventHandler signal: #mouseWheelUp: to: self verticalScrollBar selector: #decreaseValueBySingleStep.
	self connect: self eventHandler signal: #mouseWheelDown: to: self verticalScrollBar selector: #increaseValueBySingleStep.! !

!UiScrollArea methodsFor: 'testing' stamp: 'mt 3/7/2011 14:06:34.696'!
isHorizontalScrollBarVisible

	^ self horizontalScrollBarPolicy = #alwaysOn
		or: [self horizontalScrollBarPolicy = #asNeeded
			and: [self widget isNil or: [self transformMorph width < self widget width]]]! !

!UiScrollArea methodsFor: 'testing' stamp: 'mt 3/7/2011 14:06:22.788'!
isVerticalScrollBarVisible

	^ self verticalScrollBarPolicy = #alwaysOn
		or: [self verticalScrollBarPolicy = #asNeeded
			and: [self widget isNil or: [self transformMorph height < self widget height]]]! !

!UiScrollArea methodsFor: 'scrolling - private' stamp: 'mt 7/17/2012 16:14:49.128'!
offsetToShow: aRectangle
	"Calculate the offset necessary to show the rectangle."
	
	| offset |
	offset := self transformMorph offset.

	"Vertical Scrolling"
	(aRectangle top - offset y) < 0
		ifTrue: [offset := offset x @ (
			(aRectangle top min: self widget height - self transformMorph height))].
		
	((aRectangle bottom - offset y) > self transformMorph height and: [aRectangle height <= self transformMorph height])
		ifTrue: [offset := offset x @ (
					(aRectangle top - self transformMorph height + aRectangle height min: self widget height - self transformMorph height))].
	
	"Horizontal Scrolling"
	(aRectangle left - offset x) < 0
		ifTrue: [offset := (
			(aRectangle left min: self widget width - self transformMorph width)) @ offset y].
		
	((aRectangle right - offset x) > self transformMorph width and: [aRectangle width <= self transformMorph width])
		ifTrue: [offset := (
			(aRectangle left - self transformMorph width + aRectangle width min: self widget width - self transformMorph width)) @ offset y].

	^ offset! !

!UiScrollArea methodsFor: 'geometry' stamp: 'mt 6/10/2011 11:36:11.501'!
optimalWidth

	^ self widget
		ifNil: [0]
		ifNotNil: [:w | w width + self scrollBarThickness]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/29/2011 10:30:04.954'!
outerBorderWidth

	^ outerBorderWidth ifNil: [outerBorderWidth := 0]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/29/2011 10:28:48.321'!
outerBorderWidth: aNumber

	outerBorderWidth := aNumber.
	self redrawLater.! !

!UiScrollArea methodsFor: 'geometry' stamp: 'mt 3/29/2011 10:29:04.634'!
outerBounds

	^ self bounds outsetBy: self outerBorderWidth! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 6/10/2011 11:38:32.374'!
scrollBarThickness

	^ scrollBarThickness ifNil: [scrollBarThickness := 9]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 4/8/2011 10:11:25.649'!
scrollBarThickness: anInteger

	anInteger = scrollBarThickness ifTrue: [^ self].
	
	scrollBarThickness := anInteger.
	self updateLayout.! !

!UiScrollArea methodsFor: 'scrolling' stamp: 'mt 4/18/2011 17:45:18.292'!
scrollToBottom

	self widget ifNil: [^ self].
	
	self scrollToShow: (self widget bottomLeft extent: 1@1).! !

!UiScrollArea methodsFor: 'scrolling' stamp: 'mt 5/2/2011 20:54:03.921'!
scrollToShow: aRectangle
	"Scroll to include as much of aRectangle as possible, where aRectangle is in the scroller's local space."

	self transformMorph offset: (self offsetToShow: aRectangle).! !

!UiScrollArea methodsFor: 'scrolling' stamp: 'mt 6/30/2011 10:10:48.532'!
scrollToShow: aRectangle duration: milliseconds
	"Animated scrolling."
	
	| anim newOffset |
	newOffset := self offsetToShow: aRectangle.
	
	newOffset = self transformMorph offset
		ifTrue: [^ self].
	
	"Consider caching before starting the animation."
	self flag: #refactor.
	self transformMorph drawCacheActive
		ifTrue: [self transformMorph updateDrawCache].
	
	anim := (AnimPropertyAnimation
		on: self transformMorph
		property: #offset
		start: self transformMorph offset
		end: newOffset  
		duration: milliseconds).
	anim easingCurve conversionBlock: [:x | (-1 * (x-1 raisedTo: 6)) + 1].
	anim
		register;
		start: #deleteWhenFinished.! !

!UiScrollArea methodsFor: 'scrolling' stamp: 'mt 6/28/2011 17:07:32.796'!
scrollToShowGlobal: aGlobalRectangle

	self scrollToShow: 
		((self widget globalPointToLocal: aGlobalRectangle topLeft)
			extent: aGlobalRectangle extent).! !

!UiScrollArea methodsFor: 'scrolling' stamp: 'mt 6/28/2011 17:08:06.735'!
scrollToShowGlobal: aGlobalRectangle duration: milliseconds

	self
		scrollToShow: ((self widget globalPointToLocal: aGlobalRectangle topLeft)
			extent: aGlobalRectangle extent)
		duration: milliseconds.! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.643'!
transformMorph

	^ transformMorph! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.719'!
transformMorph: anObject

	transformMorph := anObject.! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 7/1/2011 16:39:06.282'!
transformMorphClass

	^ UiTransformMorph! !

!UiScrollArea methodsFor: 'layouting' stamp: 'mt 1/4/2012 14:03:26.089'!
updateLayout

	"viewport bounds can only be calculated right if transform morph has correct size..."
	self transformMorph disconnectSignal: #areaChanged from: self selector: #updateLayout.
	self transformMorph bounds: self viewportBounds.
	self connect: self transformMorph signal: #areaChanged toSelector: #updateLayout.

	self isVerticalScrollBarVisible
		ifFalse: [self removeMorph: self verticalScrollBar]
		ifTrue: [self addMorph: self verticalScrollBar].  
	
	self verticalScrollBar
		extent: self scrollBarThickness @ self transformMorph height;
		topLeft: self transformMorph right @ self top.

	self isHorizontalScrollBarVisible
		ifFalse: [self removeMorph: self horizontalScrollBar]
		ifTrue: [self addMorph: self horizontalScrollBar].  
		
	self horizontalScrollBar
		extent: self transformMorph width @ self scrollBarThickness;
		topLeft: self left @ self transformMorph bottom.

	self isHorizontalScrollBarVisible & self isVerticalScrollBarVisible
		ifFalse: [self removeMorph: self cornerWidget]
		ifTrue: [self addMorph: self cornerWidget].  
		
	self cornerWidget
		extent: self scrollBarThickness @ self scrollBarThickness;
		topLeft: self transformMorph bottomRight.
		
	self widget ifNil: [^ self].
	
	"Intelligent layout mechanisms."
	self widgetResizable ifTrue: [
		self horizontalScrollBarPolicy = #alwaysOff
			ifTrue: [self widget width: self transformMorph width / self transformMorph scale]
			ifFalse: [self verticalScrollBarPolicy = #alwaysOff
				ifTrue: [self widget height: self transformMorph height / self transformMorph scale]]].
	
	self areaResizable ifTrue: [
		self verticalScrollBarPolicy = #alwaysOff
		ifTrue: [
			self transformMorph verticalOffset: 0.
			self height: self widget height * self transformMorph scale + (self isHorizontalScrollBarVisible
				ifTrue: [self scrollBarThickness + 1] ifFalse: [0])]
		ifFalse: [self horizontalScrollBarPolicy = #alwaysOff
			ifTrue: [
				self transformMorph horizontalOffset: 0.
				self width: self widget width * self transformMorph scale + (self isVerticalScrollBarVisible
					ifTrue: [self scrollBarThickness + 1] ifFalse: [0])]]].! !

!UiScrollArea methodsFor: 'layouting' stamp: 'mt 4/20/2011 14:51:07.678'!
updateScrollBars

	self widget ifNil: [^ self].
	
	self horizontalScrollBar
		maximum: (self widget width * self transformMorph scale - self transformMorph width max: 0);
		pageStep: self transformMorph width;
		currentValue: self transformMorph offset x.
	
	self verticalScrollBar
		maximum: (self widget height * self transformMorph scale - self transformMorph height max: 0);
		pageStep: self transformMorph height;
		currentValue: self transformMorph offset y.! !

!UiScrollArea methodsFor: 'layout-properties' stamp: 'mt 3/29/2011 15:23:07.214'!
vResizing: aSymbol

	aSymbol = self vResizing
		ifTrue: [^ self].
		
	super vResizing: aSymbol.
	self updateLayout.  ! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.303'!
verticalScrollBar

	^ verticalScrollBar! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.362'!
verticalScrollBar: anObject

	verticalScrollBar := anObject.! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:47:58.761'!
verticalScrollBarPolicy

	^ verticalScrollBarPolicy ifNil: [#alwaysOn]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 10:48:43.579'!
verticalScrollBarPolicy: aSymbol
	"#asNeeded, #alwaysOn, #alwaysOff"
	
	aSymbol = self verticalScrollBarPolicy ifTrue: [^ self].
	
	verticalScrollBarPolicy := aSymbol.
	
	self
		updateLayout;
		updateScrollBars.! !

!UiScrollArea methodsFor: 'geometry' stamp: 'mt 4/5/2011 15:44:18.529'!
viewportBounds

	^ self bounds insetBy: (0@0 corner:
		(self isVerticalScrollBarVisible ifTrue: [self scrollBarThickness + 1] ifFalse: [0])
		@
		(self isHorizontalScrollBarVisible ifTrue: [self scrollBarThickness + 1] ifFalse: [0]))! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:44:22.696'!
widget
	"The morph that is scrolled."
	
	^ self transformMorph submorphs
		ifEmpty: [nil]
		ifNotEmpty: [self transformMorph submorphs first]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/24/2011 15:16:16.979'!
widget: aMorph

	self transformMorph removeAllMorphs.
	
	aMorph ifNotNil: [:m |
		self transformMorph addMorph: aMorph].! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/29/2011 11:57:37.956'!
widgetResizable
	"Check whether width or height can be adapted to when scroll bars are #alwaysOff."
	
	^ widgetResizable ifNil: [false]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/29/2011 11:48:29.577'!
widgetResizable: aBoolean

	aBoolean = widgetResizable ifTrue: [^ false].
	
	widgetResizable := aBoolean.
	
	self updateLayout.! !

UiScrollArea subclass: #UiTextEdit
	instanceVariableNames: 'originalText scrollingMode scrollingLimit colors displayMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiTextEdit commentStamp: 'mt 4/8/2011 10:27:09.13' prior: 0!
At the moment, you should never activate the horizontal scrollbar as the text can only be wrapped.

If you want to disable the vertical scrollbar, enable #areaResizable too.

Do not make the vertical scrollbar #asNeeded. Needs to be fixed. ;)!

UiTextEdit subclass: #UiLineEdit
	instanceVariableNames: 'helpText hideCursor deferEditSignalTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiLineEdit commentStamp: 'mt 1/10/2012 11:23:35.803' prior: 0!
This is an input field that has one line only.!

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 3/23/2011 10:49:19.076'!
widgetClassIcon

	^ UiFugueIcons uiTextFieldIcon! !

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 3/23/2011 10:49:25.347'!
widgetClassName

	^ 'Line Edit'! !

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 4/28/2011 16:28:48.843'!
widgetProperties

	^ super widgetProperties, {{'Line Edit'. #yourself} -> {
		#helpText -> String.
		#hideCursor -> Boolean}}! !

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 4/18/2011 17:38:52.221'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #(vResizing scrollBarThickness)! !

!UiLineEdit methodsFor: 'accessing' stamp: 'mt 6/3/2011 22:50:25.43'!
deferEditSignalTime

	^ deferEditSignalTime ifNil: [deferEditSignalTime := 0]! !

!UiLineEdit methodsFor: 'accessing' stamp: 'mt 6/7/2011 14:09:01.822'!
deferEditSignalTime: milliseconds

	deferEditSignalTime := milliseconds.! !

!UiLineEdit methodsFor: 'drawing' stamp: 'mt 1/10/2012 11:29:16.346'!
drawOn: aCanvas

	UiPainter default new
		drawLineEdit: self on: aCanvas.! !

!UiLineEdit methodsFor: 'signals' stamp: 'mt 7/8/2012 14:27:39.733'!
escapePressed: discardedText
	
	self emitAlways.! !

!UiLineEdit methodsFor: 'events' stamp: 'mt 4/28/2011 16:34:31.335'!
handleMouseMove: evt

	self restoreCursor.
	^ super handleMouseMove: evt    ! !

!UiLineEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:30:16.854'!
helpText

	^ helpText ifNil: [helpText := '']! !

!UiLineEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:30:22.53'!
helpText: aString
	"Drawn whenver #theText is empty."
	
	helpText := aString.
	self redrawLater.! !

!UiLineEdit methodsFor: 'accessing' stamp: 'mt 4/28/2011 16:37:02.88'!
hideCursor
	"Hide the cursor while typing."
	
	^ hideCursor ifNil: [true]! !

!UiLineEdit methodsFor: 'accessing' stamp: 'mt 4/28/2011 15:35:29.459'!
hideCursor: aBoolean

	hideCursor := aBoolean.! !

!UiLineEdit methodsFor: 'initialization' stamp: 'mt 7/8/2012 14:27:25.622'!
initialize

	super initialize.
	
	self
		hResizing: #spaceFill;
		verticalScrollBarPolicy: #alwaysOff;
		widgetResizable: false;  
		height: 20;
		acceptOnFocusLost: true.
	
	self textMorph
		width: 999999;
		acceptOnCR: true;
		revertOnEscape: true.
		
	self connect: self textMorph signal: #returnPressed: toSelector: #returnPressed:.
	self connect: self textMorph signal: #escapePressed: toSelector: #escapePressed:.
	self connect: self signal: #textEdited: toSelector: #tryHideCursor.! !

!UiLineEdit methodsFor: 'initialization' stamp: 'mt 4/28/2011 16:36:37.338'!
initializeEventHandler

	super initializeEventHandler.
	
	self eventHandler grabKeyboardOnMouseEnter: true.
	
	self connect: self eventHandler signal: #focusLost toSelector: #restoreCursor.! !

!UiLineEdit methodsFor: 'cursor' stamp: 'mt 4/28/2011 16:32:44.772'!
restoreCursor

	ActiveHand showTemporaryCursor: nil.! !

!UiLineEdit methodsFor: 'signals' stamp: 'mt 7/8/2012 14:27:47.001'!
returnPressed: acceptedText
	
	self emitAlways.! !

!UiLineEdit methodsFor: 'signals' stamp: 'mt 6/7/2011 14:15:15.527'!
textEdited: aText

	self deferEditSignalTime > 0 ifTrue: [
		self
			removeAlarm: #triggerDeferredEditSignal;
			addAlarm: #triggerDeferredEditSignal
			after: self deferEditSignalTime.
		^ self].
	
	self emitAlways.! !

!UiLineEdit methodsFor: 'accessing - private' stamp: 'mt 7/18/2012 16:05'!
textMorphClass

	^ UiTextLineMorph! !

!UiLineEdit methodsFor: 'actions' stamp: 'mt 6/9/2011 11:31:03.779'!
triggerDeferredEditSignal

	super textEdited: self theText.! !

!UiLineEdit methodsFor: 'cursor' stamp: 'mt 4/28/2011 16:45:53.306'!
tryHideCursor

	(self hideCursor
		and: [self bounds containsPoint: (self globalPointToLocal: ActiveHand position)]
		and: [ActiveHand temporaryCursor isNil])
		ifTrue: [ActiveHand showTemporaryCursor: Cursor blank].! !

!UiTextEdit class methodsFor: 'testing' stamp: 'mt 3/23/2011 10:48:23.69'!
isWidgetClass

	^ true! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 3/23/2011 10:48:41.087'!
widgetCategory

	^ 'Input Widgets'! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 3/23/2011 10:48:47.811'!
widgetClassIcon

	^ UiFugueIcons uiTextAreaIcon! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 3/23/2011 10:48:53.067'!
widgetClassName

	^ 'Text Edit'! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 4/28/2011 15:31:23.781'!
widgetProperties

	^ super widgetProperties, {{'Text Edit'. #yourself} -> {
		#theText -> String.
		#readOnly -> Boolean.
		#autoConvert -> Boolean.
		#autoAccept -> Boolean.
		#acceptOnFocusLost -> Boolean.
		#scrollingMode -> #(none never limit always).
		#scrollingLimit -> Integer}}! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 3/29/2011 12:12:37.553'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout' widgetResizable horizontalScrollBarPolicy verticalScrollBarPolicy)! !

!UiTextEdit methodsFor: 'actions' stamp: 'mt 4/13/2011 16:07:30.76'!
acceptChanges

	self originalText: self theText copy.
	self editingFinished: self theText copy.
	
	self updateFocusColor: self hasKeyboard.! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/23/2011 09:21:54.406'!
acceptOnFocusLost
	"Should the contents be accepted if the keyboard focus gets lost?"
	
	^ self textMorph acceptOnFocusLost! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/23/2011 09:21:43.524'!
acceptOnFocusLost: aBoolean

	self textMorph acceptOnFocusLost: aBoolean.! !

!UiTextEdit methodsFor: 'text changing' stamp: 'mt 4/19/2011 10:38:37.912'!
append: stringOrText

	self theText append: stringOrText.
	self textMorph recompose.
	
	self autoAccept
		ifTrue: [self textMorph editor accept].! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:11:29.281'!
autoAccept

	^ self textMorph autoAccept! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:11:21.722'!
autoAccept: aBoolean

	self textMorph autoAccept: aBoolean! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 17:46:43.014'!
autoConvert

	^ self textMorph autoConvert! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 17:46:34.323'!
autoConvert: aBoolean

	self textMorph autoConvert: aBoolean.  ! !

!UiTextEdit methodsFor: 'actions' stamp: 'mt 4/6/2011 15:42:04.336'!
clear

	self theText: ''.! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 4/28/2011 17:01:16.688'!
colorBackground

	^ self colors
		at: #background
		ifAbsentPut: [Color white]! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 4/28/2011 17:03:40.305'!
colorBackground: aColor

	self colors
		at: #background
		put: aColor! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 4/28/2011 17:01:09.252'!
colorBorder

	^ self colors
		at: #border
		ifAbsentPut: [Color gray: 0.3]! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 4/28/2011 17:03:56.543'!
colorBorder: aColor

	self colors
		at: #border
		put: aColor! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 5/10/2011 17:33:24.116'!
colorChangedBackground

	^ self colors
		at: #changedBackground
		ifAbsentPut: [Color yellow muchLighter paler]! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 4/28/2011 17:04:09.806'!
colorChangedBackground: aColor

	self colors
		at: #changedBackground
		put: aColor! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 5/10/2011 17:33:27.92'!
colorChangedBorder

	^ self colors
		at: #changedBorder
		ifAbsentPut: [Color yellow muchDarker]! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 4/28/2011 17:04:24.817'!
colorChangedBorder: aColor

	self colors
		at: #changedBorder
		put: aColor! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 4/28/2011 17:00:07.404'!
colorFocusBackground

	^ self colors
		at: #focusBackground
		ifAbsentPut: [(Color r: 0.0 g: 0.0 b: 0.5) muchLighter paler]! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 4/28/2011 17:04:36.158'!
colorFocusBackground: aColor

	self colors
		at: #focusBackground
		put: aColor! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 4/28/2011 17:00:27.289'!
colorFocusBorder

	^ self colors
		at: #focusBorder
		ifAbsentPut: [(Color r: 0.5 g: 0.5 b: 1.0) muchDarker]! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 4/28/2011 17:04:51.483'!
colorFocusBorder: aColor

	self colors
		at: #focusBorder
		put: aColor! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 5/12/2011 15:32:33.026'!
colorHighlightedBackground

	^ self colors
		at: #colorHighlightedBackground
		ifAbsentPut: [Color orange muchLighter paler]! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 5/10/2011 16:46:24.392'!
colorHighlightedBackground: aColor

	^ self colors
		at: #colorHighlightedBackground
		put: aColor! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 5/12/2011 15:38:04.224'!
colorHighlightedBorder

	^ self colors
		at: #colorHighlightedBorder
		ifAbsentPut: [Color orange muchDarker]! !

!UiTextEdit methodsFor: 'accessing - colors' stamp: 'mt 5/10/2011 16:46:13.251'!
colorHighlightedBorder: aColor

	^ self colors
		at: #colorHighlightedBorder
		put: aColor! !

!UiTextEdit methodsFor: 'accessing - private' stamp: 'mt 4/28/2011 16:58:14.791'!
colors

	^ colors ifNil: [colors := Dictionary new]! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 18:29:16.694'!
converter
	
	^ self textMorph converter! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 18:29:11.591'!
converter: aBlock
	
	self textMorph converter: aBlock.  ! !

!UiTextEdit methodsFor: 'selection' stamp: 'mt 5/24/2011 15:47:53.806'!
cursorPosition

	^ self textMorph editor selectionInterval first! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 5/10/2011 17:13:05.772'!
displayMode
	"#normal ... normal mode with different colors for keyboard focus and changed state
	#highlight ... normal colors will be replaced with highlight ones."
	
	^ displayMode ifNil: [displayMode := #normal]! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 5/10/2011 17:13:38.21'!
displayMode: aSymbol

	displayMode = aSymbol ifTrue: [^ self].
	
	displayMode := aSymbol.! !

!UiTextEdit methodsFor: 'drawing' stamp: 'mt 1/10/2012 11:31:20.306'!
drawOn: aCanvas

	UiPainter default new
		drawTextEdit: self on: aCanvas.! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 3/23/2011 09:15:15.653'!
editingFinished: text
	"Emitted whenever the changed contents were accepted. This could happen with Cmd+S (Save operation), or focus lost."
	
	self emitAlways.! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 7/6/2012 13:05:43.63'!
font: aFont
	"Change the default font."
	
	self textMorph font: aFont.! !

!UiTextEdit methodsFor: 'actions' stamp: 'mt 4/4/2011 14:25:48.751'!
grabKeyboard
	"Pass-on keyboard focus to text morph."
	
	self textMorph grabKeyboard.! !

!UiTextEdit methodsFor: 'testing' stamp: 'mt 4/4/2011 14:26:57.511'!
hasKeyboard
	
	^ self textMorph hasKeyboard! !

!UiTextEdit methodsFor: 'testing' stamp: 'mt 4/18/2011 17:55:43.805'!
hasUnacceptedChanges

	^ self originalText asString ~= self theText asString! !

!UiTextEdit methodsFor: 'initialization' stamp: 'mt 7/8/2012 14:18:52.3'!
initialize

	horizontalScrollBarPolicy := #alwaysOff.
	"verticalScrollBarPolicy := #asNeeded." "not working yet for text morph"
	widgetResizable := true.

	super initialize.
		
	self
		color: Color white;
		outerBorderWidth: 1.
		
	self transformMorph color: Color transparent.
	
	self verticalScrollBar
		singleStep: 20;
		outerBorderWidth: 0;
		color: Color transparent.  
	self verticalScrollBar eventHandler setProperty: #handlesKeyboard toValue: [false].
	
	self connect: self textMorph signal: #focusChanged: toSelector: #scrollToShow:.
	self connect: self textMorph signal: #textEdited: toSelector: #textEdited:.
	self connect: self textMorph signal: #textEdited: toSelector: #textChanged:.
	self connect: self textMorph signal: #accepted toSelector: #acceptChanges.
	self connect: self textMorph signal: #reverted toSelector: #revertChanges.
	self connect: self textMorph signal: #valueChanged: toSelector: #valueChanged:.! !

!UiTextEdit methodsFor: 'initialization' stamp: 'mt 7/18/2012 16:05'!
initializeEventHandler

	super initializeEventHandler.
	
	"Need the widget right before setting up the event handler connections."
	self widget: (self textMorphClass on: self).
	
	self connect: self eventHandler signal: #mouseClicked: to: self textMorph selector: #grabKeyboard.

"	self connect: self eventHandler signal: #focusReceived toSelector: #updateFocusColor: pattern: #(=true).
	self connect: self eventHandler signal: #focusLost toSelector: #updateFocusColor: pattern: #(=false)."! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:40:50.714'!
margins

	^ self textMorph margins! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:40:59.522'!
margins: margins

	self textMorph margins: margins.! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 5/11/2011 11:30:20.817'!
optimalWidth
	"Calculate the optimal with for the default font based of line breaks."
	
	| maxWidth |
	maxWidth := 0.
	(self theText asString copyReplaceAll: String tab with: '   ')
	   linesDo: [:line | 
			maxWidth := maxWidth max: (self textMorph textStyle defaultFont widthOfString: line)].
		
	^ maxWidth + self scrollBarThickness + 20 ! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/23/2011 09:26:42.103'!
originalText

	^ originalText ifNil: [originalText := '' asText]! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 18:11:05.141'!
originalText: stringOrText

	originalText := stringOrText.! !

!UiTextEdit methodsFor: 'accessing - private' stamp: 'mt 7/5/2011 16:41:44.253'!
preferredHeight

	^ (self scrollingLimit * self textMorph lineHeight)
		+ self margins top + self margins bottom! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:09:09.753'!
readOnly

	^ self textMorph readOnly! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 11:09:27.78'!
readOnly: aBoolean

	self textMorph readOnly: aBoolean! !

!UiTextEdit methodsFor: 'actions' stamp: 'mt 4/14/2011 14:43:41.737'!
revertChanges

	self theText: self originalText copy.
	self textReverted: self theText copy.
	
	self updateFocusColor: self hasKeyboard.! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 4/28/2011 13:53:01.032'!
scrollingLimit
	"When #scrollingMode is not #never use this value to compute the height of this text edit field."
	
	^ scrollingLimit ifNil: [scrollingLimit := 10 "lines"]! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 4/28/2011 13:53:12.051'!
scrollingLimit: anInteger

	scrollingLimit = anInteger ifTrue: [^ self].

	scrollingLimit := anInteger.
	
	self updateLayout.! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 4/28/2011 13:53:15.977'!
scrollingMode
	"Decide when or if to show vertical scroll bar.
	#none ... deactivate any special handling
	#never ... expand vertically and never show scroll bar
	#limit ... use #scrollingLimit to decide when to add the scroll bar
	#always ... always show scroll bar and have the height specified by #scrollingLimit"
	
	^ scrollingMode ifNil: [scrollingMode := #none]! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 4/28/2011 13:53:21.905'!
scrollingMode: aSymbol

	scrollingMode = aSymbol ifTrue: [^ self].

	scrollingMode := aSymbol.
	
	self updateLayout.! !

!UiTextEdit methodsFor: 'selection' stamp: 'mt 1/18/2012 10:56:29.693'!
select: anInterval

	self textMorph editor selectInterval: anInterval. 
	self redrawLater.! !

!UiTextEdit methodsFor: 'selection' stamp: 'mt 1/18/2012 10:56:36.529'!
selectAll

	self textMorph editor selectAll.
	self redrawLater.! !

!UiTextEdit methodsFor: 'selection' stamp: 'mt 4/6/2011 14:35:46.011'!
selectedText

	^ self theText copyFrom: self textMorph editor selectionInterval first to: self textMorph editor selectionInterval last! !

!UiTextEdit methodsFor: 'selection' stamp: 'mt 6/25/2012 17:05:58.527'!
selection

	^ self textMorph editor selectionInterval! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 3/23/2011 09:30:39.094'!
textChanged: text
	"Sent whenever the text was changed programmatically via #theText: or due to user input."
	
	self emitAlways.! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 3/23/2011 09:14:43.869'!
textEdited: text
	"Only emitted if text changed via user interaction and not programmatically."
	
	self emitAlways.! !

!UiTextEdit methodsFor: 'accessing - private' stamp: 'mt 3/21/2011 16:56:42.343'!
textMorph

	^ self widget! !

!UiTextEdit methodsFor: 'accessing - private' stamp: 'mt 7/18/2012 16:05'!
textMorphClass

	^ UiTextMorph! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 4/12/2011 17:47:19.641'!
textReverted: text

	self emit.! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 3/22/2011 12:10:30.082'!
theText

	^ self textMorph text! !

!UiTextEdit methodsFor: 'accessing' stamp: 'bs 7/26/2011 14:15:02.945'!
theText: aValue

	aValue ifNil: [^ self theText: ''].

	aValue == self theText ifTrue: [^ self].
	
	self originalText: aValue.  
	
	"Scroll to the beginning."
	self transformMorph offset: 0@0.
	
	self textMorph newContents: aValue asStringOrText.

	self autoConvert
		ifTrue: [self textMorph convertText]
		ifFalse: [self updateScrollBars].
	
	self textChanged: self theText.
	
	self autoConvert
		ifFalse: [	self valueChanged: aValue].
			
	self textMorph style.
	
	self updateLayout.! !

!UiTextEdit methodsFor: 'actions' stamp: 'mt 5/10/2011 17:16:26.308'!
updateFocusColor: hasFocus

	hasFocus
		ifTrue: [self color: self colorFocusBackground]
		ifFalse: [
			self hasUnacceptedChanges
				ifTrue: [self color: self colorChangedBackground]
				ifFalse: [self displayMode = #highlight
					ifTrue: [self color: self colorHighlightedBackground]
					ifFalse: [self color: self colorBackground]]].! !

!UiTextEdit methodsFor: 'layouting' stamp: 'mt 4/28/2011 13:54:57.076'!
updateLayout

	self updateScrollingBehavior.
	super updateLayout.
! !

!UiTextEdit methodsFor: 'layouting' stamp: 'mt 4/28/2011 13:54:44.673'!
updateScrollingBehavior
	"Read #scrollingLimit and #scrollingMode and update height and scroll bar visibility."
	
	self scrollingMode ~= #none
		ifTrue: [areaResizable := true].
	
	self scrollingMode = #never
		ifTrue: [verticalScrollBarPolicy := #alwaysOff].
		
	self scrollingMode = #limit ifTrue: [
		self scrollingLimit < self textMorph lineCountComposed
			ifTrue: [
				verticalScrollBarPolicy := #alwaysOn.
				self height: self preferredHeight]
			ifFalse: [verticalScrollBarPolicy := #alwaysOff]].
		
	self scrollingMode = #always ifTrue: [
		verticalScrollBarPolicy := #alwaysOn.
		self height: self preferredHeight].! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 3/23/2011 09:38:35.655'!
valueChanged: convertedValue
	"Only emitted if set programmatically with #theText:."
	
	self emitAlways.! !

Morph subclass: #UiViewHeaderItem
	instanceVariableNames: 'orientation mouseDownPosition resizeable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewHeaderItem class methodsFor: 'testing' stamp: 'mt 1/10/2012 11:57:08.351'!
isWidgetClass

	^ false! !

!UiViewHeaderItem methodsFor: 'events-processing' stamp: 'mt 1/10/2012 13:47:46.124'!
handleMouseMove: anEvent
	"Receive any mouse move event."
	
	super handleMouseMove: anEvent.
	
	anEvent wasHandled not
		ifTrue: [self mouseMove: anEvent. anEvent wasHandled: true].! !

!UiViewHeaderItem methodsFor: 'initialization' stamp: 'mt 3/23/2012 10:08:19.817'!
initialize

	super initialize.
	self
		changeTableLayout.! !

!UiViewHeaderItem methodsFor: 'initialization' stamp: 'mt 3/23/2012 10:49:47.535'!
initializeEventHandler

	self eventHandler ifNotNil: [^ self].

	self eventHandler: UiEventHandler new.

	"Recognize drag start."
	self connect: self eventHandler signal: #mousePressed: toSelector: #updateMouseDownPosition:.

	"Update cursor."
	self connect: self eventHandler signal: #mouseMoved: toSelector: #updateMouseCursor:.
	self connect: self eventHandler signal: #mouseLeft: toSelector: #resetMouseCursor:.
	self connect: self eventHandler signal: #mouseReleased: toSelector: #resetMouseCursor:.

	"Trigger resize actions."
	self connect: self eventHandler signal: #mouseMoved: toSelector: #resizeByEvent:.
	self connect: self eventHandler signal: #mouseDoubleClicked: toSelector: #resizeToShrinkWrapByEvent:.! !

!UiViewHeaderItem methodsFor: 'testing' stamp: 'mt 1/10/2012 13:58:11.49'!
isMouseInResizeRect: aMouseEvent

	^ (self orientation == #horizontal and: [aMouseEvent position x + 5 > self right])
		or: [self orientation == #vertical and: [aMouseEvent position y + 5 > self bottom]]! !

!UiViewHeaderItem methodsFor: 'accessing' stamp: 'mt 1/10/2012 11:57:35.734'!
orientation

	^ orientation ifNil: [#horizontal]! !

!UiViewHeaderItem methodsFor: 'accessing' stamp: 'mt 1/10/2012 12:11:34.673'!
orientation: aSymbol
	"#horizontal, #vertical"

	orientation := aSymbol.
	self updateLayout.! !

!UiViewHeaderItem methodsFor: 'updating' stamp: 'mt 1/10/2012 14:10:06.792'!
resetMouseCursor: aMouseEvent

	mouseDownPosition := nil.
	aMouseEvent hand showTemporaryCursor: nil.! !

!UiViewHeaderItem methodsFor: 'actions' stamp: 'mt 3/23/2012 10:48:35.216'!
resize: widthOrHeight

	self orientation == #horizontal
		ifTrue: [self width: widthOrHeight]
		ifFalse: [self height: widthOrHeight].! !

!UiViewHeaderItem methodsFor: 'actions' stamp: 'mt 3/23/2012 10:46:39.905'!
resizeByEvent: aMouseEvent

	mouseDownPosition ifNil: [^ self].

	self resized: (self orientation == #horizontal
		ifTrue: [(aMouseEvent position - self left) x]
		ifFalse: [(aMouseEvent position - self top) y]).! !

!UiViewHeaderItem methodsFor: 'actions' stamp: 'mt 3/23/2012 10:46:47.668'!
resizeToShrinkWrapByEvent: aMouseEvent

	(self isMouseInResizeRect: aMouseEvent)
		ifTrue: [self resizedToShrinkWrap].! !

!UiViewHeaderItem methodsFor: 'accessing' stamp: 'mt 1/10/2012 17:13:51.191'!
resizeable
	"Anserws whether this item can be resized using a mouse or not."
	
	^ resizeable ifNil: [false]! !

!UiViewHeaderItem methodsFor: 'accessing' stamp: 'mt 1/10/2012 17:15:59.677'!
resizeable: aBoolean

	resizeable := aBoolean.
	aBoolean
		ifTrue: [self initializeEventHandler]
		ifFalse: [self eventHandler: nil].! !

!UiViewHeaderItem methodsFor: 'signals' stamp: 'mt 1/10/2012 14:20:55.469'!
resized: anInteger

	self emit.! !

!UiViewHeaderItem methodsFor: 'signals' stamp: 'mt 1/10/2012 17:17:36.411'!
resizedToShrinkWrap

	self emit.! !

!UiViewHeaderItem methodsFor: 'updating' stamp: 'mt 3/23/2012 10:07:20.019'!
updateLayout

	| c |
	c := Color gray: 0.85.
	
	self orientation == #horizontal ifTrue: [
		self
			listDirection: #leftToRight;
			hResizing: #rigid;
			vResizing: #shrinkWrap;
			fillStyle: ((GradientFillStyle ramp: {
				0.0 -> Color white.
				0.1-> (c adjustBrightness: 0.05).
				0.6 -> (c darker)})
				origin: self topLeft;
				direction: 0 @ self height);
			borderStyle: (BorderStyle raised width: 1).].
	
	self orientation == #vertical ifTrue: [
		self
			listDirection: #topToBottom;
			hResizing: #shrinkWrap;
			vResizing: #rigid;
			color: c;
			"fillStyle: ((GradientFillStyle ramp: {
				0.0 -> Color white.
				0.1-> (c adjustBrightness: 0.05).
				0.6 -> (c darker)})
				origin: self topLeft;
				direction: self width @ 0);"
			borderStyle: (BorderStyle raised width: 1)].! !

!UiViewHeaderItem methodsFor: 'updating' stamp: 'mt 1/10/2012 14:08:50.921'!
updateMouseCursor: aMouseEvent

	(aMouseEvent isMouseLeave or: [aMouseEvent isMouseUp]) ifTrue: [
		mouseDownPosition := nil.
		aMouseEvent hand showTemporaryCursor: nil.
		^ self].

	(mouseDownPosition notNil or: [self isMouseInResizeRect: aMouseEvent])
		ifTrue: [aMouseEvent hand showTemporaryCursor: (self orientation == #horizontal
			ifTrue: [Cursor resizeLeft]
			ifFalse: [Cursor resizeTop])]
		ifFalse: [aMouseEvent hand showTemporaryCursor: nil].! !

!UiViewHeaderItem methodsFor: 'updating' stamp: 'mt 1/10/2012 13:58:39.014'!
updateMouseDownPosition: aMouseEvent

	(self isMouseInResizeRect: aMouseEvent)
		ifTrue: [mouseDownPosition := aMouseEvent position]	.! !

Morph subclass: #UiWidgetPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiWidgetPage commentStamp: 'mt 7/14/2010 11:14:35.743' prior: 0!
I am used in a UiStackedWidget.!

!UiWidgetPage class methodsFor: 'properties' stamp: 'mt 7/16/2010 13:14:14.223'!
widgetProperties

	^ {{'Stacked Widget - Layout'. #owner} -> {
		#topLeft -> Point.
		#width -> Integer.
		#height -> Integer.
		#hResizing -> #(rigid spaceFill shrinkWrap).
		#vResizing -> #(rigid spaceFill shrinkWrap)}.
		{'Stacked Widget - Pages'. #owner} -> {
			#currentIndex -> Integer}}! !

!UiWidgetPage class methodsFor: 'properties' stamp: 'mt 7/16/2010 11:29:42.685'!
widgetPropertiesToIgnore

	^ #(hResizing vResizing width height topLeft)! !

!UiWidgetPage methodsFor: 'initialization' stamp: 'mt 7/14/2010 10:32:53.703'!
initialize

	super initialize.
	self
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

Morph subclass: #UiWidgetPageButtonContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiWidgetPageButtonContainer commentStamp: 'mt 7/14/2010 11:15:56.239' prior: 0!
I am a container for edit buttons that has a high mouse priority to accept mouse clicks.!

!UiWidgetPageButtonContainer methodsFor: 'events-processing' stamp: 'mt 7/16/2010 12:53:09.338'!
handlerForMouseDown: evt

	^ self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
		! !

!UiWidgetPageButtonContainer methodsFor: 'events-processing' stamp: 'mt 7/16/2010 12:53:21.162'!
handlerForYellowButtonDown: evt

	^ self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
		! !

!UiWidgetPageButtonContainer methodsFor: 'initialization' stamp: 'mt 7/16/2010 12:57:41.845'!
initialize

	super initialize.
	self
		color: (Color gray: 0.8);
		changeTableLayout;
		listDirection: #leftToRight;
		borderStyle: (BorderStyle raised width: 1);
		disableTableLayout: true;
		setToAdhereToEdge: #topRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.! !

!UiWidgetPageButtonContainer methodsFor: 'events-processing' stamp: 'mt 7/14/2010 11:20:22.466'!
mouseDownPriority

	^ 150! !

Morph subclass: #UiWindow
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiWindow commentStamp: 'mt 11/27/2010 14:01:27.968' prior: 0!
This is an abstract base class for a system window that uses a user interface generated by the Morphic Designer.

Implement #uiClass and override #title to configure the look of this window.!

!UiWindow class methodsFor: 'as yet unclassified' stamp: 'mt 11/27/2010 13:55:25.929'!
open

	^ self new open! !

!UiWindow methodsFor: 'initialization' stamp: 'mt 11/27/2010 13:57:48.499'!
initialize

	super initialize.
	self ui setupUi: self.! !

!UiWindow methodsFor: 'open/close' stamp: 'mt 11/27/2010 13:55:39.471'!
open

	self openInWindowLabeled: self title.! !

!UiWindow methodsFor: 'accessing' stamp: 'mt 11/27/2010 17:32:06.393'!
title

	^ 'Unnamed Dialog'! !

!UiWindow methodsFor: 'accessing' stamp: 'mt 11/27/2010 13:56:20.01'!
ui

	^ ui ifNil: [ui := self uiClass new]! !

!UiWindow methodsFor: 'accessing' stamp: 'mt 11/27/2010 13:55:57.56'!
uiClass

	self subclassResponsibility.! !
